
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         DRIZZLEparse
#define yylex           DRIZZLElex
#define yyerror         DRIZZLEerror
#define yylval          DRIZZLElval
#define yychar          DRIZZLEchar
#define yydebug         DRIZZLEdebug
#define yynerrs         DRIZZLEnerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 23 "sql_yacc.yy"

/* session is passed as an argument to yyparse(), and subsequently to yylex().
** The type will be void*, so it must be  cast to (Session*) when used.
** Use the YYSession macro for this.
*/
#define YYPARSE_PARAM yysession
#define YYLEX_PARAM yysession
#define YYSession (static_cast<Session *>(yysession))

#define YYENABLE_NLS 0
#define YYLTYPE_IS_TRIVIAL 0

#define DRIZZLE_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (YYSession->lex)

#include "config.h"
#include <cstdio>
#include "drizzled/parser.h"

int yylex(void *yylval, void *yysession);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    ulong val= *(F);                          \
    if (drizzled::my_yyoverflow((B), (D), &val)) \
    {                                         \
      yyerror((char*) (A));                   \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define DRIZZLE_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(YYSession);\
    YYABORT;                                  \
  } while (0)

#define DRIZZLE_YYABORT_UNLESS(A)         \
  if (!(A))                             \
  {                                     \
    my_parse_error(ER(ER_SYNTAX_ERROR));\
    DRIZZLE_YYABORT;                      \
  }


#define YYDEBUG 0

namespace drizzled
{

class Table_ident;
class Item;
class Item_num;


static bool check_reserved_words(LEX_STRING *name)
{
  if (!my_strcasecmp(system_charset_info, name->str, "GLOBAL") ||
      !my_strcasecmp(system_charset_info, name->str, "LOCAL") ||
      !my_strcasecmp(system_charset_info, name->str, "SESSION"))
    return true;
  return false;
}

/**
  @brief Push an error message into MySQL error stack with line
  and position information.

  This function provides semantic action implementers with a way
  to push the famous "You have a syntax error near..." error
  message into the error stack, which is normally produced only if
  a parse error is discovered internally by the Bison generated
  parser.
*/

static void my_parse_error(const char *s)
{
  Session *session= current_session;
  Lex_input_stream *lip= session->m_lip;

  const char *yytext= lip->get_tok_start();
  /* Push an error into the error stack */
  my_printf_error(ER_PARSE_ERROR,  ER(ER_PARSE_ERROR), MYF(0), s,
                  (yytext ? yytext : ""),
                  lip->yylineno);
}

/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use DRIZZLE_YYABORT/DRIZZLE_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup.
  In semantic actions, please use my_parse_error or my_error to
  push an error into the error stack and DRIZZLE_YYABORT
  to abort from the parser.
*/

static void DRIZZLEerror(const char *s)
{
  Session *session= current_session;

  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the Session.
  */
  LEX::cleanup_lex_after_parse_error(session);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER(ER_SYNTAX_ERROR);
  my_parse_error(s);
}

/**
  Helper to resolve the SQL:2003 Syntax exception 1) in <in predicate>.
  See SQL:2003, Part 2, section 8.4 <in predicate>, Note 184, page 383.
  This function returns the proper item for the SQL expression
  <code>left [NOT] IN ( expr )</code>
  @param session the current thread
  @param left the in predicand
  @param equal true for IN predicates, false for NOT IN predicates
  @param expr first and only expression of the in value list
  @return an expression representing the IN predicate.
*/
static Item* handle_sql2003_note184_exception(Session *session,
                                              Item* left, bool equal,
                                              Item *expr)
{
  /*
    Relevant references for this issue:
    - SQL:2003, Part 2, section 8.4 <in predicate>, page 383,
    - SQL:2003, Part 2, section 7.2 <row value expression>, page 296,
    - SQL:2003, Part 2, section 6.3 <value expression primary>, page 174,
    - SQL:2003, Part 2, section 7.15 <subquery>, page 370,
    - SQL:2003 Feature F561, "Full value expressions".

    The exception in SQL:2003 Note 184 means:
    Item_singlerow_subselect, which corresponds to a <scalar subquery>,
    should be re-interpreted as an Item_in_subselect, which corresponds
    to a <table subquery> when used inside an <in predicate>.

    Our reading of Note 184 is reccursive, so that all:
    - IN (( <subquery> ))
    - IN ((( <subquery> )))
    - IN '('^N <subquery> ')'^N
    - etc
    should be interpreted as a <table subquery>, no matter how deep in the
    expression the <subquery> is.
  */

  Item *result;

  if (expr->type() == Item::SUBSELECT_ITEM)
  {
    Item_subselect *expr2 = (Item_subselect*) expr;

    if (expr2->substype() == Item_subselect::SINGLEROW_SUBS)
    {
      Item_singlerow_subselect *expr3 = (Item_singlerow_subselect*) expr2;
      Select_Lex *subselect;

      /*
        Implement the mandated change, by altering the semantic tree:
          left IN Item_singlerow_subselect(subselect)
        is modified to
          left IN (subselect)
        which is represented as
          Item_in_subselect(left, subselect)
      */
      subselect= expr3->invalidate_and_restore_select_lex();
      result= new (session->mem_root) Item_in_subselect(left, subselect);

      if (! equal)
        result = negate_expression(session, result);

      return(result);
    }
  }

  if (equal)
    result= new (session->mem_root) Item_func_eq(left, expr);
  else
    result= new (session->mem_root) Item_func_ne(left, expr);

  return(result);
}

/**
   @brief Creates a new Select_Lex for a UNION branch.

   Sets up and initializes a Select_Lex structure for a query once the parser
   discovers a UNION token. The current Select_Lex is pushed on the stack and
   the new Select_Lex becomes the current one..=

   @lex The parser state.

   @is_union_distinct True if the union preceding the new select statement
   uses UNION DISTINCT.

   @return <code>false</code> if successful, <code>true</code> if an error was
   reported. In the latter case parsing should stop.
 */
static bool add_select_to_union_list(LEX *lex, bool is_union_distinct)
{
  if (lex->result)
  {
    /* Only the last SELECT can have  INTO...... */
    my_error(ER_WRONG_USAGE, MYF(0), "UNION", "INTO");
    return true;
  }
  if (lex->current_select->linkage == GLOBAL_OPTIONS_TYPE)
  {
    my_parse_error(ER(ER_SYNTAX_ERROR));
    return true;
  }
  /* This counter shouldn't be incremented for UNION parts */
  lex->nest_level--;
  if (mysql_new_select(lex, 0))
    return true;
  mysql_init_select(lex);
  lex->current_select->linkage=UNION_TYPE;
  if (is_union_distinct) /* UNION DISTINCT - remember position */
    lex->current_select->master_unit()->union_distinct=
      lex->current_select;
  return false;
}

/**
   @brief Initializes a Select_Lex for a query within parentheses (aka
   braces).

   @return false if successful, true if an error was reported. In the latter
   case parsing should stop.
 */
static bool setup_select_in_parentheses(LEX *lex)
{
  Select_Lex * sel= lex->current_select;
  if (sel->set_braces(1))
  {
    my_parse_error(ER(ER_SYNTAX_ERROR));
    return true;
  }
  if (sel->linkage == UNION_TYPE &&
      !sel->master_unit()->first_select()->braces &&
      sel->master_unit()->first_select()->linkage ==
      UNION_TYPE)
  {
    my_parse_error(ER(ER_SYNTAX_ERROR));
    return true;
  }
  if (sel->linkage == UNION_TYPE &&
      sel->olap != UNSPECIFIED_OLAP_TYPE &&
      sel->master_unit()->fake_select_lex)
  {
    my_error(ER_WRONG_USAGE, MYF(0), "CUBE/ROLLUP", "ORDER BY");
    return true;
  }
  /* select in braces, can't contain global parameters */
  if (sel->master_unit()->fake_select_lex)
    sel->master_unit()->global_parameters=
      sel->master_unit()->fake_select_lex;
  return false;
}

static Item* reserved_keyword_function(const std::string &name, List<Item> *item_list)
{
  const plugin::Function *udf= plugin::Function::get(name.c_str(), name.length());
  Item *item= NULL;

  if (udf)
  {
    item= Create_udf_func::s_singleton.create(current_session, udf, item_list);
  } else {
    my_error(ER_SP_DOES_NOT_EXIST, MYF(0), "FUNCTION", name.c_str());
  }

  return item;
}

} /* namespace drizzled; */

using namespace drizzled;


/* Line 189 of yacc.c  */
#line 384 "drizzled/sql_yacc.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ABORT_SYM = 258,
     ACTION = 259,
     ADD = 260,
     ADDDATE_SYM = 261,
     AFTER_SYM = 262,
     AGGREGATE_SYM = 263,
     ALL = 264,
     ALTER = 265,
     ANALYZE_SYM = 266,
     AND_SYM = 267,
     ANY_SYM = 268,
     AS = 269,
     ASC = 270,
     ASENSITIVE_SYM = 271,
     AT_SYM = 272,
     AUTO_INC = 273,
     AVG_ROW_LENGTH = 274,
     AVG_SYM = 275,
     BEFORE_SYM = 276,
     BEGIN_SYM = 277,
     BETWEEN_SYM = 278,
     BIGINT_SYM = 279,
     BINARY = 280,
     BIN_NUM = 281,
     BIT_SYM = 282,
     BLOB_SYM = 283,
     BOOLEAN_SYM = 284,
     BOOL_SYM = 285,
     BOTH = 286,
     BTREE_SYM = 287,
     BY = 288,
     BYTE_SYM = 289,
     CALL_SYM = 290,
     CASCADE = 291,
     CASCADED = 292,
     CASE_SYM = 293,
     CAST_SYM = 294,
     CHAIN_SYM = 295,
     CHANGE = 296,
     CHAR_SYM = 297,
     CHECKSUM_SYM = 298,
     CHECK_SYM = 299,
     CLOSE_SYM = 300,
     COALESCE = 301,
     COLLATE_SYM = 302,
     COLLATION_SYM = 303,
     COLUMNS = 304,
     COLUMN_SYM = 305,
     COMMENT_SYM = 306,
     COMMITTED_SYM = 307,
     COMMIT_SYM = 308,
     COMPACT_SYM = 309,
     COMPRESSED_SYM = 310,
     CONCURRENT = 311,
     CONDITION_SYM = 312,
     CONNECTION_SYM = 313,
     CONSISTENT_SYM = 314,
     CONSTRAINT = 315,
     CONTAINS_SYM = 316,
     CONTINUE_SYM = 317,
     CONVERT_SYM = 318,
     COUNT_SYM = 319,
     CREATE = 320,
     CROSS = 321,
     CUBE_SYM = 322,
     CURDATE = 323,
     CURRENT_USER = 324,
     CURSOR_SYM = 325,
     DATABASE = 326,
     DATABASES = 327,
     DATAFILE_SYM = 328,
     DATA_SYM = 329,
     DATETIME_SYM = 330,
     DATE_ADD_INTERVAL = 331,
     DATE_SUB_INTERVAL = 332,
     DATE_SYM = 333,
     DAY_HOUR_SYM = 334,
     DAY_MICROSECOND_SYM = 335,
     DAY_MINUTE_SYM = 336,
     DAY_SECOND_SYM = 337,
     DAY_SYM = 338,
     DEALLOCATE_SYM = 339,
     DECIMAL_NUM = 340,
     DECIMAL_SYM = 341,
     DECLARE_SYM = 342,
     DEFAULT = 343,
     DELETE_SYM = 344,
     DESC = 345,
     DESCRIBE = 346,
     DETERMINISTIC_SYM = 347,
     DISABLE_SYM = 348,
     DISCARD = 349,
     DISTINCT = 350,
     DIV_SYM = 351,
     DOUBLE_SYM = 352,
     DROP = 353,
     DUMPFILE = 354,
     DUPLICATE_SYM = 355,
     DYNAMIC_SYM = 356,
     EACH_SYM = 357,
     ELSE = 358,
     ELSEIF_SYM = 359,
     ENABLE_SYM = 360,
     ENCLOSED = 361,
     END = 362,
     ENDS_SYM = 363,
     END_OF_INPUT = 364,
     ENGINE_SYM = 365,
     ENUM_SYM = 366,
     EQ = 367,
     EQUAL_SYM = 368,
     ERRORS = 369,
     ESCAPED = 370,
     ESCAPE_SYM = 371,
     EXCLUSIVE_SYM = 372,
     EXISTS = 373,
     EXTENDED_SYM = 374,
     EXTRACT_SYM = 375,
     FALSE_SYM = 376,
     FETCH_SYM = 377,
     COLUMN_FORMAT_SYM = 378,
     FILE_SYM = 379,
     FIRST_SYM = 380,
     FIXED_SYM = 381,
     FLOAT_NUM = 382,
     FLUSH_SYM = 383,
     FORCE_SYM = 384,
     FOREIGN = 385,
     FOR_SYM = 386,
     FOUND_SYM = 387,
     FRAC_SECOND_SYM = 388,
     FROM = 389,
     FULL = 390,
     GE = 391,
     GLOBAL_SYM = 392,
     GROUP_SYM = 393,
     GROUP_CONCAT_SYM = 394,
     GT_SYM = 395,
     HASH_SYM = 396,
     HAVING = 397,
     HEX_NUM = 398,
     HOUR_MICROSECOND_SYM = 399,
     HOUR_MINUTE_SYM = 400,
     HOUR_SECOND_SYM = 401,
     HOUR_SYM = 402,
     IDENT = 403,
     IDENTIFIED_SYM = 404,
     IDENT_QUOTED = 405,
     IF = 406,
     IGNORE_SYM = 407,
     IMPORT = 408,
     INDEXES = 409,
     INDEX_SYM = 410,
     INFILE = 411,
     INNER_SYM = 412,
     INOUT_SYM = 413,
     INSENSITIVE_SYM = 414,
     INSERT = 415,
     INTERVAL_SYM = 416,
     INTO = 417,
     INT_SYM = 418,
     IN_SYM = 419,
     IS = 420,
     ISOLATION = 421,
     ITERATE_SYM = 422,
     JOIN_SYM = 423,
     KEYS = 424,
     KEY_BLOCK_SIZE = 425,
     KEY_SYM = 426,
     KILL_SYM = 427,
     LAST_SYM = 428,
     LE = 429,
     LEADING = 430,
     LEFT = 431,
     LEVEL_SYM = 432,
     LEX_HOSTNAME = 433,
     LIKE = 434,
     LIMIT = 435,
     LINES = 436,
     LIST_SYM = 437,
     LOAD = 438,
     LOCAL_SYM = 439,
     LOCATOR_SYM = 440,
     LOCKS_SYM = 441,
     LOCK_SYM = 442,
     LOGS_SYM = 443,
     LONG_NUM = 444,
     LONG_SYM = 445,
     LOOP_SYM = 446,
     LT = 447,
     MATCH = 448,
     MAX_ROWS = 449,
     MAX_SIZE_SYM = 450,
     MAX_SYM = 451,
     MAX_VALUE_SYM = 452,
     MEDIUM_SYM = 453,
     MERGE_SYM = 454,
     MICROSECOND_SYM = 455,
     MINUTE_MICROSECOND_SYM = 456,
     MINUTE_SECOND_SYM = 457,
     MINUTE_SYM = 458,
     MIN_ROWS = 459,
     MIN_SYM = 460,
     MODE_SYM = 461,
     MODIFIES_SYM = 462,
     MODIFY_SYM = 463,
     MOD_SYM = 464,
     MONTH_SYM = 465,
     NAMES_SYM = 466,
     NAME_SYM = 467,
     NATIONAL_SYM = 468,
     NATURAL = 469,
     NE = 470,
     NEG = 471,
     NEW_SYM = 472,
     NEXT_SYM = 473,
     NONE_SYM = 474,
     NOT_SYM = 475,
     NOW_SYM = 476,
     NO_SYM = 477,
     NULL_SYM = 478,
     NUM = 479,
     NUMERIC_SYM = 480,
     OFFLINE_SYM = 481,
     OFFSET_SYM = 482,
     ON = 483,
     ONE_SHOT_SYM = 484,
     ONE_SYM = 485,
     ONLINE_SYM = 486,
     OPEN_SYM = 487,
     OPTIMIZE = 488,
     OPTION = 489,
     OPTIONALLY = 490,
     ORDER_SYM = 491,
     OR_SYM = 492,
     OUTER = 493,
     OUTFILE = 494,
     OUT_SYM = 495,
     PAGE_SYM = 496,
     PARTIAL = 497,
     PHASE_SYM = 498,
     POSITION_SYM = 499,
     PRECISION = 500,
     PREV_SYM = 501,
     PRIMARY_SYM = 502,
     PROCESS = 503,
     PROCESSLIST_SYM = 504,
     QUARTER_SYM = 505,
     QUERY_SYM = 506,
     RANGE_SYM = 507,
     READS_SYM = 508,
     READ_ONLY_SYM = 509,
     READ_SYM = 510,
     READ_WRITE_SYM = 511,
     REAL = 512,
     REDUNDANT_SYM = 513,
     REFERENCES = 514,
     RELEASE_SYM = 515,
     RENAME = 516,
     REPEATABLE_SYM = 517,
     REPEAT_SYM = 518,
     REPLACE = 519,
     RESTRICT = 520,
     RETURNS_SYM = 521,
     RETURN_SYM = 522,
     REVERSE_SYM = 523,
     REVOKE = 524,
     RIGHT = 525,
     ROLLBACK_SYM = 526,
     ROLLUP_SYM = 527,
     ROUTINE_SYM = 528,
     ROWS_SYM = 529,
     ROW_FORMAT_SYM = 530,
     ROW_SYM = 531,
     SAVEPOINT_SYM = 532,
     SECOND_MICROSECOND_SYM = 533,
     SECOND_SYM = 534,
     SECURITY_SYM = 535,
     SELECT_SYM = 536,
     SENSITIVE_SYM = 537,
     SEPARATOR_SYM = 538,
     SERIALIZABLE_SYM = 539,
     SERIAL_SYM = 540,
     SESSION_SYM = 541,
     SERVER_SYM = 542,
     SERVER_OPTIONS = 543,
     SET = 544,
     SET_VAR = 545,
     SHARE_SYM = 546,
     SHOW = 547,
     SHUTDOWN = 548,
     SIMPLE_SYM = 549,
     SNAPSHOT_SYM = 550,
     SPECIFIC_SYM = 551,
     SQLEXCEPTION_SYM = 552,
     SQLSTATE_SYM = 553,
     SQLWARNING_SYM = 554,
     SQL_BIG_RESULT = 555,
     SQL_BUFFER_RESULT = 556,
     SQL_CALC_FOUND_ROWS = 557,
     SQL_SMALL_RESULT = 558,
     SQL_SYM = 559,
     STARTING = 560,
     START_SYM = 561,
     STATUS_SYM = 562,
     STDDEV_SAMP_SYM = 563,
     STD_SYM = 564,
     STOP_SYM = 565,
     STORAGE_SYM = 566,
     STORED_SYM = 567,
     STRAIGHT_JOIN = 568,
     STRING_SYM = 569,
     SUBDATE_SYM = 570,
     SUBJECT_SYM = 571,
     SUBSTRING = 572,
     SUM_SYM = 573,
     SUSPEND_SYM = 574,
     SWAPS_SYM = 575,
     SWITCHES_SYM = 576,
     SYSDATE = 577,
     TABLES = 578,
     TABLESPACE = 579,
     TABLE_REF_PRIORITY = 580,
     TABLE_SYM = 581,
     TEMPORARY_SYM = 582,
     TERMINATED = 583,
     TEXT_STRING = 584,
     TEXT_SYM = 585,
     THEN_SYM = 586,
     TIMESTAMP_SYM = 587,
     TIMESTAMP_ADD = 588,
     TIMESTAMP_DIFF = 589,
     TO_SYM = 590,
     TRAILING = 591,
     TRANSACTION_SYM = 592,
     TRIM = 593,
     TRUE_SYM = 594,
     TRUNCATE_SYM = 595,
     TYPES_SYM = 596,
     TYPE_SYM = 597,
     ULONGLONG_NUM = 598,
     UNCOMMITTED_SYM = 599,
     UNDOFILE_SYM = 600,
     UNDO_SYM = 601,
     UNION_SYM = 602,
     UNIQUE_SYM = 603,
     UNKNOWN_SYM = 604,
     UNLOCK_SYM = 605,
     UPDATE_SYM = 606,
     USAGE = 607,
     USER = 608,
     USE_SYM = 609,
     USING = 610,
     UTC_DATE_SYM = 611,
     UTC_TIMESTAMP_SYM = 612,
     VALUES = 613,
     VALUE_SYM = 614,
     VARBINARY = 615,
     VARCHAR_SYM = 616,
     VARIABLES = 617,
     VARIANCE_SYM = 618,
     VARYING = 619,
     VAR_SAMP_SYM = 620,
     WARNINGS = 621,
     WEEK_SYM = 622,
     WHEN_SYM = 623,
     WHERE = 624,
     WITH = 625,
     WITH_ROLLUP_SYM = 626,
     WORK_SYM = 627,
     WRITE_SYM = 628,
     XOR = 629,
     YEAR_MONTH_SYM = 630,
     YEAR_SYM = 631
   };
#endif
/* Tokens.  */
#define ABORT_SYM 258
#define ACTION 259
#define ADD 260
#define ADDDATE_SYM 261
#define AFTER_SYM 262
#define AGGREGATE_SYM 263
#define ALL 264
#define ALTER 265
#define ANALYZE_SYM 266
#define AND_SYM 267
#define ANY_SYM 268
#define AS 269
#define ASC 270
#define ASENSITIVE_SYM 271
#define AT_SYM 272
#define AUTO_INC 273
#define AVG_ROW_LENGTH 274
#define AVG_SYM 275
#define BEFORE_SYM 276
#define BEGIN_SYM 277
#define BETWEEN_SYM 278
#define BIGINT_SYM 279
#define BINARY 280
#define BIN_NUM 281
#define BIT_SYM 282
#define BLOB_SYM 283
#define BOOLEAN_SYM 284
#define BOOL_SYM 285
#define BOTH 286
#define BTREE_SYM 287
#define BY 288
#define BYTE_SYM 289
#define CALL_SYM 290
#define CASCADE 291
#define CASCADED 292
#define CASE_SYM 293
#define CAST_SYM 294
#define CHAIN_SYM 295
#define CHANGE 296
#define CHAR_SYM 297
#define CHECKSUM_SYM 298
#define CHECK_SYM 299
#define CLOSE_SYM 300
#define COALESCE 301
#define COLLATE_SYM 302
#define COLLATION_SYM 303
#define COLUMNS 304
#define COLUMN_SYM 305
#define COMMENT_SYM 306
#define COMMITTED_SYM 307
#define COMMIT_SYM 308
#define COMPACT_SYM 309
#define COMPRESSED_SYM 310
#define CONCURRENT 311
#define CONDITION_SYM 312
#define CONNECTION_SYM 313
#define CONSISTENT_SYM 314
#define CONSTRAINT 315
#define CONTAINS_SYM 316
#define CONTINUE_SYM 317
#define CONVERT_SYM 318
#define COUNT_SYM 319
#define CREATE 320
#define CROSS 321
#define CUBE_SYM 322
#define CURDATE 323
#define CURRENT_USER 324
#define CURSOR_SYM 325
#define DATABASE 326
#define DATABASES 327
#define DATAFILE_SYM 328
#define DATA_SYM 329
#define DATETIME_SYM 330
#define DATE_ADD_INTERVAL 331
#define DATE_SUB_INTERVAL 332
#define DATE_SYM 333
#define DAY_HOUR_SYM 334
#define DAY_MICROSECOND_SYM 335
#define DAY_MINUTE_SYM 336
#define DAY_SECOND_SYM 337
#define DAY_SYM 338
#define DEALLOCATE_SYM 339
#define DECIMAL_NUM 340
#define DECIMAL_SYM 341
#define DECLARE_SYM 342
#define DEFAULT 343
#define DELETE_SYM 344
#define DESC 345
#define DESCRIBE 346
#define DETERMINISTIC_SYM 347
#define DISABLE_SYM 348
#define DISCARD 349
#define DISTINCT 350
#define DIV_SYM 351
#define DOUBLE_SYM 352
#define DROP 353
#define DUMPFILE 354
#define DUPLICATE_SYM 355
#define DYNAMIC_SYM 356
#define EACH_SYM 357
#define ELSE 358
#define ELSEIF_SYM 359
#define ENABLE_SYM 360
#define ENCLOSED 361
#define END 362
#define ENDS_SYM 363
#define END_OF_INPUT 364
#define ENGINE_SYM 365
#define ENUM_SYM 366
#define EQ 367
#define EQUAL_SYM 368
#define ERRORS 369
#define ESCAPED 370
#define ESCAPE_SYM 371
#define EXCLUSIVE_SYM 372
#define EXISTS 373
#define EXTENDED_SYM 374
#define EXTRACT_SYM 375
#define FALSE_SYM 376
#define FETCH_SYM 377
#define COLUMN_FORMAT_SYM 378
#define FILE_SYM 379
#define FIRST_SYM 380
#define FIXED_SYM 381
#define FLOAT_NUM 382
#define FLUSH_SYM 383
#define FORCE_SYM 384
#define FOREIGN 385
#define FOR_SYM 386
#define FOUND_SYM 387
#define FRAC_SECOND_SYM 388
#define FROM 389
#define FULL 390
#define GE 391
#define GLOBAL_SYM 392
#define GROUP_SYM 393
#define GROUP_CONCAT_SYM 394
#define GT_SYM 395
#define HASH_SYM 396
#define HAVING 397
#define HEX_NUM 398
#define HOUR_MICROSECOND_SYM 399
#define HOUR_MINUTE_SYM 400
#define HOUR_SECOND_SYM 401
#define HOUR_SYM 402
#define IDENT 403
#define IDENTIFIED_SYM 404
#define IDENT_QUOTED 405
#define IF 406
#define IGNORE_SYM 407
#define IMPORT 408
#define INDEXES 409
#define INDEX_SYM 410
#define INFILE 411
#define INNER_SYM 412
#define INOUT_SYM 413
#define INSENSITIVE_SYM 414
#define INSERT 415
#define INTERVAL_SYM 416
#define INTO 417
#define INT_SYM 418
#define IN_SYM 419
#define IS 420
#define ISOLATION 421
#define ITERATE_SYM 422
#define JOIN_SYM 423
#define KEYS 424
#define KEY_BLOCK_SIZE 425
#define KEY_SYM 426
#define KILL_SYM 427
#define LAST_SYM 428
#define LE 429
#define LEADING 430
#define LEFT 431
#define LEVEL_SYM 432
#define LEX_HOSTNAME 433
#define LIKE 434
#define LIMIT 435
#define LINES 436
#define LIST_SYM 437
#define LOAD 438
#define LOCAL_SYM 439
#define LOCATOR_SYM 440
#define LOCKS_SYM 441
#define LOCK_SYM 442
#define LOGS_SYM 443
#define LONG_NUM 444
#define LONG_SYM 445
#define LOOP_SYM 446
#define LT 447
#define MATCH 448
#define MAX_ROWS 449
#define MAX_SIZE_SYM 450
#define MAX_SYM 451
#define MAX_VALUE_SYM 452
#define MEDIUM_SYM 453
#define MERGE_SYM 454
#define MICROSECOND_SYM 455
#define MINUTE_MICROSECOND_SYM 456
#define MINUTE_SECOND_SYM 457
#define MINUTE_SYM 458
#define MIN_ROWS 459
#define MIN_SYM 460
#define MODE_SYM 461
#define MODIFIES_SYM 462
#define MODIFY_SYM 463
#define MOD_SYM 464
#define MONTH_SYM 465
#define NAMES_SYM 466
#define NAME_SYM 467
#define NATIONAL_SYM 468
#define NATURAL 469
#define NE 470
#define NEG 471
#define NEW_SYM 472
#define NEXT_SYM 473
#define NONE_SYM 474
#define NOT_SYM 475
#define NOW_SYM 476
#define NO_SYM 477
#define NULL_SYM 478
#define NUM 479
#define NUMERIC_SYM 480
#define OFFLINE_SYM 481
#define OFFSET_SYM 482
#define ON 483
#define ONE_SHOT_SYM 484
#define ONE_SYM 485
#define ONLINE_SYM 486
#define OPEN_SYM 487
#define OPTIMIZE 488
#define OPTION 489
#define OPTIONALLY 490
#define ORDER_SYM 491
#define OR_SYM 492
#define OUTER 493
#define OUTFILE 494
#define OUT_SYM 495
#define PAGE_SYM 496
#define PARTIAL 497
#define PHASE_SYM 498
#define POSITION_SYM 499
#define PRECISION 500
#define PREV_SYM 501
#define PRIMARY_SYM 502
#define PROCESS 503
#define PROCESSLIST_SYM 504
#define QUARTER_SYM 505
#define QUERY_SYM 506
#define RANGE_SYM 507
#define READS_SYM 508
#define READ_ONLY_SYM 509
#define READ_SYM 510
#define READ_WRITE_SYM 511
#define REAL 512
#define REDUNDANT_SYM 513
#define REFERENCES 514
#define RELEASE_SYM 515
#define RENAME 516
#define REPEATABLE_SYM 517
#define REPEAT_SYM 518
#define REPLACE 519
#define RESTRICT 520
#define RETURNS_SYM 521
#define RETURN_SYM 522
#define REVERSE_SYM 523
#define REVOKE 524
#define RIGHT 525
#define ROLLBACK_SYM 526
#define ROLLUP_SYM 527
#define ROUTINE_SYM 528
#define ROWS_SYM 529
#define ROW_FORMAT_SYM 530
#define ROW_SYM 531
#define SAVEPOINT_SYM 532
#define SECOND_MICROSECOND_SYM 533
#define SECOND_SYM 534
#define SECURITY_SYM 535
#define SELECT_SYM 536
#define SENSITIVE_SYM 537
#define SEPARATOR_SYM 538
#define SERIALIZABLE_SYM 539
#define SERIAL_SYM 540
#define SESSION_SYM 541
#define SERVER_SYM 542
#define SERVER_OPTIONS 543
#define SET 544
#define SET_VAR 545
#define SHARE_SYM 546
#define SHOW 547
#define SHUTDOWN 548
#define SIMPLE_SYM 549
#define SNAPSHOT_SYM 550
#define SPECIFIC_SYM 551
#define SQLEXCEPTION_SYM 552
#define SQLSTATE_SYM 553
#define SQLWARNING_SYM 554
#define SQL_BIG_RESULT 555
#define SQL_BUFFER_RESULT 556
#define SQL_CALC_FOUND_ROWS 557
#define SQL_SMALL_RESULT 558
#define SQL_SYM 559
#define STARTING 560
#define START_SYM 561
#define STATUS_SYM 562
#define STDDEV_SAMP_SYM 563
#define STD_SYM 564
#define STOP_SYM 565
#define STORAGE_SYM 566
#define STORED_SYM 567
#define STRAIGHT_JOIN 568
#define STRING_SYM 569
#define SUBDATE_SYM 570
#define SUBJECT_SYM 571
#define SUBSTRING 572
#define SUM_SYM 573
#define SUSPEND_SYM 574
#define SWAPS_SYM 575
#define SWITCHES_SYM 576
#define SYSDATE 577
#define TABLES 578
#define TABLESPACE 579
#define TABLE_REF_PRIORITY 580
#define TABLE_SYM 581
#define TEMPORARY_SYM 582
#define TERMINATED 583
#define TEXT_STRING 584
#define TEXT_SYM 585
#define THEN_SYM 586
#define TIMESTAMP_SYM 587
#define TIMESTAMP_ADD 588
#define TIMESTAMP_DIFF 589
#define TO_SYM 590
#define TRAILING 591
#define TRANSACTION_SYM 592
#define TRIM 593
#define TRUE_SYM 594
#define TRUNCATE_SYM 595
#define TYPES_SYM 596
#define TYPE_SYM 597
#define ULONGLONG_NUM 598
#define UNCOMMITTED_SYM 599
#define UNDOFILE_SYM 600
#define UNDO_SYM 601
#define UNION_SYM 602
#define UNIQUE_SYM 603
#define UNKNOWN_SYM 604
#define UNLOCK_SYM 605
#define UPDATE_SYM 606
#define USAGE 607
#define USER 608
#define USE_SYM 609
#define USING 610
#define UTC_DATE_SYM 611
#define UTC_TIMESTAMP_SYM 612
#define VALUES 613
#define VALUE_SYM 614
#define VARBINARY 615
#define VARCHAR_SYM 616
#define VARIABLES 617
#define VARIANCE_SYM 618
#define VARYING 619
#define VAR_SAMP_SYM 620
#define WARNINGS 621
#define WEEK_SYM 622
#define WHEN_SYM 623
#define WHERE 624
#define WITH 625
#define WITH_ROLLUP_SYM 626
#define WORK_SYM 627
#define WRITE_SYM 628
#define XOR 629
#define YEAR_MONTH_SYM 630
#define YEAR_SYM 631




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 324 "sql_yacc.yy"

  int  num;
  ulong ulong_num;
  uint64_t ulonglong_number;
  int64_t longlong_number;
  drizzled::LEX_STRING lex_str;
  drizzled::LEX_STRING *lex_str_ptr;
  drizzled::LEX_SYMBOL symbol;
  drizzled::Table_ident *table;
  char *simple_string;
  drizzled::Item *item;
  drizzled::Item_num *item_num;
  drizzled::List<drizzled::Item> *item_list;
  drizzled::List<drizzled::String> *string_list;
  drizzled::String *string;
  drizzled::Key_part_spec *key_part;
  const drizzled::plugin::Function *udf;
  drizzled::TableList *table_list;
  struct drizzled::sys_var_with_base variable;
  enum drizzled::sql_var_t var_type;
  drizzled::Key::Keytype key_type;
  enum drizzled::ha_key_alg key_alg;
  enum drizzled::row_type row_type;
  enum drizzled::column_format_type column_format_type;
  enum drizzled::ha_rkey_function ha_rkey_mode;
  enum drizzled::enum_tx_isolation tx_isolation;
  enum drizzled::Cast_target cast_type;
  const drizzled::CHARSET_INFO *charset;
  drizzled::thr_lock_type lock_type;
  drizzled::interval_type interval, interval_time_st;
  enum drizzled::enum_drizzle_timestamp_type date_time_type;
  drizzled::Select_Lex *select_lex;
  drizzled::chooser_compare_func_creator boolfunc2creator;
  struct drizzled::st_lex *lex;
  enum drizzled::index_hint_type index_hint;
  enum drizzled::enum_filetype filetype;
  enum drizzled::ha_build_method build_method;
  enum drizzled::Foreign_key::fk_option m_fk_option;



/* Line 214 of yacc.c  */
#line 1214 "drizzled/sql_yacc.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */

/* Line 264 of yacc.c  */
#line 364 "sql_yacc.yy"

namespace drizzled
{
bool my_yyoverflow(short **a, YYSTYPE **b, ulong *yystacksize);
}


/* Line 264 of yacc.c  */
#line 1234 "drizzled/sql_yacc.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  275
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   20494

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  390
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  401
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1128
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1944

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   631

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   385,     2,     2,     2,   381,     2,     2,
     382,   383,   379,   378,   384,   377,   388,   380,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   389,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   386,     2,   387,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    42,    44,    46,    48,    50,    52,    54,    56,    58,
      60,    62,    63,    71,    72,    86,    87,    94,    97,   100,
     104,   109,   114,   115,   120,   121,   122,   128,   129,   137,
     138,   139,   146,   147,   149,   150,   152,   154,   156,   160,
     162,   166,   170,   171,   173,   174,   178,   179,   181,   183,
     186,   188,   191,   195,   197,   201,   205,   209,   213,   217,
     219,   224,   229,   231,   233,   235,   237,   240,   242,   246,
     248,   250,   253,   256,   264,   273,   282,   285,   288,   289,
     291,   294,   295,   297,   300,   301,   305,   308,   310,   313,
     318,   320,   325,   330,   332,   334,   336,   338,   340,   343,
     346,   349,   350,   356,   358,   360,   363,   365,   367,   369,
     371,   373,   376,   377,   381,   383,   389,   390,   394,   395,
     397,   398,   400,   403,   405,   407,   410,   413,   416,   421,
     423,   427,   430,   432,   435,   438,   441,   444,   446,   448,
     450,   452,   453,   455,   456,   458,   464,   465,   469,   473,
     475,   476,   479,   482,   485,   486,   490,   494,   501,   508,
     510,   512,   515,   518,   521,   523,   526,   529,   531,   533,
     534,   536,   538,   540,   542,   543,   545,   546,   548,   551,
     552,   554,   556,   559,   562,   565,   567,   571,   574,   576,
     578,   583,   586,   588,   593,   594,   596,   597,   600,   602,
     606,   607,   615,   616,   622,   623,   625,   626,   629,   632,
     634,   635,   637,   639,   641,   645,   648,   652,   655,   660,
     661,   668,   669,   670,   678,   682,   687,   691,   695,   698,
     701,   708,   714,   718,   722,   724,   726,   728,   729,   731,
     732,   734,   735,   738,   740,   741,   743,   745,   747,   751,
     752,   756,   757,   762,   763,   768,   769,   774,   776,   780,
     784,   786,   789,   794,   797,   801,   804,   808,   809,   813,
     814,   815,   822,   825,   827,   829,   832,   835,   843,   844,
     846,   849,   851,   853,   855,   857,   859,   861,   863,   865,
     866,   869,   874,   878,   880,   882,   886,   891,   892,   893,
     894,   897,   900,   902,   904,   905,   908,   912,   916,   920,
     923,   927,   932,   936,   941,   945,   950,   952,   956,   961,
     965,   969,   976,   978,   984,   991,   997,  1005,  1012,  1021,
    1027,  1034,  1039,  1045,  1047,  1051,  1055,  1061,  1067,  1071,
    1075,  1079,  1083,  1087,  1089,  1091,  1093,  1095,  1097,  1099,
    1101,  1103,  1105,  1107,  1109,  1111,  1113,  1115,  1117,  1119,
    1121,  1125,  1127,  1129,  1131,  1134,  1137,  1141,  1145,  1151,
    1158,  1163,  1168,  1171,  1178,  1184,  1191,  1196,  1201,  1207,
    1212,  1215,  1220,  1225,  1230,  1241,  1248,  1257,  1264,  1269,
    1274,  1281,  1286,  1291,  1296,  1304,  1312,  1320,  1327,  1334,
    1341,  1348,  1352,  1357,  1364,  1373,  1376,  1385,  1394,  1401,
    1404,  1409,  1416,  1423,  1432,  1441,  1448,  1457,  1464,  1467,
    1472,  1481,  1490,  1493,  1496,  1501,  1506,  1510,  1519,  1524,
    1531,  1536,  1543,  1552,  1557,  1564,  1565,  1571,  1572,  1574,
    1576,  1580,  1585,  1590,  1596,  1602,  1607,  1608,  1609,  1617,
    1622,  1628,  1633,  1639,  1644,  1649,  1654,  1659,  1664,  1670,
    1671,  1680,  1681,  1685,  1689,  1691,  1696,  1697,  1699,  1700,
    1703,  1704,  1706,  1707,  1711,  1714,  1717,  1719,  1721,  1724,
    1726,  1730,  1731,  1733,  1734,  1737,  1742,  1748,  1750,  1752,
    1754,  1756,  1761,  1763,  1767,  1771,  1775,  1776,  1783,  1784,
    1791,  1792,  1801,  1806,  1807,  1816,  1817,  1828,  1835,  1836,
    1845,  1846,  1857,  1864,  1866,  1869,  1872,  1873,  1878,  1882,
    1888,  1892,  1893,  1894,  1903,  1905,  1906,  1907,  1914,  1915,
    1919,  1920,  1921,  1927,  1928,  1930,  1931,  1933,  1934,  1937,
    1941,  1945,  1947,  1949,  1950,  1958,  1959,  1967,  1969,  1972,
    1973,  1974,  1977,  1978,  1981,  1982,  1984,  1986,  1988,  1990,
    1994,  1996,  2000,  2002,  2004,  2006,  2008,  2010,  2012,  2014,
    2016,  2018,  2020,  2022,  2024,  2026,  2028,  2030,  2032,  2034,
    2036,  2038,  2040,  2042,  2044,  2046,  2047,  2049,  2051,  2052,
    2055,  2056,  2058,  2059,  2060,  2064,  2065,  2066,  2070,  2073,
    2074,  2075,  2080,  2085,  2088,  2089,  2091,  2095,  2099,  2101,
    2104,  2105,  2107,  2108,  2113,  2118,  2121,  2122,  2124,  2126,
    2127,  2129,  2130,  2132,  2135,  2137,  2141,  2145,  2147,  2149,
    2151,  2152,  2155,  2157,  2159,  2161,  2163,  2165,  2167,  2169,
    2171,  2173,  2175,  2177,  2178,  2181,  2185,  2187,  2190,  2191,
    2195,  2196,  2202,  2205,  2207,  2213,  2214,  2222,  2227,  2229,
    2233,  2235,  2236,  2239,  2240,  2242,  2243,  2244,  2252,  2253,
    2254,  2260,  2263,  2265,  2267,  2269,  2273,  2278,  2279,  2283,
    2287,  2289,  2292,  2295,  2296,  2300,  2301,  2307,  2311,  2313,
    2317,  2319,  2323,  2325,  2327,  2328,  2330,  2331,  2336,  2337,
    2339,  2343,  2345,  2347,  2349,  2350,  2351,  2358,  2359,  2360,
    2371,  2375,  2377,  2381,  2385,  2387,  2391,  2392,  2397,  2398,
    2405,  2406,  2409,  2411,  2415,  2416,  2418,  2419,  2423,  2426,
    2430,  2434,  2439,  2445,  2451,  2457,  2463,  2466,  2469,  2473,
    2475,  2479,  2484,  2488,  2489,  2492,  2494,  2496,  2497,  2500,
    2503,  2504,  2509,  2510,  2515,  2517,  2519,  2520,  2522,  2523,
    2525,  2527,  2528,  2532,  2536,  2538,  2539,  2543,  2548,  2550,
    2552,  2553,  2555,  2559,  2560,  2562,  2564,  2567,  2568,  2569,
    2570,  2571,  2590,  2592,  2593,  2595,  2596,  2598,  2600,  2601,
    2604,  2607,  2609,  2613,  2618,  2622,  2626,  2627,  2630,  2633,
    2635,  2639,  2643,  2644,  2648,  2650,  2652,  2653,  2657,  2660,
    2664,  2666,  2668,  2671,  2672,  2675,  2677,  2680,  2682,  2684,
    2686,  2688,  2691,  2694,  2696,  2698,  2700,  2702,  2704,  2706,
    2708,  2711,  2714,  2716,  2718,  2720,  2722,  2724,  2726,  2728,
    2732,  2738,  2740,  2742,  2744,  2746,  2748,  2752,  2757,  2763,
    2765,  2771,  2775,  2778,  2780,  2784,  2787,  2789,  2791,  2793,
    2795,  2797,  2799,  2801,  2803,  2805,  2807,  2809,  2811,  2813,
    2815,  2817,  2819,  2821,  2823,  2825,  2827,  2829,  2831,  2833,
    2835,  2837,  2839,  2841,  2843,  2845,  2847,  2849,  2851,  2853,
    2855,  2857,  2859,  2861,  2863,  2865,  2867,  2869,  2871,  2873,
    2875,  2877,  2879,  2881,  2883,  2885,  2887,  2889,  2891,  2893,
    2895,  2897,  2899,  2901,  2903,  2905,  2907,  2909,  2911,  2913,
    2915,  2917,  2919,  2921,  2923,  2925,  2927,  2929,  2931,  2933,
    2935,  2937,  2939,  2941,  2943,  2945,  2947,  2949,  2951,  2953,
    2955,  2957,  2959,  2961,  2963,  2965,  2967,  2969,  2971,  2973,
    2975,  2977,  2979,  2981,  2983,  2985,  2987,  2989,  2991,  2993,
    2995,  2997,  2999,  3001,  3003,  3005,  3007,  3009,  3011,  3013,
    3015,  3017,  3019,  3021,  3023,  3025,  3027,  3029,  3031,  3033,
    3035,  3037,  3039,  3041,  3043,  3045,  3047,  3049,  3051,  3053,
    3055,  3057,  3059,  3061,  3063,  3065,  3067,  3069,  3071,  3073,
    3075,  3077,  3079,  3081,  3083,  3085,  3087,  3089,  3091,  3093,
    3095,  3097,  3099,  3101,  3103,  3105,  3107,  3109,  3111,  3113,
    3115,  3117,  3119,  3121,  3123,  3125,  3127,  3129,  3131,  3132,
    3137,  3138,  3140,  3142,  3146,  3147,  3150,  3152,  3154,  3156,
    3158,  3159,  3161,  3162,  3164,  3166,  3168,  3169,  3172,  3175,
    3178,  3180,  3183,  3188,  3194,  3199,  3206,  3208,  3211,  3214,
    3217,  3219,  3221,  3223,  3225,  3227,  3229,  3231,  3233,  3234,
    3238,  3239,  3243,  3244,  3246,  3247,  3251,  3254,  3255,  3257,
    3260,  3261,  3263,  3268,  3273,  3279,  3282,  3286,  3287,  3289,
    3290,  3295,  3296,  3298,  3300,  3301,  3304,  3307,  3309,  3310,
    3312,  3314,  3317,  3321,  3323,  3324,  3330,  3334,  3335
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     391,     0,    -1,   109,    -1,   392,   109,    -1,   393,    -1,
     767,    -1,   475,    -1,   493,    -1,   495,    -1,   773,    -1,
     394,    -1,   678,    -1,   692,    -1,   639,    -1,   698,    -1,
     645,    -1,   704,    -1,   707,    -1,   776,    -1,   497,    -1,
     648,    -1,   774,    -1,   775,    -1,   501,    -1,   748,    -1,
     686,    -1,   491,    -1,   684,    -1,   765,    -1,   671,    -1,
     706,    -1,    -1,    65,   411,   326,   412,   739,   395,   398,
      -1,    -1,    65,   480,   396,   462,   155,   744,   464,   228,
     739,   382,   470,   383,   465,    -1,    -1,    65,    71,   412,
     744,   397,   408,    -1,   382,   399,    -1,   413,   401,    -1,
     179,   739,   413,    -1,   382,   179,   739,   383,    -1,   422,
     383,   413,   401,    -1,    -1,   404,   383,   400,   780,    -1,
      -1,    -1,   714,   407,   404,   402,   777,    -1,    -1,   714,
     407,   382,   404,   383,   403,   780,    -1,    -1,    -1,   281,
     405,   512,   516,   406,   421,    -1,    -1,    14,    -1,    -1,
     419,    -1,   409,    -1,   410,    -1,   410,   384,   409,    -1,
     745,    -1,   745,   662,   745,    -1,   745,   662,   630,    -1,
      -1,   327,    -1,    -1,   151,   528,   118,    -1,    -1,   415,
      -1,   416,    -1,   416,   414,    -1,   416,    -1,   416,   415,
      -1,   416,   384,   415,    -1,   417,    -1,   110,   662,   745,
      -1,    51,   663,   741,    -1,    18,   663,   630,    -1,   745,
     662,   745,    -1,   745,   662,   630,    -1,   418,    -1,   449,
      47,   663,   448,    -1,   449,    47,   663,   448,    -1,    88,
      -1,   126,    -1,   101,    -1,   624,    -1,   511,   515,    -1,
     423,    -1,   422,   384,   423,    -1,   424,    -1,   425,    -1,
     430,   426,    -1,   430,   451,    -1,   457,   472,   464,   382,
     470,   383,   465,    -1,   428,   458,   472,   464,   382,   470,
     383,   465,    -1,   428,   130,   171,   472,   382,   470,   383,
     451,    -1,   429,   426,    -1,   428,   427,    -1,    -1,   427,
      -1,    44,   522,    -1,    -1,   429,    -1,    60,   472,    -1,
      -1,   738,   431,   432,    -1,   433,   443,    -1,   437,    -1,
     438,   442,    -1,   435,   382,   224,   383,    -1,   435,    -1,
     436,   382,   224,   383,    -1,   360,   382,   224,   383,    -1,
      78,    -1,   332,    -1,    75,    -1,    28,    -1,   330,    -1,
      86,   439,    -1,   225,   439,    -1,   126,   439,    -1,    -1,
     111,   434,   382,   474,   383,    -1,   285,    -1,    42,    -1,
     435,   364,    -1,   361,    -1,   163,    -1,    24,    -1,   257,
      -1,    97,    -1,    97,   245,    -1,    -1,   382,   224,   383,
      -1,   440,    -1,   382,   224,   384,   224,   383,    -1,    -1,
     382,   224,   383,    -1,    -1,   440,    -1,    -1,   444,    -1,
     444,   445,    -1,   445,    -1,   223,    -1,   123,   420,    -1,
     528,   223,    -1,    88,   446,    -1,   228,   351,   221,   521,
      -1,    18,    -1,   285,    88,   359,    -1,   450,   171,    -1,
     348,    -1,   348,   171,    -1,    51,   741,    -1,    47,   447,
      -1,   221,   521,    -1,   729,    -1,   745,    -1,   447,    -1,
      88,    -1,    -1,    88,    -1,    -1,   247,    -1,   259,   739,
     452,   454,   455,    -1,    -1,   382,   453,   383,    -1,   453,
     384,   744,    -1,   744,    -1,    -1,   193,   135,    -1,   193,
     242,    -1,   193,   294,    -1,    -1,   228,   351,   456,    -1,
     228,    89,   456,    -1,   228,   351,   456,   228,    89,   456,
      -1,   228,    89,   456,   228,   351,   456,    -1,   265,    -1,
      36,    -1,   289,   223,    -1,   222,     4,    -1,   289,    88,
      -1,   459,    -1,   247,   171,    -1,   348,   460,    -1,   171,
      -1,   155,    -1,    -1,   459,    -1,   169,    -1,   155,    -1,
     154,    -1,    -1,   348,    -1,    -1,   463,    -1,   463,   467,
      -1,    -1,   466,    -1,   468,    -1,   466,   468,    -1,   355,
     469,    -1,   342,   469,    -1,   467,    -1,   170,   663,   629,
      -1,    51,   741,    -1,    32,    -1,   141,    -1,   470,   384,
     471,   622,    -1,   471,   622,    -1,   744,    -1,   744,   382,
     224,   383,    -1,    -1,   738,    -1,    -1,   388,   744,    -1,
     728,    -1,   474,   384,   728,    -1,    -1,    10,   480,   488,
     326,   739,   476,   479,    -1,    -1,    10,    71,   478,   477,
     419,    -1,    -1,   744,    -1,    -1,    94,   324,    -1,   153,
     324,    -1,   481,    -1,    -1,   231,    -1,   226,    -1,   483,
      -1,   481,   384,   483,    -1,     5,   487,    -1,   482,   424,
     489,    -1,     5,   425,    -1,   482,   382,   422,   383,    -1,
      -1,    41,   487,   738,   484,   430,   489,    -1,    -1,    -1,
     208,   487,   738,   485,   432,   486,   489,    -1,    98,   487,
     738,    -1,    98,   130,   171,   472,    -1,    98,   247,   171,
      -1,    98,   459,   738,    -1,    93,   169,    -1,   105,   169,
      -1,    10,   487,   738,   289,    88,   729,    -1,    10,   487,
     738,    98,    88,    -1,   261,   490,   739,    -1,    63,   335,
     448,    -1,   414,    -1,   129,    -1,   615,    -1,    -1,    50,
      -1,    -1,   152,    -1,    -1,     7,   744,    -1,   125,    -1,
      -1,   335,    -1,   112,    -1,    14,    -1,   306,   337,   492,
      -1,    -1,   370,    59,   295,    -1,    -1,    11,   764,   494,
     641,    -1,    -1,    44,   764,   496,   641,    -1,    -1,   261,
     764,   498,   499,    -1,   500,    -1,   499,   384,   500,    -1,
     739,   335,   739,    -1,   502,    -1,   281,   505,    -1,   382,
     503,   383,   780,    -1,   281,   507,    -1,   382,   503,   383,
      -1,   281,   576,    -1,   382,   504,   383,    -1,    -1,   507,
     506,   777,    -1,    -1,    -1,   508,   512,   516,   509,   510,
     515,    -1,   618,   624,    -1,   635,    -1,   511,    -1,   635,
     511,    -1,   511,   635,    -1,   134,   558,   607,   612,   609,
     618,   624,    -1,    -1,   513,    -1,   513,   514,    -1,   514,
      -1,   313,    -1,    95,    -1,   303,    -1,   300,    -1,   301,
      -1,   302,    -1,     9,    -1,    -1,   131,   351,    -1,   187,
     164,   291,   206,    -1,   516,   384,   517,    -1,   517,    -1,
     379,    -1,   518,   733,   519,    -1,   518,   522,   519,   520,
      -1,    -1,    -1,    -1,    14,   744,    -1,    14,   741,    -1,
     744,    -1,   741,    -1,    -1,   382,   383,    -1,   522,   526,
     522,    -1,   522,   374,   522,    -1,   522,   527,   522,    -1,
     220,   522,    -1,   523,   165,   339,    -1,   523,   165,   528,
     339,    -1,   523,   165,   121,    -1,   523,   165,   528,   121,
      -1,   523,   165,   349,    -1,   523,   165,   528,   349,    -1,
     523,    -1,   523,   165,   223,    -1,   523,   165,   528,   223,
      -1,   523,   113,   524,    -1,   523,   529,   524,    -1,   523,
     529,   530,   382,   788,   383,    -1,   524,    -1,   525,   164,
     382,   788,   383,    -1,   525,   528,   164,   382,   788,   383,
      -1,   525,   164,   382,   522,   383,    -1,   525,   164,   382,
     522,   384,   553,   383,    -1,   525,   528,   164,   382,   522,
     383,    -1,   525,   528,   164,   382,   522,   384,   553,   383,
      -1,   525,    23,   525,    12,   524,    -1,   525,   528,    23,
     525,    12,   524,    -1,   525,   179,   531,   611,    -1,   525,
     528,   179,   531,   611,    -1,   525,    -1,   525,   378,   525,
      -1,   525,   377,   525,    -1,   525,   378,   161,   522,   601,
      -1,   525,   377,   161,   522,   601,    -1,   525,   379,   525,
      -1,   525,   380,   525,    -1,   525,   381,   525,    -1,   525,
      96,   525,    -1,   525,   209,   525,    -1,   531,    -1,   237,
      -1,    12,    -1,   220,    -1,   112,    -1,   136,    -1,   140,
      -1,   174,    -1,   192,    -1,   215,    -1,     9,    -1,    13,
      -1,   735,    -1,   532,    -1,   533,    -1,   535,    -1,   534,
      -1,   531,    47,   745,    -1,   730,    -1,   544,    -1,   540,
      -1,   378,   531,    -1,   377,   531,    -1,   382,   788,   383,
      -1,   382,   522,   383,    -1,   382,   522,   384,   553,   383,
      -1,   276,   382,   522,   384,   553,   383,    -1,   118,   382,
     788,   383,    -1,   386,   744,   522,   387,    -1,    25,   531,
      -1,    39,   382,   522,    14,   552,   383,    -1,    38,   554,
     556,   555,   107,    -1,    63,   382,   522,   384,   552,   383,
      -1,    88,   382,   735,   383,    -1,   358,   382,   736,   383,
      -1,   161,   522,   601,   378,   522,    -1,    42,   382,   553,
     383,    -1,    69,   521,    -1,    78,   382,   522,   383,    -1,
      83,   382,   522,   383,    -1,   147,   382,   522,   383,    -1,
     160,   382,   522,   384,   522,   384,   522,   384,   522,   383,
      -1,   161,   382,   522,   384,   522,   383,    -1,   161,   382,
     522,   384,   522,   384,   553,   383,    -1,   176,   382,   522,
     384,   522,   383,    -1,   203,   382,   522,   383,    -1,   210,
     382,   522,   383,    -1,   270,   382,   522,   384,   522,   383,
      -1,   279,   382,   522,   383,    -1,   332,   382,   522,   383,
      -1,   338,   382,   522,   383,    -1,   338,   382,   175,   522,
     134,   522,   383,    -1,   338,   382,   336,   522,   134,   522,
     383,    -1,   338,   382,    31,   522,   134,   522,   383,    -1,
     338,   382,   175,   134,   522,   383,    -1,   338,   382,   336,
     134,   522,   383,    -1,   338,   382,    31,   134,   522,   383,
      -1,   338,   382,   522,   134,   522,   383,    -1,   353,   382,
     383,    -1,   376,   382,   522,   383,    -1,     6,   382,   522,
     384,   522,   383,    -1,     6,   382,   522,   384,   161,   522,
     601,   383,    -1,    68,   521,    -1,    76,   382,   522,   384,
     161,   522,   601,   383,    -1,    77,   382,   522,   384,   161,
     522,   601,   383,    -1,   120,   382,   601,   134,   522,   383,
      -1,   221,   521,    -1,   221,   382,   522,   383,    -1,   244,
     382,   525,   164,   522,   383,    -1,   315,   382,   522,   384,
     522,   383,    -1,   315,   382,   522,   384,   161,   522,   601,
     383,    -1,   317,   382,   522,   384,   522,   384,   522,   383,
      -1,   317,   382,   522,   384,   522,   383,    -1,   317,   382,
     522,   134,   522,   131,   522,   383,    -1,   317,   382,   522,
     134,   522,   383,    -1,   322,   521,    -1,   322,   382,   522,
     383,    -1,   333,   382,   602,   384,   522,   384,   522,   383,
      -1,   334,   382,   602,   384,   522,   384,   522,   383,    -1,
     356,   521,    -1,   357,   521,    -1,    46,   382,   553,   383,
      -1,    48,   382,   522,   383,    -1,    71,   382,   383,    -1,
     151,   382,   522,   384,   522,   384,   522,   383,    -1,   200,
     382,   522,   383,    -1,   209,   382,   522,   384,   522,   383,
      -1,   250,   382,   522,   383,    -1,   263,   382,   522,   384,
     522,   383,    -1,   264,   382,   522,   384,   522,   384,   522,
     383,    -1,   268,   382,   522,   383,    -1,   340,   382,   522,
     384,   522,   383,    -1,    -1,   740,   382,   536,   537,   383,
      -1,    -1,   538,    -1,   539,    -1,   538,   384,   539,    -1,
     518,   522,   519,   520,    -1,    20,   382,   550,   383,    -1,
      20,   382,    95,   550,   383,    -1,    64,   382,   606,   379,
     383,    -1,    64,   382,   550,   383,    -1,    -1,    -1,    64,
     382,    95,   541,   553,   542,   383,    -1,   205,   382,   550,
     383,    -1,   205,   382,    95,   550,   383,    -1,   196,   382,
     550,   383,    -1,   196,   382,    95,   550,   383,    -1,   309,
     382,   550,   383,    -1,   363,   382,   550,   383,    -1,   308,
     382,   550,   383,    -1,   365,   382,   550,   383,    -1,   318,
     382,   550,   383,    -1,   318,   382,    95,   550,   383,    -1,
      -1,   139,   382,   547,   543,   553,   549,   548,   383,    -1,
      -1,   389,   545,   546,    -1,   745,   290,   522,    -1,   745,
      -1,   389,   757,   745,   473,    -1,    -1,    95,    -1,    -1,
     283,   728,    -1,    -1,   619,    -1,    -1,   606,   551,   522,
      -1,    25,   441,    -1,    42,   441,    -1,    78,    -1,    75,
      -1,    86,   439,    -1,   522,    -1,   553,   384,   522,    -1,
      -1,   522,    -1,    -1,   103,   522,    -1,   368,   522,   331,
     522,    -1,   556,   368,   522,   331,   522,    -1,   570,    -1,
     561,    -1,   560,    -1,   557,    -1,   386,   744,   557,   387,
      -1,   559,    -1,   560,   384,   559,    -1,   557,   569,   557,
      -1,   557,   313,   570,    -1,    -1,   557,   569,   557,   228,
     562,   522,    -1,    -1,   557,   313,   570,   228,   563,   522,
      -1,    -1,   557,   569,   557,   355,   564,   382,   600,   383,
      -1,   557,   214,   168,   570,    -1,    -1,   557,   176,   586,
     168,   557,   228,   565,   522,    -1,    -1,   557,   176,   586,
     168,   570,   566,   355,   382,   600,   383,    -1,   557,   214,
     176,   586,   168,   570,    -1,    -1,   557,   270,   586,   168,
     557,   228,   567,   522,    -1,    -1,   557,   270,   586,   168,
     570,   568,   355,   382,   600,   383,    -1,   557,   214,   270,
     586,   168,   570,    -1,   168,    -1,   157,   168,    -1,    66,
     168,    -1,    -1,   571,   739,   605,   595,    -1,   585,   584,
     581,    -1,   382,   584,   572,   383,   605,    -1,   579,   618,
     624,    -1,    -1,    -1,   572,   347,   784,   573,   785,   574,
     618,   624,    -1,   576,    -1,    -1,    -1,   577,   512,   516,
     578,   421,   515,    -1,    -1,   584,   580,   560,    -1,    -1,
      -1,   582,   512,   516,   583,   421,    -1,    -1,   281,    -1,
      -1,   238,    -1,    -1,   131,   168,    -1,   131,   236,    33,
      -1,   131,   138,    33,    -1,   129,    -1,   152,    -1,    -1,
     588,   459,   587,   590,   382,   599,   383,    -1,    -1,   354,
     459,   587,   591,   382,   597,   383,    -1,   589,    -1,   592,
     589,    -1,    -1,    -1,   594,   592,    -1,    -1,   596,   593,
      -1,    -1,   599,    -1,   744,    -1,   247,    -1,   598,    -1,
     599,   384,   598,    -1,   744,    -1,   600,   384,   744,    -1,
     603,    -1,    79,    -1,    80,    -1,    81,    -1,    82,    -1,
     144,    -1,   145,    -1,   146,    -1,   201,    -1,   202,    -1,
     278,    -1,   375,    -1,   603,    -1,   133,    -1,    83,    -1,
     367,    -1,   147,    -1,   203,    -1,   210,    -1,   250,    -1,
     279,    -1,   200,    -1,   376,    -1,    -1,    14,    -1,   112,
      -1,    -1,   604,   744,    -1,    -1,     9,    -1,    -1,    -1,
     369,   608,   522,    -1,    -1,    -1,   142,   610,   522,    -1,
     116,   531,    -1,    -1,    -1,   138,    33,   613,   614,    -1,
     613,   384,   734,   622,    -1,   734,   622,    -1,    -1,   371,
      -1,   236,    33,   616,    -1,   616,   384,   617,    -1,   617,
      -1,   736,   622,    -1,    -1,   619,    -1,    -1,   236,    33,
     620,   621,    -1,   621,   384,   734,   622,    -1,   734,   622,
      -1,    -1,    15,    -1,    90,    -1,    -1,   625,    -1,    -1,
     625,    -1,   180,   626,    -1,   627,    -1,   627,   384,   627,
      -1,   627,   227,   627,    -1,   343,    -1,   189,    -1,   224,
      -1,    -1,   180,   627,    -1,   224,    -1,   143,    -1,   189,
      -1,   343,    -1,    85,    -1,   127,    -1,   224,    -1,   343,
      -1,   189,    -1,    85,    -1,   127,    -1,    -1,   632,   633,
      -1,   633,   384,   634,    -1,   634,    -1,   389,   745,    -1,
      -1,   162,   636,   637,    -1,    -1,   239,   743,   638,   715,
     718,    -1,    99,   743,    -1,   631,    -1,    98,   644,   764,
     643,   641,    -1,    -1,    98,   480,   155,   744,   228,   739,
     640,    -1,    98,    71,   643,   744,    -1,   642,    -1,   641,
     384,   642,    -1,   739,    -1,    -1,   151,   118,    -1,    -1,
     327,    -1,    -1,    -1,   160,   646,   488,   651,   647,   653,
     669,    -1,    -1,    -1,   264,   649,   651,   650,   653,    -1,
     162,   652,    -1,   652,    -1,   642,    -1,   656,    -1,   382,
     383,   656,    -1,   382,   655,   383,   656,    -1,    -1,   289,
     654,   660,    -1,   655,   384,   732,    -1,   732,    -1,   358,
     659,    -1,   359,   659,    -1,    -1,   404,   657,   777,    -1,
      -1,   382,   404,   383,   658,   780,    -1,   659,   384,   664,
      -1,   664,    -1,   660,   384,   661,    -1,   661,    -1,   736,
     662,   668,    -1,   112,    -1,   290,    -1,    -1,   662,    -1,
      -1,   382,   665,   666,   383,    -1,    -1,   667,    -1,   667,
     384,   668,    -1,   668,    -1,   522,    -1,    88,    -1,    -1,
      -1,   228,   100,   670,   171,   351,   676,    -1,    -1,    -1,
     351,   488,   739,   672,   289,   674,   673,   607,   618,   628,
      -1,   674,   384,   675,    -1,   675,    -1,   736,   662,   668,
      -1,   676,   384,   677,    -1,   677,    -1,   736,   662,   668,
      -1,    -1,    89,   679,   682,   680,    -1,    -1,   134,   739,
     681,   607,   618,   628,    -1,    -1,   683,   682,    -1,   152,
      -1,   340,   685,   642,    -1,    -1,   326,    -1,    -1,   292,
     687,   688,    -1,    72,   691,    -1,   323,   689,   691,    -1,
     327,   323,   691,    -1,   326,   307,   689,   691,    -1,    49,
     690,   739,   689,   691,    -1,   461,   690,   739,   689,   607,
      -1,    64,   382,   379,   383,   366,    -1,    64,   382,   379,
     383,   114,    -1,   366,   623,    -1,   114,   623,    -1,   756,
     307,   691,    -1,   249,    -1,   756,   362,   691,    -1,    65,
      71,   412,   744,    -1,    65,   326,   739,    -1,    -1,   690,
     744,    -1,   134,    -1,   164,    -1,    -1,   179,   741,    -1,
     369,   522,    -1,    -1,   695,   739,   693,   697,    -1,    -1,
     695,   696,   694,   501,    -1,    90,    -1,    91,    -1,    -1,
     119,    -1,    -1,   728,    -1,   744,    -1,    -1,   128,   699,
     700,    -1,   700,   384,   701,    -1,   701,    -1,    -1,   764,
     702,   703,    -1,   323,   370,   255,   187,    -1,   188,    -1,
     307,    -1,    -1,   641,    -1,   172,   705,   522,    -1,    -1,
      58,    -1,   251,    -1,   354,   744,    -1,    -1,    -1,    -1,
      -1,   183,   712,   708,   713,   156,   743,   709,   714,   162,
     710,   326,   739,   711,   715,   718,   721,   723,   726,    -1,
      74,    -1,    -1,    56,    -1,    -1,   264,    -1,   152,    -1,
      -1,    49,   716,    -1,   716,   717,    -1,   717,    -1,   328,
      33,   728,    -1,   235,   106,    33,   728,    -1,   106,    33,
     728,    -1,   115,    33,   728,    -1,    -1,   181,   719,    -1,
     719,   720,    -1,   720,    -1,   328,    33,   728,    -1,   305,
      33,   728,    -1,    -1,   152,   224,   722,    -1,   181,    -1,
     274,    -1,    -1,   382,   724,   383,    -1,   382,   383,    -1,
     724,   384,   725,    -1,   725,    -1,   736,    -1,   389,   745,
      -1,    -1,   289,   676,    -1,   742,    -1,   727,   742,    -1,
     742,    -1,   143,    -1,    26,    -1,   730,    -1,   378,   731,
      -1,   377,   731,    -1,   727,    -1,   731,    -1,   223,    -1,
     121,    -1,   339,    -1,   143,    -1,    26,    -1,    78,   727,
      -1,   332,   727,    -1,   224,    -1,   189,    -1,   343,    -1,
      85,    -1,   127,    -1,   736,    -1,   733,    -1,   744,   388,
     379,    -1,   744,   388,   744,   388,   379,    -1,   522,    -1,
     744,    -1,   737,    -1,   744,    -1,   737,    -1,   744,   388,
     744,    -1,   388,   744,   388,   744,    -1,   744,   388,   744,
     388,   744,    -1,   744,    -1,   744,   388,   744,   388,   744,
      -1,   744,   388,   744,    -1,   388,   744,    -1,   744,    -1,
     744,   388,   744,    -1,   388,   744,    -1,   148,    -1,   150,
      -1,   329,    -1,   329,    -1,   329,    -1,   740,    -1,   746,
      -1,   744,    -1,   741,    -1,   178,    -1,   747,    -1,    22,
      -1,    34,    -1,    43,    -1,    45,    -1,    51,    -1,    53,
      -1,    61,    -1,    84,    -1,   107,    -1,   128,    -1,   222,
      -1,   232,    -1,   271,    -1,   277,    -1,   280,    -1,   287,
      -1,   306,    -1,   310,    -1,   340,    -1,     4,    -1,     6,
      -1,     7,    -1,     8,    -1,    13,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,    27,    -1,    30,    -1,    29,
      -1,    32,    -1,    37,    -1,    40,    -1,    46,    -1,    48,
      -1,   123,    -1,    49,    -1,    52,    -1,    54,    -1,    55,
      -1,    56,    -1,    58,    -1,    59,    -1,    67,    -1,    74,
      -1,    72,    -1,    73,    -1,    75,    -1,    78,    -1,    83,
      -1,    93,    -1,    94,    -1,    99,    -1,   100,    -1,   101,
      -1,   108,    -1,   111,    -1,   110,    -1,   114,    -1,   116,
      -1,   117,    -1,   119,    -1,   132,    -1,   105,    -1,   135,
      -1,   124,    -1,   125,    -1,   126,    -1,   133,    -1,   137,
      -1,   141,    -1,   147,    -1,   149,    -1,   153,    -1,   154,
      -1,   166,    -1,   170,    -1,   173,    -1,   177,    -1,   182,
      -1,   184,    -1,   186,    -1,   188,    -1,   194,    -1,   195,
      -1,   197,    -1,   198,    -1,   199,    -1,   200,    -1,   203,
      -1,   204,    -1,   208,    -1,   206,    -1,   210,    -1,   212,
      -1,   211,    -1,   213,    -1,   218,    -1,   217,    -1,   219,
      -1,   226,    -1,   227,    -1,   229,    -1,   230,    -1,   231,
      -1,   241,    -1,   242,    -1,   243,    -1,   246,    -1,   248,
      -1,   249,    -1,   250,    -1,   251,    -1,   254,    -1,   258,
      -1,   262,    -1,   266,    -1,   268,    -1,   272,    -1,   273,
      -1,   274,    -1,   275,    -1,   276,    -1,   279,    -1,   285,
      -1,   284,    -1,   286,    -1,   294,    -1,   291,    -1,   293,
      -1,   295,    -1,   301,    -1,   307,    -1,   311,    -1,   314,
      -1,   315,    -1,   316,    -1,   319,    -1,   320,    -1,   321,
      -1,   323,    -1,   324,    -1,   327,    -1,   330,    -1,   337,
      -1,   332,    -1,   333,    -1,   334,    -1,   341,    -1,   342,
      -1,   344,    -1,   345,    -1,   349,    -1,   353,    -1,   362,
      -1,   359,    -1,   366,    -1,   367,    -1,   372,    -1,   376,
      -1,    -1,   289,   750,   749,   751,    -1,    -1,   234,    -1,
     752,    -1,   751,   384,   752,    -1,    -1,   753,   758,    -1,
     755,    -1,   137,    -1,   184,    -1,   286,    -1,    -1,   229,
      -1,    -1,   137,    -1,   184,    -1,   286,    -1,    -1,   137,
     388,    -1,   184,   388,    -1,   286,   388,    -1,   759,    -1,
     755,   760,    -1,   754,   761,   662,   763,    -1,   754,   337,
     166,   177,   762,    -1,   389,   745,   662,   522,    -1,   389,
     389,   757,   761,   662,   763,    -1,   744,    -1,   255,   344,
      -1,   255,    52,    -1,   262,   255,    -1,   284,    -1,   522,
      -1,    88,    -1,   228,    -1,     9,    -1,    25,    -1,   326,
      -1,   323,    -1,    -1,   350,   766,   764,    -1,    -1,    22,
     768,   769,    -1,    -1,   372,    -1,    -1,    12,   222,    40,
      -1,    12,    40,    -1,    -1,   260,    -1,   222,   260,    -1,
      -1,   277,    -1,    53,   769,   770,   771,    -1,   271,   769,
     770,   771,    -1,   271,   769,   335,   772,   744,    -1,   277,
     744,    -1,   260,   277,   744,    -1,    -1,   778,    -1,    -1,
     347,   784,   779,   502,    -1,    -1,   778,    -1,   781,    -1,
      -1,   782,   783,    -1,   619,   623,    -1,   625,    -1,    -1,
      95,    -1,     9,    -1,   281,   575,    -1,   382,   504,   383,
      -1,   785,    -1,    -1,   786,   347,   784,   787,   785,    -1,
     789,   786,   790,    -1,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   959,   959,   976,   980,   981,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1017,  1016,  1050,  1049,  1077,  1076,  1094,  1095,  1097,
    1107,  1120,  1123,  1122,  1128,  1130,  1129,  1133,  1132,  1139,
    1169,  1138,  1183,  1184,  1188,  1189,  1190,  1194,  1195,  1199,
    1206,  1214,  1229,  1230,  1234,  1235,  1238,  1240,  1244,  1245,
    1249,  1250,  1251,  1254,  1257,  1265,  1272,  1283,  1290,  1299,
    1303,  1322,  1332,  1333,  1334,  1338,  1339,  1343,  1344,  1348,
    1349,  1353,  1354,  1361,  1370,  1380,  1399,  1403,  1409,  1411,
    1415,  1419,  1420,  1424,  1429,  1428,  1463,  1467,  1484,  1497,
    1515,  1526,  1545,  1566,  1576,  1586,  1596,  1615,  1626,  1636,
    1646,  1657,  1656,  1668,  1686,  1690,  1691,  1695,  1696,  1700,
    1704,  1706,  1712,  1713,  1715,  1720,  1729,  1730,  1734,  1735,
    1739,  1740,  1744,  1745,  1749,  1761,  1768,  1780,  1787,  1789,
    1802,  1817,  1832,  1840,  1848,  1856,  1872,  1874,  1879,  1890,
    1891,  1895,  1896,  1899,  1901,  1905,  1917,  1918,  1922,  1924,
    1934,  1935,  1937,  1939,  1945,  1949,  1954,  1959,  1965,  1974,
    1975,  1976,  1977,  1978,  1982,  1986,  1987,  1991,  1992,  1996,
    1997,  2001,  2002,  2003,  2007,  2008,  2012,  2024,  2025,  2029,
    2030,  2034,  2035,  2039,  2040,  2044,  2045,  2047,  2052,  2053,
    2057,  2058,  2062,  2063,  2075,  2076,  2080,  2081,  2085,  2086,
    2094,  2093,  2118,  2117,  2136,  2137,  2140,  2142,  2147,  2152,
    2157,  2160,  2164,  2171,  2172,  2176,  2186,  2187,  2193,  2201,
    2200,  2208,  2221,  2207,  2236,  2243,  2250,  2258,  2266,  2273,
    2280,  2287,  2294,  2316,  2326,  2332,  2338,  2347,  2348,  2352,
    2353,  2357,  2358,  2365,  2375,  2376,  2377,  2378,  2382,  2393,
    2394,  2402,  2401,  2415,  2414,  2429,  2428,  2440,  2441,  2445,
    2463,  2475,  2476,  2480,  2485,  2490,  2495,  2500,  2499,  2519,
    2527,  2519,  2534,  2535,  2536,  2537,  2538,  2542,  2551,  2553,
    2565,  2566,  2570,  2571,  2572,  2573,  2574,  2580,  2586,  2589,
    2591,  2596,  2605,  2606,  2607,  2619,  2626,  2646,  2654,  2662,
    2663,  2664,  2665,  2666,  2670,  2671,  2676,  2725,  2730,  2771,
    2773,  2775,  2777,  2779,  2781,  2783,  2785,  2789,  2791,  2793,
    2795,  2797,  2799,  2803,  2807,  2813,  2817,  2823,  2827,  2835,
    2837,  2843,  2845,  2847,  2851,  2853,  2855,  2857,  2859,  2861,
    2863,  2865,  2867,  2869,  2873,  2877,  2881,  2885,  2886,  2887,
    2888,  2889,  2890,  2894,  2895,  2899,  2900,  2901,  2902,  2903,
    2904,  2912,  2913,  2914,  2915,  2916,  2918,  2922,  2923,  2928,
    2933,  2937,  2938,  2943,  2951,  2953,  2960,  2965,  2970,  2982,
    2984,  2992,  2994,  2996,  2998,  3000,  3009,  3017,  3019,  3021,
    3023,  3025,  3027,  3029,  3031,  3033,  3035,  3037,  3039,  3041,
    3043,  3045,  3053,  3069,  3074,  3076,  3080,  3082,  3084,  3086,
    3090,  3094,  3096,  3101,  3103,  3115,  3126,  3138,  3149,  3151,
    3153,  3155,  3157,  3161,  3173,  3175,  3177,  3185,  3187,  3189,
    3191,  3193,  3195,  3197,  3207,  3221,  3220,  3268,  3269,  3273,
    3278,  3286,  3306,  3308,  3310,  3312,  3315,  3317,  3314,  3320,
    3327,  3329,  3331,  3333,  3335,  3337,  3339,  3341,  3343,  3346,
    3345,  3361,  3360,  3369,  3373,  3377,  3391,  3392,  3397,  3400,
    3405,  3408,  3420,  3419,  3436,  3438,  3440,  3442,  3444,  3449,
    3454,  3462,  3463,  3467,  3468,  3472,  3478,  3489,  3490,  3499,
    3510,  3511,  3517,  3518,  3538,  3540,  3544,  3542,  3559,  3557,
    3575,  3573,  3580,  3589,  3587,  3605,  3604,  3614,  3625,  3623,
    3642,  3641,  3652,  3663,  3664,  3665,  3677,  3677,  3690,  3730,
    3772,  3776,  3781,  3773,  3793,  3813,  3821,  3813,  3830,  3829,
    3852,  3868,  3852,  3875,  3879,  3899,  3900,  3905,  3908,  3909,
    3910,  3914,  3915,  3920,  3919,  3925,  3924,  3932,  3933,  3936,
    3938,  3938,  3942,  3942,  3947,  3948,  3952,  3954,  3959,  3960,
    3964,  3972,  3982,  3983,  3984,  3985,  3986,  3987,  3988,  3989,
    3990,  3991,  3992,  3993,  3997,  3998,  4016,  4017,  4018,  4019,
    4020,  4021,  4022,  4023,  4024,  4027,  4029,  4030,  4034,  4035,
    4039,  4041,  4045,  4047,  4046,  4060,  4063,  4062,  4077,  4083,
    4093,  4095,  4099,  4101,  4106,  4107,  4132,  4136,  4137,  4141,
    4154,  4156,  4161,  4160,  4195,  4197,  4202,  4203,  4204,  4209,
    4215,  4219,  4220,  4224,  4228,  4235,  4242,  4252,  4253,  4254,
    4259,  4263,  4272,  4273,  4274,  4275,  4276,  4277,  4281,  4282,
    4283,  4284,  4285,  4289,  4289,  4299,  4300,  4304,  4320,  4319,
    4326,  4325,  4333,  4344,  4353,  4364,  4364,  4379,  4391,  4392,
    4396,  4404,  4405,  4409,  4410,  4418,  4430,  4417,  4440,  4450,
    4439,  4459,  4460,  4464,  4473,  4474,  4475,  4477,  4476,  4487,
    4488,  4492,  4493,  4495,  4494,  4498,  4497,  4503,  4504,  4508,
    4509,  4513,  4523,  4524,  4528,  4529,  4534,  4533,  4547,  4548,
    4552,  4557,  4565,  4566,  4569,  4571,  4571,  4579,  4592,  4578,
    4612,  4613,  4617,  4625,  4626,  4630,  4643,  4642,  4659,  4658,
    4669,  4670,  4674,  4678,  4690,  4692,  4699,  4698,  4711,  4748,
    4805,  4831,  4873,  4915,  4956,  4964,  4972,  4979,  4986,  5025,
    5047,  5086,  5096,  5108,  5109,  5113,  5114,  5117,  5119,  5126,
    5137,  5136,  5178,  5177,  5187,  5188,  5192,  5193,  5197,  5198,
    5199,  5212,  5211,  5225,  5226,  5231,  5230,  5236,  5241,  5246,
    5254,  5255,  5261,  5274,  5275,  5276,  5282,  5297,  5311,  5320,
    5326,  5296,  5342,  5345,  5346,  5353,  5354,  5355,  5358,  5360,
    5364,  5365,  5369,  5374,  5381,  5386,  5393,  5395,  5399,  5400,
    5404,  5409,  5416,  5418,  5426,  5427,  5431,  5432,  5433,  5437,
    5439,  5444,  5445,  5450,  5451,  5457,  5462,  5469,  5475,  5486,
    5499,  5500,  5501,  5509,  5510,  5511,  5516,  5517,  5518,  5519,
    5520,  5521,  5525,  5530,  5535,  5537,  5545,  5560,  5561,  5565,
    5571,  5580,  5584,  5596,  5600,  5610,  5614,  5634,  5650,  5670,
    5671,  5688,  5699,  5703,  5704,  5705,  5709,  5710,  5728,  5735,
    5742,  5749,  5750,  5759,  5760,  5761,  5766,  5767,  5768,  5769,
    5770,  5771,  5772,  5773,  5774,  5775,  5776,  5777,  5778,  5779,
    5780,  5781,  5782,  5783,  5784,  5785,  5795,  5796,  5797,  5798,
    5799,  5800,  5801,  5802,  5803,  5804,  5805,  5806,  5807,  5808,
    5809,  5810,  5811,  5812,  5813,  5814,  5815,  5816,  5817,  5818,
    5819,  5820,  5821,  5822,  5823,  5824,  5825,  5826,  5827,  5828,
    5829,  5830,  5831,  5832,  5833,  5834,  5835,  5836,  5837,  5838,
    5839,  5840,  5841,  5842,  5843,  5844,  5845,  5846,  5847,  5848,
    5849,  5850,  5851,  5852,  5853,  5854,  5855,  5856,  5857,  5858,
    5859,  5860,  5861,  5862,  5863,  5864,  5865,  5866,  5867,  5868,
    5869,  5870,  5871,  5872,  5873,  5874,  5875,  5876,  5877,  5878,
    5879,  5880,  5881,  5882,  5883,  5884,  5885,  5886,  5887,  5888,
    5889,  5890,  5891,  5892,  5893,  5894,  5895,  5896,  5897,  5898,
    5899,  5900,  5901,  5902,  5903,  5904,  5905,  5906,  5907,  5908,
    5909,  5910,  5911,  5912,  5913,  5914,  5915,  5916,  5917,  5918,
    5919,  5920,  5921,  5922,  5923,  5924,  5925,  5926,  5927,  5928,
    5929,  5930,  5931,  5932,  5933,  5934,  5935,  5936,  5943,  5942,
    5959,  5960,  5964,  5965,  5969,  5969,  5977,  5978,  5979,  5980,
    5984,  5985,  5989,  5990,  5991,  5992,  5996,  5997,  5998,  5999,
    6003,  6004,  6008,  6020,  6032,  6036,  6044,  6061,  6062,  6063,
    6064,  6068,  6069,  6070,  6071,  6072,  6076,  6077,  6082,  6081,
    6095,  6094,  6106,  6107,  6112,  6113,  6114,  6119,  6120,  6121,
    6125,  6126,  6130,  6144,  6155,  6168,  6180,  6197,  6198,  6203,
    6202,  6218,  6219,  6220,  6224,  6224,  6248,  6249,  6253,  6254,
    6255,  6259,  6263,  6270,  6273,  6271,  6286,  6293,  6313
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ABORT_SYM", "ACTION", "ADD",
  "ADDDATE_SYM", "AFTER_SYM", "AGGREGATE_SYM", "ALL", "ALTER",
  "ANALYZE_SYM", "AND_SYM", "ANY_SYM", "AS", "ASC", "ASENSITIVE_SYM",
  "AT_SYM", "AUTO_INC", "AVG_ROW_LENGTH", "AVG_SYM", "BEFORE_SYM",
  "BEGIN_SYM", "BETWEEN_SYM", "BIGINT_SYM", "BINARY", "BIN_NUM", "BIT_SYM",
  "BLOB_SYM", "BOOLEAN_SYM", "BOOL_SYM", "BOTH", "BTREE_SYM", "BY",
  "BYTE_SYM", "CALL_SYM", "CASCADE", "CASCADED", "CASE_SYM", "CAST_SYM",
  "CHAIN_SYM", "CHANGE", "CHAR_SYM", "CHECKSUM_SYM", "CHECK_SYM",
  "CLOSE_SYM", "COALESCE", "COLLATE_SYM", "COLLATION_SYM", "COLUMNS",
  "COLUMN_SYM", "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM",
  "COMPACT_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONDITION_SYM",
  "CONNECTION_SYM", "CONSISTENT_SYM", "CONSTRAINT", "CONTAINS_SYM",
  "CONTINUE_SYM", "CONVERT_SYM", "COUNT_SYM", "CREATE", "CROSS",
  "CUBE_SYM", "CURDATE", "CURRENT_USER", "CURSOR_SYM", "DATABASE",
  "DATABASES", "DATAFILE_SYM", "DATA_SYM", "DATETIME_SYM",
  "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DATE_SYM", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DECIMAL_NUM", "DECIMAL_SYM", "DECLARE_SYM", "DEFAULT",
  "DELETE_SYM", "DESC", "DESCRIBE", "DETERMINISTIC_SYM", "DISABLE_SYM",
  "DISCARD", "DISTINCT", "DIV_SYM", "DOUBLE_SYM", "DROP", "DUMPFILE",
  "DUPLICATE_SYM", "DYNAMIC_SYM", "EACH_SYM", "ELSE", "ELSEIF_SYM",
  "ENABLE_SYM", "ENCLOSED", "END", "ENDS_SYM", "END_OF_INPUT",
  "ENGINE_SYM", "ENUM_SYM", "EQ", "EQUAL_SYM", "ERRORS", "ESCAPED",
  "ESCAPE_SYM", "EXCLUSIVE_SYM", "EXISTS", "EXTENDED_SYM", "EXTRACT_SYM",
  "FALSE_SYM", "FETCH_SYM", "COLUMN_FORMAT_SYM", "FILE_SYM", "FIRST_SYM",
  "FIXED_SYM", "FLOAT_NUM", "FLUSH_SYM", "FORCE_SYM", "FOREIGN", "FOR_SYM",
  "FOUND_SYM", "FRAC_SECOND_SYM", "FROM", "FULL", "GE", "GLOBAL_SYM",
  "GROUP_SYM", "GROUP_CONCAT_SYM", "GT_SYM", "HASH_SYM", "HAVING",
  "HEX_NUM", "HOUR_MICROSECOND_SYM", "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM",
  "HOUR_SYM", "IDENT", "IDENTIFIED_SYM", "IDENT_QUOTED", "IF",
  "IGNORE_SYM", "IMPORT", "INDEXES", "INDEX_SYM", "INFILE", "INNER_SYM",
  "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERVAL_SYM", "INTO",
  "INT_SYM", "IN_SYM", "IS", "ISOLATION", "ITERATE_SYM", "JOIN_SYM",
  "KEYS", "KEY_BLOCK_SIZE", "KEY_SYM", "KILL_SYM", "LAST_SYM", "LE",
  "LEADING", "LEFT", "LEVEL_SYM", "LEX_HOSTNAME", "LIKE", "LIMIT", "LINES",
  "LIST_SYM", "LOAD", "LOCAL_SYM", "LOCATOR_SYM", "LOCKS_SYM", "LOCK_SYM",
  "LOGS_SYM", "LONG_NUM", "LONG_SYM", "LOOP_SYM", "LT", "MATCH",
  "MAX_ROWS", "MAX_SIZE_SYM", "MAX_SYM", "MAX_VALUE_SYM", "MEDIUM_SYM",
  "MERGE_SYM", "MICROSECOND_SYM", "MINUTE_MICROSECOND_SYM",
  "MINUTE_SECOND_SYM", "MINUTE_SYM", "MIN_ROWS", "MIN_SYM", "MODE_SYM",
  "MODIFIES_SYM", "MODIFY_SYM", "MOD_SYM", "MONTH_SYM", "NAMES_SYM",
  "NAME_SYM", "NATIONAL_SYM", "NATURAL", "NE", "NEG", "NEW_SYM",
  "NEXT_SYM", "NONE_SYM", "NOT_SYM", "NOW_SYM", "NO_SYM", "NULL_SYM",
  "NUM", "NUMERIC_SYM", "OFFLINE_SYM", "OFFSET_SYM", "ON", "ONE_SHOT_SYM",
  "ONE_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIMIZE", "OPTION", "OPTIONALLY",
  "ORDER_SYM", "OR_SYM", "OUTER", "OUTFILE", "OUT_SYM", "PAGE_SYM",
  "PARTIAL", "PHASE_SYM", "POSITION_SYM", "PRECISION", "PREV_SYM",
  "PRIMARY_SYM", "PROCESS", "PROCESSLIST_SYM", "QUARTER_SYM", "QUERY_SYM",
  "RANGE_SYM", "READS_SYM", "READ_ONLY_SYM", "READ_SYM", "READ_WRITE_SYM",
  "REAL", "REDUNDANT_SYM", "REFERENCES", "RELEASE_SYM", "RENAME",
  "REPEATABLE_SYM", "REPEAT_SYM", "REPLACE", "RESTRICT", "RETURNS_SYM",
  "RETURN_SYM", "REVERSE_SYM", "REVOKE", "RIGHT", "ROLLBACK_SYM",
  "ROLLUP_SYM", "ROUTINE_SYM", "ROWS_SYM", "ROW_FORMAT_SYM", "ROW_SYM",
  "SAVEPOINT_SYM", "SECOND_MICROSECOND_SYM", "SECOND_SYM", "SECURITY_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHARE_SYM", "SHOW", "SHUTDOWN", "SIMPLE_SYM", "SNAPSHOT_SYM",
  "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM", "SQLWARNING_SYM",
  "SQL_BIG_RESULT", "SQL_BUFFER_RESULT", "SQL_CALC_FOUND_ROWS",
  "SQL_SMALL_RESULT", "SQL_SYM", "STARTING", "START_SYM", "STATUS_SYM",
  "STDDEV_SAMP_SYM", "STD_SYM", "STOP_SYM", "STORAGE_SYM", "STORED_SYM",
  "STRAIGHT_JOIN", "STRING_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBSTRING",
  "SUM_SYM", "SUSPEND_SYM", "SWAPS_SYM", "SWITCHES_SYM", "SYSDATE",
  "TABLES", "TABLESPACE", "TABLE_REF_PRIORITY", "TABLE_SYM",
  "TEMPORARY_SYM", "TERMINATED", "TEXT_STRING", "TEXT_SYM", "THEN_SYM",
  "TIMESTAMP_SYM", "TIMESTAMP_ADD", "TIMESTAMP_DIFF", "TO_SYM", "TRAILING",
  "TRANSACTION_SYM", "TRIM", "TRUE_SYM", "TRUNCATE_SYM", "TYPES_SYM",
  "TYPE_SYM", "ULONGLONG_NUM", "UNCOMMITTED_SYM", "UNDOFILE_SYM",
  "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM", "UNKNOWN_SYM", "UNLOCK_SYM",
  "UPDATE_SYM", "USAGE", "USER", "USE_SYM", "USING", "UTC_DATE_SYM",
  "UTC_TIMESTAMP_SYM", "VALUES", "VALUE_SYM", "VARBINARY", "VARCHAR_SYM",
  "VARIABLES", "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WARNINGS",
  "WEEK_SYM", "WHEN_SYM", "WHERE", "WITH", "WITH_ROLLUP_SYM", "WORK_SYM",
  "WRITE_SYM", "XOR", "YEAR_MONTH_SYM", "YEAR_SYM", "'-'", "'+'", "'*'",
  "'/'", "'%'", "'('", "')'", "','", "'!'", "'{'", "'}'", "'.'", "'@'",
  "$accept", "query", "verb_clause", "statement", "create", "$@1", "$@2",
  "$@3", "create2", "create2a", "$@4", "create3", "$@5", "$@6",
  "create_select", "$@7", "$@8", "opt_as", "opt_create_database_options",
  "opt_database_custom_options", "custom_database_option",
  "opt_table_options", "opt_if_not_exists", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "custom_engine_option", "default_collation",
  "default_collation_schema", "column_format_types", "opt_select_from",
  "field_list", "field_list_item", "column_def", "key_def",
  "opt_check_constraint", "check_constraint", "opt_constraint",
  "constraint", "field_spec", "$@9", "field_def", "type", "$@10", "char",
  "varchar", "int_type", "real_type", "float_options", "precision",
  "opt_len", "opt_precision", "opt_attribute", "opt_attribute_list",
  "attribute", "now_or_signed_literal", "collation_name",
  "collation_name_or_default", "opt_default", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "key_type", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "init_key_options",
  "key_alg", "key_options", "key_opts", "key_using_alg", "key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "opt_component",
  "string_list", "alter", "$@11", "$@12", "ident_or_empty",
  "alter_commands", "build_method", "alter_list", "add_column",
  "alter_list_item", "$@13", "$@14", "$@15", "opt_column", "opt_ignore",
  "opt_place", "opt_to", "start", "start_transaction_opts", "analyze",
  "$@16", "check", "$@17", "rename", "$@18", "table_to_table_list",
  "table_to_table", "select", "select_init", "select_paren",
  "select_paren_derived", "select_init2", "$@19", "select_part2", "$@20",
  "$@21", "select_into", "select_from", "select_options",
  "select_option_list", "select_option", "select_lock_type",
  "select_item_list", "select_item", "remember_name", "remember_end",
  "select_alias", "optional_braces", "expr", "bool_pri", "predicate",
  "bit_expr", "or", "and", "not", "comp_op", "all_or_any", "simple_expr",
  "function_call_keyword", "function_call_nonkeyword",
  "function_call_conflict", "function_call_generic", "@22",
  "opt_udf_expr_list", "udf_expr_list", "udf_expr", "sum_expr", "$@23",
  "$@24", "$@25", "variable", "$@26", "variable_aux", "opt_distinct",
  "opt_gconcat_separator", "opt_gorder_clause", "in_sum_expr", "$@27",
  "cast_type", "expr_list", "opt_expr", "opt_else", "when_list",
  "table_ref", "join_table_list", "esc_table_ref", "derived_table_list",
  "join_table", "$@28", "$@29", "$@30", "$@31", "$@32", "$@33", "$@34",
  "normal_join", "table_factor", "$@35", "select_derived_union", "$@36",
  "$@37", "select_init2_derived", "select_part2_derived", "$@38", "$@39",
  "select_derived", "$@40", "select_derived2", "$@41", "$@42",
  "get_select_lex", "select_derived_init", "opt_outer",
  "index_hint_clause", "index_hint_type", "index_hint_definition", "$@43",
  "$@44", "index_hints_list", "opt_index_hints_list", "$@45",
  "opt_key_definition", "$@46", "opt_key_usage_list", "key_usage_element",
  "key_usage_list", "using_list", "interval", "interval_time_stamp",
  "interval_time_st", "table_alias", "opt_table_alias", "opt_all",
  "where_clause", "$@47", "having_clause", "$@48", "opt_escape",
  "group_clause", "group_list", "olap_opt", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@49", "order_list", "order_dir",
  "opt_limit_clause_init", "opt_limit_clause", "limit_clause",
  "limit_options", "limit_option", "delete_limit_clause", "ulong_num",
  "ulonglong_num", "select_var_list_init", "$@50", "select_var_list",
  "select_var_ident", "into", "$@51", "into_destination", "$@52", "drop",
  "$@53", "table_list", "table_name", "if_exists", "opt_temporary",
  "insert", "$@54", "$@55", "replace", "$@56", "$@57", "insert2",
  "insert_table", "insert_field_spec", "$@58", "fields", "insert_values",
  "$@59", "$@60", "values_list", "ident_eq_list", "ident_eq_value",
  "equal", "opt_equal", "no_braces", "$@61", "opt_values", "values",
  "expr_or_default", "opt_insert_update", "$@62", "update", "$@63", "$@64",
  "update_list", "update_elem", "insert_update_list", "insert_update_elem",
  "delete", "$@65", "single_multi", "$@66", "opt_delete_options",
  "opt_delete_option", "truncate", "opt_table_sym", "show", "$@67",
  "show_param", "opt_db", "from_or_in", "show_wild", "describe", "$@68",
  "$@69", "describe_command", "opt_extended_describe",
  "opt_describe_column", "flush", "$@70", "flush_options", "flush_option",
  "$@71", "opt_table_list", "kill", "kill_option", "use", "load", "$@72",
  "$@73", "$@74", "$@75", "data_file", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_ignore_lines", "lines_or_rows",
  "opt_field_or_var_spec", "fields_or_vars", "field_or_var",
  "opt_load_data_set_spec", "text_literal", "text_string",
  "signed_literal", "literal", "NUM_literal", "insert_ident", "table_wild",
  "order_ident", "simple_ident", "simple_ident_nospvar", "simple_ident_q",
  "field_ident", "table_ident", "IDENT_sys", "TEXT_STRING_sys",
  "TEXT_STRING_literal", "TEXT_STRING_filesystem", "ident",
  "ident_or_text", "keyword", "keyword_sp", "set", "$@76", "opt_option",
  "option_value_list", "option_type_value", "$@77", "option_type",
  "option_type2", "opt_var_type", "opt_var_ident_type", "ext_option_value",
  "sys_option_value", "option_value", "internal_variable_name",
  "isolation_types", "set_expr_or_default", "table_or_tables", "unlock",
  "$@78", "begin", "$@79", "opt_work", "opt_chain", "opt_release",
  "opt_savepoint", "commit", "rollback", "savepoint", "release",
  "union_clause", "union_list", "$@80", "union_opt",
  "union_order_or_limit", "$@81", "order_or_limit", "union_option",
  "query_specification", "query_expression_body", "$@82", "subselect",
  "subselect_start", "subselect_end", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,    45,    43,    42,
      47,    37,    40,    41,    44,    33,   123,   125,    46,    64
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   390,   391,   391,   392,   392,   393,   393,   393,   393,
     393,   393,   393,   393,   393,   393,   393,   393,   393,   393,
     393,   393,   393,   393,   393,   393,   393,   393,   393,   393,
     393,   395,   394,   396,   394,   397,   394,   398,   398,   398,
     398,   399,   400,   399,   401,   402,   401,   403,   401,   405,
     406,   404,   407,   407,   408,   408,   408,   409,   409,   410,
     410,   410,   411,   411,   412,   412,   413,   413,   414,   414,
     415,   415,   415,   416,   417,   417,   417,   417,   417,   417,
     418,   419,   420,   420,   420,   421,   421,   422,   422,   423,
     423,   424,   424,   425,   425,   425,   425,   425,   426,   426,
     427,   428,   428,   429,   431,   430,   432,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   434,   433,   433,   435,   436,   436,   437,   437,   438,
     438,   438,   439,   439,   439,   440,   441,   441,   442,   442,
     443,   443,   444,   444,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   446,   446,   447,   448,
     448,   449,   449,   450,   450,   451,   452,   452,   453,   453,
     454,   454,   454,   454,   455,   455,   455,   455,   455,   456,
     456,   456,   456,   456,   457,   458,   458,   459,   459,   460,
     460,   461,   461,   461,   462,   462,   463,   464,   464,   465,
     465,   466,   466,   467,   467,   468,   468,   468,   469,   469,
     470,   470,   471,   471,   472,   472,   473,   473,   474,   474,
     476,   475,   477,   475,   478,   478,   479,   479,   479,   479,
     480,   480,   480,   481,   481,   482,   483,   483,   483,   484,
     483,   485,   486,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   487,   487,   488,
     488,   489,   489,   489,   490,   490,   490,   490,   491,   492,
     492,   494,   493,   496,   495,   498,   497,   499,   499,   500,
     501,   502,   502,   503,   503,   504,   504,   506,   505,   508,
     509,   507,   510,   510,   510,   510,   510,   511,   512,   512,
     513,   513,   514,   514,   514,   514,   514,   514,   514,   515,
     515,   515,   516,   516,   516,   517,   517,   518,   519,   520,
     520,   520,   520,   520,   521,   521,   522,   522,   522,   522,
     522,   522,   522,   522,   522,   522,   522,   523,   523,   523,
     523,   523,   523,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   526,   527,   528,   529,   529,   529,
     529,   529,   529,   530,   530,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   531,   531,   531,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   534,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   536,   535,   537,   537,   538,
     538,   539,   540,   540,   540,   540,   541,   542,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   543,
     540,   545,   544,   546,   546,   546,   547,   547,   548,   548,
     549,   549,   551,   550,   552,   552,   552,   552,   552,   553,
     553,   554,   554,   555,   555,   556,   556,   557,   557,   558,
     559,   559,   560,   560,   561,   561,   562,   561,   563,   561,
     564,   561,   561,   565,   561,   566,   561,   561,   567,   561,
     568,   561,   561,   569,   569,   569,   571,   570,   570,   570,
     572,   573,   574,   572,   575,   577,   578,   576,   580,   579,
     582,   583,   581,   584,   585,   586,   586,   587,   587,   587,
     587,   588,   588,   590,   589,   591,   589,   592,   592,   593,
     594,   593,   596,   595,   597,   597,   598,   598,   599,   599,
     600,   600,   601,   601,   601,   601,   601,   601,   601,   601,
     601,   601,   601,   601,   602,   602,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   604,   604,   604,   605,   605,
     606,   606,   607,   608,   607,   609,   610,   609,   611,   611,
     612,   612,   613,   613,   614,   614,   615,   616,   616,   617,
     618,   618,   620,   619,   621,   621,   622,   622,   622,   623,
     623,   624,   624,   625,   626,   626,   626,   627,   627,   627,
     628,   628,   629,   629,   629,   629,   629,   629,   630,   630,
     630,   630,   630,   632,   631,   633,   633,   634,   636,   635,
     638,   637,   637,   637,   639,   640,   639,   639,   641,   641,
     642,   643,   643,   644,   644,   646,   647,   645,   649,   650,
     648,   651,   651,   652,   653,   653,   653,   654,   653,   655,
     655,   656,   656,   657,   656,   658,   656,   659,   659,   660,
     660,   661,   662,   662,   663,   663,   665,   664,   666,   666,
     667,   667,   668,   668,   669,   670,   669,   672,   673,   671,
     674,   674,   675,   676,   676,   677,   679,   678,   681,   680,
     682,   682,   683,   684,   685,   685,   687,   686,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   689,   689,   690,   690,   691,   691,   691,
     693,   692,   694,   692,   695,   695,   696,   696,   697,   697,
     697,   699,   698,   700,   700,   702,   701,   701,   701,   701,
     703,   703,   704,   705,   705,   705,   706,   708,   709,   710,
     711,   707,   712,   713,   713,   714,   714,   714,   715,   715,
     716,   716,   717,   717,   717,   717,   718,   718,   719,   719,
     720,   720,   721,   721,   722,   722,   723,   723,   723,   724,
     724,   725,   725,   726,   726,   727,   727,   728,   728,   728,
     729,   729,   729,   730,   730,   730,   730,   730,   730,   730,
     730,   730,   731,   731,   731,   731,   731,   732,   732,   733,
     733,   734,   735,   735,   736,   736,   737,   737,   737,   738,
     738,   738,   738,   739,   739,   739,   740,   740,   741,   742,
     743,   744,   744,   745,   745,   745,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   746,   746,   746,   746,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   749,   748,
     750,   750,   751,   751,   753,   752,   754,   754,   754,   754,
     755,   755,   756,   756,   756,   756,   757,   757,   757,   757,
     758,   758,   759,   759,   760,   760,   761,   762,   762,   762,
     762,   763,   763,   763,   763,   763,   764,   764,   766,   765,
     768,   767,   769,   769,   770,   770,   770,   771,   771,   771,
     772,   772,   773,   774,   774,   775,   776,   777,   777,   779,
     778,   780,   780,   780,   782,   781,   783,   783,   784,   784,
     784,   785,   785,   786,   787,   786,   788,   789,   790
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     7,     0,    13,     0,     6,     2,     2,     3,
       4,     4,     0,     4,     0,     0,     5,     0,     7,     0,
       0,     6,     0,     1,     0,     1,     1,     1,     3,     1,
       3,     3,     0,     1,     0,     3,     0,     1,     1,     2,
       1,     2,     3,     1,     3,     3,     3,     3,     3,     1,
       4,     4,     1,     1,     1,     1,     2,     1,     3,     1,
       1,     2,     2,     7,     8,     8,     2,     2,     0,     1,
       2,     0,     1,     2,     0,     3,     2,     1,     2,     4,
       1,     4,     4,     1,     1,     1,     1,     1,     2,     2,
       2,     0,     5,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     0,     3,     1,     5,     0,     3,     0,     1,
       0,     1,     2,     1,     1,     2,     2,     2,     4,     1,
       3,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       1,     0,     1,     0,     1,     5,     0,     3,     3,     1,
       0,     2,     2,     2,     0,     3,     3,     6,     6,     1,
       1,     2,     2,     2,     1,     2,     2,     1,     1,     0,
       1,     1,     1,     1,     0,     1,     0,     1,     2,     0,
       1,     1,     2,     2,     2,     1,     3,     2,     1,     1,
       4,     2,     1,     4,     0,     1,     0,     2,     1,     3,
       0,     7,     0,     5,     0,     1,     0,     2,     2,     1,
       0,     1,     1,     1,     3,     2,     3,     2,     4,     0,
       6,     0,     0,     7,     3,     4,     3,     3,     2,     2,
       6,     5,     3,     3,     1,     1,     1,     0,     1,     0,
       1,     0,     2,     1,     0,     1,     1,     1,     3,     0,
       3,     0,     4,     0,     4,     0,     4,     1,     3,     3,
       1,     2,     4,     2,     3,     2,     3,     0,     3,     0,
       0,     6,     2,     1,     1,     2,     2,     7,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     4,     3,     1,     1,     3,     4,     0,     0,     0,
       2,     2,     1,     1,     0,     2,     3,     3,     3,     2,
       3,     4,     3,     4,     3,     4,     1,     3,     4,     3,
       3,     6,     1,     5,     6,     5,     7,     6,     8,     5,
       6,     4,     5,     1,     3,     3,     5,     5,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     2,     2,     3,     3,     5,     6,
       4,     4,     2,     6,     5,     6,     4,     4,     5,     4,
       2,     4,     4,     4,    10,     6,     8,     6,     4,     4,
       6,     4,     4,     4,     7,     7,     7,     6,     6,     6,
       6,     3,     4,     6,     8,     2,     8,     8,     6,     2,
       4,     6,     6,     8,     8,     6,     8,     6,     2,     4,
       8,     8,     2,     2,     4,     4,     3,     8,     4,     6,
       4,     6,     8,     4,     6,     0,     5,     0,     1,     1,
       3,     4,     4,     5,     5,     4,     0,     0,     7,     4,
       5,     4,     5,     4,     4,     4,     4,     4,     5,     0,
       8,     0,     3,     3,     1,     4,     0,     1,     0,     2,
       0,     1,     0,     3,     2,     2,     1,     1,     2,     1,
       3,     0,     1,     0,     2,     4,     5,     1,     1,     1,
       1,     4,     1,     3,     3,     3,     0,     6,     0,     6,
       0,     8,     4,     0,     8,     0,    10,     6,     0,     8,
       0,    10,     6,     1,     2,     2,     0,     4,     3,     5,
       3,     0,     0,     8,     1,     0,     0,     6,     0,     3,
       0,     0,     5,     0,     1,     0,     1,     0,     2,     3,
       3,     1,     1,     0,     7,     0,     7,     1,     2,     0,
       0,     2,     0,     2,     0,     1,     1,     1,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     0,     2,
       0,     1,     0,     0,     3,     0,     0,     3,     2,     0,
       0,     4,     4,     2,     0,     1,     3,     3,     1,     2,
       0,     1,     0,     4,     4,     2,     0,     1,     1,     0,
       1,     0,     1,     2,     1,     3,     3,     1,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     3,     1,     2,     0,     3,
       0,     5,     2,     1,     5,     0,     7,     4,     1,     3,
       1,     0,     2,     0,     1,     0,     0,     7,     0,     0,
       5,     2,     1,     1,     1,     3,     4,     0,     3,     3,
       1,     2,     2,     0,     3,     0,     5,     3,     1,     3,
       1,     3,     1,     1,     0,     1,     0,     4,     0,     1,
       3,     1,     1,     1,     0,     0,     6,     0,     0,    10,
       3,     1,     3,     3,     1,     3,     0,     4,     0,     6,
       0,     2,     1,     3,     0,     1,     0,     3,     2,     3,
       3,     4,     5,     5,     5,     5,     2,     2,     3,     1,
       3,     4,     3,     0,     2,     1,     1,     0,     2,     2,
       0,     4,     0,     4,     1,     1,     0,     1,     0,     1,
       1,     0,     3,     3,     1,     0,     3,     4,     1,     1,
       0,     1,     3,     0,     1,     1,     2,     0,     0,     0,
       0,    18,     1,     0,     1,     0,     1,     1,     0,     2,
       2,     1,     3,     4,     3,     3,     0,     2,     2,     1,
       3,     3,     0,     3,     1,     1,     0,     3,     2,     3,
       1,     1,     2,     0,     2,     1,     2,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       5,     1,     1,     1,     1,     1,     3,     4,     5,     1,
       5,     3,     2,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     4,
       0,     1,     1,     3,     0,     2,     1,     1,     1,     1,
       0,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       1,     2,     4,     5,     4,     6,     1,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       0,     3,     0,     1,     0,     3,     2,     0,     1,     2,
       0,     1,     4,     4,     5,     2,     3,     0,     1,     0,
       4,     0,     1,     1,     0,     2,     2,     1,     0,     1,
       1,     2,     3,     1,     0,     5,     3,     0,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,   230,     0,  1090,     0,  1092,   230,   736,   774,   775,
     683,     2,   781,   685,   793,     0,     0,     0,   688,  1092,
       0,   289,  1050,   746,     0,   744,  1088,   259,     0,     0,
       0,     0,     4,    10,     6,    26,     7,     8,    19,    23,
     280,    13,    15,    20,    29,    11,    27,    25,    12,   776,
      14,    16,    30,    17,    24,    28,     5,     9,    21,    22,
      18,   224,   232,   231,   259,  1087,  1086,   271,  1092,   273,
    1093,  1094,    64,    63,     0,    33,   740,   681,   684,     0,
       0,     0,   259,   794,   795,     0,   802,   797,     0,   275,
       0,  1094,   906,   907,   908,   909,   910,   911,   912,   913,
     914,   887,   915,   917,   916,   918,   888,   919,   920,   889,
     890,   921,   922,   924,   891,   925,   892,   926,   927,   928,
     929,   930,   893,   931,   933,   934,   932,   935,   936,   937,
     894,   938,   939,   940,   941,   942,   951,   895,   943,   945,
     944,   946,   947,   948,   949,   923,   953,   954,   955,   896,
     950,   956,   952,   957,   958,   959,   876,   960,   877,   961,
     962,   963,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,   976,   977,   978,   980,   979,   981,
     983,   982,   984,   986,   985,   987,   897,   988,   989,   990,
     991,   992,   898,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,   899,  1006,  1007,  1008,
    1009,  1010,   900,  1011,   901,  1013,  1012,  1014,   902,  1016,
    1017,  1015,  1018,  1019,   903,  1020,   904,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1033,  1034,
    1035,  1032,   905,  1036,  1037,  1038,  1039,  1040,  1041,  1043,
    1042,  1044,  1045,  1046,  1047,   881,  1105,   882,   886,   281,
     287,   298,  1051,  1048,  1062,   269,   745,     0,     0,   260,
       0,   796,   289,     0,     0,     1,     3,   949,     0,   772,
     770,   873,   222,   225,     0,     0,  1091,     0,     0,  1097,
       0,     0,    64,   194,   742,     0,   740,     0,     0,     0,
     681,   788,   789,  1087,   782,   784,   785,     0,   907,   914,
       0,   849,   501,     0,     0,   921,   922,     0,     0,   324,
     324,     0,     0,     0,   936,   937,   855,     0,     0,     0,
     846,   856,     0,   848,   959,     0,     0,     0,     0,   853,
       0,   976,   977,     0,     0,   981,     0,   324,   845,   852,
       0,   999,     0,     0,  1005,     0,  1010,  1011,     0,     0,
    1023,     0,     0,   324,   879,  1033,  1034,  1035,     0,   847,
     905,   854,  1041,   324,   324,     0,     0,     0,  1047,     0,
       0,  1127,     0,     0,   481,   792,   336,   342,   353,   363,
     376,   377,   379,   378,   383,   382,   843,   381,   844,   375,
     863,   881,   835,   862,   803,  1106,     0,     0,   693,   689,
     692,   680,  1100,  1097,  1107,   308,   303,   305,   306,   307,
     304,   302,   317,   299,   301,  1054,     0,     0,     0,   767,
     639,  1063,   193,   192,   191,  1064,   759,  1065,   763,     0,
       0,   639,     0,   747,     0,     0,   268,   743,  1089,   727,
     283,     0,  1111,   875,     0,   778,     0,   161,     0,   272,
     678,   274,  1096,     0,     0,  1098,  1102,   366,     0,    35,
       0,   195,     0,     0,   737,   741,   682,   677,     0,     0,
       0,     0,   790,   686,     0,   610,   392,   502,     0,     0,
       0,     0,     0,     0,   610,     0,   425,   400,     0,     0,
       0,     0,   850,     0,     0,  1127,     0,   486,     0,     0,
       0,  1127,     0,     0,   610,     0,     0,   610,     0,     0,
     329,     0,   429,     0,     0,     0,     0,     0,     0,     0,
       0,   610,   610,     0,     0,   610,     0,   438,     0,   851,
       0,     0,     0,     0,     0,   442,   443,     0,   610,   610,
       0,   385,   384,     0,     0,     0,     0,     0,     0,   365,
     364,     0,     0,     0,   367,     0,   368,   369,     0,   370,
     371,   372,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   836,   455,     0,   804,     0,
     276,   277,     0,   691,     0,  1101,     0,  1103,  1118,   288,
    1108,   314,   290,   313,     0,   300,  1049,  1052,  1060,   765,
     766,     0,     0,    64,     0,     0,     0,   748,     0,   757,
     640,   767,     0,   763,   767,   756,     0,   767,   767,     0,
       0,   284,  1112,   282,  1113,     0,   773,   839,   838,   771,
     779,   837,   780,   874,   162,   223,     0,   220,     0,  1095,
    1099,    65,    54,    31,     0,   738,     0,   674,     0,   783,
     791,   786,     0,     0,   611,   610,     0,   492,     0,   503,
       0,   499,     0,     0,     0,     0,   466,     0,   492,   325,
     446,     0,     0,     0,     0,     0,     0,   583,   584,   585,
     586,   596,   587,   588,   589,   598,   603,   590,   591,   599,
     600,   601,   592,   602,   597,   593,   604,     0,   582,   487,
     479,     0,     0,     0,     0,     0,     0,   610,     0,     0,
       0,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   610,     0,
       0,     0,   595,     0,   594,     0,     0,     0,     0,     0,
       0,   421,     0,   865,   864,     0,     0,     0,   387,     0,
     386,   545,     0,  1123,  1128,     0,     0,   885,   878,  1066,
     482,   884,   883,   484,   327,   326,   328,   339,   332,   337,
     330,   334,     0,   373,   910,   340,     0,     0,   361,  1127,
     619,   362,     0,   355,     0,   354,   358,   359,   360,     0,
       0,     0,   380,   317,   866,     0,     0,     0,    49,   697,
       0,     0,     0,   703,   690,   694,  1104,  1120,  1119,  1109,
     317,   630,   318,   318,   862,  1054,  1057,  1058,  1061,  1059,
       0,  1056,  1055,  1070,   763,     0,     0,   762,   768,   769,
     648,   649,   647,   643,   644,   749,   764,   767,   750,   763,
     758,   760,   270,     0,     0,   639,  1117,  1115,   714,   161,
     679,    36,    56,    57,    55,    59,    66,   196,   612,   675,
     787,   724,     0,     0,   462,     0,     0,     0,     0,     0,
       0,   399,     0,   444,   445,     0,     0,   465,     0,     0,
       0,   401,   402,   396,   390,     0,     0,   403,     0,     0,
       0,     0,     0,     0,   471,   448,   408,     0,   469,     0,
     409,   430,     0,   450,     0,     0,   453,     0,     0,   411,
     475,   473,     0,     0,     0,     0,   477,   439,   412,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   413,     0,
     397,   474,   476,   422,     0,  1121,   544,   298,   545,     0,
       0,  1118,  1126,   391,   867,     0,     0,     0,     0,     0,
     333,   338,   331,   335,  1127,     0,     0,     0,     0,   351,
       0,     0,     0,  1127,   619,     0,     0,   458,   459,     0,
     880,   798,   278,   279,   298,     0,   716,   701,   708,   702,
       0,     0,     0,   700,   858,   857,   864,  1107,     0,   312,
     536,   668,   309,   294,   641,   631,   293,   319,   315,     0,
    1053,  1032,  1076,     0,     0,  1071,   767,     0,   761,     0,
       0,   751,   612,   728,   731,     0,   632,  1116,   712,   713,
     715,     0,   257,   257,   714,   257,   714,     0,   938,   939,
     257,   951,     0,   255,   961,   257,     0,   264,   254,    68,
      73,    79,     0,   221,   229,     0,   233,   256,     0,     0,
       0,     0,   101,    32,   805,    67,    70,   197,     0,   613,
     630,   676,     0,   687,     0,     0,   463,   493,     0,   504,
       0,   394,   136,   136,   497,   496,   132,     0,   500,     0,
     467,   464,     0,     0,     0,   490,     0,     0,     0,   398,
       0,   472,   470,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   388,   317,   285,     0,  1122,  1124,
    1067,  1068,  1069,   216,   483,     0,   349,   345,     0,   343,
     618,   357,   356,     0,     0,     0,   352,   318,   456,   317,
     868,   805,   317,   698,   710,     0,   718,     0,     0,   695,
     705,     0,     0,   704,  1110,   554,   553,     0,   510,   612,
     512,   509,   508,   507,     0,   553,   663,     0,     0,   291,
     296,   292,   642,   295,     0,   316,   323,   322,   859,   866,
       0,     0,  1066,     0,   752,   755,   754,   646,   645,   753,
       0,   612,     0,     0,   160,   159,    81,   158,   258,   214,
     188,   187,   237,     0,    98,   214,   184,   235,     0,     0,
       0,     0,     0,   248,   227,     0,     0,     0,     0,   249,
       0,   228,     0,     0,   267,   266,   265,     0,    69,   714,
     161,   101,     0,   261,    98,   104,   869,     0,    58,   661,
     662,   660,   658,   659,    61,    60,    66,     0,    37,     0,
       0,    87,    89,    90,   807,   806,    38,    52,   161,    71,
       0,     0,   198,     0,     0,   650,   725,     0,   423,   505,
       0,     0,   494,   495,     0,   498,   134,   393,   395,     0,
       0,     0,   428,   488,   491,     0,     0,   405,     0,   407,
     449,   431,   451,     0,   410,   389,     0,   432,     0,   437,
     435,     0,     0,     0,   419,     0,   417,     0,   418,     0,
     420,   454,   546,   286,     0,     0,   485,   341,     0,   350,
     347,     0,   344,   319,   460,     0,    50,     0,     0,   723,
     722,     0,   719,   721,   707,  1111,   696,   699,   553,   536,
       0,     0,   533,   555,     0,   555,   536,   536,   620,   536,
     605,   550,     0,     0,   673,     0,   669,   310,     0,   321,
     320,     0,     0,  1084,  1085,  1082,  1083,  1081,  1072,     0,
       0,   730,   630,   732,   861,   633,   636,   103,   215,     0,
       0,     0,   189,    97,   214,    96,    99,   196,     0,    76,
     239,    75,   253,   214,   246,   247,   244,    74,   241,   626,
     628,   636,   252,     0,   234,     0,   872,     0,   263,   236,
       0,    91,    92,     0,     0,    78,    77,    39,     0,    42,
      66,   101,    53,     0,    72,   208,   209,   204,   203,     0,
     614,     0,   739,     0,     0,   506,     0,     0,   468,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   416,   414,   415,   641,  1125,   217,   346,     0,
     461,   799,   641,   709,   711,   717,     0,   706,     0,   630,
     548,     0,   535,   534,   556,     0,   536,   555,   555,     0,
     515,   514,     0,   615,   513,   606,   607,     0,   572,   538,
     298,   672,   670,     0,   664,   666,     0,   860,     0,     0,
    1080,  1073,     0,  1074,   650,     0,   637,   638,   635,   100,
     214,   185,   190,   186,   196,     0,     0,     0,     0,   245,
       0,     0,   629,    80,   238,   262,   166,   128,   116,   124,
     115,   113,   132,   130,   121,   132,   127,   132,   129,   123,
     117,   114,     0,   126,   105,   140,   110,     0,   107,   138,
     871,    40,  1114,   805,    88,     0,    45,     0,   651,     0,
     424,   137,   133,     0,   426,   427,   489,   480,   447,     0,
     406,   452,   433,   436,   434,   440,   441,   309,   309,    85,
     348,     0,    51,   720,  1118,   605,   641,   536,   511,   536,
     522,     0,     0,   536,   518,   516,   520,     0,   616,   630,
     609,   537,   569,   317,   808,   667,     0,   311,  1078,  1077,
    1079,     0,   729,   636,     0,     0,     0,   251,     0,   261,
     242,   627,     0,   170,   118,   131,     0,   120,   119,     0,
     149,     0,     0,     0,     0,   144,     0,   164,     0,   152,
     106,   141,   143,     0,     0,   125,     0,     0,     0,   139,
     108,     0,    43,    41,     0,  1107,     0,   636,   212,     0,
       0,     0,   547,    86,     0,   541,   539,   540,   549,     0,
     507,   536,   536,     0,   507,     0,     0,     0,   624,   636,
       0,   641,   573,     0,   551,     0,   816,   665,  1075,   634,
       0,     0,     0,     0,     0,     0,     0,   250,   840,   240,
     261,     0,   169,     0,   174,     0,     0,   155,   154,   324,
     147,   157,    82,    84,    83,   145,     0,     0,   153,   142,
     151,   146,     0,     0,     0,   870,    47,    46,   199,     0,
     211,     0,   726,   734,     0,   135,   404,   800,     0,   523,
       0,   527,   532,   528,     0,   519,   517,     0,   625,     0,
     621,   623,   617,   297,   561,   562,     0,     0,   567,   571,
     641,     0,     0,     0,     0,   809,   811,     0,   671,     0,
       0,   199,   842,   841,   243,   167,     0,   171,   172,   173,
       0,   165,     0,   218,   112,   156,   324,   150,   109,   111,
    1114,     0,   714,    34,   200,   205,   201,   636,     0,     0,
       0,   808,   542,     0,     0,     0,     0,     0,   580,   636,
     557,   557,   568,   552,     0,     0,     0,     0,   810,     0,
       0,   817,   819,     0,   199,    93,   168,     0,     0,   122,
       0,   148,    48,   207,     0,   202,   210,   213,   733,   735,
     816,   630,   524,     0,   529,     0,   521,     0,   622,     0,
     565,   563,   814,   815,     0,   812,     0,     0,   818,    95,
      94,   180,     0,   179,     0,   176,   175,   219,   656,   657,
     653,   654,   652,   655,   206,   822,   641,     0,     0,   581,
       0,   558,     0,     0,     0,   813,   821,   820,   182,   183,
     181,     0,     0,     0,   826,   543,   526,   531,   560,   559,
     574,     0,     0,     0,     0,     0,   833,   577,     0,   578,
     575,   576,     0,   178,   177,   824,   825,   823,   828,     0,
       0,   830,   831,     0,   801,   566,     0,   564,   832,   827,
       0,   834,   579,   829
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    30,    31,    32,    33,   866,   293,   652,  1063,  1258,
    1562,  1266,  1665,  1800,   813,   984,  1472,  1433,   861,   862,
     863,    74,   291,  1064,  1048,  1065,  1066,  1050,  1051,   645,
    1725,  1587,  1260,  1261,  1262,  1263,  1395,  1396,  1213,  1214,
    1244,  1423,  1554,  1555,  1636,  1556,  1557,  1558,  1559,  1285,
    1286,  1282,  1660,  1650,  1651,  1652,  1720,  1205,  1206,  1052,
    1653,  1422,  1633,  1711,  1714,  1791,  1875,  1215,  1394,  1216,
    1523,   442,   472,  1067,  1068,  1803,  1804,  1805,  1806,  1437,
    1666,  1667,  1387,  1326,  1792,    34,   859,   457,   282,  1053,
      64,  1054,  1055,  1056,  1528,  1530,  1710,  1217,   270,  1419,
    1237,    35,   446,    36,   285,    37,   287,    38,   406,   590,
     591,    39,    40,   274,   950,   259,   414,   260,   261,   821,
    1002,  1588,   422,   423,   424,  1179,   602,   603,   604,  1007,
    1185,   496,   671,   386,   387,   388,   562,   563,  1654,   572,
     786,   389,   390,   391,   392,   393,   803,   976,   977,   978,
     394,   886,  1289,   896,   395,   558,   770,   710,  1452,  1293,
     666,   875,  1087,   944,   488,   879,   669,  1168,  1169,  1170,
    1171,  1172,  1686,  1685,  1687,  1813,  1750,  1815,  1754,  1357,
    1173,  1174,  1478,  1748,  1851,   945,   946,   947,  1465,  1479,
    1597,  1499,  1500,  1770,  1348,  1175,  1485,  1860,  1767,  1768,
    1894,  1893,  1769,  1692,  1693,  1611,  1612,  1918,  1919,  1920,
    1817,   707,   743,   708,  1497,  1498,   667,  1070,  1274,  1609,
    1690,   969,  1493,  1688,  1760,  1057,  1409,  1410,  1004,  1005,
    1203,  1385,  1518,   619,  1589,  1182,   843,   844,  1442,  1884,
    1254,  1364,  1365,  1504,  1505,  1006,  1176,  1366,  1614,    41,
    1071,   459,   460,   298,    80,    42,    82,   662,    43,    90,
     594,   409,   410,   814,   985,   992,   815,   997,  1345,   987,
    1153,  1154,  1030,  1031,   988,  1156,  1341,  1342,  1343,  1073,
    1443,    44,   630,  1201,  1023,  1024,  1742,  1743,    45,    76,
     474,   868,   295,   296,    46,   267,    47,   264,   443,   621,
     622,   617,    48,   455,   454,    49,   279,   639,    50,    81,
     304,   305,   482,   661,    51,    85,    52,    53,   404,  1151,
    1591,  1811,    87,   589,  1267,  1696,  1775,  1776,  1778,  1831,
    1832,  1904,  1927,  1916,  1930,  1931,  1934,   396,   640,  1707,
     397,   398,   993,   994,  1386,   399,  1744,   400,  1245,   411,
     401,   771,   402,   981,   403,  1058,   257,   258,    54,   425,
     263,   606,   607,   608,   830,   831,   444,   958,   832,   833,
    1015,  1013,  1511,  1378,   306,    55,   268,    56,    68,    71,
     289,   466,   596,    57,    58,    59,    60,   599,   632,   998,
     633,   634,   635,   857,   819,   763,   764,  1324,   554,   555,
     952
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1689
static const yytype_int16 yypact[] =
{
    1406,   502,   123, -1689,   123,  -167,   656, -1689, -1689, -1689,
     765, -1689, -1689, -1689,    45,   295,   124,   123, -1689,  -167,
   19751, -1689,   -23, -1689,   -78,   106, -1689,   376, 19751,  -160,
     568,   427, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, 12390,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, 19751, -1689, -1689,   376, -1689, -1689, -1689,  -167, -1689,
   -1689,   661,   491, -1689,   353, -1689,   589,   564, -1689,   622,
     123,   455,   376, -1689, -1689,  5661, -1689, -1689, 19751, -1689,
   11656,    40, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689,   621, -1689, -1689,  1307,   388, -1689, 12757,   123, -1689,
   12757, -1689, -1689,  -160,   365, -1689, -1689,   -68, 19751, -1689,
   -1689,   379, -1689, -1689,   473, 12757, -1689, 12757,    67,   -58,
     598, 19751,   491,   474, -1689,   723,   589,   772, 19751, 19751,
     564, -1689, -1689,   514,   510, -1689, -1689, 11656,   516,   518,
    7932, -1689,  5661,   520,   537,   544,   557,   574,   576,   590,
     590,   597,   611,   627,  -138,   646, -1689,   652,   654,   663,
   -1689, -1689,   665, -1689,   668,   672,   681,  6038,   690, -1689,
     695,   704,   707,   709,   712,   718,  5661,   721, -1689, -1689,
     729,   737,   742,   759,   764,   768,   781,   786,   789,   797,
     801,   806,   808,   810, -1689,   101,   812,   815,   817, -1689,
     819, -1689,   829,   590,   590,   836,   841,   848,   849,  7932,
    7932,  5661, 19751, 19751, -1689,   674,   890, -1689,   748,   862,
   -1689, -1689, -1689, -1689, -1689, -1689,   604, -1689, -1689, -1689,
   -1689,   850, -1689,   586,   996, -1689, 12757, 12757, -1689, -1689,
   -1689, -1689,   779,   -58,   734, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689,   691,   621, -1689, -1689,   239,   853,     8,   -84,
     950, -1689, -1689, -1689, -1689, -1689, -1689, -1689,   239,   922,
     915,   950,   239, -1689,  -148,  1182, -1689, -1689, -1689, -1689,
   -1689,   860,    -2, -1689,   215, 17182, 19751,  1156, 12757,   861,
   -1689,   861, -1689,  1206,   987, -1689, -1689, -1689,  1131, -1689,
   12757, -1689,  1095, 12757, -1689, -1689, -1689, -1689,  1024, 12757,
    1001,   455, 12757, -1689,  5661,   125,   862,   674,   889,  5661,
    5661,  5661,  5661,  5661,   151,   875, -1689, -1689,   876,  5661,
    5661,  5661,   604,  5661, 13124, -1689,  2149,  1165,  5661,  5661,
    5661,  5661,  1652,  5661,   222,  5661,  5661,   380,  5661,  5661,
   -1689,  4144, -1689,  7932,  5661,  5661,  5661,  5661,  5661,  5661,
    5661,  1253,  1253,  5661,  5661,   610,  4144, -1689,  5661,   604,
     955,   955,  3381,  5661,   881, -1689, -1689, 13124,  1253,  1253,
    5661,   862,   862,    32,   882,   332,  5661,   878,  9063, -1689,
   -1689,  5661,  5661,  5661, -1689,  7932, -1689, -1689,   744, -1689,
   -1689, -1689,  6424,  7932,  7932,   885,  7932,  7932,  8309,  8686,
    7932,  7932,  7932,   398, 18283, -1689, -1689, 19751, -1689,  1112,
     886, -1689,   934, -1689,   726, -1689, 19751, -1689,   630, -1689,
   -1689, -1689,   892, -1689,  5661, -1689,   893, -1689,   631, -1689,
   -1689, 12757,   894,   491, 12757,   945,  5661, -1689,   460, -1689,
   -1689,   -84, 19751,   239,   -84, -1689, 12757,   -84,   -84,   984,
     993, -1689, -1689, -1689, -1689,    -8, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689,  1234, -1689, 12757, -1689,
   -1689, -1689, 16448, -1689, 19751, -1689, 12757,   861,  1096, -1689,
     861, -1689,   726,    74, -1689,  1253,   901, -1689,  5661,   -45,
      71,   674,   430,   492,   134,   115, -1689,   902,   908, -1689,
   -1689,   135,   141,   183,   227,   905,   907, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689,  1159, -1689, -1689,
   -1689,   270,   142,   156,    98,   916,   157,  1253,   912,   292,
     300,  1253,   913,   159,   316,   334,   754,   335,   161,   168,
     347,   174,   177,   348,   917,   919,   181,    33,  1253,   920,
     378,   383, -1689,   923, -1689,   924,  4530,  4907,  5284,    51,
     185, -1689,   921, -1689,   586,   926,   929,   400, -1689,  5661,
   -1689, -1689,   374, -1689,   959,    26, 19751, -1689, -1689,   555,
   -1689, -1689, -1689,  1025,  1302,    34, -1689, -1689, -1689, -1689,
   -1689, -1689,    15, -1689,   937, -1689,   938,   551, -1689,  5661,
      94, -1689,  6038,   699,  6038,   699, -1689, -1689, -1689,  7932,
     941,  7932, -1689,   933,   936,   998, 12757, 12757, -1689, -1689,
     947,   947, 11289, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689,     1,   674, -1689,   942, -1689, -1689, -1689, -1689, -1689,
   20118,   943, -1689, -1689,   239,   954, 19751, -1689, -1689,   674,
   -1689, -1689, -1689, -1689,   -66, -1689, -1689,   -84, -1689,   239,
   -1689, -1689, -1689, 13124,  1300,   950, -1689, -1689,   -16, 15341,
   -1689, -1689, -1689,   960, -1689,   -16, 14231, -1689,   969, -1689,
   -1689,  1111,  6801,   962, -1689,  5661,   116,  5661,  5661,  1239,
    1065, -1689,  5661, -1689, -1689,  1065,  5661, -1689,   964,  1187,
    1188, -1689, -1689, -1689, -1689,  5661,  5661, -1689,  5661,  5661,
    5661,  5661,  5661,   972, -1689, -1689, -1689,   975, -1689,  5661,
   -1689, -1689,  5661, -1689,  5661,  5661, -1689,  5661,  5661, -1689,
   -1689, -1689,  7178,  5661,  5661,   977, -1689, -1689, -1689,  5661,
    5661,  5661,   130,  5661,   249,  5661,   606,  5661, -1689,  5661,
   -1689, -1689, -1689, -1689,   521, -1689, -1689,   621, -1689,   374,
     981,   630, -1689, -1689, -1689,   979,   985,   988, 18283,  5661,
   -1689, -1689, -1689, -1689, -1689,  7932,   111,   982,  7932, -1689,
    1652,  1652,   688,  5661,    94,  5661,   994,   968, -1689, 19751,
   -1689, -1689, -1689, -1689,   621, 13124, -1689,   997, -1689,   997,
     377,   995,   558, -1689, -1689, -1689,   942,   734,   215, -1689,
     415, -1689,    17,  1218,   950, -1689,  1248, 18650, -1689, 14598,
   -1689,  1219, -1689,   -16,  9436, -1689,   -84,   -40, -1689,   460,
     460, -1689,   969,  1006, -1689,   -16, -1689, -1689, -1689, -1689,
   -1689, 17549,    44,  1341,   -16,  1341,   -16,  1060,  1227,  1074,
     693,  1232,   -16, -1689,  1083,    31,  1379,    50, -1689, 16815,
   -1689, -1689,  1367, -1689,  1031, 12023, -1689, -1689,   -16, 18283,
   16081, 12757, 10555, -1689,    97, -1689, 13858,  -159,  1190, -1689,
    1183, -1689,  1320, -1689,  6038,   457, -1689,   674,  5661,   674,
     454, -1689,  1040,  1040, -1689, -1689,  1041,  1043,   674,  1044,
    1048, -1689,  5661,  5661,   489,  -124,   186,   205,   119, -1689,
     500, -1689, -1689,   512,   527,   532,   206,   542,   641,  6038,
     563,   104,   137, -1689,   214,   243,   570,  5661,   571,  5661,
     587,  5661,   588,   592, -1689,   691, -1689,  1046, -1689, -1689,
   -1689, -1689, -1689,  1036,   674,  1051, -1689, -1689,  5661, -1689,
     862, -1689, -1689,  7932,   139,  1053, -1689,   674, -1689, -1689,
   -1689,   -32,   691,  1055, -1689,   -16,  7555,   947,  1160, -1689,
   -1689,   377, 13124, -1689, -1689, -1689, -1689, 19751,   685,   969,
   -1689,  1056, -1689, -1689, 12757, -1689,   143,  1091,  1279, -1689,
   -1689, -1689, -1689, -1689, 19017, -1689, -1689, -1689, -1689,  1059,
    1271,  3767,   555,   -16, -1689, -1689, -1689, -1689, -1689, -1689,
   13124,   969,  7555,  5661, -1689, -1689, -1689, -1689, -1689, 13491,
   -1689, -1689, -1689,    89,   565, 13491, -1689, -1689, 13491,    -1,
   13491,   945, 17549, -1689, -1689,  1278,  1280, 13491, 13491, -1689,
   18283, -1689, 13491, 13124, -1689, -1689, -1689, 12757, -1689,   -16,
   15714, 10922, 19751,   118,    38, -1689,  1064, 16081, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689, -1689, 16815, 12757, -1689,  1070,
     675, -1689, -1689, -1689, -1689, -1689, -1689,  1444, 17916, -1689,
     100,   100, -1689, 12757,  5661,  1283, -1689,  1652, -1689,   674,
    5661,  1236, -1689, -1689,  1241, -1689, -1689, -1689, -1689,  1084,
    1652,  1652, -1689,  1186, -1689,  5661,  5661, -1689,  5661, -1689,
   -1689, -1689, -1689,  5661, -1689, -1689,  1652, -1689,  5661, -1689,
   -1689,  5661,  5661,  5661, -1689,   595, -1689,   612, -1689,   614,
   -1689, -1689,   892, -1689,   332, 19751, -1689, -1689,   678, -1689,
   -1689,  5661, -1689, 18650, -1689,  1304,   892, 13124,  7555,   652,
     674,  1085,  1090, -1689, -1689,    -2, -1689, -1689, -1689,   423,
    1310,  1311, -1689,  1237,   720,  1237,   423,   423,  1343,   415,
     483, -1689,   998,   998, -1689,  1098, -1689, -1689,  1193, -1689,
   -1689, 14965,   572, -1689,  7932,   652, -1689,   674, -1689, 19751,
    5661, -1689,  1183, -1689,   674,  1106,   167, -1689, -1689,  5661,
    1321,  1322,    37, -1689, 13491, -1689, -1689, -1689,    21, -1689,
   -1689, -1689, -1689, 13491, -1689, -1689, -1689, -1689, -1689,  1110,
   -1689,   167, -1689, 17549, -1689,   692, -1689, 19751, -1689, -1689,
   12757, -1689, -1689,  1200, 19751, -1689, -1689, -1689,  1116, -1689,
   16815, 10922, -1689,   429, -1689, -1689, -1689, -1689, -1689,  1119,
     674,   460, -1689,  1332,   294,   674,  1122,   732, -1689,  1124,
    1127,    22,  1129,   634,   297,   753,   636,   329,   640,   644,
     648,   670, -1689, -1689, -1689,    10, -1689, -1689, -1689,   755,
   -1689, -1689,    10, -1689, -1689, -1689,  7555, -1689,  -171,  1183,
   -1689,   556, -1689, -1689, -1689,  1345,   423,  1237,  1237,  1346,
    1289,   -99,  1485,  1377, -1689, -1689, -1689, 19751, -1689, -1689,
     621, -1689, -1689, 18283,  1138, -1689,  1319, -1689,    13,  1273,
   -1689, -1689,   -16,   674,  1283,  5661, -1689, -1689, -1689,   674,
   13491, -1689, -1689, -1689, -1689,  1147,  1443,  1445, 13491, -1689,
    1200, 13124, -1689, -1689, -1689, -1689,  1153, -1689, -1689, -1689,
   -1689, -1689,  1041,  1291, -1689,  1041, -1689,  1041, -1689, -1689,
   -1689, -1689,  1155, -1689, -1689,   986,  -198,  1157, -1689,  1163,
    1150, -1689,   -17,    97, -1689,  1160, -1689, 19751, -1689,  1191,
   -1689, -1689, -1689,  1324, -1689, -1689, -1689, -1689, -1689,  5661,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689,    17,    17, -1689,
   -1689,  1223, -1689, -1689,   630,   163,   950,   415, -1689,   423,
   -1689,  1383,  1384,   423, -1689, -1689, -1689,  5661, -1689,  1183,
   -1689, -1689,   -39,   691,  1505, -1689,  1098, -1689, -1689, -1689,
   -1689,  3767, -1689,   167,  1173,  1177, 19751, -1689,  1265,   118,
   -1689, -1689, 19751,  1369, -1689, -1689,  1181, -1689, -1689,  1340,
   -1689, 18283,   945,  1214,   847, -1689,  1220, -1689,  1477,  1398,
   -1689,   986, -1689,  1399,  1349, -1689,  1350,  1351,  1352, -1689,
   -1689, 19751, -1689, -1689,  1194,   734,   761,   167,  1197, 13124,
    1198,   677, -1689, -1689, 12757, -1689, -1689, -1689,  1056,  1185,
    1228,   423,   423,  1288,  1229,  5661,  5661,  1203,   484,   167,
    5661,   950, -1689,   -30,   892,   623,  1401, -1689, -1689, -1689,
   19751, 19751,   769,   604,   604,   593,   593, -1689, -1689, -1689,
     118,   776, -1689,   -26,  1358,    22,  1204, -1689, -1689,   590,
   -1689, -1689, -1689, -1689, -1689, -1689,  1374,  1231, -1689, -1689,
   -1689, -1689,  1205,  1213,  1215, -1689, -1689, -1689,   536, 19751,
   -1689,  1376,  1221, -1689,   -16, -1689, -1689, -1689,   332, -1689,
    1243, -1689, -1689, -1689,  1247,   674,   674, 19751, -1689,  5661,
   -1689, -1689,   674, -1689, -1689, -1689,    37,    37, -1689,   -30,
      10,  1570,  1574,  1503,  1577,   623, -1689,   336, -1689,   778,
     783,   536, -1689, -1689, -1689, -1689, 19751, -1689, -1689, -1689,
     -14, -1689,   790, -1689, -1689, -1689,   590, -1689, -1689, -1689,
     -17,   945,   -16, -1689,   536, -1689, -1689,   167,  1230, 13124,
    7555,  1505, -1689,  5661,  1233,  5661,  1235,   792, -1689,   167,
    1480,  1480, -1689, -1689,    22,    22,  1581,    22, -1689,  1583,
    1587,   336, -1689,  1370,   536, -1689, -1689,   784,   784, -1689,
      22, -1689, -1689, -1689,    12, -1689, -1689, -1689, -1689, -1689,
    1401,  1183,   674, 19751,   674, 19751, -1689, 19751, -1689,   724,
   -1689, -1689, -1689, -1689,    22, -1689,    22,    22, -1689, -1689,
   -1689, -1689,  1624, -1689,    30,  1403,  1404, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1689,  1483,   950,   794,   798, -1689,
    1603, -1689,  1604,  1256,  1257, -1689, -1689, -1689, -1689, -1689,
   -1689,  1293,  1551,  1421,  1264, -1689, -1689, -1689, -1689, -1689,
   19384, 19384,   784,   784,   -44,  9809,  1359, -1689,  1267, -1689,
    1263, -1689,   802, -1689, -1689, -1689, -1689, -1689, -1689, 18283,
     820, -1689, -1689, 13124, -1689, -1689, 19384, -1689, -1689, -1689,
   10182,  1221, -1689, -1689
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689,    88, -1689, -1689,  -800, -1689, -1689, -1689, -1689,   594,
   -1689, -1689,  -245, -1154,   609,  -966,  -816, -1689, -1689,  1000,
   -1689, -1405,   414,   228,   605,   629,   418,   450, -1689, -1689,
     140, -1689,   144, -1689, -1689, -1689, -1689, -1689, -1689,  -595,
     110,   582, -1689, -1689, -1689,    20, -1689,    35, -1047,  -366,
   -1689,  -158, -1689, -1689, -1689, -1689, -1688, -1689, -1689, -1022,
   -1689, -1689, -1689, -1689, -1273, -1131, -1689,   615,  -126,   408,
    -946,   -55, -1110, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
     766, -1689, -1689,   445, -1689, -1689, -1689,    77,   603, -1489,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
     880,  1238,   696,  1415,   740, -1689, -1689,  1418, -1689, -1689,
   -1689,  -707,  -922, -1689,  1268,  -611, -1099,   877,  -747,  -766,
     363,  -314,  1663, -1689,  -538,  1045, -1689, -1689,  -236, -1689,
   -1689,  -303, -1689, -1689, -1689, -1689, -1689, -1689, -1689,   552,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
     992, -1689,   818,  -477, -1689, -1689, -1689, -1219, -1689,   341,
     105, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
    -583, -1689, -1689, -1689, -1689, -1689,   756, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689, -1058, -1689,  -608,  -116, -1689,   -63,
   -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,  -229,  -203,
   -1008,  -497,  1169,   608, -1689,   120,  1217,  -921, -1689, -1689,
   -1689,   743, -1689, -1689, -1689, -1689, -1689,   187, -1053,  -607,
   -1689, -1689, -1340,  -399,  -993,  -390, -1689,  -984,   200, -1689,
   -1040, -1689, -1689, -1689,   108,   713, -1689, -1689, -1689, -1689,
   -1689,  -176,   -67,  1420, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689,  1419,  1315,  1063, -1689, -1689,  -884, -1689, -1689,   918,
   -1689,   390,  -855, -1012,   579, -1689, -1689, -1689, -1181, -1689,
   -1689, -1689, -1689, -1689, -1689,   538,  -194,   -69, -1689, -1689,
   -1689, -1689,  1446, -1689, -1689, -1689, -1689, -1689, -1689,  -536,
     393,  -555, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689,  1260, -1689, -1689, -1689, -1689, -1689, -1689, -1689, -1689,
   -1689, -1689, -1689, -1689,   596,   -62, -1689,   -31,  -107, -1689,
     -81, -1689, -1689, -1689, -1689,  -189, -1689,  -315, -1396,   109,
   -1434,  -490,   591,  1151, -1426,  1250,  -531,  -546,  -114,   -18,
     -20,  -610,  -394,  -137,   714,  -554, -1689, -1689, -1689, -1689,
   -1689, -1689,   939, -1689, -1689, -1689, -1689,   566, -1689, -1689,
   -1689,   382, -1689,   138,    76, -1689, -1689, -1689, -1689,   682,
    1671,  1354, -1689, -1689, -1689, -1689, -1689,  -977,  -411, -1689,
   -1308, -1689, -1689, -1689,  -932, -1285, -1689, -1689,  -473, -1689,
   -1689
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1115
static const yytype_int16 yytable[] =
{
     255,   753,   585,   600,   773,   838,   497,   486,   255,   502,
    1060,  1181,   991,   672,   673,   715,   752,  1275,  1227,  1129,
    1163,  1383,  1219,   408,  1221,  1125,  1322,   777,   855,   255,
     802,   280,   686,   522,   785,  1197,  1198,  1477,   559,  1466,
     620,   255,   625,  1049,   559,   559,   559,   470,   637,   537,
     539,   620,   288,  1336,   468,  1576,   975,  1008,   877,   545,
     546,   641,  1152,   559,  1234,  1618,   845,  1592,   255,   848,
     255,  1532,   850,   851,  1195,  1837,   551,   552,    67,   613,
      69,  1208,  1389,   559,  1249,   880,   559,   847,  -101,  1623,
    -570,   646, -1111,    89,  1208,   615,  1028,  1878,   865,  1764,
    1269,  1199,  1427,    83,  1209,  1397,  1159,   462,   585,  1787,
     559,   461,   854,  -570,  1003,  1354,   559,  1361,  1899,  1526,
    1264,   272,  1765,   559,  1525,  1417,  1250,   559,   559,  1605,
    1481,   559,  1435,  1389,   664,  1000,   960,  1925,  1491,  1879,
    1709,   584,   559,  -979,  1000,   585,   559,   559,  1177,   559,
    1876,   559,   583,   559,   559,  1880,   300,  1474,  1191,   627,
     664,  1019,  1235,  1001,   464,   638,  1655,   923,   559,   559,
    1202,   559,   618,   559,  -101,  1402,  1594,  1495, -1114,  1399,
     559,  1689,  1516,  1270,  1656,   937,   559,  1230,  1251,   559,
     618,   364,  1210,   559,  1708,   559,  1271,   559,   559,  1210,
     447,  1881,   465,  1247,  1178,    70,   -44,  1425,  1211,  1708,
     968,   262,  1595,  -777,   628,  1211,  1788,   559,   559,  1390,
     665,  1784,   273,  1252,  1923,  1924,   559,  1413,   854,  -608,
    1926,   664,  1265,  1049, -1114,  1308,  1882,   854,   961,   559,
     408,  1436,  1362,  1418,   501,   856,   676,   255,  1358,  1264,
     255,  1625,   449,  1900,  1662,   559,  1606,  1517,   255,   265,
     882,   559,  1259,   560,  1117,   255,   753,   255,  1789,   560,
     560,   255,  -608,   790,  1029,  1496,  1563,  1346,   255,   255,
    1382,   995,   559,  1699,  1524,   616,   646,   255,   560,   463,
    1480,  -101,  1021,  1529,  -608,  1593,    84,  1420,  1016,  1183,
    1338,  -608,  1434,   657,   559,  -608,   660,   753,   560,   559,
    1527,   560,   559,  1022,  -777,  -570,   967,   717,  1020,  1793,
    -608,  -979,  1025,   878,  1766,  -608,  1196,  1740,   559,  1514,
     598,  -608,   782,  1819,   614,   560,  1391,  1838,  1380,  -608,
     408,   560,  1253,  -608,   448,   598,   559,   559,   560,  1761,
    -608,   364,   560,   560,   962,  1883,   560,  1619,   991,   559,
     559,  1265,   255,   255,   963,  1823,  1533,   560,   836,    86,
    1522,   560,   560,   609,   560,   412,   560,  -608,   560,   560,
    1679,  1333,  1363,  1119,  1683,  1236,   255,   255,   592,   664,
     559,  -608,  -101,   560,   560,   559,   560,  1186,   560,  -608,
     561,    88,   975,   610,  1133,   560,   561,   561,   561,  1090,
    1624,   560,   559,   953,   560,   758,   759,   924,   560,  1095,
     560,   799,   560,   560,  1049,   561,  1596,  1136,  1862,  1863,
     364,  1865,   266,  -608,   938,   255,   255,  1392,   255,   753,
     647,  1108,   560,   560,  1877,   561,    65,  1078,   561,    66,
     255,   560,   653,   255,  1155,   655,  1027,  1568,   872,   255,
    1193,  1194,   255,  1812,   560,   620,   559,  1846,  1895,   559,
    1896,  1897,   561,  1141,  1142,   721,  -608,  1207,   561,  1858,
     560,   758,   900,   538,   255,   561,   560,  1309,  1294,   561,
     561,  1135,  1842,   561,  1137,  1138,    21,  1495,   974,   885,
    1145,   559,  1297,  1298,   561,   865,  1255,   560,   561,   561,
    -608,   561,   559,   561,  1694,   561,   561,   884,  -608,   889,
    1310,  1311,  1330,  1331,   559,   890,   898,   255,   269,   560,
     561,   561,  -608,   561,   560,   561,   276,   560,   255,   559,
     899,   902,   561,   909,   559,   914,  -608,  -608,   561,  -608,
    -608,   561,   915,   560,   559,   561,  1691,   561,   917,   561,
     561,   918,   800,   965,   255,   922,   891,   255,   275,   939,
    1295,   560,   560,    61,  1369,   559,   255,   801,  1613,   561,
     561,   860,   559,   559,   560,   560,   600,  1801,   561,  1296,
    1303,   255,  -608,   834,   255,  1496,   837,    29,  1312,   559,
     559,   561,   255,  1677,   559,  1329,   255,   559,   849,  1389,
     892,  1401,  -608,   761,  -608,   560,   753,   561,   559,   664,
     560,  -608,  1350,   561,   559,  -608,   559,  1313,   255,  1849,
     415,   995,   255,  1566,   255,  -608,   255,   560,   869,   817,
    -608,  1829,   290,   301,   561,  -608,   559,   574,   559,   840,
    1835,  -608,   559,   897,   753,   948,   559,  1621,   808,  -608,
     559,  1328,  1675,  -608,  1830,  1140,   561,   284,  1207,  1025,
    -608,   561,   901,   288,   561,   905,  1407,  1570,   326,   292,
    1702,  1579,   559,   906,   841,   307,   559,   753,  1737,   559,
     561,   560,   955,  1426,   560,  -102,  1165,  -608,  1763,   910,
    1143,    91,  1411,  1870,  1165,   738,  1802,   901,   561,   561,
     808,  -608,  1582,  1351,   762,   297,   416,   911,   913,  -608,
     331,   561,   561,  1186,  1352,   818,   560,    72,    62,  1771,
     916,   919,  1353,    63,   256,   810,   811,   560,  1772,   956,
    1121,   294,   271,  1208,  1820,  1821,   255,  1489,   452,   560,
     286,  1350,   561,  -608,  1779,  1780,   949,   561,   445,  1158,
     577,   927,   302,   281,   560,  1664,   928,   456,   826,   560,
    1354,   573,    75,  1490,   561,   283,    79,   299,   303,   560,
    1444,    66,   339,   943,   574,  1280,   255,   255,   592,   983,
    1844,   753,   255,  1449,  1450,   574,  -608,  1166,  1886,   458,
     560,  1167,   405,   842,   281,  1166,  1155,   560,   560,  1457,
     255,  1565,  -102,   881,   882,   827,   255,   349,   467,   611,
    1871,  1455,   471,  1225,   560,   560,  1355,  1508,   561,   560,
    -608,   561,   560,   255,  1509,   626,    77,  -608,  -608,   255,
    1278,   957,  1351,   560,   574,  1887,   255,  1888,  1210,   560,
     574,   560,  -608,  1352,  1469,  1758,  1510,   473,  1773,  1207,
     828,  1353,  1890,   561,  1211,   778,  -608,  -608,  1759,  1356,
    -608,   560,  1292,   560,   561,   883,   882,   560,  1270,  1601,
    1602,   560,    62,  1299,   480,   560,   561,    63,  1486,  1810,
     476,  1271,  1891,  1905,   481,  1300,  1487,   577,   484,  1354,
     485,   561,   489,  1600,  1124,   882,   561,   560,   577,   584,
    1301,   560,   575,  -102,   560,  1302,   561,   829,   912,   490,
    -230,   417,   418,   419,   420,  1304,   491,   576,   578,   579,
     580,   581,   582,   364,   421,  1722,   371,   561,   255,   492,
    1226,  1161,  1162,  1598,   561,   561,  1307,  1634,  1723,  1615,
    1637,  1774,  1638,  1314,  1316,  1355,   493,   577,   494,   255,
    1892,   561,   561,   577,   467,   255,   561,   779,   467,   561,
    1318,  1320,   495,  1724,   587,  1321,  1672,  1673,  1462,   498,
     561,   281,   -62,    73,   281,   753,   561,   255,   561,   255,
    1488,    62,   453,   499,   255,  1463,    63,  1464,  1356,   281,
    1411,   281,   564,   565,  1640,   469,  1872,   808,   561,   500,
     561,   255,   477,   478,   561,   809,  1680,  1578,   561,  1581,
    1684,   281,   561,  1583,  1305,   882,   566,  1584,   503,   255,
     567,  1585,  1718,  1641,   504,   255,   505,  1642,   691,   255,
     255,   255,   255,  1256,   561,   506,   255,   507,   561,  1873,
     508,   561,   588,  1586,   509,   568,   595,   641,  1430,  1431,
    1746,  1468,   882,   510,   569,   578,   579,   580,   581,   582,
     601,   486,   513,  1874,  1643,  1534,  1431,   514,   580,   581,
     582,   598,   570,   780,   810,   811,   515,  1207,   742,   516,
    1082,   517,    78,   781,   518,  1388,   556,   557,  1751,  1752,
     519,  1388,   695,   521,  1398,   571,  1400,  1083,   812,  1644,
    1218,   523,  1220,  1405,  1406,  1572,  1573,  1228,  1408,   524,
     281,   281,  1232,   753,   525,   578,   579,   580,   581,   582,
     618,   578,   579,   580,   581,   582,  1580,   882,  1590,   882,
    1084,   526,   255,  1085,  1738,  1739,   527,   255,   744,   744,
     528,  1086,  1781,  1739,   255,   696,  1360,  -163,   699,  1785,
    1786,  1833,  1739,   529,   255,   700,  1834,  1739,   530,   642,
     643,   531,   281,  1839,  1840,  1856,  1857,  1906,  1857,   532,
     255,  1907,  1857,   533,   281,  1937,  1936,   281,   534,   255,
     535,  1843,   536,   281,   540,   255,   281,   541,   255,   542,
     255,   543,   255,  1939,  1940,   701,   467,   255,   255,  1645,
     255,   544,   255,   255,  1646,  1782,  1783,   255,   547,  1412,
     255,   255,   255,   548,  1537,  1501,  1502,   255,  1538,   623,
     549,   550,   586,  1647,   703,   612,   255,   255,   624,  1428,
     311,   629,  1539,   631,   644,   648,   649,   650,   255,   651,
     654,  1350,   656,   255,   600,  1439,   658,   668,   679,   680,
     709,   754,   664,   753,   751,   760,   766,   789,   805,   807,
     806,  1648,   772,   835,   768,  1540,   820,   825,  1541,   852,
    1388,   858,   853,   870,   874,   887,  1542,   888,   893,  1388,
     894,   311,  1703,   895,   901,   904,   908,  1543,   772,   326,
     920,   804,   921,   926,   940,   255,   951,   929,   930,   941,
     816,  1544,   942,   255,   559,   959,  -457,   255,   824,  -374,
     964,   641,   704,   973,   979,   281,  1545,   980,   281,   986,
    1009,   706,  1014,  1026,  1649,   330,   846,  1017,  1069,  1072,
     281,   331,  1351,  1703,  1059,  1076,  1081,  1091,  1092,  1093,
     326,   255,  1149,  1352,  1350,  1101,   426,   333,  1102,   255,
    1113,  1353,   281,  1546,  1128,  1139,   772,  1130,   867,   753,
     281,   427,   428,  1131,   255,  1938,  1132,  1148,  1160,   429,
    1001,  1157,  1000,   255,  1932,  1190,   330,   753,   502,   539,
    1200,  1208,   331,   255,   753,  1222,  1223,   255,  1224,  1354,
     255,  1229,  1536,   339,   255,  1795,  1388,  1231,   333,  1932,
     255,   255,  1233,  1749,  1239,  1240,     1,     2,  1273,   854,
    1276,   430,  1281,  1284,  1325,  1547,  1287,  1288,     3,  1323,
     641,   641,   882,   641,  1327,  1719,  1332,   348,   349,  1337,
    1359,   808,  1367,  1368,   431,  1351,   641,  1371,  1372,  1403,
       4,  1404,  1424,  1429,   339,  1355,  1352,  1548,  1432,     5,
    1446,   432,   433,  1441,  1353,  1447,  1471,  1448,  1475,  1451,
     641,     6,   641,   641,  1476,  1484,   434,   255,  1482,  1483,
     954,  1492,  1841,   255,  1506,  1549,   677,  1503,   348,   349,
    1515,   435,  1520,  1521,  1531,     7,     8,     9,  1356,  1561,
     255,  1567,  1354,  1569,    10,  1571,   718,  1574,   255,   722,
    1575,   255,  1577,  1599,  1603,    11,  1753,  1604,  1607,  1608,
     281,   281,  1616,   734,   735,  1617,   996,   739,  1620,  1626,
    1550,  1627,  1551,  1628,    12,  1632,  1635,  1639,  1661,  1657,
     755,   756,  1669,   364,  1012,  1658,  1704,   255,  1670,  1674,
    1018,  1681,  1682,   369,  1695,  1700,   436,   371,  1355,  1701,
    1552,  1553,  1713,  1715,  1716,  1727,    13,   754,   726,  1728,
    1730,  1726,  1731,   772,  1732,  1733,  1734,  1736,    14,  1741,
     772,  1745,  1777,  -525,  -530,  1757,  1790,  1794,  1798,    15,
    1797,  1705,  1706,   437,   364,  1796,  1799,  1704,  1814,  1573,
    1808,  1356,  1816,  1824,   369,  1809,   255,  1825,   371,  1826,
    1827,  1859,   255,  1847,  1864,  1853,  1866,  1855,   787,   788,
    1867,   255,   791,   793,   795,   796,   797,   798,  1898,  1420,
     438,  1901,  1902,   439,   440,  1903,  1908,  1909,  1910,  1911,
    1913,   255,  1705,  1706,  1912,  1914,  1915,  1936,  1933,   255,
    1935,  1663,   864,  1248,   255,  1415,  1747,   873,  1238,  1564,
    1243,  1212,  1421,  1393,   559,  1283,    16,    17,  1629,  1659,
      18,  1729,   772,   441,  1630,  1869,  1717,    19,  1845,  1438,
     255,   255,  1272,    20,  1807,  1414,   982,    21,   451,  1127,
     450,   605,   636,  1150,  1164,    22,  1470,   999,    23,   754,
    1494,  1334,  1678,  1089,  1126,  1861,  1822,  1942,  1922,   903,
     745,   678,    24,   907,  1622,  1676,  1180,  1146,  1631,   255,
     479,  1187,   593,  1189,  1697,   871,   483,  1473,   772,   989,
     925,   687,   688,   689,   690,   691,  1344,   255,  1381,  1941,
    1848,   659,   475,  1885,  1828,   772,    25,  1335,   385,  1850,
    1868,  1943,  1721,  1347,   685,   823,    26,    27,  1379,  1698,
      28,  1512,   413,   772,  1010,     0,   255,   597,     0,  1246,
       0,     0,     0,   772,   772,   281,  1246,     0,     0,     0,
     772,     0,     0,     0,     0,     0,     0,     0,    29,   255,
       0,     0,     0,     0,     0,     0,   692,   693,   694,   695,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   255,     0,   255,     0,   255,     0,     0,
       0,     0,     0,     0,   972,     0,     0,     0,     0,     0,
       0,     0,   696,   697,   698,   699,     0,     0,     0,     0,
       0,     0,   700,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   996,     0,     0,     0,
       0,  1349,     0,     0,     0,     0,     0,     0,   281,   560,
     255,   255,     0,     0,     0,   255,     0,     0,  1370,     0,
       0,     0,   701,     0,     0,     0,     0,     0,     0,   255,
       0,     0,     0,   255,   754,     0,   255,     0,     0,     0,
     255,     0,     0,  1246,     0,     0,     0,     0,     0,  1246,
     702,   703,  1246,     0,  1246,     0,   772,     0,     0,     0,
       0,  1246,  1246,     0,   772,     0,  1246,   754,     0,     0,
       0,   281,     0,     0,   772,  1246,  1416,     0,     0,     0,
       0,   772,     0,     0,     0,     0,     0,     0,     0,     0,
     772,   281,     0,     0,     0,   487,     0,     0,     0,     0,
       0,     0,   772,     0,     0,     0,     0,   281,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     512,     0,     0,     0,     0,     0,     0,     0,     0,   520,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   704,
       0,     0,     0,     0,     0,     0,   561,   705,   706,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1467,
       0,     0,     0,     0,   553,     0,     0,  1187,     0,     0,
       0,   754,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1150,     0,     0,     0,     0,
       0,     0,     0,  1012,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1246,     0,
       0,     0,     0,     0,     0,     0,     0,  1246,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   772,     0,     0,
       0,  1535,     0,     0,   281,     0,     0,     0,  1560,     0,
       0,     0,     0,     0,   772,  1246,     0,   663,     0,     0,
       0,     0,   670,     0,     0,   674,   675,     0,     0,     0,
       0,     0,   681,   682,   683,     0,   684,     0,     0,     0,
       0,   711,   712,   713,   714,     0,   716,     0,   719,   720,
       0,   723,   724,     0,   725,     0,     0,   727,   728,   729,
     730,   731,   732,   733,     0,     0,   736,   737,     0,   740,
       0,   741,     0,     0,     0,   749,   750,     0,     0,     0,
       0,  1610,     0,   757,     0,     0,     0,   772,     0,   765,
       0,     0,     0,     0,   774,   775,   776,     0,   687,   688,
     689,   690,   691,     0,  1246,     0,     0,     0,     0,     0,
       0,     0,  1246,     0,     0,   754,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   822,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   839,
       0,  1668,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   692,   693,   694,   695,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   876,     0,     0,     0,     0,     0,     0,     0,     0,
    1668,     0,     0,     0,     0,     0,  1712,     0,     0,   696,
     697,   698,   699,     0,     0,   772,     0,     0,     0,   700,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1735,     0,     0,     0,     0,
       0,     0,     0,   754,     0,     0,     0,     0,   281,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   701,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   932,
     934,   936,     0,     0,  1668,  1668,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   702,   703,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   966,  1668,     0,   970,     0,   971,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   704,     0,     0,     0,
       0,     0,     0,   754,   705,   706,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1075,     0,     0,  1077,     0,
    1079,  1080,     0,     0,     0,  1088,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1094,     0,
       0,  1096,  1097,  1098,  1099,  1100,     0,  1818,     0,  1818,
       0,  1889,  1103,     0,     0,  1104,     0,  1105,  1106,     0,
    1107,     0,     0,     0,     0,  1110,  1111,  1112,     0,     0,
       0,     0,  1114,  1115,  1116,     0,  1118,     0,  1120,     0,
    1122,     0,  1123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1134,     0,  1921,  1921,     0,     0,     0,   754,
       0,     0,     0,     0,     0,     0,  1144,     0,  1147,     0,
       0,     0,     0,   772,     0,     0,     0,   754,     0,     0,
    1921,     0,     0,     0,   754,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1277,     0,     0,
       0,  1279,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1290,  1291,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1306,     0,     0,     0,     0,     0,     0,     0,
    1315,     0,  1317,     0,  1319,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1377,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,  1384,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1440,     0,     0,
       0,     0,     0,  1445,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1453,  1454,
       0,     0,     0,     0,     0,     0,  1456,     0,     0,     0,
       0,  1458,     0,     0,  1459,  1460,  1461,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1513,     0,     0,     0,     0,     0,     0,
       0,     0,  1519,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1384,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1384,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1377,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1755,  1756,
       0,     0,     0,  1762,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    92,     0,   308,    94,    95,
       0,     0,     0,     0,    96,     0,     0,     0,    97,    98,
      99,   309,     0,   101,     0,     0,   310,   311,   102,     0,
     103,   104,   746,   105,     0,   106,     0,     0,   107,   312,
     313,   108,  1384,   314,   109,     0,   110,   315,     0,   316,
     113,     0,   114,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,   317,   318,     0,     0,   123,   319,
     320,     0,   321,   124,   125,   126,   127,   322,   323,   324,
       0,     0,     0,     0,   325,   130,   326,     0,     0,   327,
       0,     0,     0,  1340,   131,   132,  1852,     0,  1854,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,   139,   140,     0,     0,   141,     0,   142,   143,   328,
     144,   329,   330,     0,   145,   146,   147,   148,   331,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
     332,     0,   154,     0,   333,     0,     0,     0,   334,   156,
     157,   158,   335,     0,   159,   160,     0,     0,     0,     0,
       0,   336,   337,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,   747,   338,   164,     0,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
     339,     0,     0,     0,     0,   169,   170,   340,   171,   172,
     173,   341,     0,     0,   342,   176,   343,   177,     0,   178,
     344,   345,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   346,   347,   186,   348,   349,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,   350,     0,   196,     0,   197,
     198,   351,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,   352,   353,     0,   204,     0,   354,
       0,   355,   206,   207,   208,   209,   210,   356,   212,     0,
     357,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,   358,
     359,   226,   227,     0,     0,   228,   360,   230,   361,   362,
     231,   232,   233,   363,   234,   235,     0,     0,   236,     0,
     364,   237,     0,   365,   366,   367,     0,   748,   241,   368,
     369,   370,   243,   244,   371,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   372,     0,     0,   373,   374,   375,
     249,     0,     0,   250,   376,     0,   377,   251,   252,     0,
       0,     0,     0,   253,     0,     0,     0,   378,   379,   380,
       0,     0,     0,   381,     0,     0,     0,   382,     0,   383,
     384,    92,     0,   308,    94,    95,  1373,     0,     0,     0,
      96,     0,     0,     0,    97,    98,    99,   309,     0,   101,
       0,     0,  1374,   311,   102,     0,   103,   104,     0,   105,
       0,   106,     0,     0,   107,   312,   313,   108,     0,   314,
     109,     0,   110,   315,     0,   316,   113,     0,   114,   115,
     116,   117,   118,   119,     0,   120,   121,     0,   122,     0,
     317,   318,     0,     0,   123,   319,   320,     0,   321,   124,
     125,   126,   127,   322,   323,   324,     0,     0,     0,     0,
     325,   130,   326,     0,     0,  1375,     0,     0,     0,     0,
     131,   132,     0,     0,     0,     0,   133,   134,   135,     0,
       0,     0,   136,     0,   137,   138,     0,   139,   140,     0,
       0,   141,     0,   142,   143,   328,   144,   329,   330,     0,
     145,   146,   147,   148,   331,   149,     0,     0,     0,   150,
     151,     0,   152,     0,   153,     0,   332,     0,   154,     0,
     333,     0,     0,     0,   334,   156,   157,   158,   335,     0,
     159,   160,     0,     0,     0,     0,     0,   336,   337,     0,
       0,     0,     0,   161,     0,     0,     0,   162,     0,     0,
     163,     0,     0,   338,   164,     0,     0,     0,     0,   165,
       0,   166,     0,   167,     0,   168,   339,     0,     0,     0,
       0,   169,   170,   340,   171,   172,   173,   341,     0,     0,
     342,   176,   343,   177,     0,   178,   344,   345,   180,   181,
     182,     0,     0,     0,   183,   184,   185,   346,   347,   186,
     348,   349,     0,   187,   188,  1376,   189,   190,   191,   192,
       0,     0,     0,     0,     0,     0,     0,     0,   193,   194,
     195,   350,     0,   196,     0,   197,   198,   351,   200,     0,
       0,   201,     0,     0,     0,   202,     0,     0,     0,   203,
     352,   353,     0,   204,     0,   354,     0,   355,   206,   207,
     208,   209,   210,   356,   212,     0,   357,   214,     0,     0,
       0,   215,   216,   217,   218,     0,     0,     0,   219,     0,
     220,   221,   222,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,   224,   225,   358,   359,   226,   227,     0,
       0,   228,   360,   230,   361,   362,   231,   232,   233,   363,
     234,   235,     0,     0,   236,     0,   364,   237,     0,   365,
     366,   367,     0,     0,   241,   368,   369,   370,   243,   244,
     371,   245,   246,     0,     0,     0,   247,     0,     0,     0,
     372,     0,     0,   373,   374,   375,   249,     0,     0,   250,
     376,     0,   377,   251,   252,     0,     0,     0,     0,   253,
       0,     0,     0,   378,   379,   380,     0,     0,    92,   381,
     308,    94,    95,   382,     0,   383,   384,    96,     0,     0,
       0,    97,    98,    99,   309,     0,   101,     0,     0,   310,
     311,   102,     0,   103,   104,     0,   105,     0,   106,     0,
       0,   107,   312,   313,   108,     0,   314,   109,     0,   110,
     315,     0,   316,   113,     0,   114,   115,   116,   117,   118,
     119,     0,   120,   121,     0,   122,     0,   317,   318,     0,
       0,   123,   319,   320,     0,   321,   124,   125,   126,   127,
     322,   323,   324,     0,     0,     0,     0,   325,   130,   326,
       0,     0,   327,     0,     0,     0,     0,   131,   132,     0,
       0,     0,     0,   133,   134,   135,     0,     0,     0,   136,
       0,   137,   138,     0,   139,   140,     0,     0,   141,     0,
     142,   143,   328,   144,   329,   330,     0,   145,   146,   147,
     148,   331,   149,     0,     0,     0,   150,   151,     0,   152,
       0,   153,     0,   332,     0,   154,     0,   333,     0,     0,
       0,   334,   156,   157,   158,   335,     0,   159,   160,     0,
       0,     0,     0,     0,   336,   337,     0,     0,     0,     0,
     161,     0,     0,     0,   162,     0,     0,   163,     0,     0,
     338,   164,     0,     0,     0,     0,   165,     0,   166,     0,
     167,     0,   168,   339,     0,     0,     0,     0,   169,   170,
     340,   171,   172,   173,   341,     0,     0,   342,   176,   343,
     177,     0,   178,   344,   345,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   346,   347,   186,   348,   349,     0,
     187,   188,     0,   189,   190,   191,   192,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,   195,   350,     0,
     196,     0,   197,   198,   351,   200,     0,     0,   201,     0,
       0,     0,   202,     0,     0,     0,   203,   352,   353,     0,
     204,     0,   354,     0,   355,   206,   207,   208,   209,   210,
     356,   212,     0,   357,   214,     0,     0,     0,   215,   216,
     217,   218,     0,     0,     0,   219,     0,   220,   221,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
     224,   225,   358,   359,   226,   227,     0,     0,   228,   360,
     230,   361,   362,   231,   232,   233,   363,   234,   235,     0,
       0,   236,     0,   364,   237,     0,   365,   366,   367,     0,
       0,   241,   368,   369,   370,   243,   244,   371,   245,   246,
       0,     0,     0,   247,     0,     0,     0,   372,     0,     0,
     373,   374,   375,   249,     0,     0,   250,   376,     0,   377,
     251,   252,     0,     0,     0,     0,   253,     0,     0,     0,
     378,   379,   380,     0,     0,     0,   381,   679,     0,     0,
     382,     0,   383,   384,    92,     0,   308,    94,    95,     0,
       0,     0,     0,    96,     0,     0,     0,    97,    98,    99,
     309,     0,   101,     0,     0,   310,   311,   102,     0,   103,
     104,     0,   105,     0,   106,     0,     0,   107,   312,   313,
     108,     0,   314,   109,     0,   110,   315,     0,   316,   113,
       0,   114,   115,   116,   117,   118,   119,     0,   120,   121,
       0,   122,     0,   317,   318,     0,     0,   123,   319,   320,
       0,   321,   124,   125,   126,   127,   322,   323,   324,     0,
       0,     0,     0,   325,   130,   326,     0,     0,   327,     0,
       0,     0,     0,   131,   132,     0,     0,     0,     0,   133,
     134,   135,     0,     0,     0,   136,     0,   137,   138,     0,
     139,   140,     0,     0,   141,     0,   142,   143,   328,   144,
     329,   330,     0,   145,   146,   147,   148,   331,   149,     0,
       0,     0,   150,   151,   931,   152,     0,   153,     0,   332,
       0,   154,     0,   333,     0,     0,     0,   334,   156,   157,
     158,   335,     0,   159,   160,     0,     0,     0,     0,     0,
     336,   337,     0,     0,     0,     0,   161,     0,     0,     0,
     162,     0,     0,   163,     0,     0,   338,   164,     0,     0,
       0,     0,   165,     0,   166,     0,   167,     0,   168,   339,
       0,     0,     0,     0,   169,   170,   340,   171,   172,   173,
     341,     0,     0,   342,   176,   343,   177,     0,   178,   344,
     345,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     346,   347,   186,   348,   349,     0,   187,   188,     0,   189,
     190,   191,   192,     0,     0,     0,     0,     0,     0,     0,
       0,   193,   194,   195,   350,     0,   196,     0,   197,   198,
     351,   200,     0,     0,   201,     0,     0,     0,   202,     0,
       0,     0,   203,   352,   353,     0,   204,     0,   354,     0,
     355,   206,   207,   208,   209,   210,   356,   212,     0,   357,
     214,     0,     0,     0,   215,   216,   217,   218,     0,     0,
       0,   219,     0,   220,   221,   222,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,   224,   225,   358,   359,
     226,   227,     0,     0,   228,   360,   230,   361,   362,   231,
     232,   233,   363,   234,   235,     0,     0,   236,     0,   364,
     237,     0,   365,   366,   367,     0,     0,   241,   368,   369,
     370,   243,   244,   371,   245,   246,     0,     0,     0,   247,
       0,     0,     0,   372,     0,     0,   373,   374,   375,   249,
       0,     0,   250,   376,     0,   377,   251,   252,     0,     0,
       0,     0,   253,     0,     0,     0,   378,   379,   380,     0,
       0,    92,   381,   308,    94,    95,   382,     0,   383,   384,
      96,     0,     0,     0,    97,    98,    99,   309,     0,   101,
       0,     0,   310,   311,   102,     0,   103,   104,     0,   105,
       0,   106,     0,     0,   107,   312,   313,   108,     0,   314,
     109,     0,   110,   315,     0,   316,   113,     0,   114,   115,
     116,   117,   118,   119,     0,   120,   121,     0,   122,     0,
     317,   318,     0,     0,   123,   319,   320,     0,   321,   124,
     125,   126,   127,   322,   323,   324,     0,     0,     0,     0,
     325,   130,   326,     0,     0,   327,     0,     0,     0,     0,
     131,   132,     0,     0,     0,     0,   133,   134,   135,     0,
       0,     0,   136,     0,   137,   138,     0,   139,   140,     0,
       0,   141,     0,   142,   143,   328,   144,   329,   330,     0,
     145,   146,   147,   148,   331,   149,     0,     0,     0,   150,
     151,   933,   152,     0,   153,     0,   332,     0,   154,     0,
     333,     0,     0,     0,   334,   156,   157,   158,   335,     0,
     159,   160,     0,     0,     0,     0,     0,   336,   337,     0,
       0,     0,     0,   161,     0,     0,     0,   162,     0,     0,
     163,     0,     0,   338,   164,     0,     0,     0,     0,   165,
       0,   166,     0,   167,     0,   168,   339,     0,     0,     0,
       0,   169,   170,   340,   171,   172,   173,   341,     0,     0,
     342,   176,   343,   177,     0,   178,   344,   345,   180,   181,
     182,     0,     0,     0,   183,   184,   185,   346,   347,   186,
     348,   349,     0,   187,   188,     0,   189,   190,   191,   192,
       0,     0,     0,     0,     0,     0,     0,     0,   193,   194,
     195,   350,     0,   196,     0,   197,   198,   351,   200,     0,
       0,   201,     0,     0,     0,   202,     0,     0,     0,   203,
     352,   353,     0,   204,     0,   354,     0,   355,   206,   207,
     208,   209,   210,   356,   212,     0,   357,   214,     0,     0,
       0,   215,   216,   217,   218,     0,     0,     0,   219,     0,
     220,   221,   222,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,   224,   225,   358,   359,   226,   227,     0,
       0,   228,   360,   230,   361,   362,   231,   232,   233,   363,
     234,   235,     0,     0,   236,     0,   364,   237,     0,   365,
     366,   367,     0,     0,   241,   368,   369,   370,   243,   244,
     371,   245,   246,     0,     0,     0,   247,     0,     0,     0,
     372,     0,     0,   373,   374,   375,   249,     0,     0,   250,
     376,     0,   377,   251,   252,     0,     0,     0,     0,   253,
       0,     0,     0,   378,   379,   380,     0,     0,    92,   381,
     308,    94,    95,   382,     0,   383,   384,    96,     0,     0,
       0,    97,    98,    99,   309,     0,   101,     0,     0,   310,
     311,   102,     0,   103,   104,     0,   105,     0,   106,     0,
       0,   107,   312,   313,   108,     0,   314,   109,     0,   110,
     315,     0,   316,   113,     0,   114,   115,   116,   117,   118,
     119,     0,   120,   121,     0,   122,     0,   317,   318,     0,
       0,   123,   319,   320,     0,   321,   124,   125,   126,   127,
     322,   323,   324,     0,     0,     0,     0,   325,   130,   326,
       0,     0,   327,     0,     0,     0,     0,   131,   132,     0,
       0,     0,     0,   133,   134,   135,     0,     0,     0,   136,
       0,   137,   138,     0,   139,   140,     0,     0,   141,     0,
     142,   143,   328,   144,   329,   330,     0,   145,   146,   147,
     148,   331,   149,     0,     0,     0,   150,   151,   935,   152,
       0,   153,     0,   332,     0,   154,     0,   333,     0,     0,
       0,   334,   156,   157,   158,   335,     0,   159,   160,     0,
       0,     0,     0,     0,   336,   337,     0,     0,     0,     0,
     161,     0,     0,     0,   162,     0,     0,   163,     0,     0,
     338,   164,     0,     0,     0,     0,   165,     0,   166,     0,
     167,     0,   168,   339,     0,     0,     0,     0,   169,   170,
     340,   171,   172,   173,   341,     0,     0,   342,   176,   343,
     177,     0,   178,   344,   345,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   346,   347,   186,   348,   349,     0,
     187,   188,     0,   189,   190,   191,   192,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,   195,   350,     0,
     196,     0,   197,   198,   351,   200,     0,     0,   201,     0,
       0,     0,   202,     0,     0,     0,   203,   352,   353,     0,
     204,     0,   354,     0,   355,   206,   207,   208,   209,   210,
     356,   212,     0,   357,   214,     0,     0,     0,   215,   216,
     217,   218,     0,     0,     0,   219,     0,   220,   221,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
     224,   225,   358,   359,   226,   227,     0,     0,   228,   360,
     230,   361,   362,   231,   232,   233,   363,   234,   235,     0,
       0,   236,     0,   364,   237,     0,   365,   366,   367,     0,
       0,   241,   368,   369,   370,   243,   244,   371,   245,   246,
       0,     0,     0,   247,     0,     0,     0,   372,     0,     0,
     373,   374,   375,   249,     0,     0,   250,   376,     0,   377,
     251,   252,     0,     0,     0,     0,   253,     0,     0,     0,
     378,   379,   380,     0,     0,    92,   381,   308,    94,    95,
     382,     0,   383,   384,    96,     0,     0,     0,    97,    98,
      99,   309,     0,   101,     0,     0,   310,   311,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,   312,
     313,   108,     0,   314,   109,     0,   110,   315,     0,   316,
     113,     0,   114,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,   317,   318,     0,     0,   123,   319,
     320,     0,   321,   124,   125,   126,   127,   322,   323,   324,
       0,     0,     0,     0,   325,   130,   326,     0,     0,   327,
       0,     0,     0,     0,   131,   132,     0,     0,     0,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,   139,   140,     0,     0,   141,     0,   142,   143,   328,
     144,   329,   330,     0,   145,   146,   147,   148,   331,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
     332,     0,   154,     0,   333,     0,     0,     0,   334,   156,
     157,   158,   335,     0,   159,   160,     0,     0,     0,     0,
       0,   336,   337,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,   338,   164,     0,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
     339,     0,     0,     0,     0,   169,   170,   340,   171,   172,
     173,   341,     0,     0,   342,   176,   343,   177,     0,   178,
     344,   345,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   346,   347,   186,   348,   349,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,   350,     0,   196,     0,   197,
     198,   351,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,   352,   353,     0,   204,     0,   354,
       0,   355,   206,   207,   208,   209,   210,   356,   212,     0,
     357,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,   358,
     359,   226,   227,     0,     0,   228,   360,   230,   361,   362,
     231,   232,   233,   363,   234,   235,     0,     0,   236,     0,
     364,   237,     0,   365,   366,   367,     0,     0,   241,   368,
     369,   370,   243,   244,   371,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   372,     0,     0,   373,   374,   375,
     249,     0,     0,   250,   376,     0,   377,   251,   252,     0,
       0,     0,     0,   253,     0,     0,     0,   378,   379,   380,
       0,     0,    92,   381,   308,    94,    95,   382,     0,   383,
     384,    96,     0,     0,     0,    97,    98,    99,   309,     0,
     101,     0,     0,   310,   311,   102,     0,   103,   104,     0,
     105,     0,   106,     0,     0,   107,   312,   313,   108,     0,
     314,   109,     0,   110,   315,     0,   316,   113,     0,   114,
     115,   116,   117,   118,   119,     0,   120,   121,     0,   122,
       0,   317,   318,     0,     0,   123,   319,   320,     0,   321,
     124,   125,   126,   127,   322,   323,   324,     0,     0,     0,
       0,   325,   130,   326,     0,     0,   327,     0,     0,     0,
       0,   131,   132,     0,     0,     0,     0,   133,   134,   135,
       0,     0,     0,   136,     0,   137,   138,     0,   139,   140,
       0,     0,   141,     0,   142,   143,   328,   144,   329,   330,
       0,   145,   146,   147,   148,   331,   149,     0,     0,     0,
     150,   151,     0,   152,     0,   153,     0,   332,     0,   154,
       0,   333,     0,     0,     0,   334,   156,   157,   158,   335,
       0,   159,   160,     0,     0,     0,     0,     0,   336,   337,
       0,     0,     0,     0,   161,     0,     0,     0,   162,     0,
       0,   163,     0,     0,   338,   164,     0,     0,     0,     0,
     165,     0,   166,     0,   167,     0,   168,   339,     0,     0,
       0,     0,   169,   170,   340,   171,   172,   173,   341,     0,
       0,   342,   176,   343,   177,     0,   178,   344,   345,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   346,   347,
     186,   348,   349,     0,   187,   188,     0,   189,   190,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,   350,     0,   196,     0,   197,   198,   351,   200,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
     203,   352,   353,     0,   204,     0,   354,     0,   355,   206,
     207,   208,   209,   210,   356,   212,     0,   357,   214,     0,
       0,     0,   215,   216,   217,   218,     0,     0,     0,   219,
       0,   220,   221,   222,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,   225,   358,   359,   226,   227,
       0,     0,   228,   360,   230,   361,   362,   231,   232,   233,
     363,   234,   235,     0,     0,   236,     0,   364,   237,     0,
     365,   366,   367,     0,     0,   241,   368,   369,   370,   243,
     244,   371,   245,   246,     0,     0,     0,   247,     0,     0,
       0,   372,     0,     0,   373,   374,   375,   249,     0,     0,
     250,   376,     0,   377,   251,   252,     0,     0,     0,     0,
     253,     0,     0,     0,   378,   379,   380,     0,     0,     0,
     511,     0,     0,     0,   382,     0,   383,   384,    92,     0,
     308,    94,    95,   783,     0,     0,     0,   784,     0,     0,
       0,    97,    98,    99,   309,     0,   101,     0,     0,   310,
     311,   102,     0,   103,   104,     0,   105,     0,   106,     0,
       0,   107,   312,   313,   108,     0,   314,   109,     0,   110,
     315,     0,   316,   113,     0,   114,   115,   116,   117,   118,
     119,     0,   120,   121,     0,   122,     0,   317,   318,     0,
       0,   123,   319,   320,     0,   321,   124,   125,   126,   127,
     322,   323,   324,     0,     0,     0,     0,   325,   130,   326,
       0,     0,   327,     0,     0,     0,     0,   131,   132,     0,
       0,     0,     0,   133,   134,   135,     0,     0,     0,   136,
       0,   137,   138,     0,   139,   140,     0,     0,   141,     0,
     142,   143,   328,   144,   329,   330,     0,   145,   146,   147,
     148,   331,   149,     0,     0,     0,   150,   151,     0,   152,
       0,   153,     0,   332,     0,   154,     0,   333,     0,     0,
       0,   334,   156,   157,   158,   335,     0,   159,   160,     0,
       0,     0,     0,     0,   336,   337,     0,     0,     0,     0,
     161,     0,     0,     0,   162,     0,     0,   163,     0,     0,
     338,   164,     0,     0,     0,     0,   165,     0,   166,     0,
     167,     0,   168,   339,     0,     0,     0,     0,   169,   170,
     340,   171,   172,   173,   341,     0,     0,   342,   176,   343,
     177,     0,   178,   344,   345,   180,   181,   182,     0,     0,
       0,   183,   184,   185,     0,   347,   186,   348,   349,     0,
     187,   188,     0,   189,   190,   191,   192,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,   195,   350,     0,
     196,     0,   197,   198,   351,   200,     0,     0,   201,     0,
       0,     0,   202,     0,     0,     0,   203,   352,   353,     0,
     204,     0,   354,     0,   355,   206,   207,   208,   209,   210,
     356,   212,     0,   357,   214,     0,     0,     0,   215,   216,
     217,   218,     0,     0,     0,   219,     0,   220,   221,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
     224,   225,   358,   359,   226,   227,     0,     0,   228,   360,
     230,   361,   362,   231,   232,   233,   363,   234,   235,     0,
       0,   236,     0,   364,   237,     0,   365,   366,   367,     0,
       0,   241,   368,   369,   370,   243,   244,   371,   245,   246,
       0,     0,     0,   247,     0,     0,     0,   372,     0,     0,
     373,   374,   375,   249,     0,     0,   250,   376,     0,   377,
     251,   252,     0,     0,     0,     0,   253,     0,     0,     0,
     378,   379,   380,     0,     0,    92,   381,   308,    94,    95,
     382,     0,   383,   384,    96,     0,     0,     0,    97,    98,
      99,   309,     0,   101,     0,     0,   310,   311,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,   312,
     313,   108,     0,   314,   109,     0,   110,   315,     0,   316,
     113,     0,   114,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,   317,   318,     0,     0,   123,   319,
     320,     0,   321,   124,   125,   126,   127,   322,   323,   324,
       0,     0,     0,     0,   325,   130,   326,     0,     0,   327,
       0,     0,     0,     0,   131,   132,     0,     0,     0,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,   139,   140,     0,     0,   141,     0,   142,   143,   328,
     144,   329,   330,     0,   145,   146,   147,   148,   331,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
     332,     0,   154,     0,   333,     0,     0,     0,   334,   156,
     157,   158,   335,     0,   159,   160,     0,     0,     0,     0,
       0,   336,  1074,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,   338,   164,     0,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
     339,     0,     0,     0,     0,   169,   170,   340,   171,   172,
     173,   341,     0,     0,   342,   176,   343,   177,     0,   178,
     344,   345,   180,   181,   182,     0,     0,     0,   183,   184,
     185,   346,   347,   186,   348,   349,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,   350,     0,   196,     0,   197,
     198,   351,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,   352,   353,     0,   204,     0,   354,
       0,   355,   206,   207,   208,   209,   210,   356,   212,     0,
     357,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,   358,
     359,   226,   227,     0,     0,   228,   360,   230,   361,   362,
     231,   232,   233,   363,   234,   235,     0,     0,   236,     0,
     364,   237,     0,   365,   366,   367,     0,     0,   241,   368,
     369,   370,   243,   244,   371,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   372,     0,     0,   373,   374,   375,
     249,     0,     0,   250,   376,     0,   377,   251,   252,     0,
       0,     0,     0,   253,     0,     0,     0,   378,   379,   380,
       0,     0,    92,   381,   308,    94,    95,   382,     0,   383,
     384,    96,     0,     0,     0,    97,    98,    99,   309,     0,
     101,     0,     0,   310,   311,   102,     0,   103,   104,     0,
     105,     0,   106,     0,     0,   107,   312,   313,   108,     0,
     314,   109,     0,   110,   315,     0,   316,   113,     0,   114,
     115,   116,   117,   118,   119,     0,   120,   121,     0,   122,
       0,   317,   318,     0,     0,   123,   319,   320,     0,   321,
     124,   125,   126,   127,   322,   323,   324,     0,     0,     0,
       0,   325,   130,   326,     0,     0,   327,     0,     0,     0,
       0,   131,   132,     0,     0,     0,     0,   133,   134,   135,
       0,     0,     0,   136,     0,   137,   138,     0,   139,   140,
       0,     0,   141,     0,   142,   143,   328,   144,   329,   330,
       0,   145,   146,   147,   148,   331,   149,     0,     0,     0,
     150,   151,     0,   152,     0,   153,     0,   332,     0,   154,
       0,   333,     0,     0,     0,   334,   156,   157,   158,   335,
       0,   159,   160,     0,     0,     0,     0,     0,   336,  1109,
       0,     0,     0,     0,   161,     0,     0,     0,   162,     0,
       0,   163,     0,     0,   338,   164,     0,     0,     0,     0,
     165,     0,   166,     0,   167,     0,   168,   339,     0,     0,
       0,     0,   169,   170,   340,   171,   172,   173,   341,     0,
       0,   342,   176,   343,   177,     0,   178,   344,   345,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   346,   347,
     186,   348,   349,     0,   187,   188,     0,   189,   190,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,   350,     0,   196,     0,   197,   198,   351,   200,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
     203,   352,   353,     0,   204,     0,   354,     0,   355,   206,
     207,   208,   209,   210,   356,   212,     0,   357,   214,     0,
       0,     0,   215,   216,   217,   218,     0,     0,     0,   219,
       0,   220,   221,   222,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,   225,   358,   359,   226,   227,
       0,     0,   228,   360,   230,   361,   362,   231,   232,   233,
     363,   234,   235,     0,     0,   236,     0,   364,   237,     0,
     365,   366,   367,     0,     0,   241,   368,   369,   370,   243,
     244,   371,   245,   246,     0,     0,     0,   247,     0,     0,
       0,   372,     0,     0,   373,   374,   375,   249,     0,     0,
     250,   376,     0,   377,   251,   252,     0,     0,     0,     0,
     253,     0,     0,     0,   378,   379,   380,     0,     0,    92,
     381,   308,    94,    95,   382,     0,   383,   384,    96,     0,
       0,     0,    97,    98,    99,   309,     0,   101,     0,     0,
     310,   311,   102,     0,   103,   104,     0,   105,     0,   106,
       0,     0,   107,   312,   313,   108,     0,   314,   109,     0,
     110,   315,     0,   316,   113,     0,   114,   115,   116,   117,
     118,   119,     0,   120,   121,     0,   122,     0,   317,   318,
       0,     0,   123,   319,   320,     0,   321,   124,   125,   126,
     127,   322,   323,   324,     0,     0,     0,     0,   325,   130,
     326,     0,     0,  1339,     0,     0,     0,     0,   131,   132,
       0,     0,     0,     0,   133,   134,   135,     0,     0,     0,
     136,     0,   137,   138,     0,   139,   140,     0,     0,   141,
       0,   142,   143,   328,   144,   329,   330,     0,   145,   146,
     147,   148,   331,   149,     0,     0,     0,   150,   151,     0,
     152,     0,   153,     0,   332,     0,   154,     0,   333,     0,
       0,     0,   334,   156,   157,   158,   335,     0,   159,   160,
       0,     0,     0,     0,     0,   336,   337,     0,     0,     0,
       0,   161,     0,     0,     0,   162,     0,     0,   163,     0,
       0,   338,   164,     0,     0,     0,     0,   165,     0,   166,
       0,   167,     0,   168,   339,     0,     0,     0,     0,   169,
     170,   340,   171,   172,   173,   341,     0,     0,   342,   176,
     343,   177,     0,   178,   344,   345,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   346,   347,   186,   348,   349,
       0,   187,   188,     0,   189,   190,   191,   192,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,   195,   350,
       0,   196,     0,   197,   198,   351,   200,     0,     0,   201,
       0,     0,     0,   202,     0,     0,     0,   203,   352,   353,
       0,   204,     0,   354,     0,   355,   206,   207,   208,   209,
     210,   356,   212,     0,   357,   214,     0,     0,     0,   215,
     216,   217,   218,     0,     0,     0,   219,     0,   220,   221,
     222,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,   224,   225,   358,   359,   226,   227,     0,     0,   228,
     360,   230,   361,   362,   231,   232,   233,   363,   234,   235,
       0,     0,   236,     0,   364,   237,     0,   365,   366,   367,
       0,     0,   241,   368,   369,   370,   243,   244,   371,   245,
     246,     0,     0,     0,   247,     0,     0,     0,   372,     0,
       0,   373,   374,   375,   249,     0,     0,   250,   376,     0,
     377,   251,   252,     0,     0,     0,     0,   253,     0,     0,
       0,   378,   379,   380,     0,     0,    92,   381,   308,    94,
      95,   382,     0,   383,   384,    96,     0,     0,     0,    97,
      98,    99,   309,     0,   101,     0,     0,   310,   311,   102,
       0,   103,   104,     0,   105,     0,   106,     0,     0,   107,
     312,   313,   108,     0,   314,   109,     0,   110,   315,     0,
     316,   113,     0,   114,   115,   116,   117,   118,   119,     0,
     120,   121,     0,   122,     0,   317,   318,     0,     0,   123,
     319,   320,     0,   321,   124,   125,   126,   127,   322,   323,
     324,     0,     0,     0,     0,   325,   130,   326,     0,     0,
     327,     0,     0,     0,     0,   131,   132,     0,     0,     0,
       0,   133,   134,   135,     0,     0,     0,   136,     0,   137,
     138,     0,   139,   140,     0,     0,   141,     0,   142,   143,
     328,   144,   329,   330,     0,   145,   146,   147,   148,   331,
     149,     0,     0,     0,   150,   151,     0,   152,     0,   153,
       0,   332,     0,   154,     0,   333,     0,     0,     0,   334,
     156,   157,   158,   335,     0,   159,   160,     0,     0,     0,
       0,     0,   336,   337,     0,     0,     0,     0,   161,     0,
       0,     0,   162,     0,     0,   163,     0,     0,   338,   164,
       0,     0,     0,     0,   165,     0,   166,     0,   167,     0,
     168,   339,     0,     0,     0,     0,   169,   170,   340,   171,
     172,   173,   341,     0,     0,   342,   176,   343,   177,     0,
     178,   344,   345,   180,   181,   182,     0,     0,     0,   183,
     184,   185,     0,   347,   186,   348,   349,     0,   187,   188,
       0,   189,   190,   191,   192,     0,     0,     0,     0,     0,
       0,     0,     0,   193,   194,   195,   350,     0,   196,     0,
     197,   198,   351,   200,     0,     0,   201,     0,     0,     0,
     202,     0,     0,     0,   203,   352,   353,     0,   204,     0,
     354,     0,   355,   206,   207,   208,   209,   210,   356,   212,
       0,   357,   214,     0,     0,     0,   215,   216,   217,   218,
       0,     0,     0,   219,     0,   220,   221,   222,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,   224,   225,
     358,   359,   226,   227,     0,     0,   228,   360,   230,   361,
     362,   231,   232,   233,   363,   234,   235,     0,     0,   236,
       0,   364,   237,     0,   365,   366,   367,     0,     0,   241,
     368,   369,   370,   243,   244,   371,   245,   246,     0,     0,
       0,   247,     0,     0,     0,   372,     0,     0,   373,   374,
     375,   249,     0,     0,   250,   376,     0,   377,   251,   252,
       0,     0,     0,     0,   253,     0,     0,     0,   378,   379,
     380,     0,     0,    92,   381,   308,    94,    95,   382,     0,
     383,   384,    96,     0,     0,     0,    97,    98,    99,   309,
       0,   101,     0,     0,   310,   311,   102,     0,   103,   104,
       0,   105,     0,   106,     0,     0,   107,   312,   313,   108,
       0,   314,   109,     0,   110,   315,     0,   316,   113,     0,
     114,   115,   116,   117,   118,   119,     0,   120,   121,     0,
     122,     0,   317,   318,     0,     0,   123,   319,   320,     0,
     321,   124,   125,   126,   127,   322,   323,   324,     0,     0,
       0,     0,   325,   130,   326,     0,     0,   327,     0,     0,
       0,     0,   131,   132,     0,     0,     0,     0,   133,   134,
     135,     0,     0,     0,   136,     0,   137,   138,     0,   139,
     140,     0,     0,   141,     0,   142,   143,   328,   144,   329,
     330,     0,   145,   146,   147,   148,   331,   149,     0,     0,
       0,   150,   151,     0,   152,     0,   153,     0,   332,     0,
     154,     0,   333,     0,     0,     0,   334,   156,   157,   158,
     335,     0,   159,   160,     0,     0,     0,     0,     0,   336,
     792,     0,     0,     0,     0,   161,     0,     0,     0,   162,
       0,     0,   163,     0,     0,   338,   164,     0,     0,     0,
       0,   165,     0,   166,     0,   167,     0,   168,   339,     0,
       0,     0,     0,   169,   170,   340,   171,   172,   173,   341,
       0,     0,   342,   176,   343,   177,     0,   178,   344,   345,
     180,   181,   182,     0,     0,     0,   183,   184,   185,     0,
     347,   186,   348,   349,     0,   187,   188,     0,   189,   190,
     191,   192,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,   195,   350,     0,   196,     0,   197,   198,   351,
     200,     0,     0,   201,     0,     0,     0,   202,     0,     0,
       0,   203,   352,   353,     0,   204,     0,   354,     0,   355,
     206,   207,   208,   209,   210,   356,   212,     0,   357,   214,
       0,     0,     0,   215,   216,   217,   218,     0,     0,     0,
     219,     0,   220,   221,   222,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,   224,   225,   358,   359,   226,
     227,     0,     0,   228,   360,   230,   361,   362,   231,   232,
     233,   363,   234,   235,     0,     0,   236,     0,   364,   237,
       0,   365,   366,   367,     0,     0,   241,   368,   369,   370,
     243,   244,   371,   245,   246,     0,     0,     0,   247,     0,
       0,     0,   372,     0,     0,   373,   374,   375,   249,     0,
       0,   250,   376,     0,   377,   251,   252,     0,     0,     0,
       0,   253,     0,     0,     0,   378,   379,   380,     0,     0,
      92,   381,   308,    94,    95,   382,     0,   383,   384,    96,
       0,     0,     0,    97,    98,    99,   309,     0,   101,     0,
       0,   310,   311,   102,     0,   103,   104,     0,   105,     0,
     106,     0,     0,   107,   312,   313,   108,     0,   314,   109,
       0,   110,   315,     0,   316,   113,     0,   114,   115,   116,
     117,   118,   119,     0,   120,   121,     0,   122,     0,   317,
     318,     0,     0,   123,   319,   320,     0,   321,   124,   125,
     126,   127,   322,   323,   324,     0,     0,     0,     0,   325,
     130,   326,     0,     0,   327,     0,     0,     0,     0,   131,
     132,     0,     0,     0,     0,   133,   134,   135,     0,     0,
       0,   136,     0,   137,   138,     0,   139,   140,     0,     0,
     141,     0,   142,   143,   328,   144,   329,   330,     0,   145,
     146,   147,   148,   331,   149,     0,     0,     0,   150,   151,
       0,   152,     0,   153,     0,   332,     0,   154,     0,   333,
       0,     0,     0,   334,   156,   157,   158,   335,     0,   159,
     160,     0,     0,     0,     0,     0,   336,   794,     0,     0,
       0,     0,   161,     0,     0,     0,   162,     0,     0,   163,
       0,     0,   338,   164,     0,     0,     0,     0,   165,     0,
     166,     0,   167,     0,   168,   339,     0,     0,     0,     0,
     169,   170,   340,   171,   172,   173,   341,     0,     0,   342,
     176,   343,   177,     0,   178,   344,   345,   180,   181,   182,
       0,     0,     0,   183,   184,   185,     0,   347,   186,   348,
     349,     0,   187,   188,     0,   189,   190,   191,   192,     0,
       0,     0,     0,     0,     0,     0,     0,   193,   194,   195,
     350,     0,   196,     0,   197,   198,   351,   200,     0,     0,
     201,     0,     0,     0,   202,     0,     0,     0,   203,   352,
     353,     0,   204,     0,   354,     0,   355,   206,   207,   208,
     209,   210,   356,   212,     0,   357,   214,     0,     0,     0,
     215,   216,   217,   218,     0,     0,     0,   219,     0,   220,
     221,   222,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,   224,   225,   358,   359,   226,   227,     0,     0,
     228,   360,   230,   361,   362,   231,   232,   233,   363,   234,
     235,     0,     0,   236,     0,   364,   237,     0,   365,   366,
     367,     0,     0,   241,   368,   369,   370,   243,   244,   371,
     245,   246,     0,     0,     0,   247,     0,     0,     0,   372,
       0,     0,   373,   374,   375,   249,     0,     0,   250,   376,
       0,   377,   251,   252,     0,     0,     0,     0,   253,     0,
       0,     0,   378,   379,   380,     0,     0,    92,   381,    93,
      94,    95,   382,     0,   383,   384,    96,     0,     0,     0,
      97,    98,    99,   100,     0,   101,     0,     0,     0,     0,
     102,     0,   103,   104,     0,   105,     0,   106,     0,     0,
     107,     0,     0,   108,     0,     0,   109,     0,   110,   111,
       0,   112,   113,     0,   114,   115,   116,   117,   118,   119,
       0,   120,   121,     0,   122,     0,     0,     0,     0,     0,
     123,     0,     0,     0,     0,   124,   125,   126,   127,     0,
       0,   128,     0,     0,     0,     0,   129,   130,     0,     0,
       0,     0,     0,     0,     0,     0,   131,   132,     0,     0,
       0,     0,   133,   134,   135,     0,     0,     0,   136,     0,
     137,   138,     0,   139,   140,     0,     0,   141,     0,   142,
     143,     0,   144,     0,     0,     0,   145,   146,   147,   148,
       0,   149,     0,     0,     0,   150,   151,     0,   152,     0,
     153,     0,     0,     0,   154,     0,     0,     0,     0,     0,
     155,   156,   157,   158,     0,     0,   159,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,   162,     0,     0,   163,     0,     0,     0,
     164,   767,     0,     0,     0,   165,     0,   166,     0,   167,
       0,   168,     0,     0,     0,     0,     0,   169,   170,     0,
     171,   172,   173,   174,     0,     0,   175,   176,     0,   177,
       0,   178,     0,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,     0,     0,   186,     0,     0,     0,   187,
     188,     0,   189,   190,   191,   192,     0,     0,     0,     0,
       0,     0,     0,     0,   193,   194,   195,     0,     0,   196,
       0,   197,   198,   199,   200,     0,     0,   201,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,   204,
       0,   205,     0,     0,   206,   207,   208,   209,   210,   211,
     212,     0,   213,   214,     0,     0,     0,   215,   216,   217,
     218,     0,     0,     0,   219,     0,   220,   221,   222,     0,
       0,     0,     0,     0,   223,     0,     0,     0,     0,   224,
     225,     0,     0,   226,   227,     0,     0,   228,   229,   230,
       0,     0,   231,   232,   233,     0,   234,   235,     0,     0,
     236,     0,   768,   237,     0,   238,   239,   240,     0,     0,
     241,     0,     0,   242,   243,   244,     0,   245,   246,     0,
       0,     0,   247,     0,     0,     0,   248,     0,     0,     0,
       0,     0,   249,     0,     0,   250,     0,     0,     0,   251,
     252,     0,     0,     0,     0,   253,     0,     0,     0,   254,
      92,     0,    93,    94,    95,     0,     0,     0,     0,    96,
       0,     0,   769,    97,    98,    99,   100,     0,   101,     0,
       0,     0,     0,   102,     0,   103,   104,     0,   105,     0,
     106,     0,     0,   107,     0,     0,   108,     0,     0,   109,
       0,   110,   111,     0,   112,   113,     0,   114,   115,   116,
     117,   118,   119,     0,   120,   121,     0,   122,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,   124,   125,
     126,   127,     0,     0,   128,     0,     0,     0,     0,   129,
     130,     0,     0,     0,     0,     0,     0,     0,     0,   131,
     132,     0,     0,     0,     0,   133,   134,   135,     0,     0,
       0,   136,     0,   137,   138,     0,   139,   140,     0,     0,
     141,     0,   142,   143,     0,   144,     0,     0,     0,   145,
     146,   147,   148,     0,   149,     0,     0,     0,   150,   151,
       0,   152,     0,   153,     0,     0,     0,   154,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,   159,
     160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   161,     0,     0,     0,   162,     0,     0,   163,
       0,     0,     0,   164,   767,     0,     0,     0,   165,     0,
     166,     0,   167,     0,   168,     0,     0,     0,     0,     0,
     169,   170,     0,   171,   172,   173,   174,     0,     0,   175,
     176,     0,   177,     0,   178,     0,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,     0,     0,   186,     0,
       0,     0,   187,   188,     0,   189,   190,   191,   192,     0,
       0,     0,     0,     0,     0,     0,     0,   193,   194,   195,
       0,     0,   196,     0,   197,   198,   199,   200,     0,     0,
     201,     0,     0,     0,   202,     0,     0,     0,   203,     0,
       0,     0,   204,     0,   205,     0,     0,   206,   207,   208,
     209,   210,   211,   212,     0,   213,   214,     0,     0,     0,
     215,   216,   217,   218,     0,     0,     0,   219,     0,   220,
     221,   222,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,   224,   225,     0,     0,   226,   227,     0,     0,
     228,   229,   230,     0,     0,   231,   232,   233,     0,   234,
     235,     0,     0,   236,     0,   768,   237,     0,   238,   239,
     240,     0,     0,   241,     0,     0,   242,   243,   244,     0,
     245,   246,     0,     0,     0,   247,     0,     0,     0,   248,
       0,     0,     0,     0,     0,   249,     0,     0,   250,     0,
       0,     0,   251,   252,     0,     0,     0,     0,   253,     0,
       0,     0,   254,    92,     0,    93,    94,    95,     0,     0,
       0,     0,    96,     0,     0,  1192,    97,    98,    99,   100,
       0,   101,     0,     0,     0,     0,   102,     0,   103,   104,
       0,   105,     0,   106,     0,     0,   107,     0,     0,   108,
       0,     0,   109,     0,   110,   111,     0,   112,   113,     0,
     114,   115,   116,   117,   118,   119,     0,   120,   121,     0,
     122,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,   124,   125,   126,   127,     0,     0,   128,     0,     0,
       0,     0,   129,   130,     0,     0,     0,     0,     0,     0,
       0,     0,   131,   132,     0,     0,     0,     0,   133,   134,
     135,     0,     0,     0,   136,     0,   137,   138,     0,   139,
     140,     0,     0,   141,     0,   142,   143,     0,   144,     0,
       0,     0,   145,   146,   147,   148,     0,   149,     0,     0,
       0,   150,   151,     0,   152,     0,   153,     0,     0,     0,
     154,     0,     0,     0,     0,     0,   155,   156,   157,   158,
       0,     0,   159,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,   162,
       0,     0,   163,     0,     0,     0,   164,     0,     0,     0,
       0,   165,     0,   166,     0,   167,     0,   168,     0,     0,
       0,     0,     0,   169,   170,     0,   171,   172,   173,   174,
       0,     0,   175,   176,     0,   177,     0,   178,     0,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,     0,
       0,   186,     0,     0,     0,   187,   188,     0,   189,   190,
     191,   192,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,   195,     0,     0,   196,     0,   197,   198,   199,
     200,     0,     0,   201,     0,     0,     0,   202,     0,     0,
       0,   203,     0,     0,     0,   204,     0,   205,     0,     0,
     206,   207,   208,   209,   210,   211,   212,     0,   213,   214,
       0,     0,     0,   215,   216,   217,   218,     0,     0,     0,
     219,     0,   220,   221,   222,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,   224,   225,     0,     0,   226,
     227,     0,     0,   228,   229,   230,     0,     0,   231,   232,
     233,     0,   234,   235,     0,     0,   236,     0,     0,   237,
       0,   238,   239,   240,     0,     0,   241,     0,     0,   242,
     243,   244,     0,   245,   246,     0,     0,     0,   247,     0,
       0,     0,   248,     0,     0,     0,     0,     0,   249,     0,
       0,   250,     0,     0,     0,   251,   252,     0,     0,     0,
       0,   253,     0,     0,     0,   254,    92,     0,    93,    94,
      95,     0,  1928,     0,     0,    96,     0,   383,  1929,    97,
      98,    99,   100,     0,   101,     0,     0,     0,     0,   102,
       0,   103,   104,     0,   105,     0,   106,     0,     0,   107,
       0,     0,   108,     0,     0,   109,     0,   110,   111,     0,
     112,   113,     0,   114,   115,   116,   117,   118,   119,     0,
     120,   121,     0,   122,     0,     0,     0,     0,     0,   123,
       0,     0,     0,     0,   124,   125,   126,   127,     0,     0,
     128,     0,     0,     0,     0,   129,   130,     0,     0,     0,
       0,     0,     0,     0,     0,   131,   132,     0,     0,     0,
       0,   133,   134,   135,     0,     0,     0,   136,     0,   137,
     138,     0,   139,   140,     0,     0,   141,     0,   142,   143,
       0,   144,     0,     0,     0,   145,   146,   147,   148,     0,
     149,     0,     0,     0,   150,   151,     0,   152,     0,   153,
       0,     0,     0,   154,     0,     0,     0,     0,     0,   155,
     156,   157,   158,     0,     0,   159,   160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   161,     0,
       0,     0,   162,     0,     0,   163,     0,     0,     0,   164,
       0,     0,     0,     0,   165,     0,   166,     0,   167,     0,
     168,     0,     0,     0,     0,     0,   169,   170,     0,   171,
     172,   173,   174,     0,     0,   175,   176,     0,   177,     0,
     178,     0,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,     0,     0,   186,     0,     0,     0,   187,   188,
       0,   189,   190,   191,   192,     0,     0,     0,     0,     0,
       0,     0,     0,   193,   194,   195,     0,     0,   196,     0,
     197,   198,   199,   200,     0,     0,   201,     0,     0,     0,
     202,     0,     0,     0,   203,     0,     0,     0,   204,     0,
     205,     0,     0,   206,   207,   208,   209,   210,   211,   212,
       0,   213,   214,     0,     0,     0,   215,   216,   217,   218,
       0,     0,     0,   219,     0,   220,   221,   222,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,   224,   225,
       0,     0,   226,   227,     0,     0,   228,   229,   230,     0,
       0,   231,   232,   233,     0,   234,   235,     0,     0,   236,
       0,     0,   237,     0,   238,   239,   240,     0,     0,   241,
       0,     0,   242,   243,   244,     0,   245,   246,     0,     0,
       0,   247,     0,     0,     0,   248,     0,     0,     0,     0,
       0,   249,     0,     0,   250,     0,     0,     0,   251,   252,
       0,     0,     0,     0,   253,     0,     0,     0,   254,    92,
       0,    93,    94,    95,     0,     0,     0,     0,    96,     0,
     383,  1929,    97,    98,    99,   100,     0,   101,     0,     0,
       0,     0,   102,     0,   103,   104,     0,   105,     0,   106,
       0,     0,   107,     0,     0,   108,     0,     0,   109,     0,
     110,   111,     0,   112,   113,     0,   114,   115,   116,   117,
     118,   119,     0,   120,   121,  1209,   122,     0,     0,     0,
       0,     0,   123,     0,     0,     0,     0,   124,   125,   126,
     127,     0,     0,   128,     0,     0,     0,     0,   129,   130,
       0,     0,     0,     0,     0,     0,     0,     0,   131,   132,
       0,     0,     0,     0,   133,   134,   135,     0,     0,     0,
     136,     0,   137,   138,     0,   139,   140,     0,     0,   141,
       0,   142,   143,     0,   144,     0,     0,     0,   145,   146,
     147,   148,     0,   149,     0,     0,     0,   150,   151,     0,
     152,     0,   153,     0,     0,     0,   154,     0,     0,     0,
       0,     0,   155,   156,   157,   158,     0,     0,   159,   160,
    1210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,   162,  1211,     0,   163,     0,
       0,     0,   164,     0,  1257,     0,     0,   165,     0,   166,
       0,   167,     0,   168,     0,     0,     0,     0,     0,   169,
     170,     0,   171,   172,   173,   174,     0,     0,   175,   176,
       0,   177,     0,   178,     0,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,     0,     0,   186,     0,     0,
       0,   187,   188,     0,   189,   190,   191,   192,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,   195,     0,
       0,   196,     0,   197,   198,   199,   200,     0,     0,   201,
       0,     0,     0,   202,     0,     0,     0,   203,     0,     0,
       0,   204,     0,   205,     0,     0,   206,   207,   208,   209,
     210,   211,   212,     0,   213,   214,   808,     0,     0,   215,
     216,   217,   218,     0,     0,     0,   219,     0,   220,   221,
     222,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,   224,   225,     0,     0,   226,   227,     0,     0,   228,
     229,   230,     0,     0,   231,   232,   233,     0,   234,   235,
       0,     0,   236,     0,     0,   237,     0,   238,   239,   240,
       0,     0,   241,     0,     0,   242,   243,   244,     0,   245,
     246,     0,     0,     0,   247,     0,     0,     0,   248,     0,
       0,     0,     0,     0,   249,     0,     0,   250,     0,     0,
       0,   251,   252,     0,     0,     0,    92,   253,    93,    94,
      95,   254,     0,     0,     0,    96,     0,     0,     0,    97,
      98,    99,   100,  1242,   101,     0,     0,     0,     0,   102,
       0,   103,   104,     0,   105,     0,   106,     0,     0,   107,
       0,     0,   108,     0,     0,   109,     0,   110,   111,     0,
     112,   113,     0,   114,   115,   116,   117,   118,   119,     0,
     120,   121,  1209,   122,     0,     0,     0,     0,     0,   123,
       0,     0,     0,     0,   124,   125,   126,   127,     0,     0,
     128,     0,     0,     0,     0,   129,   130,     0,     0,     0,
       0,     0,     0,     0,     0,   131,   132,     0,     0,     0,
       0,   133,   134,   135,     0,     0,     0,   136,     0,   137,
     138,     0,   139,   140,     0,     0,   141,     0,   142,   143,
       0,   144,     0,     0,     0,   145,   146,   147,   148,     0,
     149,     0,     0,     0,   150,   151,     0,   152,     0,   153,
       0,     0,     0,   154,     0,     0,     0,     0,     0,   155,
     156,   157,   158,     0,     0,   159,   160,  1210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   161,     0,
       0,     0,   162,  1211,     0,   163,     0,     0,     0,   164,
       0,     0,     0,     0,   165,     0,   166,     0,   167,     0,
     168,     0,     0,     0,     0,     0,   169,   170,     0,   171,
     172,   173,   174,     0,     0,   175,   176,     0,   177,     0,
     178,     0,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,     0,     0,   186,     0,     0,     0,   187,   188,
       0,   189,   190,   191,   192,     0,     0,     0,     0,     0,
       0,     0,     0,   193,   194,   195,     0,     0,   196,     0,
     197,   198,   199,   200,     0,     0,   201,     0,     0,     0,
     202,     0,     0,     0,   203,     0,     0,     0,   204,     0,
     205,     0,     0,   206,   207,   208,   209,   210,   211,   212,
       0,   213,   214,     0,     0,     0,   215,   216,   217,   218,
       0,     0,     0,   219,     0,   220,   221,   222,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,   224,   225,
       0,     0,   226,   227,     0,     0,   228,   229,   230,     0,
       0,   231,   232,   233,     0,   234,   235,     0,     0,   236,
       0,     0,   237,     0,   238,   239,   240,     0,     0,   241,
       0,     0,   242,   243,   244,     0,   245,   246,     0,     0,
       0,   247,     0,     0,     0,   248,     0,     0,     0,     0,
       0,   249,     0,     0,   250,     0,     0,     0,   251,   252,
       0,     0,     0,    92,   253,    93,    94,    95,   254,     0,
       0,     0,    96,     0,     0,     0,    97,    98,    99,   100,
    1242,   101,     0,     0,     0,     0,   102,     0,   103,   104,
       0,   105,     0,   106,     0,     0,   107,     0,     0,   108,
       0,     0,   109,     0,   110,   111,     0,   112,   113,     0,
     114,   115,   116,   117,   118,   119,     0,   120,   121,     0,
     122,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,   124,   125,   126,   127,     0,     0,   128,     0,     0,
       0,     0,   129,   130,     0,     0,     0,     0,     0,     0,
       0,     0,   131,   132,     0,     0,     0,     0,   133,   134,
     135,     0,     0,     0,   136,     0,   137,   138,     0,   139,
     140,     0,     0,   141,     0,   142,   143,     0,   144,     0,
       0,     0,   145,   146,   147,   148,     0,   149,     0,     0,
       0,   150,   151,     0,   152,     0,   153,     0,     0,     0,
     154,     0,     0,     0,     0,     0,   155,   156,   157,   158,
       0,     0,   159,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,   162,
       0,     0,   163,     0,     0,     0,   164,     0,     0,     0,
       0,   165,     0,   166,     0,   167,     0,   168,     0,     0,
       0,     0,     0,   169,   170,     0,   171,   172,   173,   174,
       0,     0,   175,   176,     0,   177,     0,   178,     0,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,     0,
       0,   186,     0,     0,     0,   187,   188,     0,   189,   190,
     191,   192,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,   195,     0,     0,   196,     0,   197,   198,   199,
     200,     0,     0,   201,     0,     0,     0,   202,     0,     0,
       0,   203,     0,     0,     0,   204,     0,   205,     0,     0,
     206,   207,   208,   209,   210,   211,   212,     0,   213,   214,
     808,     0,     0,   215,   216,   217,   218,     0,     0,     0,
     219,     0,   220,   221,   222,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,   224,   225,     0,     0,   226,
     227,     0,     0,   228,   229,   230,     0,     0,   231,   232,
     233,     0,   234,   235,     0,     0,   236,     0,     0,   237,
       0,   238,   239,   240,     0,     0,   241,     0,     0,   242,
     243,   244,     0,   245,   246,     0,     0,     0,   247,     0,
       0,     0,   248,     0,     0,     0,     0,     0,   249,     0,
       0,   250,     0,     0,     0,   251,   252,     0,     0,     0,
      92,   253,    93,    94,    95,   254,     0,     0,     0,    96,
       0,     0,   990,    97,    98,    99,   100,   383,   101,     0,
       0,     0,     0,   102,     0,   103,   104,     0,   105,     0,
     106,     0,     0,   107,     0,     0,   108,     0,     0,   109,
       0,   110,   111,     0,   112,   113,     0,   114,   115,   116,
     117,   118,   119,     0,   120,   121,     0,   122,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,   124,   125,
     126,   127,     0,     0,   128,     0,     0,     0,     0,   129,
     130,     0,     0,     0,     0,     0,     0,     0,     0,   131,
     132,     0,     0,     0,     0,   133,   134,   135,     0,     0,
       0,   136,     0,   137,   138,     0,   139,   140,     0,     0,
     141,     0,   142,   143,     0,   144,     0,     0,     0,   145,
     146,   147,   148,     0,   149,     0,     0,     0,   150,   151,
       0,   152,     0,   153,     0,     0,     0,   154,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,   159,
     160,     0,     0,     0,     0,     0,     0,     0,   407,     0,
       0,     0,   161,     0,     0,     0,   162,     0,     0,   163,
       0,     0,     0,   164,     0,     0,     0,     0,   165,     0,
     166,     0,   167,     0,   168,     0,     0,     0,     0,     0,
     169,   170,     0,   171,   172,   173,   174,     0,     0,   175,
     176,     0,   177,     0,   178,     0,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,     0,     0,   186,     0,
       0,     0,   187,   188,     0,   189,   190,   191,   192,     0,
       0,     0,     0,     0,     0,     0,     0,   193,   194,   195,
       0,     0,   196,     0,   197,   198,   199,   200,     0,     0,
     201,     0,     0,     0,   202,     0,     0,     0,   203,     0,
       0,     0,   204,     0,   205,     0,     0,   206,   207,   208,
     209,   210,   211,   212,     0,   213,   214,     0,     0,     0,
     215,   216,   217,   218,     0,     0,     0,   219,     0,   220,
     221,   222,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,   224,   225,     0,     0,   226,   227,     0,     0,
     228,   229,   230,     0,     0,   231,   232,   233,     0,   234,
     235,     0,     0,   236,     0,     0,   237,     0,   238,   239,
     240,     0,     0,   241,     0,     0,   242,   243,   244,     0,
     245,   246,     0,     0,     0,   247,     0,     0,     0,   248,
       0,     0,     0,     0,     0,   249,     0,     0,   250,     0,
       0,     0,   251,   252,     0,     0,     0,    92,   253,    93,
      94,    95,   254,     0,     0,     0,    96,     0,     0,     0,
      97,    98,    99,   100,   278,   101,     0,     0,     0,     0,
     102,     0,   103,   104,     0,   105,     0,   106,     0,     0,
     107,     0,     0,   108,     0,     0,   109,     0,   110,   111,
       0,   112,   113,     0,   114,   115,   116,   117,   118,   119,
       0,   120,   121,     0,   122,     0,     0,     0,     0,     0,
     123,     0,     0,     0,     0,   124,   125,   126,   127,     0,
       0,   128,     0,     0,     0,     0,   129,   130,     0,     0,
       0,     0,     0,     0,     0,     0,   131,   132,     0,     0,
       0,     0,   133,   134,   135,     0,     0,     0,   136,     0,
     137,   138,     0,   139,   140,     0,     0,   141,     0,   142,
     143,     0,   144,     0,     0,     0,   145,   146,   147,   148,
       0,   149,     0,     0,     0,   150,   151,     0,   152,     0,
     153,     0,     0,     0,   154,     0,     0,     0,     0,     0,
     155,   156,   157,   158,     0,     0,   159,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,   162,     0,     0,   163,     0,     0,     0,
     164,     0,     0,     0,     0,   165,     0,   166,     0,   167,
       0,   168,     0,     0,     0,     0,     0,   169,   170,     0,
     171,   172,   173,   174,     0,     0,   175,   176,     0,   177,
       0,   178,     0,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,     0,     0,   186,     0,     0,     0,   187,
     188,     0,   189,   190,   191,   192,     0,     0,     0,     0,
       0,     0,     0,     0,   193,   194,   195,     0,     0,   196,
       0,   197,   198,   199,   200,     0,     0,   201,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,   204,
       0,   205,     0,     0,   206,   207,   208,   209,   210,   211,
     212,     0,   213,   214,     0,     0,     0,   215,   216,   217,
     218,     0,     0,     0,   219,     0,   220,   221,   222,     0,
       0,     0,     0,     0,   223,     0,     0,     0,     0,   224,
     225,     0,     0,   226,   227,     0,     0,   228,   229,   230,
       0,     0,   231,   232,   233,     0,   234,   235,     0,     0,
     236,     0,     0,   237,     0,   238,   239,   240,     0,     0,
     241,     0,     0,   242,   243,   244,     0,   245,   246,     0,
       0,     0,   247,     0,     0,     0,   248,     0,     0,     0,
       0,     0,   249,     0,     0,   250,     0,     0,     0,   251,
     252,     0,     0,     0,    92,   253,    93,    94,    95,   254,
       0,     0,     0,    96,     0,  1241,     0,    97,    98,    99,
     100,  1242,   101,     0,     0,     0,     0,   102,     0,   103,
     104,     0,   105,     0,   106,     0,     0,   107,     0,     0,
     108,     0,     0,   109,     0,   110,   111,     0,   112,   113,
       0,   114,   115,   116,   117,   118,   119,     0,   120,   121,
       0,   122,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,   124,   125,   126,   127,     0,     0,   128,     0,
       0,     0,     0,   129,   130,     0,     0,     0,     0,     0,
       0,     0,     0,   131,   132,     0,     0,     0,     0,   133,
     134,   135,     0,     0,     0,   136,     0,   137,   138,     0,
     139,   140,     0,     0,   141,     0,   142,   143,     0,   277,
       0,     0,     0,   145,   146,   147,   148,     0,   149,     0,
       0,     0,   150,   151,     0,   152,     0,   153,     0,     0,
       0,   154,     0,     0,     0,     0,     0,   155,   156,   157,
     158,     0,     0,   159,   160,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   161,     0,     0,     0,
     162,     0,     0,   163,     0,     0,     0,   164,     0,     0,
       0,     0,   165,     0,   166,     0,   167,     0,   168,     0,
       0,     0,     0,     0,   169,   170,     0,   171,   172,   173,
     174,     0,     0,   175,   176,     0,   177,     0,   178,     0,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
       0,     0,   186,     0,     0,     0,   187,   188,     0,   189,
     190,   191,   192,     0,     0,     0,     0,     0,     0,     0,
       0,   193,   194,   195,     0,     0,   196,     0,   197,   198,
     199,   200,     0,     0,   201,     0,     0,     0,   202,     0,
       0,     0,   203,     0,     0,     0,   204,     0,   205,     0,
       0,   206,   207,   208,   209,   210,   211,   212,     0,   213,
     214,     0,     0,     0,   215,   216,   217,   218,     0,     0,
       0,   219,     0,   220,   221,   222,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,   224,   225,     0,     0,
     226,   227,     0,     0,   228,   229,   230,     0,     0,   231,
     232,   233,     0,   234,   235,     0,     0,   236,     0,     0,
     237,     0,   238,   239,   240,     0,     0,   241,     0,     0,
     242,   243,   244,     0,   245,   246,     0,     0,     0,   247,
       0,     0,     0,   248,     0,     0,     0,     0,     0,   249,
       0,     0,   250,     0,     0,     0,   251,   252,     0,     0,
       0,    92,   253,    93,    94,    95,   254,     0,     0,     0,
      96,     0,     0,     0,    97,    98,    99,   100,   278,   101,
       0,     0,     0,     0,   102,     0,   103,   104,     0,   105,
       0,   106,     0,     0,   107,     0,     0,   108,     0,     0,
     109,     0,   110,   111,     0,   112,   113,     0,   114,   115,
     116,   117,   118,   119,     0,   120,   121,     0,   122,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,   124,
     125,   126,   127,     0,     0,   128,     0,     0,     0,     0,
     129,   130,     0,     0,     0,     0,     0,     0,     0,     0,
     131,   132,     0,     0,     0,     0,   133,   134,   135,     0,
       0,     0,   136,     0,   137,   138,     0,   139,   140,     0,
       0,   141,     0,   142,   143,     0,   144,     0,     0,     0,
     145,   146,   147,   148,     0,   149,     0,     0,     0,   150,
     151,     0,   152,     0,   153,     0,     0,     0,   154,     0,
       0,     0,     0,     0,   155,   156,   157,   158,     0,     0,
     159,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,     0,   162,     0,     0,
     163,     0,     0,     0,   164,     0,     0,     0,     0,   165,
       0,   166,     0,   167,     0,   168,     0,     0,     0,     0,
       0,   169,   170,     0,   171,   172,   173,   174,     0,     0,
     175,   176,     0,   177,     0,   178,     0,   179,   180,   181,
     182,     0,     0,     0,   183,   184,   185,     0,     0,   186,
       0,     0,     0,   187,   188,     0,   189,   190,   191,   192,
       0,     0,     0,     0,     0,     0,     0,     0,   193,   194,
     195,     0,     0,   196,     0,   197,   198,   199,   200,     0,
       0,   201,     0,     0,     0,   202,     0,     0,     0,   203,
       0,     0,     0,   204,     0,   205,     0,     0,   206,   207,
     208,   209,   210,   211,   212,     0,   213,   214,     0,     0,
       0,   215,   216,   217,   218,     0,     0,     0,   219,     0,
     220,   221,   222,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,   224,   225,     0,     0,   226,   227,     0,
       0,   228,   229,   230,     0,     0,   231,   232,   233,     0,
     234,   235,     0,     0,   236,     0,     0,   237,     0,   238,
     239,   240,     0,     0,   241,     0,     0,   242,   243,   244,
       0,   245,   246,     0,     0,     0,   247,     0,     0,     0,
     248,     0,     0,     0,     0,     0,   249,     0,     0,   250,
       0,     0,     0,   251,   252,     0,     0,     0,    92,   253,
      93,    94,    95,   254,     0,     0,     0,    96,     0,     0,
       0,    97,    98,    99,   100,   278,   101,     0,     0,     0,
       0,   102,     0,   103,   104,     0,   105,     0,   106,     0,
       0,   107,     0,     0,   108,     0,     0,   109,     0,   110,
     111,     0,   112,   113,     0,   114,   115,   116,   117,   118,
     119,     0,   120,   121,     0,   122,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,   124,   125,   126,   127,
       0,     0,   128,     0,     0,     0,     0,   129,   130,     0,
       0,     0,     0,     0,     0,     0,     0,   131,   132,     0,
       0,     0,     0,   133,   134,   135,     0,     0,     0,   136,
       0,   137,   138,     0,   139,   140,     0,     0,   141,     0,
     142,   143,     0,   144,     0,     0,     0,   145,   146,   147,
     148,     0,   149,     0,     0,     0,   150,   151,     0,   152,
       0,   153,     0,     0,     0,   154,     0,     0,     0,     0,
       0,   155,   156,   157,   158,     0,     0,   159,   160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     161,     0,     0,     0,   162,     0,     0,   163,     0,     0,
       0,   164,     0,     0,     0,     0,   165,     0,   166,     0,
     167,     0,   168,     0,     0,     0,     0,     0,   169,   170,
       0,   171,   172,   173,   174,     0,     0,   175,   176,     0,
     177,     0,   178,     0,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,     0,     0,   186,     0,     0,     0,
     187,   188,     0,   189,   190,   191,   192,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,   195,     0,     0,
     196,     0,   197,   198,   199,   200,     0,     0,   201,     0,
       0,     0,   202,     0,     0,     0,   203,     0,     0,     0,
     204,     0,   205,     0,     0,   206,   207,   208,   209,   210,
     211,   212,     0,   213,   214,     0,     0,     0,   215,   216,
     217,   218,     0,     0,     0,   219,     0,   220,   221,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
     224,   225,     0,     0,   226,   227,     0,     0,   228,   229,
     230,     0,     0,   231,   232,   233,     0,   234,   235,     0,
       0,   236,     0,     0,   237,     0,   238,   239,   240,     0,
       0,   241,     0,     0,   242,   243,   244,     0,   245,   246,
       0,     0,     0,   247,     0,     0,     0,   248,     0,     0,
       0,     0,     0,   249,     0,     0,   250,     0,     0,     0,
     251,   252,     0,     0,     0,    92,   253,    93,    94,    95,
     254,     0,     0,     0,    96,     0,     0,     0,    97,    98,
      99,   100,   383,   101,     0,     0,     0,     0,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,     0,
       0,   108,     0,     0,   109,     0,   110,   111,     0,   112,
     113,     0,   114,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,   124,   125,   126,   127,     0,     0,   128,
       0,     0,     0,     0,   129,   130,     0,     0,     0,     0,
       0,     0,     0,     0,   131,   132,     0,     0,     0,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,   139,   140,     0,     0,   141,     0,   142,   143,     0,
     144,     0,     0,     0,   145,   146,   147,   148,     0,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
       0,     0,   154,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,     0,   164,     0,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
       0,     0,     0,     0,     0,   169,   170,     0,   171,   172,
     173,   174,     0,     0,   175,   176,     0,   177,     0,   178,
       0,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,     0,     0,   186,     0,     0,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,     0,     0,   196,     0,   197,
     198,   199,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,     0,     0,     0,   204,     0,   205,
       0,     0,   206,   207,   208,   209,   210,   211,   212,     0,
     213,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,     0,
       0,   226,   227,     0,     0,   228,   229,   230,     0,     0,
     231,   232,   233,     0,   234,   235,     0,     0,   236,     0,
       0,   237,     0,   238,   239,   240,     0,     0,   241,     0,
       0,   242,   243,   244,     0,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   248,     0,     0,     0,     0,     0,
     249,     0,     0,   250,     0,     0,     0,   251,   252,     0,
       0,     0,    92,   253,    93,    94,    95,   254,     0,     0,
       0,    96,     0,     0,     0,    97,  1034,    99,   100,  1242,
     101,     0,     0,     0,     0,   102,     0,   103,   104,     0,
     105,     0,   106,     0,     0,   107,     0,     0,   108,     0,
       0,   109,     0,   110,   111,  -161,   112,   113,     0,  1036,
     115,   116,   117,   118,   119,     0,   120,   121,     0,   122,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
     124,   125,   126,   127,     0,     0,   128,     0,     0,     0,
       0,   129,   130,     0,     0,     0,   644,     0,     0,     0,
       0,   131,   132,     0,     0,     0,     0,   133,   134,   135,
       0,     0,     0,   136,     0,   137,   138,     0,  1042,   140,
       0,     0,   141,     0,   142,   143,     0,   144,     0,     0,
       0,   145,   146,   147,   148,     0,   149,     0,     0,     0,
     150,   151,     0,   152,     0,   153,     0,     0,     0,   154,
       0,     0,     0,     0,     0,   155,   156,   157,   158,     0,
       0,   159,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   161,     0,     0,     0,   162,     0,
       0,   163,     0,     0,     0,   164,   767,     0,     0,     0,
     165,     0,   166,     0,   167,     0,   168,     0,     0,     0,
       0,     0,   169,   170,     0,   171,   172,   173,   174,     0,
       0,   175,   176,     0,   177,     0,   178,     0,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,     0,     0,
     186,     0,     0,     0,   187,   188,     0,   189,   190,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,     0,     0,   196,     0,   197,   198,   199,   200,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
     203,     0,     0,     0,   204,     0,   205,     0,     0,   206,
     207,   208,   209,   210,   211,   212,     0,   213,   214,     0,
       0,     0,   215,   216,   217,   218,     0,     0,     0,   219,
       0,   220,   221,   222,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,   225,     0,     0,   226,   227,
       0,     0,   228,   229,   230,     0,     0,   231,   232,   233,
       0,   234,   235,     0,     0,   236,     0,   768,   237,     0,
     238,   239,   240,     0,     0,   241,     0,     0,   242,   243,
     244,     0,   245,   246,     0,     0,     0,   247,     0,     0,
       0,   248,     0,     0,     0,     0,     0,   249,     0,     0,
     250,     0,     0,     0,   251,   252,     0,     0,     0,     0,
     253,     0,     0,     0,   254,    92,     0,    93,    94,    95,
       0,     0,  1268,     0,    96,     0,     0,     0,    97,  1034,
      99,   100,     0,   101,     0,     0,     0,     0,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,     0,
       0,   108,     0,     0,   109,     0,   110,   111,  -161,   112,
     113,     0,  1036,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,   124,   125,   126,   127,     0,     0,   128,
       0,     0,     0,     0,   129,   130,     0,     0,     0,   644,
       0,     0,     0,     0,   131,   132,     0,     0,     0,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,  1042,   140,     0,     0,   141,     0,   142,   143,     0,
     144,     0,     0,     0,   145,   146,   147,   148,     0,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
       0,     0,   154,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,     0,   164,   767,
    1061,     0,     0,   165,     0,   166,     0,   167,     0,   168,
       0,     0,     0,     0,     0,   169,   170,     0,   171,   172,
     173,   174,     0,     0,   175,   176,     0,   177,     0,   178,
       0,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,     0,     0,   186,     0,     0,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,     0,     0,   196,     0,   197,
     198,   199,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,     0,     0,     0,   204,     0,   205,
       0,     0,   206,   207,   208,   209,   210,   211,   212,     0,
     213,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,     0,
       0,   226,   227,     0,     0,   228,   229,   230,     0,     0,
     231,   232,   233,     0,   234,   235,     0,     0,   236,     0,
     768,   237,     0,   238,   239,   240,     0,     0,   241,     0,
       0,   242,   243,   244,     0,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   248,     0,     0,     0,     0,     0,
     249,     0,     0,   250,     0,     0,     0,   251,   252,     0,
       0,     0,    92,   253,    93,    94,    95,   254,     0,     0,
       0,    96,     0,  1062,     0,    97,    98,    99,   100,     0,
     101,     0,     0,     0,     0,   102,     0,   103,   104,     0,
     105,     0,   106,     0,     0,   107,     0,     0,   108,     0,
       0,   109,     0,   110,   111,     0,   112,   113,     0,   114,
     115,   116,   117,   118,   119,     0,   120,   121,     0,   122,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
     124,   125,   126,   127,     0,     0,   128,     0,     0,     0,
       0,   129,   130,     0,     0,     0,     0,     0,     0,     0,
       0,   131,   132,     0,     0,     0,     0,   133,   134,   135,
       0,     0,     0,   136,     0,   137,   138,     0,   139,   140,
       0,     0,   141,     0,   142,   143,     0,   144,     0,     0,
       0,   145,   146,   147,   148,     0,   149,     0,     0,     0,
     150,   151,     0,   152,     0,   153,     0,     0,     0,   154,
       0,     0,     0,     0,     0,   155,   156,   157,   158,     0,
       0,   159,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   161,     0,     0,     0,   162,     0,
       0,   163,     0,     0,     0,   164,     0,     0,     0,     0,
     165,     0,   166,     0,   167,     0,   168,     0,     0,     0,
       0,     0,   169,   170,     0,   171,   172,   173,   174,     0,
       0,   175,   176,     0,   177,     0,   178,     0,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,     0,     0,
     186,     0,     0,     0,   187,   188,     0,   189,   190,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,     0,     0,   196,     0,   197,   198,   199,   200,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
     203,     0,     0,     0,   204,     0,   205,     0,     0,   206,
     207,   208,   209,   210,   211,   212,     0,   213,   214,     0,
       0,     0,   215,   216,   217,   218,     0,     0,     0,   219,
       0,   220,   221,   222,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,   225,     0,     0,   226,   227,
       0,     0,   228,   229,   230,     0,     0,   231,   232,   233,
       0,   234,   235,     0,     0,   236,     0,     0,   237,     0,
     238,   239,   240,     0,     0,   241,     0,     0,   242,   243,
     244,     0,   245,   246,     0,     0,     0,   247,     0,     0,
       0,   248,     0,     0,     0,     0,     0,   249,     0,     0,
     250,     0,     0,     0,   251,   252,     0,     0,     0,    92,
     253,    93,    94,    95,   254,     0,     0,  1188,    96,     0,
       0,     0,    97,    98,    99,   100,     0,   101,     0,     0,
       0,     0,   102,     0,   103,   104,     0,   105,     0,   106,
       0,     0,   107,     0,     0,   108,     0,     0,   109,     0,
     110,   111,     0,   112,   113,     0,   114,   115,   116,   117,
     118,   119,     0,   120,   121,     0,   122,     0,     0,     0,
       0,     0,   123,     0,     0,     0,     0,   124,   125,   126,
     127,     0,     0,   128,     0,     0,     0,     0,   129,   130,
       0,     0,     0,     0,     0,     0,     0,     0,   131,   132,
       0,     0,     0,     0,   133,   134,   135,     0,     0,     0,
     136,     0,   137,   138,     0,   139,   140,     0,     0,   141,
       0,   142,   143,     0,   144,     0,     0,     0,   145,   146,
     147,   148,     0,   149,     0,     0,     0,   150,   151,     0,
     152,     0,   153,     0,     0,     0,   154,     0,     0,     0,
       0,     0,   155,   156,   157,   158,     0,     0,   159,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,   162,     0,     0,   163,     0,
       0,     0,   164,     0,     0,     0,     0,   165,     0,   166,
       0,   167,     0,   168,     0,     0,     0,     0,     0,   169,
     170,     0,   171,   172,   173,   174,     0,     0,   175,   176,
       0,   177,     0,   178,     0,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,     0,     0,   186,     0,     0,
       0,   187,   188,     0,   189,   190,   191,   192,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,   195,     0,
       0,   196,     0,   197,   198,   199,   200,     0,     0,   201,
       0,     0,     0,   202,     0,     0,     0,   203,     0,     0,
       0,   204,     0,   205,     0,     0,   206,   207,   208,   209,
     210,   211,   212,     0,   213,   214,     0,     0,     0,   215,
     216,   217,   218,     0,     0,     0,   219,     0,   220,   221,
     222,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,   224,   225,     0,     0,   226,   227,     0,     0,   228,
     229,   230,     0,     0,   231,   232,   233,     0,   234,   235,
       0,     0,   236,     0,     0,   237,     0,   238,   239,   240,
       0,     0,   241,     0,     0,   242,   243,   244,     0,   245,
     246,     0,     0,     0,   247,     0,     0,     0,   248,     0,
       0,     0,     0,     0,   249,     0,     0,   250,     0,     0,
       0,   251,   252,     0,     0,     0,     0,   253,     0,     0,
       0,   254,     0,     0,  1507,    92,  1032,    93,    94,    95,
       0,  1033,     0,     0,    96,     0,     0,     0,    97,  1034,
      99,   100,     0,   101,     0,     0,     0,     0,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,     0,
       0,   108,  1035,     0,   109,     0,   110,   111,     0,   112,
     113,     0,  1036,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,  1037,     0,     0,     0,   123,     0,
       0,     0,     0,   124,   125,   126,   127,     0,     0,   128,
       0,     0,     0,     0,   129,   130,     0,     0,     0,   644,
       0,     0,     0,     0,  1038,  1039,     0,     0,     0,  1040,
     133,   134,   135,     0,     0,     0,  1041,     0,   137,   138,
    -226,  1042,   140,     0,     0,   141,     0,   142,   143,     0,
     144,     0,     0,     0,   145,   146,   147,   148,     0,   149,
    1043,     0,     0,   150,   151,     0,   152,     0,   153,     0,
       0,     0,   154,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,  1044,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,     0,   164,   767,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
       0,     0,     0,     0,     0,   169,   170,     0,   171,   172,
     173,   174,     0,     0,   175,   176,     0,   177,     0,  1045,
       0,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,     0,     0,   186,     0,     0,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,  1046,     0,     0,
       0,     0,   193,   194,   195,     0,     0,   196,     0,   197,
     198,   199,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,  1047,   203,     0,     0,     0,   204,     0,   205,
       0,     0,   206,   207,   208,   209,   210,   211,   212,     0,
     213,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,     0,
       0,   226,   227,     0,     0,   228,   229,   230,     0,     0,
     231,   232,   233,     0,   234,   235,     0,     0,   236,     0,
     768,   237,     0,   238,   239,   240,     0,     0,   241,     0,
       0,   242,   243,   244,     0,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   248,     0,     0,     0,     0,     0,
     249,     0,     0,   250,     0,     0,     0,   251,   252,     0,
       0,     0,     0,   253,     0,     0,     0,   254,    92,  1032,
      93,    94,    95,     0,  1033,     0,     0,    96,     0,     0,
       0,    97,  1034,    99,   100,     0,   101,     0,     0,     0,
       0,   102,     0,   103,   104,     0,   105,     0,   106,     0,
       0,   107,     0,     0,   108,  1035,     0,   109,     0,   110,
     111,     0,   112,   113,     0,  1036,   115,   116,   117,   118,
     119,     0,   120,   121,     0,   122,     0,  1037,     0,     0,
       0,   123,     0,     0,     0,     0,   124,   125,   126,   127,
       0,     0,   128,     0,     0,     0,     0,   129,   130,     0,
       0,     0,   644,     0,     0,     0,     0,  1038,   132,     0,
       0,     0,  1040,   133,   134,   135,     0,     0,     0,  1041,
       0,   137,   138,     0,  1042,   140,     0,     0,   141,     0,
     142,   143,     0,   144,     0,     0,     0,   145,   146,   147,
     148,     0,   149,  1043,     0,     0,   150,   151,     0,   152,
       0,   153,     0,     0,     0,   154,     0,     0,     0,     0,
       0,   155,   156,   157,   158,     0,     0,   159,   160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     161,     0,     0,     0,   162,     0,     0,   163,     0,     0,
       0,   164,   767,     0,     0,     0,   165,     0,   166,     0,
     167,     0,   168,     0,     0,     0,     0,     0,   169,   170,
       0,   171,   172,   173,   174,     0,     0,   175,   176,     0,
     177,     0,  1045,     0,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,     0,     0,   186,     0,     0,     0,
     187,   188,     0,   189,   190,   191,   192,     0,     0,     0,
    1046,     0,     0,     0,     0,   193,   194,   195,     0,     0,
     196,     0,   197,   198,   199,   200,     0,     0,   201,     0,
       0,     0,   202,     0,     0,  1047,   203,     0,     0,     0,
     204,     0,   205,     0,     0,   206,   207,   208,   209,   210,
     211,   212,     0,   213,   214,     0,     0,     0,   215,   216,
     217,   218,     0,     0,     0,   219,     0,   220,   221,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
     224,   225,     0,     0,   226,   227,     0,     0,   228,   229,
     230,     0,     0,   231,   232,   233,     0,   234,   235,     0,
       0,   236,     0,   768,   237,     0,   238,   239,   240,     0,
       0,   241,     0,     0,   242,   243,   244,     0,   245,   246,
       0,     0,     0,   247,     0,     0,     0,   248,     0,     0,
       0,     0,     0,   249,     0,     0,   250,     0,     0,     0,
     251,   252,     0,     0,     0,    92,   253,    93,    94,    95,
     254,     0,     0,     0,    96,     0,     0,     0,    97,    98,
      99,   100,     0,   101,     0,     0,     0,     0,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,     0,
       0,   108,     0,     0,   109,     0,   110,   111,     0,   112,
     113,     0,   114,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,   124,   125,   126,   127,     0,     0,   128,
       0,     0,     0,     0,   129,   130,  1249,     0,     0,     0,
       0,     0,     0,     0,   131,   132,     0,     0,     0,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,   139,   140,     0,     0,   141,     0,   142,   143,     0,
     144,     0,     0,     0,   145,   146,   147,   148,  1250,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
       0,     0,   154,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,     0,   164,   767,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
    1251,     0,     0,     0,     0,   169,   170,     0,   171,   172,
     173,   174,     0,     0,   175,   176,     0,   177,     0,   178,
       0,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,     0,     0,   186,     0,  1252,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,     0,     0,   196,     0,   197,
     198,   199,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,     0,     0,     0,   204,     0,   205,
       0,     0,   206,   207,   208,   209,   210,   211,   212,     0,
     213,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,     0,
       0,   226,   227,     0,     0,   228,   229,   230,     0,     0,
     231,   232,   233,     0,   234,   235,     0,     0,   236,     0,
     768,   237,     0,   238,   239,   240,     0,     0,   241,     0,
       0,   242,   243,   244,  1253,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   248,     0,     0,     0,     0,     0,
     249,     0,     0,   250,     0,     0,     0,   251,   252,     0,
       0,     0,    92,   253,    93,    94,    95,   254,     0,     0,
       0,    96,     0,     0,     0,    97,    98,    99,   100,     0,
     101,     0,     0,     0,     0,   102,     0,   103,   104,     0,
     105,     0,   106,     0,     0,   107,     0,     0,   108,     0,
       0,   109,     0,   110,   111,  -161,   112,   113,     0,   114,
     115,   116,   117,   118,   119,     0,   120,   121,     0,   122,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
     124,   125,   126,   127,     0,     0,   128,     0,     0,     0,
       0,   129,   130,     0,     0,     0,   644,     0,     0,     0,
       0,   131,   132,     0,     0,     0,     0,   133,   134,   135,
       0,     0,     0,   136,     0,   137,   138,     0,   139,   140,
       0,     0,   141,     0,   142,   143,     0,   144,     0,     0,
       0,   145,   146,   147,   148,     0,   149,     0,     0,     0,
     150,   151,     0,   152,     0,   153,     0,     0,     0,   154,
       0,     0,     0,     0,     0,   155,   156,   157,   158,     0,
       0,   159,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   161,     0,     0,     0,   162,     0,
       0,   163,     0,     0,     0,   164,   767,     0,     0,     0,
     165,     0,   166,     0,   167,     0,   168,     0,     0,     0,
       0,     0,   169,   170,     0,   171,   172,   173,   174,     0,
       0,   175,   176,     0,   177,     0,   178,     0,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,     0,     0,
     186,     0,     0,     0,   187,   188,     0,   189,   190,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,     0,     0,   196,     0,   197,   198,   199,   200,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
     203,     0,     0,     0,   204,     0,   205,     0,     0,   206,
     207,   208,   209,   210,   211,   212,     0,   213,   214,     0,
       0,     0,   215,   216,   217,   218,     0,     0,     0,   219,
       0,   220,   221,   222,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,   225,     0,     0,   226,   227,
       0,     0,   228,   229,   230,     0,     0,   231,   232,   233,
       0,   234,   235,     0,     0,   236,     0,   768,   237,     0,
     238,   239,   240,     0,     0,   241,     0,     0,   242,   243,
     244,     0,   245,   246,     0,     0,     0,   247,     0,     0,
       0,   248,     0,     0,     0,     0,     0,   249,     0,     0,
     250,     0,     0,     0,   251,   252,     0,     0,     0,    92,
     253,    93,    94,    95,   254,     0,     0,     0,    96,     0,
       0,     0,    97,  1034,    99,   100,     0,   101,     0,     0,
       0,     0,   102,     0,   103,   104,     0,   105,     0,   106,
       0,     0,   107,     0,     0,   108,     0,     0,   109,     0,
     110,   111,  -161,   112,   113,     0,  1036,   115,   116,   117,
     118,   119,     0,   120,   121,     0,   122,     0,     0,     0,
       0,     0,   123,     0,     0,     0,     0,   124,   125,   126,
     127,     0,     0,   128,     0,     0,     0,     0,   129,   130,
       0,     0,     0,   644,     0,     0,     0,     0,   131,   132,
       0,     0,     0,     0,   133,   134,   135,     0,     0,     0,
     136,     0,   137,   138,     0,  1042,   140,     0,     0,   141,
       0,   142,   143,     0,   144,     0,     0,     0,   145,   146,
     147,   148,     0,   149,     0,     0,     0,   150,   151,     0,
     152,     0,   153,     0,     0,     0,   154,     0,     0,     0,
       0,     0,   155,   156,   157,   158,     0,     0,   159,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,     0,   162,     0,     0,   163,     0,
       0,     0,   164,   767,     0,     0,     0,   165,     0,   166,
       0,   167,     0,   168,     0,     0,     0,     0,     0,   169,
     170,     0,   171,   172,   173,   174,     0,     0,   175,   176,
       0,   177,     0,   178,     0,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,     0,     0,   186,     0,     0,
       0,   187,   188,     0,   189,   190,   191,   192,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,   195,     0,
       0,   196,     0,   197,   198,   199,   200,     0,     0,   201,
       0,     0,     0,   202,     0,     0,     0,   203,     0,     0,
       0,   204,     0,   205,     0,     0,   206,   207,   208,   209,
     210,   211,   212,     0,   213,   214,     0,     0,     0,   215,
     216,   217,   218,     0,     0,     0,   219,     0,   220,   221,
     222,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,   224,   225,     0,     0,   226,   227,     0,     0,   228,
     229,   230,     0,     0,   231,   232,   233,     0,   234,   235,
       0,     0,   236,     0,   768,   237,     0,   238,   239,   240,
       0,     0,   241,     0,     0,   242,   243,   244,     0,   245,
     246,     0,     0,     0,   247,     0,     0,     0,   248,     0,
       0,     0,     0,     0,   249,     0,     0,   250,     0,     0,
       0,   251,   252,     0,     0,     0,    92,   253,    93,    94,
      95,   254,     0,     0,     0,    96,     0,     0,     0,    97,
      98,    99,   100,     0,   101,     0,     0,     0,   637,   102,
       0,   103,   104,     0,   105,     0,   106,     0,     0,   107,
       0,     0,   108,     0,     0,   109,     0,   110,   111,     0,
     112,   113,     0,   114,   115,   116,   117,   118,   119,     0,
     120,   121,     0,   122,     0,     0,     0,     0,     0,   123,
       0,     0,     0,     0,   124,   125,   126,   127,     0,     0,
     128,     0,     0,     0,     0,   129,   130,     0,     0,     0,
       0,     0,     0,     0,     0,   131,   132,     0,     0,     0,
       0,   133,   134,   135,     0,     0,     0,   136,     0,   137,
     138,     0,   139,   140,     0,     0,   141,     0,   142,   143,
       0,   144,     0,     0,     0,   145,   146,   147,   148,     0,
     149,     0,     0,     0,   150,   151,     0,   152,     0,   153,
       0,     0,     0,   154,     0,   638,     0,     0,     0,   155,
     156,   157,   158,     0,     0,   159,   160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   161,     0,
       0,     0,   162,     0,     0,   163,     0,     0,     0,   164,
       0,     0,     0,     0,   165,     0,   166,     0,   167,     0,
     168,     0,     0,     0,     0,     0,   169,   170,     0,   171,
     172,   173,   174,     0,     0,   175,   176,     0,   177,     0,
     178,     0,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,     0,     0,   186,     0,     0,     0,   187,   188,
       0,   189,   190,   191,   192,     0,     0,     0,     0,     0,
       0,     0,     0,   193,   194,   195,     0,     0,   196,     0,
     197,   198,   199,   200,     0,     0,   201,     0,     0,     0,
     202,     0,     0,     0,   203,     0,     0,     0,   204,     0,
     205,     0,     0,   206,   207,   208,   209,   210,   211,   212,
       0,   213,   214,     0,     0,     0,   215,   216,   217,   218,
       0,     0,     0,   219,     0,   220,   221,   222,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,   224,   225,
       0,     0,   226,   227,     0,     0,   228,   229,   230,     0,
       0,   231,   232,   233,     0,   234,   235,     0,     0,   236,
       0,   364,   237,     0,   238,   239,   240,     0,     0,   241,
       0,     0,   242,   243,   244,     0,   245,   246,     0,     0,
       0,   247,     0,     0,     0,   248,     0,     0,     0,     0,
       0,   249,     0,     0,   250,     0,     0,     0,   251,   252,
       0,     0,     0,    92,   253,    93,    94,    95,   254,     0,
       0,     0,    96,     0,     0,     0,    97,    98,    99,   100,
       0,   101,     0,     0,     0,     0,   102,     0,   103,   104,
       0,   105,     0,   106,     0,     0,   107,     0,     0,   108,
       0,     0,   109,     0,   110,   111,     0,   112,   113,     0,
     114,   115,   116,   117,   118,   119,     0,   120,   121,     0,
     122,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,   124,   125,   126,   127,     0,     0,   128,     0,     0,
       0,     0,   129,   130,     0,     0,     0,  1204,     0,     0,
       0,     0,   131,   132,     0,     0,     0,     0,   133,   134,
     135,     0,     0,     0,   136,     0,   137,   138,     0,   139,
     140,     0,     0,   141,     0,   142,   143,     0,   144,     0,
       0,     0,   145,   146,   147,   148,     0,   149,     0,     0,
       0,   150,   151,     0,   152,     0,   153,     0,     0,     0,
     154,     0,     0,     0,     0,     0,   155,   156,   157,   158,
       0,     0,   159,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,   162,
       0,     0,   163,     0,     0,     0,   164,   767,     0,     0,
       0,   165,     0,   166,     0,   167,     0,   168,     0,     0,
       0,     0,     0,   169,   170,     0,   171,   172,   173,   174,
       0,     0,   175,   176,     0,   177,     0,   178,     0,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,     0,
       0,   186,     0,     0,     0,   187,   188,     0,   189,   190,
     191,   192,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,   195,     0,     0,   196,     0,   197,   198,   199,
     200,     0,     0,   201,     0,     0,     0,   202,     0,     0,
       0,   203,     0,     0,     0,   204,     0,   205,     0,     0,
     206,   207,   208,   209,   210,   211,   212,     0,   213,   214,
       0,     0,     0,   215,   216,   217,   218,     0,     0,     0,
     219,     0,   220,   221,   222,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,   224,   225,     0,     0,   226,
     227,     0,     0,   228,   229,   230,     0,     0,   231,   232,
     233,     0,   234,   235,     0,     0,   236,     0,   768,   237,
       0,   238,   239,   240,     0,     0,   241,     0,     0,   242,
     243,   244,     0,   245,   246,     0,     0,     0,   247,     0,
       0,     0,   248,     0,     0,     0,     0,     0,   249,     0,
       0,   250,     0,     0,     0,   251,   252,     0,     0,     0,
      92,   253,    93,    94,    95,   254,     0,     0,     0,    96,
       0,     0,     0,    97,  1034,    99,   100,     0,   101,     0,
       0,     0,     0,   102,     0,   103,   104,     0,   105,     0,
     106,     0,     0,   107,     0,     0,   108,     0,     0,   109,
       0,   110,   111,     0,   112,   113,     0,  1036,   115,   116,
     117,   118,   119,     0,   120,   121,     0,   122,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,   124,   125,
     126,   127,     0,     0,   128,     0,     0,     0,     0,   129,
     130,     0,     0,     0,   644,     0,     0,     0,     0,   131,
     132,     0,     0,     0,     0,   133,   134,   135,     0,     0,
       0,   136,     0,   137,   138,     0,  1042,   140,     0,     0,
     141,     0,   142,   143,     0,   144,     0,     0,     0,   145,
     146,   147,   148,     0,   149,     0,     0,     0,   150,   151,
       0,   152,     0,   153,     0,     0,     0,   154,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,   159,
     160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   161,     0,     0,     0,   162,     0,     0,   163,
       0,     0,     0,   164,   767,     0,     0,     0,   165,     0,
     166,     0,   167,     0,   168,     0,     0,     0,     0,     0,
     169,   170,     0,   171,   172,   173,   174,     0,     0,   175,
     176,     0,   177,     0,   178,     0,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,     0,     0,   186,     0,
       0,     0,   187,   188,     0,   189,   190,   191,   192,     0,
       0,     0,     0,     0,     0,     0,     0,   193,   194,   195,
       0,     0,   196,     0,   197,   198,   199,   200,     0,     0,
     201,     0,     0,     0,   202,     0,     0,     0,   203,     0,
       0,     0,   204,     0,   205,     0,     0,   206,   207,   208,
     209,   210,   211,   212,     0,   213,   214,     0,     0,     0,
     215,   216,   217,   218,     0,     0,     0,   219,     0,   220,
     221,   222,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,   224,   225,     0,     0,   226,   227,     0,     0,
     228,   229,   230,     0,     0,   231,   232,   233,     0,   234,
     235,     0,     0,   236,     0,   768,   237,     0,   238,   239,
     240,     0,     0,   241,     0,     0,   242,   243,   244,     0,
     245,   246,     0,     0,     0,   247,     0,     0,     0,   248,
       0,     0,     0,     0,     0,   249,     0,     0,   250,     0,
       0,     0,   251,   252,     0,     0,     0,    92,   253,    93,
      94,    95,   254,     0,     0,     0,    96,     0,     0,     0,
      97,    98,    99,   100,     0,   101,     0,     0,     0,     0,
     102,     0,   103,   104,     0,   105,     0,   106,     0,     0,
     107,     0,     0,   108,     0,     0,   109,     0,   110,   111,
       0,   112,   113,     0,   114,   115,   116,   117,   118,   119,
       0,   120,   121,     0,   122,     0,     0,     0,     0,     0,
     123,     0,     0,     0,     0,   124,   125,   126,   127,     0,
       0,   128,     0,     0,     0,     0,   129,   130,     0,     0,
       0,     0,     0,     0,     0,     0,   131,   132,     0,     0,
       0,     0,   133,   134,   135,     0,     0,     0,   136,     0,
     137,   138,     0,   139,   140,     0,     0,   141,     0,   142,
     143,     0,   144,     0,     0,     0,   145,   146,   147,   148,
       0,   149,     0,     0,     0,   150,   151,     0,   152,     0,
     153,     0,     0,     0,   154,     0,     0,     0,     0,     0,
     155,   156,   157,   158,     0,     0,   159,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,     0,   162,     0,     0,   163,     0,     0,     0,
     164,   767,     0,     0,     0,   165,     0,   166,     0,   167,
       0,   168,     0,     0,     0,     0,     0,   169,   170,     0,
     171,   172,   173,   174,     0,     0,   175,   176,     0,   177,
       0,   178,     0,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,     0,     0,   186,     0,     0,     0,   187,
     188,     0,   189,   190,   191,   192,     0,     0,     0,     0,
       0,     0,     0,     0,   193,   194,   195,     0,     0,   196,
       0,   197,   198,   199,   200,     0,     0,   201,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,   204,
       0,   205,     0,     0,   206,   207,   208,   209,   210,   211,
     212,     0,   213,   214,     0,     0,     0,   215,   216,   217,
     218,     0,     0,     0,   219,     0,   220,   221,   222,     0,
       0,     0,     0,     0,   223,     0,     0,     0,     0,   224,
     225,     0,     0,   226,   227,     0,     0,   228,   229,   230,
       0,     0,   231,   232,   233,     0,   234,   235,     0,     0,
     236,     0,   768,   237,     0,   238,   239,   240,     0,     0,
     241,     0,     0,   242,   243,   244,     0,   245,   246,     0,
       0,     0,   247,     0,     0,     0,   248,     0,     0,     0,
       0,     0,   249,     0,     0,   250,     0,     0,     0,   251,
     252,     0,     0,     0,    92,   253,    93,    94,    95,   254,
       0,     0,     0,    96,  1184,     0,     0,    97,    98,    99,
     100,     0,   101,     0,     0,     0,     0,   102,     0,   103,
     104,     0,   105,     0,   106,     0,     0,   107,     0,     0,
     108,     0,     0,   109,     0,   110,   111,     0,   112,   113,
       0,   114,   115,   116,   117,   118,   119,     0,   120,   121,
       0,   122,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,   124,   125,   126,   127,     0,     0,   128,     0,
       0,     0,     0,   129,   130,     0,     0,     0,     0,     0,
       0,     0,     0,   131,   132,     0,     0,     0,     0,   133,
     134,   135,     0,     0,     0,   136,     0,   137,   138,     0,
     139,   140,     0,     0,   141,     0,   142,   143,     0,   144,
       0,     0,     0,   145,   146,   147,   148,     0,   149,     0,
       0,     0,   150,   151,     0,   152,     0,   153,     0,     0,
       0,   154,     0,     0,     0,     0,     0,   155,   156,   157,
     158,     0,     0,   159,   160,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   161,     0,     0,     0,
     162,     0,     0,   163,     0,     0,     0,   164,     0,     0,
       0,     0,   165,     0,   166,     0,   167,     0,   168,     0,
       0,     0,     0,     0,   169,   170,     0,   171,   172,   173,
     174,     0,     0,   175,   176,     0,   177,     0,   178,     0,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
       0,     0,   186,     0,     0,     0,   187,   188,     0,   189,
     190,   191,   192,     0,     0,     0,     0,     0,     0,     0,
       0,   193,   194,   195,     0,     0,   196,     0,   197,   198,
     199,   200,     0,     0,   201,     0,     0,     0,   202,     0,
       0,     0,   203,     0,     0,     0,   204,     0,   205,     0,
       0,   206,   207,   208,   209,   210,   211,   212,     0,   213,
     214,     0,     0,     0,   215,   216,   217,   218,     0,     0,
       0,   219,     0,   220,   221,   222,     0,     0,     0,     0,
       0,   223,     0,     0,     0,     0,   224,   225,     0,     0,
     226,   227,     0,     0,   228,   229,   230,     0,     0,   231,
     232,   233,     0,   234,   235,     0,     0,   236,     0,   768,
     237,     0,   238,   239,   240,     0,     0,   241,     0,     0,
     242,   243,   244,     0,   245,   246,     0,     0,     0,   247,
       0,     0,     0,   248,     0,     0,     0,     0,     0,   249,
       0,     0,   250,     0,     0,     0,   251,   252,     0,     0,
       0,    92,   253,    93,    94,    95,   254,     0,     0,     0,
      96,     0,     0,     0,    97,    98,    99,   100,     0,   101,
       0,     0,     0,     0,   102,     0,   103,   104,     0,   105,
       0,   106,     0,     0,   107,     0,     0,   108,     0,     0,
     109,     0,   110,   111,     0,   112,   113,     0,   114,   115,
     116,   117,   118,   119,     0,   120,   121,     0,   122,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,   124,
     125,   126,   127,     0,     0,   128,     0,     0,     0,     0,
     129,   130,     0,     0,     0,     0,     0,     0,     0,     0,
     131,   132,     0,     0,     0,     0,   133,   134,   135,     0,
       0,     0,   136,     0,   137,   138,     0,   139,   140,     0,
       0,   141,     0,   142,   143,     0,   144,     0,     0,     0,
     145,   146,   147,   148,     0,   149,     0,     0,     0,   150,
     151,     0,   152,     0,   153,     0,     0,     0,   154,     0,
       0,     0,     0,     0,   155,   156,   157,   158,     0,     0,
     159,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,     0,   162,     0,     0,
     163,     0,     0,     0,   164,     0,     0,     0,     0,   165,
       0,   166,     0,   167,     0,   168,     0,     0,     0,     0,
       0,   169,   170,     0,   171,   172,   173,   174,     0,     0,
     175,   176,     0,   177,     0,   178,     0,   179,   180,   181,
     182,     0,     0,     0,   183,   184,   185,     0,     0,   186,
       0,     0,     0,   187,   188,     0,   189,   190,   191,   192,
       0,     0,     0,     0,     0,     0,     0,     0,   193,   194,
     195,     0,     0,   196,     0,   197,   198,   199,   200,     0,
       0,   201,     0,     0,     0,   202,     0,     0,     0,   203,
       0,     0,     0,   204,     0,   205,     0,     0,   206,   207,
     208,   209,   210,   211,   212,     0,   213,   214,     0,     0,
       0,   215,   216,   217,   218,     0,     0,     0,   219,     0,
     220,   221,   222,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,   224,   225,     0,     0,   226,   227,     0,
       0,   228,   229,   230,     0,     0,   231,   232,   233,     0,
     234,   235,     0,     0,   236,     0,   768,   237,     0,   238,
     239,   240,     0,     0,   241,     0,     0,   242,   243,   244,
       0,   245,   246,     0,     0,     0,   247,     0,     0,     0,
     248,     0,     0,     0,     0,     0,   249,     0,     0,   250,
       0,     0,     0,   251,   252,     0,     0,     0,    92,   253,
      93,    94,    95,   254,     0,     0,     0,    96,     0,     0,
       0,    97,    98,    99,   100,     0,   101,     0,     0,     0,
       0,   102,     0,   103,   104,     0,   105,     0,   106,     0,
       0,   107,     0,     0,   108,     0,     0,   109,     0,   110,
     111,     0,   112,   113,     0,   114,   115,   116,   117,   118,
     119,     0,   120,   121,     0,   122,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,   124,   125,   126,   127,
       0,     0,   128,     0,     0,     0,     0,   129,   130,     0,
       0,     0,     0,     0,     0,     0,     0,   131,   132,     0,
       0,     0,     0,   133,   134,   135,     0,     0,     0,   136,
       0,   137,   138,     0,   139,   140,     0,     0,   141,     0,
     142,   143,     0,   144,     0,     0,     0,   145,   146,   147,
     148,     0,   149,     0,     0,     0,   150,   151,     0,   152,
       0,   153,     0,     0,     0,   154,     0,     0,     0,     0,
       0,   155,   156,   157,   158,     0,     0,   159,   160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     161,     0,     0,     0,   162,     0,     0,   163,     0,     0,
       0,   164,     0,     0,     0,     0,   165,     0,   166,     0,
     167,     0,   168,     0,     0,     0,     0,     0,   169,   170,
       0,   171,   172,   173,   174,     0,     0,   175,   176,     0,
     177,     0,   178,     0,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,     0,     0,   186,     0,     0,     0,
     187,   188,     0,   189,   190,   191,   192,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,   195,     0,     0,
     196,  1917,   197,   198,   199,   200,     0,     0,   201,     0,
       0,     0,   202,     0,     0,     0,   203,     0,     0,     0,
     204,     0,   205,     0,     0,   206,   207,   208,   209,   210,
     211,   212,     0,   213,   214,     0,     0,     0,   215,   216,
     217,   218,     0,     0,     0,   219,     0,   220,   221,   222,
       0,     0,     0,     0,     0,   223,     0,     0,     0,     0,
     224,   225,     0,     0,   226,   227,     0,     0,   228,   229,
     230,     0,     0,   231,   232,   233,     0,   234,   235,     0,
       0,   236,     0,     0,   237,     0,   238,   239,   240,     0,
       0,   241,     0,     0,   242,   243,   244,     0,   245,   246,
       0,     0,     0,   247,     0,     0,     0,   248,     0,     0,
       0,     0,     0,   249,     0,     0,   250,     0,     0,     0,
     251,   252,     0,     0,     0,    92,   253,    93,    94,    95,
     254,     0,     0,     0,    96,     0,     0,     0,    97,    98,
      99,   100,     0,   101,     0,     0,     0,     0,   102,     0,
     103,   104,     0,   105,     0,   106,     0,     0,   107,     0,
       0,   108,     0,     0,   109,     0,   110,   111,     0,   112,
     113,     0,   114,   115,   116,   117,   118,   119,     0,   120,
     121,     0,   122,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,   124,   125,   126,   127,     0,     0,   128,
       0,     0,     0,     0,   129,   130,     0,     0,     0,     0,
       0,     0,     0,     0,   131,   132,     0,     0,     0,     0,
     133,   134,   135,     0,     0,     0,   136,     0,   137,   138,
       0,   139,   140,     0,     0,   141,     0,   142,   143,     0,
     144,     0,     0,     0,   145,   146,   147,   148,     0,   149,
       0,     0,     0,   150,   151,     0,   152,     0,   153,     0,
       0,     0,   154,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,   159,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,   162,     0,     0,   163,     0,     0,     0,   164,     0,
       0,     0,     0,   165,     0,   166,     0,   167,     0,   168,
       0,     0,     0,     0,     0,   169,   170,     0,   171,   172,
     173,   174,     0,     0,   175,   176,     0,   177,     0,   178,
       0,   179,   180,   181,   182,     0,     0,     0,   183,   184,
     185,     0,     0,   186,     0,     0,     0,   187,   188,     0,
     189,   190,   191,   192,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,   195,     0,     0,   196,     0,   197,
     198,   199,   200,     0,     0,   201,     0,     0,     0,   202,
       0,     0,     0,   203,     0,     0,     0,   204,     0,   205,
       0,     0,   206,   207,   208,   209,   210,   211,   212,     0,
     213,   214,     0,     0,     0,   215,   216,   217,   218,     0,
       0,     0,   219,     0,   220,   221,   222,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,     0,
       0,   226,   227,     0,     0,   228,   229,   230,     0,     0,
     231,   232,   233,     0,   234,   235,     0,     0,   236,     0,
       0,   237,     0,   238,   239,   240,     0,     0,   241,     0,
       0,   242,   243,   244,     0,   245,   246,     0,     0,     0,
     247,     0,     0,     0,   248,     0,     0,     0,     0,     0,
     249,     0,     0,   250,     0,     0,     0,   251,   252,     0,
       0,     0,    92,   253,    93,    94,    95,   254,     0,     0,
       0,    96,     0,     0,     0,    97,    98,    99,   100,     0,
     101,     0,     0,     0,     0,   102,     0,   103,   104,     0,
     105,     0,   106,     0,     0,   107,     0,     0,   108,     0,
       0,   109,     0,   110,   111,     0,   112,   113,     0,   114,
     115,   116,   117,   118,   119,     0,   120,   121,     0,   122,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
     124,   125,   126,   127,     0,     0,   128,     0,     0,     0,
       0,   129,   130,     0,     0,     0,     0,     0,     0,     0,
       0,   131,   132,     0,     0,     0,     0,   133,   134,   135,
       0,     0,     0,   136,     0,   137,   138,     0,   139,   140,
       0,     0,   141,     0,   142,   143,     0,   144,     0,     0,
       0,   145,   146,   147,   148,     0,   149,     0,     0,     0,
     150,   151,     0,   152,     0,   153,     0,     0,     0,   154,
       0,     0,     0,     0,     0,   155,   156,   157,   158,     0,
       0,   159,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   161,     0,     0,     0,   162,     0,
       0,   163,     0,     0,     0,   164,     0,     0,     0,     0,
     165,     0,   166,     0,   167,     0,   168,     0,     0,     0,
       0,     0,   169,   170,     0,   171,   172,   173,   174,     0,
       0,   175,   176,     0,   177,     0,   178,     0,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,     0,     0,
     186,     0,     0,     0,   187,   188,     0,   189,   190,   191,
     192,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     194,   195,     0,     0,   196,     0,   197,   198,   199,   200,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
     203,     0,     0,     0,   204,     0,   205,     0,     0,   206,
     207,   208,   209,   210,   211,   212,     0,   213,   214,     0,
       0,     0,   215,   216,   217,   218,     0,     0,     0,   219,
       0,   220,   221,   222,     0,     0,     0,     0,     0,   223,
       0,     0,     0,     0,   224,   225,     0,     0,   226,   227,
       0,     0,   228,   229,   230,     0,     0,   231,   232,   233,
       0,   234,   235,     0,     0,   236,     0,     0,   237,     0,
     238,   239,   240,     0,     0,  1011,     0,     0,   242,   243,
     244,     0,   245,   246,     0,     0,     0,   247,     0,     0,
       0,   248,     0,     0,     0,     0,     0,   249,     0,     0,
     250,     0,     0,     0,   251,   252,     0,     0,     0,     0,
     253,     0,     0,     0,   254
};

static const yytype_int16 yycheck[] =
{
      20,   547,   396,   414,   558,   615,   320,   310,    28,   324,
     865,  1004,   812,   490,   491,   512,   547,  1070,  1040,   951,
     997,  1202,  1034,    90,  1036,   947,  1125,   565,   635,    49,
     584,    49,   505,   347,   572,  1019,  1020,  1345,    12,  1324,
     430,    61,   441,   859,    12,    12,    12,   292,    26,   363,
     365,   441,    12,  1152,   290,  1451,   803,   823,   103,   373,
     374,   455,   984,    12,    14,    52,   621,  1472,    88,   624,
      90,  1411,   627,   628,   114,    89,   379,   380,     2,    71,
       4,    50,    44,    12,    85,    14,    12,   623,    44,  1515,
     129,   457,   109,    17,    50,   179,   112,    85,   652,   129,
    1066,  1022,  1256,    58,    60,  1215,   990,    40,   502,   135,
      12,   287,   236,   152,   821,   214,    12,  1175,    88,    98,
     152,   281,   152,    12,  1397,     7,   127,    12,    12,   228,
    1349,    12,    32,    44,     9,   134,   121,   181,  1357,   127,
    1629,    47,    12,   112,   134,   539,    12,    12,   131,    12,
    1838,    12,   388,    12,    12,   143,    80,  1338,  1013,   307,
       9,   227,   112,   162,   222,   143,   364,   134,    12,    12,
    1025,    12,   180,    12,   130,  1222,   347,    14,   180,  1219,
      12,  1607,    15,   342,   382,   134,    12,  1042,   189,    12,
     180,   329,   155,    12,  1628,    12,   355,    12,    12,   155,
     267,   189,   260,  1058,   187,   372,   109,  1247,   171,  1643,
     116,   234,   383,   281,   362,   171,   242,    12,    12,   130,
      95,  1710,   382,   224,  1912,  1913,    12,  1239,   236,    66,
     274,     9,   264,  1049,   236,   131,   224,   236,   223,    12,
     307,   141,    99,   125,   382,   635,    95,   267,  1169,   152,
     270,  1524,   270,   223,  1562,    12,   355,    90,   278,   337,
     384,    12,  1062,   237,   134,   285,   812,   287,   294,   237,
     237,   291,   109,   576,   290,   112,  1430,  1161,   298,   299,
    1201,   812,    12,  1623,  1394,   369,   652,   307,   237,   222,
    1348,   247,   847,  1403,   131,  1476,   251,   259,   834,  1006,
    1155,   138,  1268,   479,    12,   142,   482,   853,   237,    12,
     289,   237,    12,   849,   382,   354,   789,    95,   384,  1715,
     157,   290,   853,   368,   354,   162,   366,  1667,    12,  1382,
     347,   168,   568,  1759,   326,   237,   247,   351,  1193,   176,
     407,   237,   343,   180,   268,   347,    12,    12,   237,  1689,
     187,   329,   237,   237,   339,   343,   237,   344,  1158,    12,
      12,   264,   382,   383,   349,  1770,  1413,   237,   613,    74,
    1392,   237,   237,   134,   237,   335,   237,   214,   237,   237,
    1599,  1147,   239,   134,  1603,   335,   406,   407,   406,     9,
      12,   228,   348,   237,   237,    12,   237,  1007,   237,   236,
     374,   277,  1149,   164,   958,   237,   374,   374,   374,   886,
    1520,   237,    12,   387,   237,   383,   384,   384,   237,   896,
     237,    23,   237,   237,  1240,   374,  1479,   965,  1824,  1825,
     329,  1827,   326,   270,   383,   455,   456,   348,   458,   985,
     458,   918,   237,   237,  1840,   374,   323,   331,   374,   326,
     470,   237,   470,   473,   985,   473,   855,  1441,   384,   479,
    1014,  1016,   482,  1748,   237,   855,    12,  1807,  1864,    12,
    1866,  1867,   374,   970,   971,    95,   313,  1031,   374,  1819,
     237,   383,   384,   382,   504,   374,   237,   383,  1095,   374,
     374,   964,  1800,   374,   383,   384,   281,    14,   801,   384,
     973,    12,   383,   384,   374,  1059,  1060,   237,   374,   374,
     347,   374,    12,   374,  1613,   374,   374,   383,   355,   384,
     383,   384,   383,   384,    12,   384,   384,   547,   152,   237,
     374,   374,   369,   374,   237,   374,   109,   237,   558,    12,
     384,   384,   374,   384,    12,   384,   383,   384,   374,    66,
     387,   374,   384,   237,    12,   374,  1609,   374,   384,   374,
     374,   384,   164,    12,   584,   384,   383,   587,     0,   384,
     384,   237,   237,    71,  1184,    12,   596,   179,  1500,   374,
     374,   648,    12,    12,   237,   237,   997,    51,   374,   384,
     384,   611,   109,   611,   614,   112,   614,   382,   384,    12,
      12,   374,   622,  1596,    12,  1143,   626,    12,   626,    44,
     383,  1221,   129,   281,   131,   237,  1162,   374,    12,     9,
     237,   138,    66,   374,    12,   142,    12,   384,   648,  1810,
       9,  1162,   652,  1433,   654,   152,   656,   237,   656,     9,
     157,   305,   151,   188,   374,   162,    12,    96,    12,   189,
    1781,   168,    12,   383,  1200,   281,    12,  1512,   281,   176,
      12,  1138,  1594,   180,   328,   968,   374,    64,  1222,  1200,
     187,   374,   378,    12,   374,   383,  1230,   383,    85,   326,
    1626,   384,    12,   383,   224,    82,    12,  1233,  1665,    12,
     374,   237,   137,  1247,   237,   130,   281,   214,  1691,   383,
      12,    19,  1233,  1834,   281,    95,   170,   378,   374,   374,
     281,   228,   383,   157,   382,   151,    95,   383,   383,   236,
     127,   374,   374,  1333,   168,    95,   237,    71,   226,   106,
     383,   383,   176,   231,    20,   358,   359,   237,   115,   184,
     134,   152,    28,    50,  1766,  1767,   766,  1355,   383,   237,
      68,    66,   374,   270,  1700,  1701,   382,   374,   370,   382,
     209,   383,   307,    49,   237,  1565,   383,   388,   137,   237,
     214,    23,     6,  1356,   374,    61,    10,   155,   323,   237,
    1277,   326,   189,   383,    96,   331,   806,   807,   806,   807,
    1802,  1337,   812,  1290,  1291,    96,   313,   382,  1851,   326,
     237,   386,    88,   343,    90,   382,  1337,   237,   237,  1306,
     830,   382,   247,   383,   384,   184,   836,   224,   220,   426,
      36,  1298,   348,   130,   237,   237,   270,   255,   374,   237,
     347,   374,   237,   853,   262,   442,    71,   354,   355,   859,
     383,   286,   157,   237,    96,  1853,   866,  1855,   155,   237,
      96,   237,   369,   168,  1331,   371,   284,   134,   235,  1413,
     229,   176,   138,   374,   171,   121,   383,   384,   384,   313,
     387,   237,   383,   237,   374,   383,   384,   237,   342,  1487,
    1488,   237,   226,   383,   370,   237,   374,   231,   168,  1744,
     118,   355,   168,  1886,   384,   383,   176,   209,   382,   214,
     382,   374,   382,  1486,   383,   384,   374,   237,   209,    47,
     383,   237,   164,   348,   237,   383,   374,   286,   164,   382,
     155,   300,   301,   302,   303,   383,   382,   179,   377,   378,
     379,   380,   381,   329,   313,    88,   343,   374,   958,   382,
     247,   383,   384,   387,   374,   374,   383,  1542,   101,  1503,
    1545,   328,  1547,   383,   383,   270,   382,   209,   382,   979,
     236,   374,   374,   209,   220,   985,   374,   223,   220,   374,
     383,   383,   382,   126,   388,   383,  1587,  1588,   383,   382,
     374,   267,   326,   327,   270,  1531,   374,  1007,   374,  1009,
     270,   226,   278,   382,  1014,   383,   231,   383,   313,   285,
    1531,   287,   112,   113,    18,   291,   222,   281,   374,   382,
     374,  1031,   298,   299,   374,   289,  1599,   383,   374,   383,
    1603,   307,   374,   383,   383,   384,   136,   383,   382,  1049,
     140,   383,  1642,    47,   382,  1055,   382,    51,    83,  1059,
    1060,  1061,  1062,  1061,   374,   382,  1066,   382,   374,   265,
     382,   374,    56,   383,   382,   165,   277,  1451,   383,   384,
     383,   383,   384,   382,   174,   377,   378,   379,   380,   381,
     379,  1374,   382,   289,    88,   383,   384,   382,   379,   380,
     381,   347,   192,   339,   358,   359,   382,  1641,   133,   382,
      25,   382,   327,   349,   382,  1209,   382,   383,  1681,  1682,
     382,  1215,   147,   382,  1218,   215,  1220,    42,   382,   123,
    1033,   382,  1035,  1227,  1228,   383,   384,  1040,  1232,   382,
     406,   407,  1045,  1669,   382,   377,   378,   379,   380,   381,
     180,   377,   378,   379,   380,   381,   383,   384,   383,   384,
      75,   382,  1162,    78,   383,   384,   382,  1167,   540,   541,
     382,    86,   383,   384,  1174,   200,  1174,   171,   203,   383,
     384,   383,   384,   382,  1184,   210,   383,   384,   382,   455,
     456,   382,   458,   383,   384,   383,   384,   383,   384,   382,
    1200,   383,   384,   382,   470,   383,   384,   473,   382,  1209,
     382,  1801,   382,   479,   382,  1215,   482,   382,  1218,   382,
    1220,   382,  1222,   383,   384,   250,   220,  1227,  1228,   223,
    1230,   382,  1232,  1233,   228,  1705,  1706,  1237,   382,  1237,
    1240,  1241,  1242,   382,    24,  1362,  1363,  1247,    28,   307,
     382,   382,   382,   247,   279,   382,  1256,  1257,   323,  1257,
      26,    59,    42,   383,    88,   384,    40,   260,  1268,   118,
     155,    66,   228,  1273,  1665,  1273,   255,   368,   383,   383,
      95,   547,     9,  1809,   383,   383,   388,   382,   156,   335,
     384,   285,   558,   379,   329,    75,   384,   384,    78,   295,
    1394,    47,   289,   187,   383,   383,    86,   379,   383,  1403,
     383,    26,    78,   134,   378,   383,   383,    97,   584,    85,
     383,   587,   383,   383,   383,  1325,   347,   384,   384,   383,
     596,   111,   383,  1333,    12,   290,   383,  1337,   604,   382,
     382,  1715,   367,   382,   388,   611,   126,   329,   614,   382,
     388,   376,   389,    33,   348,   121,   622,   383,   369,   228,
     626,   127,   157,    78,   384,   383,   107,   383,   161,   161,
      85,  1371,   384,   168,    66,   383,    49,   143,   383,  1379,
     383,   176,   648,   163,   383,   383,   652,   388,   654,  1915,
     656,    64,    65,   388,  1394,  1929,   388,   383,   383,    72,
     162,   384,   134,  1403,  1915,   166,   121,  1933,  1703,  1704,
     384,    50,   127,  1413,  1940,   335,   169,  1417,   324,   214,
    1420,   169,  1420,   189,  1424,  1719,  1520,   324,   143,  1940,
    1430,  1431,    33,   228,    47,   384,    10,    11,   228,   236,
     100,   114,   382,   382,   388,   225,   383,   383,    22,   383,
    1824,  1825,   384,  1827,   383,   221,   383,   223,   224,   384,
     384,   281,   351,   164,   137,   157,  1840,   388,   177,   171,
      44,   171,   388,   383,   189,   270,   168,   257,    14,    53,
     224,   154,   155,   180,   176,   224,   162,   383,   383,   283,
    1864,    65,  1866,  1867,   384,   238,   169,  1497,   168,   168,
     766,   138,  1796,  1503,   291,   285,   494,   389,   223,   224,
     384,   184,   171,   171,   384,    89,    90,    91,   313,   383,
    1520,   382,   214,   171,    98,   383,   514,   383,  1528,   517,
     383,  1531,   383,   168,   168,   109,   228,   228,    33,   142,
     806,   807,   384,   531,   532,   206,   812,   535,   255,   382,
     330,    88,   332,    88,   128,   382,   245,   382,   388,   382,
     548,   549,   351,   329,   830,   382,   332,  1567,   224,   326,
     836,   168,   168,   339,    49,   382,   249,   343,   270,   382,
     360,   361,   193,   382,   224,    88,   160,   853,   523,   171,
     171,   351,   223,   859,   224,   224,   224,   383,   172,   382,
     866,   383,   181,   355,   355,   382,   228,   383,   383,   183,
     359,   377,   378,   286,   329,   221,   383,   332,   355,   384,
     224,   313,   355,    33,   339,   384,  1626,    33,   343,   106,
      33,   131,  1632,   383,    33,   382,    33,   382,   573,   574,
      33,  1641,   577,   578,   579,   580,   581,   582,     4,   259,
     323,   228,   228,   326,   327,   152,    33,    33,   382,   382,
      89,  1661,   377,   378,   351,   224,   382,   384,   289,  1669,
     383,  1563,   652,  1059,  1674,  1241,  1674,   665,  1049,  1431,
    1055,  1032,  1244,  1213,    12,  1083,   260,   261,  1528,  1559,
     264,  1651,   958,   366,  1530,  1833,  1641,   271,  1804,  1271,
    1700,  1701,  1067,   277,  1739,  1240,   806,   281,   273,   949,
     272,   423,   454,   979,   998,   289,  1333,   820,   292,   985,
    1359,  1149,  1597,   885,   948,  1821,  1769,  1936,  1911,   717,
     541,   494,   306,   721,  1514,  1595,  1003,   974,  1531,  1739,
     300,  1007,   407,  1009,  1616,   662,   307,  1337,  1014,   811,
     738,    79,    80,    81,    82,    83,  1157,  1757,  1200,  1933,
    1809,   481,   296,  1850,  1775,  1031,   340,  1151,    85,  1811,
    1831,  1940,  1643,  1162,   504,   604,   350,   351,  1192,  1621,
     354,  1379,    91,  1049,   825,    -1,  1786,   413,    -1,  1055,
      -1,    -1,    -1,  1059,  1060,  1061,  1062,    -1,    -1,    -1,
    1066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,  1809,
      -1,    -1,    -1,    -1,    -1,    -1,   144,   145,   146,   147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1853,    -1,  1855,    -1,  1857,    -1,    -1,
      -1,    -1,    -1,    -1,   799,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   200,   201,   202,   203,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1162,    -1,    -1,    -1,
      -1,  1167,    -1,    -1,    -1,    -1,    -1,    -1,  1174,   237,
    1910,  1911,    -1,    -1,    -1,  1915,    -1,    -1,  1184,    -1,
      -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,  1929,
      -1,    -1,    -1,  1933,  1200,    -1,  1936,    -1,    -1,    -1,
    1940,    -1,    -1,  1209,    -1,    -1,    -1,    -1,    -1,  1215,
     278,   279,  1218,    -1,  1220,    -1,  1222,    -1,    -1,    -1,
      -1,  1227,  1228,    -1,  1230,    -1,  1232,  1233,    -1,    -1,
      -1,  1237,    -1,    -1,  1240,  1241,  1242,    -1,    -1,    -1,
      -1,  1247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1256,  1257,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,
      -1,    -1,  1268,    -1,    -1,    -1,    -1,  1273,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,
      -1,    -1,    -1,    -1,    -1,    -1,   374,   375,   376,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1325,
      -1,    -1,    -1,    -1,   381,    -1,    -1,  1333,    -1,    -1,
      -1,  1337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1371,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1379,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1394,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1403,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1413,    -1,    -1,
      -1,  1417,    -1,    -1,  1420,    -1,    -1,    -1,  1424,    -1,
      -1,    -1,    -1,    -1,  1430,  1431,    -1,   484,    -1,    -1,
      -1,    -1,   489,    -1,    -1,   492,   493,    -1,    -1,    -1,
      -1,    -1,   499,   500,   501,    -1,   503,    -1,    -1,    -1,
      -1,   508,   509,   510,   511,    -1,   513,    -1,   515,   516,
      -1,   518,   519,    -1,   521,    -1,    -1,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,   533,   534,    -1,   536,
      -1,   538,    -1,    -1,    -1,   542,   543,    -1,    -1,    -1,
      -1,  1497,    -1,   550,    -1,    -1,    -1,  1503,    -1,   556,
      -1,    -1,    -1,    -1,   561,   562,   563,    -1,    79,    80,
      81,    82,    83,    -1,  1520,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1528,    -1,    -1,  1531,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   604,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   616,
      -1,  1567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,   145,   146,   147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1626,    -1,    -1,    -1,    -1,    -1,  1632,    -1,    -1,   200,
     201,   202,   203,    -1,    -1,  1641,    -1,    -1,    -1,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1661,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1669,    -1,    -1,    -1,    -1,  1674,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   746,
     747,   748,    -1,    -1,  1700,  1701,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,   279,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   789,  1739,    -1,   792,    -1,   794,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1786,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,    -1,
      -1,    -1,    -1,  1809,   375,   376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   872,    -1,    -1,   875,    -1,
     877,   878,    -1,    -1,    -1,   882,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   895,    -1,
      -1,   898,   899,   900,   901,   902,    -1,  1853,    -1,  1855,
      -1,  1857,   909,    -1,    -1,   912,    -1,   914,   915,    -1,
     917,    -1,    -1,    -1,    -1,   922,   923,   924,    -1,    -1,
      -1,    -1,   929,   930,   931,    -1,   933,    -1,   935,    -1,
     937,    -1,   939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   959,    -1,  1910,  1911,    -1,    -1,    -1,  1915,
      -1,    -1,    -1,    -1,    -1,    -1,   973,    -1,   975,    -1,
      -1,    -1,    -1,  1929,    -1,    -1,    -1,  1933,    -1,    -1,
    1936,    -1,    -1,    -1,  1940,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1074,    -1,    -1,
      -1,  1078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1092,  1093,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1117,    -1,  1119,    -1,  1121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1156,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1191,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1202,  1203,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1274,    -1,    -1,
      -1,    -1,    -1,  1280,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1295,  1296,
      -1,    -1,    -1,    -1,    -1,    -1,  1303,    -1,    -1,    -1,
      -1,  1308,    -1,    -1,  1311,  1312,  1313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1380,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1389,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1476,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1621,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1685,  1686,
      -1,    -1,    -1,  1690,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     4,    -1,     6,     7,     8,
      -1,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    25,    26,    27,    -1,
      29,    30,    31,    32,    -1,    34,    -1,    -1,    37,    38,
      39,    40,  1759,    42,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,    88,
      -1,    -1,    -1,  1810,    93,    94,  1813,    -1,  1815,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
     139,    -1,   141,    -1,   143,    -1,    -1,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,   160,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
     189,    -1,    -1,    -1,    -1,   194,   195,   196,   197,   198,
     199,   200,    -1,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,   244,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,   308,
     309,   310,   311,    -1,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,    -1,   327,    -1,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,   356,   357,   358,
     359,    -1,    -1,   362,   363,    -1,   365,   366,   367,    -1,
      -1,    -1,    -1,   372,    -1,    -1,    -1,   376,   377,   378,
      -1,    -1,    -1,   382,    -1,    -1,    -1,   386,    -1,   388,
     389,     4,    -1,     6,     7,     8,     9,    -1,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    25,    26,    27,    -1,    29,    30,    -1,    32,
      -1,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      43,    -1,    45,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    -1,    61,    -1,
      63,    64,    -1,    -1,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,
      -1,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,    -1,    -1,    -1,   132,
     133,    -1,   135,    -1,   137,    -1,   139,    -1,   141,    -1,
     143,    -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,
     153,   154,    -1,    -1,    -1,    -1,    -1,   160,   161,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,   184,    -1,   186,    -1,   188,   189,    -1,    -1,    -1,
      -1,   194,   195,   196,   197,   198,   199,   200,    -1,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,    -1,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,
     243,   244,    -1,   246,    -1,   248,   249,   250,   251,    -1,
      -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,    -1,    -1,
      -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,
     293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,
      -1,    -1,    -1,   306,   307,   308,   309,   310,   311,    -1,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,   332,
     333,   334,    -1,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,
     353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,
     363,    -1,   365,   366,   367,    -1,    -1,    -1,    -1,   372,
      -1,    -1,    -1,   376,   377,   378,    -1,    -1,     4,   382,
       6,     7,     8,   386,    -1,   388,   389,    13,    -1,    -1,
      -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,    25,
      26,    27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    43,    -1,    45,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    -1,    63,    64,    -1,
      -1,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    88,    -1,    -1,    -1,    -1,    93,    94,    -1,
      -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,    -1,    -1,   132,   133,    -1,   135,
      -1,   137,    -1,   139,    -1,   141,    -1,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,   160,   161,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,    -1,
     186,    -1,   188,   189,    -1,    -1,    -1,    -1,   194,   195,
     196,   197,   198,   199,   200,    -1,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,   244,    -1,
     246,    -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,
     286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
     306,   307,   308,   309,   310,   311,    -1,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
      -1,   327,    -1,   329,   330,    -1,   332,   333,   334,    -1,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,    -1,   365,
     366,   367,    -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,
     376,   377,   378,    -1,    -1,    -1,   382,   383,    -1,    -1,
     386,    -1,   388,   389,     4,    -1,     6,     7,     8,    -1,
      -1,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      20,    -1,    22,    -1,    -1,    25,    26,    27,    -1,    29,
      30,    -1,    32,    -1,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    43,    -1,    45,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,    69,
      -1,    71,    72,    73,    74,    75,    76,    77,    78,    -1,
      -1,    -1,    -1,    83,    84,    85,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,
     110,   111,    -1,    -1,   114,    -1,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,    -1,
      -1,    -1,   132,   133,   134,   135,    -1,   137,    -1,   139,
      -1,   141,    -1,   143,    -1,    -1,    -1,   147,   148,   149,
     150,   151,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,
     160,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,   173,    -1,    -1,   176,   177,    -1,    -1,
      -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,   189,
      -1,    -1,    -1,    -1,   194,   195,   196,   197,   198,   199,
     200,    -1,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,    -1,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,    -1,   226,   227,    -1,   229,
     230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   241,   242,   243,   244,    -1,   246,    -1,   248,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,    -1,
      -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,
      -1,   301,    -1,    -1,    -1,    -1,   306,   307,   308,   309,
     310,   311,    -1,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,    -1,   327,    -1,   329,
     330,    -1,   332,   333,   334,    -1,    -1,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,    -1,    -1,   349,
      -1,    -1,    -1,   353,    -1,    -1,   356,   357,   358,   359,
      -1,    -1,   362,   363,    -1,   365,   366,   367,    -1,    -1,
      -1,    -1,   372,    -1,    -1,    -1,   376,   377,   378,    -1,
      -1,     4,   382,     6,     7,     8,   386,    -1,   388,   389,
      13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    25,    26,    27,    -1,    29,    30,    -1,    32,
      -1,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      43,    -1,    45,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    -1,    61,    -1,
      63,    64,    -1,    -1,    67,    68,    69,    -1,    71,    72,
      73,    74,    75,    76,    77,    78,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,
      -1,   114,    -1,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,    -1,    -1,    -1,   132,
     133,   134,   135,    -1,   137,    -1,   139,    -1,   141,    -1,
     143,    -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,
     153,   154,    -1,    -1,    -1,    -1,    -1,   160,   161,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,   184,    -1,   186,    -1,   188,   189,    -1,    -1,    -1,
      -1,   194,   195,   196,   197,   198,   199,   200,    -1,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,    -1,    -1,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,   227,    -1,   229,   230,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,
     243,   244,    -1,   246,    -1,   248,   249,   250,   251,    -1,
      -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,    -1,    -1,
      -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,
     293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,
      -1,    -1,    -1,   306,   307,   308,   309,   310,   311,    -1,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,   332,
     333,   334,    -1,    -1,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,
     353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,
     363,    -1,   365,   366,   367,    -1,    -1,    -1,    -1,   372,
      -1,    -1,    -1,   376,   377,   378,    -1,    -1,     4,   382,
       6,     7,     8,   386,    -1,   388,   389,    13,    -1,    -1,
      -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,    25,
      26,    27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    43,    -1,    45,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    -1,    63,    64,    -1,
      -1,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    88,    -1,    -1,    -1,    -1,    93,    94,    -1,
      -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,    -1,    -1,   132,   133,   134,   135,
      -1,   137,    -1,   139,    -1,   141,    -1,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,   160,   161,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,    -1,
     186,    -1,   188,   189,    -1,    -1,    -1,    -1,   194,   195,
     196,   197,   198,   199,   200,    -1,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,   244,    -1,
     246,    -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,
     286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
     306,   307,   308,   309,   310,   311,    -1,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
      -1,   327,    -1,   329,   330,    -1,   332,   333,   334,    -1,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,    -1,   365,
     366,   367,    -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,
     376,   377,   378,    -1,    -1,     4,   382,     6,     7,     8,
     386,    -1,   388,   389,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    25,    26,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
     139,    -1,   141,    -1,   143,    -1,    -1,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,   160,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
     189,    -1,    -1,    -1,    -1,   194,   195,   196,   197,   198,
     199,   200,    -1,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,   244,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,   308,
     309,   310,   311,    -1,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,    -1,   327,    -1,
     329,   330,    -1,   332,   333,   334,    -1,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,   356,   357,   358,
     359,    -1,    -1,   362,   363,    -1,   365,   366,   367,    -1,
      -1,    -1,    -1,   372,    -1,    -1,    -1,   376,   377,   378,
      -1,    -1,     4,   382,     6,     7,     8,   386,    -1,   388,
     389,    13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    25,    26,    27,    -1,    29,    30,    -1,
      32,    -1,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    43,    -1,    45,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    -1,    61,
      -1,    63,    64,    -1,    -1,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    83,    84,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,
      -1,    -1,   114,    -1,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
     132,   133,    -1,   135,    -1,   137,    -1,   139,    -1,   141,
      -1,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,   160,   161,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,   184,    -1,   186,    -1,   188,   189,    -1,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,    -1,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,    -1,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     242,   243,   244,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,
      -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,   306,   307,   308,   309,   310,   311,
      -1,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,
     332,   333,   334,    -1,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,    -1,   365,   366,   367,    -1,    -1,    -1,    -1,
     372,    -1,    -1,    -1,   376,   377,   378,    -1,    -1,    -1,
     382,    -1,    -1,    -1,   386,    -1,   388,   389,     4,    -1,
       6,     7,     8,     9,    -1,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,    25,
      26,    27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    43,    -1,    45,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    -1,    63,    64,    -1,
      -1,    67,    68,    69,    -1,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    88,    -1,    -1,    -1,    -1,    93,    94,    -1,
      -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,    -1,    -1,    -1,   132,   133,    -1,   135,
      -1,   137,    -1,   139,    -1,   141,    -1,   143,    -1,    -1,
      -1,   147,   148,   149,   150,   151,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,   160,   161,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,    -1,
     186,    -1,   188,   189,    -1,    -1,    -1,    -1,   194,   195,
     196,   197,   198,   199,   200,    -1,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,    -1,
      -1,   217,   218,   219,    -1,   221,   222,   223,   224,    -1,
     226,   227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,   244,    -1,
     246,    -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,
     286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
     306,   307,   308,   309,   310,   311,    -1,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
      -1,   327,    -1,   329,   330,    -1,   332,   333,   334,    -1,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,
     356,   357,   358,   359,    -1,    -1,   362,   363,    -1,   365,
     366,   367,    -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,
     376,   377,   378,    -1,    -1,     4,   382,     6,     7,     8,
     386,    -1,   388,   389,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    25,    26,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,
      69,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
     139,    -1,   141,    -1,   143,    -1,    -1,    -1,   147,   148,
     149,   150,   151,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,   160,   161,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
     189,    -1,    -1,    -1,    -1,   194,   195,   196,   197,   198,
     199,   200,    -1,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,   244,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,   308,
     309,   310,   311,    -1,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,    -1,   327,    -1,
     329,   330,    -1,   332,   333,   334,    -1,    -1,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,   356,   357,   358,
     359,    -1,    -1,   362,   363,    -1,   365,   366,   367,    -1,
      -1,    -1,    -1,   372,    -1,    -1,    -1,   376,   377,   378,
      -1,    -1,     4,   382,     6,     7,     8,   386,    -1,   388,
     389,    13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    25,    26,    27,    -1,    29,    30,    -1,
      32,    -1,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    43,    -1,    45,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    -1,    61,
      -1,    63,    64,    -1,    -1,    67,    68,    69,    -1,    71,
      72,    73,    74,    75,    76,    77,    78,    -1,    -1,    -1,
      -1,    83,    84,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,
      -1,    -1,   114,    -1,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
     132,   133,    -1,   135,    -1,   137,    -1,   139,    -1,   141,
      -1,   143,    -1,    -1,    -1,   147,   148,   149,   150,   151,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,   160,   161,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,   184,    -1,   186,    -1,   188,   189,    -1,    -1,
      -1,    -1,   194,   195,   196,   197,   198,   199,   200,    -1,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,    -1,    -1,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,    -1,   226,   227,    -1,   229,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     242,   243,   244,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,
      -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,   306,   307,   308,   309,   310,   311,
      -1,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,
     332,   333,   334,    -1,    -1,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   353,    -1,    -1,   356,   357,   358,   359,    -1,    -1,
     362,   363,    -1,   365,   366,   367,    -1,    -1,    -1,    -1,
     372,    -1,    -1,    -1,   376,   377,   378,    -1,    -1,     4,
     382,     6,     7,     8,   386,    -1,   388,   389,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      25,    26,    27,    -1,    29,    30,    -1,    32,    -1,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    43,    -1,
      45,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    -1,    61,    -1,    63,    64,
      -1,    -1,    67,    68,    69,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    -1,    -1,    -1,    -1,    83,    84,
      85,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,    94,
      -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,
      -1,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,    -1,    -1,    -1,   132,   133,    -1,
     135,    -1,   137,    -1,   139,    -1,   141,    -1,   143,    -1,
      -1,    -1,   147,   148,   149,   150,   151,    -1,   153,   154,
      -1,    -1,    -1,    -1,    -1,   160,   161,    -1,    -1,    -1,
      -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
      -1,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,
      -1,   186,    -1,   188,   189,    -1,    -1,    -1,    -1,   194,
     195,   196,   197,   198,   199,   200,    -1,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,    -1,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
      -1,   226,   227,    -1,   229,   230,   231,   232,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,   244,
      -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,   254,
      -1,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,
     285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,
     295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,   306,   307,   308,   309,   310,   311,    -1,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,    -1,   327,    -1,   329,   330,    -1,   332,   333,   334,
      -1,    -1,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,
      -1,   356,   357,   358,   359,    -1,    -1,   362,   363,    -1,
     365,   366,   367,    -1,    -1,    -1,    -1,   372,    -1,    -1,
      -1,   376,   377,   378,    -1,    -1,     4,   382,     6,     7,
       8,   386,    -1,   388,   389,    13,    -1,    -1,    -1,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    25,    26,    27,
      -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    43,    -1,    45,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,
      68,    69,    -1,    71,    72,    73,    74,    75,    76,    77,
      78,    -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,
      88,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,
     108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,
      -1,   139,    -1,   141,    -1,   143,    -1,    -1,    -1,   147,
     148,   149,   150,   151,    -1,   153,   154,    -1,    -1,    -1,
      -1,    -1,   160,   161,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,   173,    -1,    -1,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,
     188,   189,    -1,    -1,    -1,    -1,   194,   195,   196,   197,
     198,   199,   200,    -1,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,    -1,    -1,   217,
     218,   219,    -1,   221,   222,   223,   224,    -1,   226,   227,
      -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,   242,   243,   244,    -1,   246,    -1,
     248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,   287,
      -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,
      -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,
     308,   309,   310,   311,    -1,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,    -1,   327,
      -1,   329,   330,    -1,   332,   333,   334,    -1,    -1,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,    -1,
      -1,   349,    -1,    -1,    -1,   353,    -1,    -1,   356,   357,
     358,   359,    -1,    -1,   362,   363,    -1,   365,   366,   367,
      -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,   376,   377,
     378,    -1,    -1,     4,   382,     6,     7,     8,   386,    -1,
     388,   389,    13,    -1,    -1,    -1,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    25,    26,    27,    -1,    29,    30,
      -1,    32,    -1,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    43,    -1,    45,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    -1,
      61,    -1,    63,    64,    -1,    -1,    67,    68,    69,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    -1,    -1,
      -1,    -1,    83,    84,    85,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,
     111,    -1,    -1,   114,    -1,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,    -1,    -1,
      -1,   132,   133,    -1,   135,    -1,   137,    -1,   139,    -1,
     141,    -1,   143,    -1,    -1,    -1,   147,   148,   149,   150,
     151,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,   160,
     161,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,   184,    -1,   186,    -1,   188,   189,    -1,
      -1,    -1,    -1,   194,   195,   196,   197,   198,   199,   200,
      -1,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,
     221,   222,   223,   224,    -1,   226,   227,    -1,   229,   230,
     231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     241,   242,   243,   244,    -1,   246,    -1,   248,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,
      -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
      -1,    -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,
     291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,
     301,    -1,    -1,    -1,    -1,   306,   307,   308,   309,   310,
     311,    -1,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,    -1,   327,    -1,   329,   330,
      -1,   332,   333,   334,    -1,    -1,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,    -1,    -1,   349,    -1,
      -1,    -1,   353,    -1,    -1,   356,   357,   358,   359,    -1,
      -1,   362,   363,    -1,   365,   366,   367,    -1,    -1,    -1,
      -1,   372,    -1,    -1,    -1,   376,   377,   378,    -1,    -1,
       4,   382,     6,     7,     8,   386,    -1,   388,   389,    13,
      -1,    -1,    -1,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    25,    26,    27,    -1,    29,    30,    -1,    32,    -1,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    43,
      -1,    45,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    63,
      64,    -1,    -1,    67,    68,    69,    -1,    71,    72,    73,
      74,    75,    76,    77,    78,    -1,    -1,    -1,    -1,    83,
      84,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,
      94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,
     114,    -1,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,    -1,    -1,    -1,   132,   133,
      -1,   135,    -1,   137,    -1,   139,    -1,   141,    -1,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,    -1,   153,
     154,    -1,    -1,    -1,    -1,    -1,   160,   161,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,
     184,    -1,   186,    -1,   188,   189,    -1,    -1,    -1,    -1,
     194,   195,   196,   197,   198,   199,   200,    -1,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,    -1,    -1,   217,   218,   219,    -1,   221,   222,   223,
     224,    -1,   226,   227,    -1,   229,   230,   231,   232,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,
     244,    -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,
     284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,
     294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,
      -1,    -1,   306,   307,   308,   309,   310,   311,    -1,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,    -1,   327,    -1,   329,   330,    -1,   332,   333,
     334,    -1,    -1,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,
      -1,    -1,   356,   357,   358,   359,    -1,    -1,   362,   363,
      -1,   365,   366,   367,    -1,    -1,    -1,    -1,   372,    -1,
      -1,    -1,   376,   377,   378,    -1,    -1,     4,   382,     6,
       7,     8,   386,    -1,   388,   389,    13,    -1,    -1,    -1,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,
      27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    43,    -1,    45,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,
     107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,
     117,    -1,   119,    -1,    -1,    -1,   123,   124,   125,   126,
      -1,   128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,
     137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
     147,   148,   149,   150,    -1,    -1,   153,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,
     177,   178,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,
      -1,   188,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,
     197,   198,   199,   200,    -1,    -1,   203,   204,    -1,   206,
      -1,   208,    -1,   210,   211,   212,   213,    -1,    -1,    -1,
     217,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,   226,
     227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,
      -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,
      -1,   258,    -1,    -1,    -1,   262,    -1,    -1,    -1,   266,
      -1,   268,    -1,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,
     287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,
      -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,
     307,    -1,    -1,   310,   311,    -1,    -1,   314,   315,   316,
      -1,    -1,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,    -1,   329,   330,    -1,   332,   333,   334,    -1,    -1,
     337,    -1,    -1,   340,   341,   342,    -1,   344,   345,    -1,
      -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,    -1,
      -1,    -1,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,
     367,    -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,   376,
       4,    -1,     6,     7,     8,    -1,    -1,    -1,    -1,    13,
      -1,    -1,   389,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    -1,    29,    30,    -1,    32,    -1,
      34,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,
      -1,    45,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    -1,    -1,    -1,    83,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,
     114,    -1,   116,   117,    -1,   119,    -1,    -1,    -1,   123,
     124,   125,   126,    -1,   128,    -1,    -1,    -1,   132,   133,
      -1,   135,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,   147,   148,   149,   150,    -1,    -1,   153,
     154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,
      -1,    -1,    -1,   177,   178,    -1,    -1,    -1,   182,    -1,
     184,    -1,   186,    -1,   188,    -1,    -1,    -1,    -1,    -1,
     194,   195,    -1,   197,   198,   199,   200,    -1,    -1,   203,
     204,    -1,   206,    -1,   208,    -1,   210,   211,   212,   213,
      -1,    -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,
      -1,    -1,   226,   227,    -1,   229,   230,   231,   232,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,
      -1,    -1,   266,    -1,   268,    -1,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,
     284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,
     294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,
      -1,    -1,   306,   307,    -1,    -1,   310,   311,    -1,    -1,
     314,   315,   316,    -1,    -1,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,    -1,   329,   330,    -1,   332,   333,
     334,    -1,    -1,   337,    -1,    -1,   340,   341,   342,    -1,
     344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,
      -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,   362,    -1,
      -1,    -1,   366,   367,    -1,    -1,    -1,    -1,   372,    -1,
      -1,    -1,   376,     4,    -1,     6,     7,     8,    -1,    -1,
      -1,    -1,    13,    -1,    -1,   389,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,
      -1,    32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    43,    -1,    45,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,
     111,    -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,
      -1,    -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,
      -1,   132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,
      -1,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,   182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,   200,
      -1,    -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,
     211,   212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,
      -1,   222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,
     231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     241,   242,   243,    -1,    -1,   246,    -1,   248,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,
      -1,   262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
      -1,    -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,
     291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,
     301,    -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,
     311,    -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,    -1,    -1,   330,
      -1,   332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,
     341,   342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,
      -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,
      -1,   372,    -1,    -1,    -1,   376,     4,    -1,     6,     7,
       8,    -1,   383,    -1,    -1,    13,    -1,   388,   389,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,
      -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,
      -1,    -1,    40,    -1,    -1,    43,    -1,    45,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,
     108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,
      -1,   119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,
     128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,
      -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,
     148,   149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,
     188,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,
     198,   199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,
     208,    -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,
     218,   219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,
      -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
     248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,    -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,
     268,    -1,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,   287,
      -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,
      -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,
      -1,    -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,
      -1,   319,   320,   321,    -1,   323,   324,    -1,    -1,   327,
      -1,    -1,   330,    -1,   332,   333,   334,    -1,    -1,   337,
      -1,    -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,
      -1,   349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,
      -1,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,
      -1,    -1,    -1,    -1,   372,    -1,    -1,    -1,   376,     4,
      -1,     6,     7,     8,    -1,    -1,    -1,    -1,    13,    -1,
     388,   389,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    -1,    29,    30,    -1,    32,    -1,    34,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,    -1,
      45,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    -1,    -1,    -1,    83,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    94,
      -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,
      -1,   116,   117,    -1,   119,    -1,    -1,    -1,   123,   124,
     125,   126,    -1,   128,    -1,    -1,    -1,   132,   133,    -1,
     135,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,   147,   148,   149,   150,    -1,    -1,   153,   154,
     155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,    -1,    -1,   170,   171,    -1,   173,    -1,
      -1,    -1,   177,    -1,   179,    -1,    -1,   182,    -1,   184,
      -1,   186,    -1,   188,    -1,    -1,    -1,    -1,    -1,   194,
     195,    -1,   197,   198,   199,   200,    -1,    -1,   203,   204,
      -1,   206,    -1,   208,    -1,   210,   211,   212,   213,    -1,
      -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,
      -1,   226,   227,    -1,   229,   230,   231,   232,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,    -1,
      -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,   254,
      -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,    -1,
      -1,   266,    -1,   268,    -1,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,    -1,    -1,   284,
     285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,
     295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,   306,   307,    -1,    -1,   310,   311,    -1,    -1,   314,
     315,   316,    -1,    -1,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,    -1,    -1,   330,    -1,   332,   333,   334,
      -1,    -1,   337,    -1,    -1,   340,   341,   342,    -1,   344,
     345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,
      -1,    -1,    -1,    -1,   359,    -1,    -1,   362,    -1,    -1,
      -1,   366,   367,    -1,    -1,    -1,     4,   372,     6,     7,
       8,   376,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    20,   388,    22,    -1,    -1,    -1,    -1,    27,
      -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,
      -1,    -1,    40,    -1,    -1,    43,    -1,    45,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,
     108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,
      -1,   119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,
     128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,
      -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,
     148,   149,   150,    -1,    -1,   153,   154,   155,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,   171,    -1,   173,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,
     188,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,
     198,   199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,
     208,    -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,
     218,   219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,
      -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
     248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,    -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,
     268,    -1,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,   287,
      -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,
      -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,
      -1,    -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,
      -1,   319,   320,   321,    -1,   323,   324,    -1,    -1,   327,
      -1,    -1,   330,    -1,   332,   333,   334,    -1,    -1,   337,
      -1,    -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,
      -1,   349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,
      -1,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,
      -1,    -1,    -1,     4,   372,     6,     7,     8,   376,    -1,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,
     388,    22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,
      -1,    32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    43,    -1,    45,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,
     111,    -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,
      -1,    -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,
      -1,   132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,
      -1,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,   182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,   200,
      -1,    -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,
     211,   212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,
      -1,   222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,
     231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     241,   242,   243,    -1,    -1,   246,    -1,   248,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,
      -1,   262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,    -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,
     291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,
     301,    -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,
     311,    -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,    -1,    -1,   330,
      -1,   332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,
     341,   342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,
      -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,
       4,   372,     6,     7,     8,   376,    -1,    -1,    -1,    13,
      -1,    -1,   383,    17,    18,    19,    20,   388,    22,    -1,
      -1,    -1,    -1,    27,    -1,    29,    30,    -1,    32,    -1,
      34,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,
      -1,    45,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    -1,    -1,    -1,    83,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,
     114,    -1,   116,   117,    -1,   119,    -1,    -1,    -1,   123,
     124,   125,   126,    -1,   128,    -1,    -1,    -1,   132,   133,
      -1,   135,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,   147,   148,   149,   150,    -1,    -1,   153,
     154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,   182,    -1,
     184,    -1,   186,    -1,   188,    -1,    -1,    -1,    -1,    -1,
     194,   195,    -1,   197,   198,   199,   200,    -1,    -1,   203,
     204,    -1,   206,    -1,   208,    -1,   210,   211,   212,   213,
      -1,    -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,
      -1,    -1,   226,   227,    -1,   229,   230,   231,   232,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,
      -1,    -1,   266,    -1,   268,    -1,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,
     284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,
     294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,
      -1,    -1,   306,   307,    -1,    -1,   310,   311,    -1,    -1,
     314,   315,   316,    -1,    -1,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,    -1,    -1,   330,    -1,   332,   333,
     334,    -1,    -1,   337,    -1,    -1,   340,   341,   342,    -1,
     344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,
      -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,   362,    -1,
      -1,    -1,   366,   367,    -1,    -1,    -1,     4,   372,     6,
       7,     8,   376,    -1,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    20,   388,    22,    -1,    -1,    -1,    -1,
      27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    43,    -1,    45,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,
     107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,
     117,    -1,   119,    -1,    -1,    -1,   123,   124,   125,   126,
      -1,   128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,
     137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
     147,   148,   149,   150,    -1,    -1,   153,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,
     177,    -1,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,
      -1,   188,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,
     197,   198,   199,   200,    -1,    -1,   203,   204,    -1,   206,
      -1,   208,    -1,   210,   211,   212,   213,    -1,    -1,    -1,
     217,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,   226,
     227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,
      -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,
      -1,   258,    -1,    -1,    -1,   262,    -1,    -1,    -1,   266,
      -1,   268,    -1,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,
     287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,
      -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,
     307,    -1,    -1,   310,   311,    -1,    -1,   314,   315,   316,
      -1,    -1,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,    -1,    -1,   330,    -1,   332,   333,   334,    -1,    -1,
     337,    -1,    -1,   340,   341,   342,    -1,   344,   345,    -1,
      -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,    -1,
      -1,    -1,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,
     367,    -1,    -1,    -1,     4,   372,     6,     7,     8,   376,
      -1,    -1,    -1,    13,    -1,   382,    -1,    17,    18,    19,
      20,   388,    22,    -1,    -1,    -1,    -1,    27,    -1,    29,
      30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    43,    -1,    45,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,
     110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,   126,    -1,   128,    -1,
      -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,   149,
     150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,   173,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,    -1,
      -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,
     200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,    -1,
     210,   211,   212,   213,    -1,    -1,    -1,   217,   218,   219,
      -1,    -1,   222,    -1,    -1,    -1,   226,   227,    -1,   229,
     230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,
      -1,    -1,   262,    -1,    -1,    -1,   266,    -1,   268,    -1,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,    -1,
      -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,
      -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,    -1,
     310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,   319,
     320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,    -1,
     330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,    -1,
     340,   341,   342,    -1,   344,   345,    -1,    -1,    -1,   349,
      -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,   359,
      -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,    -1,
      -1,     4,   372,     6,     7,     8,   376,    -1,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    20,   388,    22,
      -1,    -1,    -1,    -1,    27,    -1,    29,    30,    -1,    32,
      -1,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      43,    -1,    45,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,
      -1,   114,    -1,   116,   117,    -1,   119,    -1,    -1,    -1,
     123,   124,   125,   126,    -1,   128,    -1,    -1,    -1,   132,
     133,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,   147,   148,   149,   150,    -1,    -1,
     153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,   182,
      -1,   184,    -1,   186,    -1,   188,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,   197,   198,   199,   200,    -1,    -1,
     203,   204,    -1,   206,    -1,   208,    -1,   210,   211,   212,
     213,    -1,    -1,    -1,   217,   218,   219,    -1,    -1,   222,
      -1,    -1,    -1,   226,   227,    -1,   229,   230,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,    -1,   248,   249,   250,   251,    -1,
      -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,
      -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,    -1,    -1,
      -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,
     293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,
      -1,    -1,    -1,   306,   307,    -1,    -1,   310,   311,    -1,
      -1,   314,   315,   316,    -1,    -1,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,    -1,    -1,   330,    -1,   332,
     333,   334,    -1,    -1,   337,    -1,    -1,   340,   341,   342,
      -1,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,
     353,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,   362,
      -1,    -1,    -1,   366,   367,    -1,    -1,    -1,     4,   372,
       6,     7,     8,   376,    -1,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    20,   388,    22,    -1,    -1,    -1,
      -1,    27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    43,    -1,    45,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    -1,
      -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,
     116,   117,    -1,   119,    -1,    -1,    -1,   123,   124,   125,
     126,    -1,   128,    -1,    -1,    -1,   132,   133,    -1,   135,
      -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,   147,   148,   149,   150,    -1,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
      -1,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,    -1,
     186,    -1,   188,    -1,    -1,    -1,    -1,    -1,   194,   195,
      -1,   197,   198,   199,   200,    -1,    -1,   203,   204,    -1,
     206,    -1,   208,    -1,   210,   211,   212,   213,    -1,    -1,
      -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,
     226,   227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,    -1,    -1,    -1,   262,    -1,    -1,    -1,
     266,    -1,   268,    -1,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,
     286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
     306,   307,    -1,    -1,   310,   311,    -1,    -1,   314,   315,
     316,    -1,    -1,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,    -1,    -1,   330,    -1,   332,   333,   334,    -1,
      -1,   337,    -1,    -1,   340,   341,   342,    -1,   344,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,
      -1,    -1,    -1,   359,    -1,    -1,   362,    -1,    -1,    -1,
     366,   367,    -1,    -1,    -1,     4,   372,     6,     7,     8,
     376,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    20,   388,    22,    -1,    -1,    -1,    -1,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,
     119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,
     149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,
      -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,   268,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,
      -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,
      -1,   330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,
      -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
     359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,
      -1,    -1,     4,   372,     6,     7,     8,   376,    -1,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,   388,
      22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    -1,
      32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    -1,    45,    46,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,
      -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,    -1,
      -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,    -1,
     132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,    -1,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,    -1,   177,   178,    -1,    -1,    -1,
     182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,    -1,
      -1,    -1,   194,   195,    -1,   197,   198,   199,   200,    -1,
      -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,   211,
     212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,    -1,
     222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,
     262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,
      -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,   311,
      -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,   321,
      -1,   323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,
     332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,   341,
     342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,
     362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,    -1,
     372,    -1,    -1,    -1,   376,     4,    -1,     6,     7,     8,
      -1,    -1,   384,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    43,    -1,    45,    46,    47,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,
     119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,
     149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,   178,
     179,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,
      -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,   268,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,
      -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,
     329,   330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,
      -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
     359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,
      -1,    -1,     4,   372,     6,     7,     8,   376,    -1,    -1,
      -1,    13,    -1,   382,    -1,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    -1,
      32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    -1,    45,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,
      -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,    -1,
      -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,    -1,
     132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,    -1,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,
     182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,    -1,
      -1,    -1,   194,   195,    -1,   197,   198,   199,   200,    -1,
      -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,   211,
     212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,    -1,
     222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,
     262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,
      -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,   311,
      -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,   321,
      -1,   323,   324,    -1,    -1,   327,    -1,    -1,   330,    -1,
     332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,   341,
     342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,
     362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,     4,
     372,     6,     7,     8,   376,    -1,    -1,   379,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    -1,    29,    30,    -1,    32,    -1,    34,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,    -1,
      45,    46,    -1,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    -1,    -1,    -1,    83,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    94,
      -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,
      -1,   116,   117,    -1,   119,    -1,    -1,    -1,   123,   124,
     125,   126,    -1,   128,    -1,    -1,    -1,   132,   133,    -1,
     135,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,   147,   148,   149,   150,    -1,    -1,   153,   154,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
      -1,    -1,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,
      -1,   186,    -1,   188,    -1,    -1,    -1,    -1,    -1,   194,
     195,    -1,   197,   198,   199,   200,    -1,    -1,   203,   204,
      -1,   206,    -1,   208,    -1,   210,   211,   212,   213,    -1,
      -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,
      -1,   226,   227,    -1,   229,   230,   231,   232,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,    -1,
      -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,   254,
      -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,    -1,
      -1,   266,    -1,   268,    -1,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,
     285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,
     295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,   306,   307,    -1,    -1,   310,   311,    -1,    -1,   314,
     315,   316,    -1,    -1,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,    -1,    -1,   330,    -1,   332,   333,   334,
      -1,    -1,   337,    -1,    -1,   340,   341,   342,    -1,   344,
     345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,
      -1,    -1,    -1,    -1,   359,    -1,    -1,   362,    -1,    -1,
      -1,   366,   367,    -1,    -1,    -1,    -1,   372,    -1,    -1,
      -1,   376,    -1,    -1,   379,     4,     5,     6,     7,     8,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,
      -1,    40,    41,    -1,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    63,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    98,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,
     119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,   128,
     129,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,
     149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,   178,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,
      -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,   261,   262,    -1,    -1,    -1,   266,    -1,   268,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,
      -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,
     329,   330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,
      -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
     359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,
      -1,    -1,    -1,   372,    -1,    -1,    -1,   376,     4,     5,
       6,     7,     8,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,
      -1,    27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,
      -1,    37,    -1,    -1,    40,    41,    -1,    43,    -1,    45,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    -1,    63,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,
      -1,    -1,    88,    -1,    -1,    -1,    -1,    93,    94,    -1,
      -1,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,
     116,   117,    -1,   119,    -1,    -1,    -1,   123,   124,   125,
     126,    -1,   128,   129,    -1,    -1,   132,   133,    -1,   135,
      -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,   147,   148,   149,   150,    -1,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
      -1,   177,   178,    -1,    -1,    -1,   182,    -1,   184,    -1,
     186,    -1,   188,    -1,    -1,    -1,    -1,    -1,   194,   195,
      -1,   197,   198,   199,   200,    -1,    -1,   203,   204,    -1,
     206,    -1,   208,    -1,   210,   211,   212,   213,    -1,    -1,
      -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,
     226,   227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
     236,    -1,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,    -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,    -1,    -1,   261,   262,    -1,    -1,    -1,
     266,    -1,   268,    -1,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,
     286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
     306,   307,    -1,    -1,   310,   311,    -1,    -1,   314,   315,
     316,    -1,    -1,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,    -1,   329,   330,    -1,   332,   333,   334,    -1,
      -1,   337,    -1,    -1,   340,   341,   342,    -1,   344,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,
      -1,    -1,    -1,   359,    -1,    -1,   362,    -1,    -1,    -1,
     366,   367,    -1,    -1,    -1,     4,   372,     6,     7,     8,
     376,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,
     119,    -1,    -1,    -1,   123,   124,   125,   126,   127,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,
     149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,   178,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
     189,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,
      -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,    -1,    -1,   222,    -1,   224,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,   268,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,
      -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,
     329,   330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,
      -1,   340,   341,   342,   343,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
     359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,
      -1,    -1,     4,   372,     6,     7,     8,   376,    -1,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    -1,
      32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    -1,    45,    46,    47,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,
      -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,    -1,
      -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,    -1,
     132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,    -1,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,    -1,   177,   178,    -1,    -1,    -1,
     182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,    -1,
      -1,    -1,   194,   195,    -1,   197,   198,   199,   200,    -1,
      -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,   211,
     212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,    -1,
     222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,
     262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,
      -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,   311,
      -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,   321,
      -1,   323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,
     332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,   341,
     342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,
     362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,     4,
     372,     6,     7,     8,   376,    -1,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    27,    -1,    29,    30,    -1,    32,    -1,    34,
      -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,    -1,
      45,    46,    47,    48,    49,    -1,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    -1,    -1,    -1,    83,    84,
      -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,    94,
      -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,
      -1,   116,   117,    -1,   119,    -1,    -1,    -1,   123,   124,
     125,   126,    -1,   128,    -1,    -1,    -1,   132,   133,    -1,
     135,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,   147,   148,   149,   150,    -1,    -1,   153,   154,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,
      -1,    -1,   177,   178,    -1,    -1,    -1,   182,    -1,   184,
      -1,   186,    -1,   188,    -1,    -1,    -1,    -1,    -1,   194,
     195,    -1,   197,   198,   199,   200,    -1,    -1,   203,   204,
      -1,   206,    -1,   208,    -1,   210,   211,   212,   213,    -1,
      -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,
      -1,   226,   227,    -1,   229,   230,   231,   232,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,    -1,
      -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,   254,
      -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,    -1,
      -1,   266,    -1,   268,    -1,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,
     285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,
     295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,   306,   307,    -1,    -1,   310,   311,    -1,    -1,   314,
     315,   316,    -1,    -1,   319,   320,   321,    -1,   323,   324,
      -1,    -1,   327,    -1,   329,   330,    -1,   332,   333,   334,
      -1,    -1,   337,    -1,    -1,   340,   341,   342,    -1,   344,
     345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,
      -1,    -1,    -1,    -1,   359,    -1,    -1,   362,    -1,    -1,
      -1,   366,   367,    -1,    -1,    -1,     4,   372,     6,     7,
       8,   376,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,    26,    27,
      -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,
      -1,    -1,    40,    -1,    -1,    43,    -1,    45,    46,    -1,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,
     108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,
      -1,   119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,
     128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,
      -1,    -1,    -1,   141,    -1,   143,    -1,    -1,    -1,   147,
     148,   149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,
     188,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,
     198,   199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,
     208,    -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,
     218,   219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,
      -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,
     248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,    -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,
     268,    -1,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,   287,
      -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,
      -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,
      -1,    -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,
      -1,   319,   320,   321,    -1,   323,   324,    -1,    -1,   327,
      -1,   329,   330,    -1,   332,   333,   334,    -1,    -1,   337,
      -1,    -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,
      -1,   349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,
      -1,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,
      -1,    -1,    -1,     4,   372,     6,     7,     8,   376,    -1,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,
      -1,    22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,
      -1,    32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,
      -1,    -1,    43,    -1,    45,    46,    -1,    48,    49,    -1,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    83,    84,    -1,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,
     111,    -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,
      -1,    -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,
      -1,   132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,
      -1,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,   177,   178,    -1,    -1,
      -1,   182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,   200,
      -1,    -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,
     211,   212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,
      -1,   222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,
     231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     241,   242,   243,    -1,    -1,   246,    -1,   248,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,
      -1,   262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
      -1,    -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,
     291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,
     301,    -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,
     311,    -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,
     321,    -1,   323,   324,    -1,    -1,   327,    -1,   329,   330,
      -1,   332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,
     341,   342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,
      -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,
       4,   372,     6,     7,     8,   376,    -1,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    -1,    -1,    27,    -1,    29,    30,    -1,    32,    -1,
      34,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,    43,
      -1,    45,    46,    -1,    48,    49,    -1,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    -1,    -1,    -1,    83,
      84,    -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    93,
      94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,    -1,
     114,    -1,   116,   117,    -1,   119,    -1,    -1,    -1,   123,
     124,   125,   126,    -1,   128,    -1,    -1,    -1,   132,   133,
      -1,   135,    -1,   137,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,   147,   148,   149,   150,    -1,    -1,   153,
     154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,
      -1,    -1,    -1,   177,   178,    -1,    -1,    -1,   182,    -1,
     184,    -1,   186,    -1,   188,    -1,    -1,    -1,    -1,    -1,
     194,   195,    -1,   197,   198,   199,   200,    -1,    -1,   203,
     204,    -1,   206,    -1,   208,    -1,   210,   211,   212,   213,
      -1,    -1,    -1,   217,   218,   219,    -1,    -1,   222,    -1,
      -1,    -1,   226,   227,    -1,   229,   230,   231,   232,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,   243,
      -1,    -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,
      -1,    -1,   266,    -1,   268,    -1,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,    -1,    -1,    -1,
     284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,   293,
     294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,
      -1,    -1,   306,   307,    -1,    -1,   310,   311,    -1,    -1,
     314,   315,   316,    -1,    -1,   319,   320,   321,    -1,   323,
     324,    -1,    -1,   327,    -1,   329,   330,    -1,   332,   333,
     334,    -1,    -1,   337,    -1,    -1,   340,   341,   342,    -1,
     344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,   353,
      -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,   362,    -1,
      -1,    -1,   366,   367,    -1,    -1,    -1,     4,   372,     6,
       7,     8,   376,    -1,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,    -1,
      27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,    -1,
      37,    -1,    -1,    40,    -1,    -1,    43,    -1,    45,    46,
      -1,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,    -1,
     107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,   116,
     117,    -1,   119,    -1,    -1,    -1,   123,   124,   125,   126,
      -1,   128,    -1,    -1,    -1,   132,   133,    -1,   135,    -1,
     137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
     147,   148,   149,   150,    -1,    -1,   153,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,    -1,
     177,   178,    -1,    -1,    -1,   182,    -1,   184,    -1,   186,
      -1,   188,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,
     197,   198,   199,   200,    -1,    -1,   203,   204,    -1,   206,
      -1,   208,    -1,   210,   211,   212,   213,    -1,    -1,    -1,
     217,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,   226,
     227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,   246,
      -1,   248,   249,   250,   251,    -1,    -1,   254,    -1,    -1,
      -1,   258,    -1,    -1,    -1,   262,    -1,    -1,    -1,   266,
      -1,   268,    -1,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,   286,
     287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,    -1,
      -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,   306,
     307,    -1,    -1,   310,   311,    -1,    -1,   314,   315,   316,
      -1,    -1,   319,   320,   321,    -1,   323,   324,    -1,    -1,
     327,    -1,   329,   330,    -1,   332,   333,   334,    -1,    -1,
     337,    -1,    -1,   340,   341,   342,    -1,   344,   345,    -1,
      -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,    -1,
      -1,    -1,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,
     367,    -1,    -1,    -1,     4,   372,     6,     7,     8,   376,
      -1,    -1,    -1,    13,    14,    -1,    -1,    17,    18,    19,
      20,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,    29,
      30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,    -1,
      40,    -1,    -1,    43,    -1,    45,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,    -1,
     110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,   119,
      -1,    -1,    -1,   123,   124,   125,   126,    -1,   128,    -1,
      -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,   149,
     150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,   173,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,    -1,
      -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,   199,
     200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,    -1,
     210,   211,   212,   213,    -1,    -1,    -1,   217,   218,   219,
      -1,    -1,   222,    -1,    -1,    -1,   226,   227,    -1,   229,
     230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,    -1,
      -1,    -1,   262,    -1,    -1,    -1,   266,    -1,   268,    -1,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,    -1,
      -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,    -1,
      -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,    -1,
     310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,   319,
     320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,   329,
     330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,    -1,
     340,   341,   342,    -1,   344,   345,    -1,    -1,    -1,   349,
      -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,   359,
      -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,    -1,
      -1,     4,   372,     6,     7,     8,   376,    -1,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    -1,    -1,    27,    -1,    29,    30,    -1,    32,
      -1,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,    -1,
      43,    -1,    45,    46,    -1,    48,    49,    -1,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,    -1,
      -1,   114,    -1,   116,   117,    -1,   119,    -1,    -1,    -1,
     123,   124,   125,   126,    -1,   128,    -1,    -1,    -1,   132,
     133,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,   147,   148,   149,   150,    -1,    -1,
     153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
     173,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,   182,
      -1,   184,    -1,   186,    -1,   188,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,   197,   198,   199,   200,    -1,    -1,
     203,   204,    -1,   206,    -1,   208,    -1,   210,   211,   212,
     213,    -1,    -1,    -1,   217,   218,   219,    -1,    -1,   222,
      -1,    -1,    -1,   226,   227,    -1,   229,   230,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,   242,
     243,    -1,    -1,   246,    -1,   248,   249,   250,   251,    -1,
      -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,   262,
      -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,    -1,    -1,
      -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,    -1,
     293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,    -1,
      -1,    -1,    -1,   306,   307,    -1,    -1,   310,   311,    -1,
      -1,   314,   315,   316,    -1,    -1,   319,   320,   321,    -1,
     323,   324,    -1,    -1,   327,    -1,   329,   330,    -1,   332,
     333,   334,    -1,    -1,   337,    -1,    -1,   340,   341,   342,
      -1,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,    -1,
     353,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,   362,
      -1,    -1,    -1,   366,   367,    -1,    -1,    -1,     4,   372,
       6,     7,     8,   376,    -1,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,
      -1,    27,    -1,    29,    30,    -1,    32,    -1,    34,    -1,
      -1,    37,    -1,    -1,    40,    -1,    -1,    43,    -1,    45,
      46,    -1,    48,    49,    -1,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    94,    -1,
      -1,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,   110,   111,    -1,    -1,   114,    -1,
     116,   117,    -1,   119,    -1,    -1,    -1,   123,   124,   125,
     126,    -1,   128,    -1,    -1,    -1,   132,   133,    -1,   135,
      -1,   137,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,   147,   148,   149,   150,    -1,    -1,   153,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,    -1,   173,    -1,    -1,
      -1,   177,    -1,    -1,    -1,    -1,   182,    -1,   184,    -1,
     186,    -1,   188,    -1,    -1,    -1,    -1,    -1,   194,   195,
      -1,   197,   198,   199,   200,    -1,    -1,   203,   204,    -1,
     206,    -1,   208,    -1,   210,   211,   212,   213,    -1,    -1,
      -1,   217,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,
     226,   227,    -1,   229,   230,   231,   232,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,    -1,    -1,
     246,   247,   248,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,    -1,    -1,    -1,   262,    -1,    -1,    -1,
     266,    -1,   268,    -1,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,    -1,    -1,    -1,   284,   285,
     286,   287,    -1,    -1,    -1,   291,    -1,   293,   294,   295,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,
     306,   307,    -1,    -1,   310,   311,    -1,    -1,   314,   315,
     316,    -1,    -1,   319,   320,   321,    -1,   323,   324,    -1,
      -1,   327,    -1,    -1,   330,    -1,   332,   333,   334,    -1,
      -1,   337,    -1,    -1,   340,   341,   342,    -1,   344,   345,
      -1,    -1,    -1,   349,    -1,    -1,    -1,   353,    -1,    -1,
      -1,    -1,    -1,   359,    -1,    -1,   362,    -1,    -1,    -1,
     366,   367,    -1,    -1,    -1,     4,   372,     6,     7,     8,
     376,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,    -1,    27,    -1,
      29,    30,    -1,    32,    -1,    34,    -1,    -1,    37,    -1,
      -1,    40,    -1,    -1,    43,    -1,    45,    46,    -1,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,   107,   108,
      -1,   110,   111,    -1,    -1,   114,    -1,   116,   117,    -1,
     119,    -1,    -1,    -1,   123,   124,   125,   126,    -1,   128,
      -1,    -1,    -1,   132,   133,    -1,   135,    -1,   137,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,   147,   148,
     149,   150,    -1,    -1,   153,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,   173,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,   182,    -1,   184,    -1,   186,    -1,   188,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   197,   198,
     199,   200,    -1,    -1,   203,   204,    -1,   206,    -1,   208,
      -1,   210,   211,   212,   213,    -1,    -1,    -1,   217,   218,
     219,    -1,    -1,   222,    -1,    -1,    -1,   226,   227,    -1,
     229,   230,   231,   232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   241,   242,   243,    -1,    -1,   246,    -1,   248,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
      -1,    -1,    -1,   262,    -1,    -1,    -1,   266,    -1,   268,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,    -1,    -1,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,   291,    -1,   293,   294,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,    -1,    -1,    -1,   306,   307,    -1,
      -1,   310,   311,    -1,    -1,   314,   315,   316,    -1,    -1,
     319,   320,   321,    -1,   323,   324,    -1,    -1,   327,    -1,
      -1,   330,    -1,   332,   333,   334,    -1,    -1,   337,    -1,
      -1,   340,   341,   342,    -1,   344,   345,    -1,    -1,    -1,
     349,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,    -1,
     359,    -1,    -1,   362,    -1,    -1,    -1,   366,   367,    -1,
      -1,    -1,     4,   372,     6,     7,     8,   376,    -1,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,    -1,
      22,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,    -1,
      32,    -1,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,
      -1,    43,    -1,    45,    46,    -1,    48,    49,    -1,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    94,    -1,    -1,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,   107,   108,    -1,   110,   111,
      -1,    -1,   114,    -1,   116,   117,    -1,   119,    -1,    -1,
      -1,   123,   124,   125,   126,    -1,   128,    -1,    -1,    -1,
     132,   133,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,   147,   148,   149,   150,    -1,
      -1,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,   173,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,
     182,    -1,   184,    -1,   186,    -1,   188,    -1,    -1,    -1,
      -1,    -1,   194,   195,    -1,   197,   198,   199,   200,    -1,
      -1,   203,   204,    -1,   206,    -1,   208,    -1,   210,   211,
     212,   213,    -1,    -1,    -1,   217,   218,   219,    -1,    -1,
     222,    -1,    -1,    -1,   226,   227,    -1,   229,   230,   231,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
     242,   243,    -1,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,    -1,    -1,    -1,
     262,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,    -1,
      -1,    -1,   284,   285,   286,   287,    -1,    -1,    -1,   291,
      -1,   293,   294,   295,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,   306,   307,    -1,    -1,   310,   311,
      -1,    -1,   314,   315,   316,    -1,    -1,   319,   320,   321,
      -1,   323,   324,    -1,    -1,   327,    -1,    -1,   330,    -1,
     332,   333,   334,    -1,    -1,   337,    -1,    -1,   340,   341,
     342,    -1,   344,   345,    -1,    -1,    -1,   349,    -1,    -1,
      -1,   353,    -1,    -1,    -1,    -1,    -1,   359,    -1,    -1,
     362,    -1,    -1,    -1,   366,   367,    -1,    -1,    -1,    -1,
     372,    -1,    -1,    -1,   376
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    10,    11,    22,    44,    53,    65,    89,    90,    91,
      98,   109,   128,   160,   172,   183,   260,   261,   264,   271,
     277,   281,   289,   292,   306,   340,   350,   351,   354,   382,
     391,   392,   393,   394,   475,   491,   493,   495,   497,   501,
     502,   639,   645,   648,   671,   678,   684,   686,   692,   695,
     698,   704,   706,   707,   748,   765,   767,   773,   774,   775,
     776,    71,   226,   231,   480,   323,   326,   764,   768,   764,
     372,   769,    71,   327,   411,   480,   679,    71,   327,   480,
     644,   699,   646,    58,   251,   705,    74,   712,   277,   764,
     649,   769,     4,     6,     7,     8,    13,    17,    18,    19,
      20,    22,    27,    29,    30,    32,    34,    37,    40,    43,
      45,    46,    48,    49,    51,    52,    53,    54,    55,    56,
      58,    59,    61,    67,    72,    73,    74,    75,    78,    83,
      84,    93,    94,    99,   100,   101,   105,   107,   108,   110,
     111,   114,   116,   117,   119,   123,   124,   125,   126,   128,
     132,   133,   135,   137,   141,   147,   148,   149,   150,   153,
     154,   166,   170,   173,   177,   182,   184,   186,   188,   194,
     195,   197,   198,   199,   200,   203,   204,   206,   208,   210,
     211,   212,   213,   217,   218,   219,   222,   226,   227,   229,
     230,   231,   232,   241,   242,   243,   246,   248,   249,   250,
     251,   254,   258,   262,   266,   268,   271,   272,   273,   274,
     275,   276,   277,   279,   280,   284,   285,   286,   287,   291,
     293,   294,   295,   301,   306,   307,   310,   311,   314,   315,
     316,   319,   320,   321,   323,   324,   327,   330,   332,   333,
     334,   337,   340,   341,   342,   344,   345,   349,   353,   359,
     362,   366,   367,   372,   376,   740,   744,   746,   747,   505,
     507,   508,   234,   750,   687,   337,   326,   685,   766,   152,
     488,   744,   281,   382,   503,     0,   109,   119,   388,   696,
     739,   744,   478,   744,   488,   494,   769,   496,    12,   770,
     151,   412,   326,   396,   152,   682,   683,   151,   643,   155,
     764,   188,   307,   323,   700,   701,   764,   488,     6,    20,
      25,    26,    38,    39,    42,    46,    48,    63,    64,    68,
      69,    71,    76,    77,    78,    83,    85,    88,   118,   120,
     121,   127,   139,   143,   147,   151,   160,   161,   176,   189,
     196,   200,   203,   205,   209,   210,   220,   221,   223,   224,
     244,   250,   263,   264,   268,   270,   276,   279,   308,   309,
     315,   317,   318,   322,   329,   332,   333,   334,   338,   339,
     340,   343,   353,   356,   357,   358,   363,   365,   376,   377,
     378,   382,   386,   388,   389,   522,   523,   524,   525,   531,
     532,   533,   534,   535,   540,   544,   727,   730,   731,   735,
     737,   740,   742,   744,   708,   744,   498,   162,   642,   651,
     652,   739,   335,   770,   506,     9,    95,   300,   301,   302,
     303,   313,   512,   513,   514,   749,    49,    64,    65,    72,
     114,   137,   154,   155,   169,   184,   249,   286,   323,   326,
     327,   366,   461,   688,   756,   370,   492,   642,   764,   739,
     507,   503,   383,   744,   694,   693,   388,   477,   326,   641,
     642,   641,    40,   222,   222,   260,   771,   220,   528,   744,
     412,   348,   462,   134,   680,   682,   118,   744,   744,   643,
     370,   384,   702,   651,   382,   382,   531,   522,   554,   382,
     382,   382,   382,   382,   382,   382,   521,   521,   382,   382,
     382,   382,   727,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   522,   382,   382,   382,   382,   382,   382,   382,
     522,   382,   521,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   521,   382,   727,
     382,   382,   382,   382,   382,   521,   521,   382,   382,   382,
     382,   531,   531,   522,   788,   789,   744,   744,   545,    12,
     237,   374,   526,   527,   112,   113,   136,   140,   165,   174,
     192,   215,   529,    23,    96,   164,   179,   209,   377,   378,
     379,   380,   381,   528,    47,   742,   382,   388,    56,   713,
     499,   500,   739,   652,   650,   277,   772,   771,   347,   777,
     778,   379,   516,   517,   518,   514,   751,   752,   753,   134,
     164,   690,   382,    71,   326,   179,   369,   691,   180,   623,
     625,   689,   690,   307,   323,   623,   690,   307,   362,    59,
     672,   383,   778,   780,   781,   782,   501,    26,   143,   697,
     728,   742,   744,   744,    88,   419,   449,   739,   384,    40,
     260,   118,   397,   739,   155,   739,   228,   641,   255,   701,
     641,   703,   647,   522,     9,    95,   550,   606,   368,   556,
     522,   522,   553,   553,   522,   522,    95,   550,   606,   383,
     383,   522,   522,   522,   522,   735,   788,    79,    80,    81,
      82,    83,   144,   145,   146,   147,   200,   201,   202,   203,
     210,   250,   278,   279,   367,   375,   376,   601,   603,    95,
     547,   522,   522,   522,   522,   601,   522,    95,   550,   522,
     522,    95,   550,   522,   522,   522,   525,   522,   522,   522,
     522,   522,   522,   522,   550,   550,   522,   522,    95,   550,
     522,   522,   133,   602,   603,   602,    31,   175,   336,   522,
     522,   383,   736,   737,   744,   550,   550,   522,   383,   384,
     383,   281,   382,   785,   786,   522,   388,   178,   329,   389,
     546,   741,   744,   745,   522,   522,   522,   524,   121,   223,
     339,   349,   528,     9,    13,   524,   530,   525,   525,   382,
     531,   525,   161,   525,   161,   525,   525,   525,   525,    23,
     164,   179,   745,   536,   744,   156,   384,   335,   281,   289,
     358,   359,   382,   404,   653,   656,   744,     9,    95,   784,
     384,   509,   522,   733,   744,   384,   137,   184,   229,   286,
     754,   755,   758,   759,   739,   379,   412,   739,   741,   522,
     189,   224,   343,   626,   627,   691,   744,   689,   691,   739,
     691,   691,   295,   289,   236,   619,   625,   783,    47,   476,
     642,   408,   409,   410,   419,   745,   395,   744,   681,   739,
     187,   653,   384,   550,   383,   551,   522,   103,   368,   555,
      14,   383,   384,   383,   383,   384,   541,   383,   379,   384,
     384,   383,   383,   383,   383,   134,   543,   383,   384,   384,
     384,   378,   384,   550,   383,   383,   383,   550,   383,   384,
     383,   383,   164,   383,   384,   384,   383,   384,   384,   383,
     383,   383,   384,   134,   384,   550,   383,   383,   383,   384,
     384,   134,   522,   134,   522,   134,   522,   134,   383,   384,
     383,   383,   383,   383,   553,   575,   576,   577,   281,   382,
     504,   347,   790,   387,   744,   137,   184,   286,   757,   290,
     121,   223,   339,   349,   382,    12,   522,   788,   116,   611,
     522,   522,   525,   382,   531,   518,   537,   538,   539,   388,
     329,   743,   500,   739,   405,   654,   382,   659,   664,   659,
     383,   404,   655,   732,   733,   736,   744,   657,   779,   517,
     134,   162,   510,   511,   618,   619,   635,   519,   519,   388,
     752,   337,   744,   761,   389,   760,   689,   383,   744,   227,
     384,   691,   689,   674,   675,   736,    33,   623,   112,   290,
     662,   663,     5,    10,    18,    41,    51,    63,    93,    94,
      98,   105,   110,   129,   153,   208,   236,   261,   414,   416,
     417,   418,   449,   479,   481,   482,   483,   615,   745,   384,
     662,   179,   382,   398,   413,   415,   416,   463,   464,   369,
     607,   640,   228,   669,   161,   522,   383,   522,   331,   522,
     522,   107,    25,    42,    75,    78,    86,   552,   522,   552,
     553,   383,   161,   161,   522,   553,   522,   522,   522,   522,
     522,   383,   383,   522,   522,   522,   522,   522,   553,   161,
     522,   522,   522,   383,   522,   522,   522,   134,   522,   134,
     522,   134,   522,   522,   383,   512,   576,   504,   383,   784,
     388,   388,   388,   745,   522,   788,   524,   383,   384,   383,
     531,   601,   601,    12,   522,   788,   611,   522,   383,   384,
     744,   709,   512,   660,   661,   736,   665,   384,   382,   656,
     383,   383,   384,   777,   502,   281,   382,   386,   557,   558,
     559,   560,   561,   570,   571,   585,   636,   131,   187,   515,
     635,   624,   625,   511,    14,   520,   741,   744,   379,   744,
     166,   662,   389,   745,   691,   114,   366,   627,   627,   607,
     384,   673,   662,   620,    88,   447,   448,   745,    50,    60,
     155,   171,   425,   428,   429,   457,   459,   487,   487,   663,
     487,   663,   335,   169,   324,   130,   247,   459,   487,   169,
     662,   324,   487,    33,    14,   112,   335,   490,   414,    47,
     384,   382,   388,   424,   430,   738,   744,   662,   409,    85,
     127,   189,   224,   343,   630,   745,   739,   179,   399,   404,
     422,   423,   424,   425,   152,   264,   401,   714,   384,   415,
     342,   355,   467,   228,   608,   618,   100,   522,   383,   522,
     331,   382,   441,   441,   382,   439,   440,   383,   383,   542,
     522,   522,   383,   549,   619,   384,   384,   383,   384,   383,
     383,   383,   383,   384,   383,   383,   522,   383,   131,   383,
     383,   384,   384,   384,   383,   522,   383,   522,   383,   522,
     383,   383,   516,   383,   787,   388,   473,   383,   553,   524,
     383,   384,   383,   519,   539,   714,   516,   384,   662,    88,
     522,   666,   667,   668,   664,   658,   656,   732,   584,   744,
      66,   157,   168,   176,   214,   270,   313,   569,   607,   384,
     739,   584,    99,   239,   631,   632,   637,   351,   164,   741,
     744,   388,   177,     9,    25,    88,   228,   522,   763,   757,
     662,   675,   607,   668,   522,   621,   734,   472,   738,    44,
     130,   247,   348,   427,   458,   426,   427,   472,   738,   630,
     738,   741,   448,   171,   171,   738,   738,   745,   738,   616,
     617,   736,   739,   663,   483,   422,   744,     7,   125,   489,
     259,   426,   451,   431,   388,   630,   745,   413,   739,   383,
     383,   384,    14,   407,   415,    32,   141,   469,   469,   739,
     522,   180,   628,   670,   601,   522,   224,   224,   383,   601,
     601,   283,   548,   522,   522,   553,   522,   601,   522,   522,
     522,   522,   383,   383,   383,   578,   785,   744,   383,   553,
     520,   162,   406,   661,   668,   383,   384,   780,   572,   579,
     584,   557,   168,   168,   238,   586,   168,   176,   270,   586,
     570,   557,   138,   612,   559,    14,   112,   604,   605,   581,
     582,   743,   743,   389,   633,   634,   291,   379,   255,   262,
     284,   762,   761,   522,   618,   384,    15,    90,   622,   522,
     171,   171,   459,   460,   472,   464,    98,   289,   484,   472,
     485,   384,   622,   448,   383,   744,   739,    24,    28,    42,
      75,    78,    86,    97,   111,   126,   163,   225,   257,   285,
     330,   332,   360,   361,   432,   433,   435,   436,   437,   438,
     744,   383,   400,   413,   423,   382,   404,   382,   627,   171,
     383,   383,   383,   384,   383,   383,   728,   383,   383,   384,
     383,   383,   383,   383,   383,   383,   383,   421,   511,   624,
     383,   710,   421,   668,   347,   383,   618,   580,   387,   168,
     570,   586,   586,   168,   228,   228,   355,    33,   142,   609,
     744,   595,   596,   512,   638,   745,   384,   206,    52,   344,
     255,   662,   628,   734,   472,   464,   382,    88,    88,   430,
     432,   617,   382,   452,   439,   245,   434,   439,   439,   382,
      18,    47,    51,    88,   123,   223,   228,   247,   285,   348,
     443,   444,   445,   450,   528,   364,   382,   382,   382,   440,
     442,   388,   780,   401,   404,   402,   470,   471,   744,   351,
     224,   522,   515,   515,   326,   784,   605,   624,   560,   557,
     570,   168,   168,   557,   570,   563,   562,   564,   613,   734,
     610,   618,   593,   594,   516,    49,   715,   634,   763,   622,
     382,   382,   470,    78,   332,   377,   378,   729,   730,   489,
     486,   453,   744,   193,   454,   382,   224,   447,   741,   221,
     446,   729,    88,   101,   126,   420,   351,    88,   171,   445,
     171,   223,   224,   224,   224,   744,   383,   777,   383,   384,
     622,   382,   676,   677,   736,   383,   383,   739,   573,   228,
     566,   570,   570,   228,   568,   522,   522,   382,   371,   384,
     614,   622,   522,   624,   129,   152,   354,   588,   589,   592,
     583,   106,   115,   235,   328,   716,   717,   181,   718,   470,
     470,   383,   731,   731,   489,   383,   384,   135,   242,   294,
     228,   455,   474,   728,   383,   521,   221,   359,   383,   383,
     403,    51,   170,   465,   466,   467,   468,   471,   224,   384,
     662,   711,   785,   565,   355,   567,   355,   600,   744,   734,
     459,   459,   589,   421,    33,    33,   106,    33,   717,   305,
     328,   719,   720,   383,   383,   465,   744,    89,   351,   383,
     384,   521,   780,   741,   663,   468,   622,   383,   677,   668,
     715,   574,   522,   382,   522,   382,   383,   384,   622,   131,
     587,   587,   728,   728,    33,   728,    33,    33,   720,   451,
     465,    36,   222,   265,   289,   456,   456,   728,    85,   127,
     143,   189,   224,   343,   629,   718,   618,   600,   600,   744,
     138,   168,   236,   591,   590,   728,   728,   728,     4,    88,
     223,   228,   228,   152,   721,   624,   383,   383,    33,    33,
     382,   382,   351,    89,   224,   382,   723,   247,   597,   598,
     599,   744,   599,   456,   456,   181,   274,   722,   383,   389,
     724,   725,   736,   289,   726,   383,   384,   383,   745,   383,
     384,   676,   598,   725
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 960 "sql_yacc.yy"
    {
            Session *session= YYSession;
            if (!(session->lex->select_lex.options & OPTION_FOUND_COMMENT))
            {
              my_message(ER_EMPTY_QUERY, ER(ER_EMPTY_QUERY), MYF(0));
              DRIZZLE_YYABORT;
            }
            else
            {
              session->lex->sql_command= SQLCOM_EMPTY_QUERY;
              session->lex->statement=
                new(std::nothrow) statement::EmptyQuery(YYSession);
              if (session->lex->statement == NULL)
                DRIZZLE_YYABORT;
            }
          }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 976 "sql_yacc.yy"
    {}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 1017 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            lex->sql_command= SQLCOM_CREATE_TABLE;
            statement::CreateTable *statement= new(std::nothrow) statement::CreateTable(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            if (!lex->select_lex.add_table_to_list(session, (yyvsp[(5) - (5)].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   TL_WRITE))
              DRIZZLE_YYABORT;
            lex->col_list.empty();
            statement->change=NULL;
            statement->is_if_not_exists= (yyvsp[(4) - (5)].num);
            statement->create_info.db_type= NULL;
            statement->create_info.default_table_charset= NULL;
            lex->name.str= 0;

	    message::Table &proto= statement->create_table_message;
	   
	    proto.set_name((yyvsp[(5) - (5)].table)->table.str);
	    if ((yyvsp[(2) - (5)].num))
	      proto.set_type(message::Table::TEMPORARY);
	    else
	      proto.set_type(message::Table::STANDARD);
          }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 1045 "sql_yacc.yy"
    {
            LEX *lex= YYSession->lex;
            lex->current_select= &lex->select_lex;
          }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 1050 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_CREATE_INDEX;
            statement::CreateIndex *statement= new(std::nothrow) statement::CreateIndex(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->alter_info.flags.set(ALTER_ADD_INDEX);
            statement->alter_info.build_method= (yyvsp[(2) - (2)].build_method);
            lex->col_list.empty();
            statement->change=NULL;
          }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 1063 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::CreateIndex *statement= (statement::CreateIndex *)Lex->statement;

            if (!lex->current_select->add_table_to_list(lex->session, (yyvsp[(9) - (13)].table),
                                                        NULL,
                                                        TL_OPTION_UPDATING))
              DRIZZLE_YYABORT;
            Key *key;
            key= new Key((yyvsp[(4) - (13)].key_type), (yyvsp[(6) - (13)].lex_str), &statement->key_create_info, 0, lex->col_list);
            statement->alter_info.key_list.push_back(key);
            lex->col_list.empty();
          }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 1077 "sql_yacc.yy"
    {
            LEX *lex=Lex;

            lex->sql_command=SQLCOM_CREATE_DB;
            statement::CreateSchema *statement= new(std::nothrow) statement::CreateSchema(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->is_if_not_exists= (yyvsp[(3) - (4)].num);
          }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 1088 "sql_yacc.yy"
    {
            Lex->name= (yyvsp[(4) - (6)].lex_str);
          }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 1094 "sql_yacc.yy"
    {}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 1096 "sql_yacc.yy"
    {}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 1098 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;

            statement->is_create_table_like= true;
            if (!lex->select_lex.add_table_to_list(session, (yyvsp[(2) - (3)].table), NULL, 0, TL_READ))
              DRIZZLE_YYABORT;
          }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 1108 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;

            statement->is_create_table_like= true;
            if (!lex->select_lex.add_table_to_list(session, (yyvsp[(3) - (4)].table), NULL, 0, TL_READ))
              DRIZZLE_YYABORT;
          }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 1121 "sql_yacc.yy"
    {}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 1123 "sql_yacc.yy"
    { Lex->current_select->set_braces(1);}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 1124 "sql_yacc.yy"
    {}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 1128 "sql_yacc.yy"
    {}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 1130 "sql_yacc.yy"
    { Lex->current_select->set_braces(0);}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 1131 "sql_yacc.yy"
    {}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 1133 "sql_yacc.yy"
    { Lex->current_select->set_braces(1);}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 1134 "sql_yacc.yy"
    {}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 1139 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->lock_option= TL_READ;
            if (lex->sql_command == SQLCOM_INSERT)
            {
              lex->sql_command= SQLCOM_INSERT_SELECT;
              delete lex->statement;
              lex->statement=
                new(std::nothrow) statement::InsertSelect(YYSession);
              if (lex->statement == NULL)
                DRIZZLE_YYABORT;
            }
            else if (lex->sql_command == SQLCOM_REPLACE)
            {
              lex->sql_command= SQLCOM_REPLACE_SELECT;
              delete lex->statement;
              lex->statement=
                new(std::nothrow) statement::ReplaceSelect(YYSession);
              if (lex->statement == NULL)
                DRIZZLE_YYABORT;
            }
            /*
              The following work only with the local list, the global list
              is created correctly in this case
            */
            lex->current_select->table_list.save_and_clear(&lex->save_list);
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
          }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 1169 "sql_yacc.yy"
    {
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 1173 "sql_yacc.yy"
    {
            /*
              The following work only with the local list, the global list
              is created correctly in this case
            */
            Lex->current_select->table_list.push_front(&Lex->save_list);
          }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 1183 "sql_yacc.yy"
    {}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 1184 "sql_yacc.yy"
    {}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 1188 "sql_yacc.yy"
    {}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 1189 "sql_yacc.yy"
    {}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 1190 "sql_yacc.yy"
    {}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1200 "sql_yacc.yy"
    {
          statement::CreateSchema *statement= (statement::CreateSchema *)Lex->statement;
          drizzled::message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();

          opt->set_name((yyvsp[(1) - (1)].lex_str).str);
        }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1207 "sql_yacc.yy"
    {
          statement::CreateSchema *statement= (statement::CreateSchema *)Lex->statement;
          drizzled::message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();

          opt->set_name((yyvsp[(1) - (3)].lex_str).str);
          opt->set_state((yyvsp[(3) - (3)].lex_str).str);
        }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1215 "sql_yacc.yy"
    {
          statement::CreateSchema *statement= (statement::CreateSchema *)Lex->statement;
          char number_as_string[22];

          snprintf(number_as_string, sizeof(number_as_string), "%"PRIu64, (yyvsp[(3) - (3)].ulonglong_number));

          drizzled::message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();

          opt->set_name((yyvsp[(1) - (3)].lex_str).str);
          opt->set_state(number_as_string);
        }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1229 "sql_yacc.yy"
    { (yyval.num)= false; }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1230 "sql_yacc.yy"
    { (yyval.num)= true; }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1234 "sql_yacc.yy"
    { (yyval.num)= false; }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1235 "sql_yacc.yy"
    { (yyval.num)= true; }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1258 "sql_yacc.yy"
    {
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;

            statement->is_engine_set= true;

            ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_engine()->set_name((yyvsp[(3) - (3)].lex_str).str);
          }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1266 "sql_yacc.yy"
    {
	    message::Table::TableOptions *tableopts;
	    tableopts= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_options();

	    tableopts->set_comment((yyvsp[(3) - (3)].lex_str).str);
          }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1273 "sql_yacc.yy"
    {
	    message::Table::TableOptions *tableopts;
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;

	    tableopts= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_options();

            statement->create_info.auto_increment_value=(yyvsp[(3) - (3)].ulonglong_number);
            statement->create_info.used_fields|= HA_CREATE_USED_AUTO;
	    tableopts->set_auto_increment_value((yyvsp[(3) - (3)].ulonglong_number));
          }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1284 "sql_yacc.yy"
    {
	    drizzled::message::Engine::Option *opt= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_engine()->add_options();

            opt->set_name((yyvsp[(1) - (3)].lex_str).str);
            opt->set_state((yyvsp[(3) - (3)].lex_str).str);
          }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1291 "sql_yacc.yy"
    {
            char number_as_string[22];
            snprintf(number_as_string, sizeof(number_as_string), "%"PRIu64, (yyvsp[(3) - (3)].ulonglong_number));

	    drizzled::message::Engine::Option *opt= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_engine()->add_options();
            opt->set_name((yyvsp[(1) - (3)].lex_str).str);
            opt->set_state(number_as_string);
          }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1304 "sql_yacc.yy"
    {
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;

            HA_CREATE_INFO *cinfo= &statement->create_info;
            if ((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                 cinfo->default_table_charset && (yyvsp[(4) - (4)].charset) &&
                 !my_charset_same(cinfo->default_table_charset,(yyvsp[(4) - (4)].charset)))
              {
                my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                         (yyvsp[(4) - (4)].charset)->name, cinfo->default_table_charset->csname);
                DRIZZLE_YYABORT;
              }
              statement->create_info.default_table_charset= (yyvsp[(4) - (4)].charset);
              statement->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1323 "sql_yacc.yy"
    {
            statement::CreateSchema *statement= (statement::CreateSchema *)Lex->statement;

            message::Schema &schema_message= statement->schema_message;
            schema_message.set_collation((yyvsp[(4) - (4)].charset)->name);
          }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1332 "sql_yacc.yy"
    { (yyval.column_format_type)= COLUMN_FORMAT_TYPE_DEFAULT; }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1333 "sql_yacc.yy"
    { (yyval.column_format_type)= COLUMN_FORMAT_TYPE_FIXED; }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1334 "sql_yacc.yy"
    { (yyval.column_format_type)= COLUMN_FORMAT_TYPE_DYNAMIC; }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1338 "sql_yacc.yy"
    {}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1355 "sql_yacc.yy"
    {
            Lex->col_list.empty(); /* Alloced by memory::sql_alloc */
          }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1362 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            Key *key= new Key((yyvsp[(1) - (7)].key_type), (yyvsp[(2) - (7)].lex_str), &statement->key_create_info, 0,
                              lex->col_list);
            statement->alter_info.key_list.push_back(key);
            lex->col_list.empty(); /* Alloced by memory::sql_alloc */
          }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1372 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            Key *key= new Key((yyvsp[(2) - (8)].key_type), (yyvsp[(3) - (8)].lex_str).str ? (yyvsp[(3) - (8)].lex_str) : (yyvsp[(1) - (8)].lex_str), &statement->key_create_info, 0,
                              lex->col_list);
            statement->alter_info.key_list.push_back(key);
            lex->col_list.empty(); /* Alloced by memory::sql_alloc */
          }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1381 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            Key *key= new Foreign_key((yyvsp[(4) - (8)].lex_str).str ? (yyvsp[(4) - (8)].lex_str) : (yyvsp[(1) - (8)].lex_str), lex->col_list,
                                      (yyvsp[(8) - (8)].table),
                                      lex->ref_list,
                                      statement->fk_delete_opt,
                                      statement->fk_update_opt,
                                      statement->fk_match_option);
            statement->alter_info.key_list.push_back(key);
            key= new Key(Key::MULTIPLE, (yyvsp[(1) - (8)].lex_str).str ? (yyvsp[(1) - (8)].lex_str) : (yyvsp[(4) - (8)].lex_str),
                         &default_key_create_info, 1,
                         lex->col_list);
            statement->alter_info.key_list.push_back(key);
            lex->col_list.empty(); /* Alloced by memory::sql_alloc */
            /* Only used for ALTER TABLE. Ignored otherwise. */
            statement->alter_info.flags.set(ALTER_FOREIGN_KEY);
          }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1400 "sql_yacc.yy"
    {
            Lex->col_list.empty(); /* Alloced by memory::sql_alloc */
          }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1404 "sql_yacc.yy"
    {
            Lex->col_list.empty(); /* Alloced by memory::sql_alloc */
          }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1419 "sql_yacc.yy"
    { (yyval.lex_str)= null_lex_str; }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1420 "sql_yacc.yy"
    { (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str); }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1424 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(2) - (2)].lex_str); }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1429 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
            lex->length=lex->dec=0;
            lex->type=0;
            statement->default_value= statement->on_update_value= 0;
            statement->comment= null_lex_str;
            lex->charset=NULL;
            statement->column_format= COLUMN_FORMAT_TYPE_DEFAULT;

            message::AlterTable &alter_proto=
              ((statement::CreateTable *)Lex->statement)->alter_info.alter_proto;
            statement->current_proto_field= alter_proto.add_added_field();
          }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1444 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_name((yyvsp[(1) - (3)].lex_str).str);

            if (add_field_to_list(lex->session, &(yyvsp[(1) - (3)].lex_str), (enum enum_field_types) (yyvsp[(3) - (3)].num),
                                  lex->length,lex->dec,lex->type,
                                  statement->column_format,
                                  statement->default_value, statement->on_update_value,
                                  &statement->comment,
                                  statement->change, &lex->interval_list, lex->charset))
              DRIZZLE_YYABORT;

            statement->current_proto_field= NULL;
          }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1463 "sql_yacc.yy"
    {}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1468 "sql_yacc.yy"
    {
          (yyval.num)=(yyvsp[(1) - (1)].num);
          Lex->length=(char*) 0; /* use default length */
          statement::CreateTable *statement=
            (statement::CreateTable *)Lex->statement;

          if (statement->current_proto_field)
          {
            if ((yyvsp[(1) - (1)].num) == DRIZZLE_TYPE_LONG)
              statement->current_proto_field->set_type(message::Table::Field::INTEGER);
            else if ((yyvsp[(1) - (1)].num) == DRIZZLE_TYPE_LONGLONG)
              statement->current_proto_field->set_type(message::Table::Field::BIGINT);
            else
              abort();
          }
          }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1485 "sql_yacc.yy"
    {
            (yyval.num)=(yyvsp[(1) - (2)].num);

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
            {
              assert ((yyvsp[(1) - (2)].num) == DRIZZLE_TYPE_DOUBLE);
              statement->current_proto_field->set_type(message::Table::Field::DOUBLE);
            }
          }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1498 "sql_yacc.yy"
    {
              Lex->length=(yyvsp[(3) - (4)].lex_str).str;
              (yyval.num)=DRIZZLE_TYPE_VARCHAR;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
            {
              statement->current_proto_field->set_type(message::Table::Field::VARCHAR);
              message::Table::Field::StringFieldOptions *string_field_options;

              string_field_options= statement->current_proto_field->mutable_string_options();

              string_field_options->set_length(atoi((yyvsp[(3) - (4)].lex_str).str));
            }
            }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1516 "sql_yacc.yy"
    {
              Lex->length=(char*) "1";
              (yyval.num)=DRIZZLE_TYPE_VARCHAR;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::VARCHAR);
            }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1527 "sql_yacc.yy"
    {
              Lex->length=(yyvsp[(3) - (4)].lex_str).str;
              (yyval.num)= DRIZZLE_TYPE_VARCHAR;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
	    {
              statement->current_proto_field->set_type(message::Table::Field::VARCHAR);

              message::Table::Field::StringFieldOptions *string_field_options;

              string_field_options= statement->current_proto_field->mutable_string_options();

              string_field_options->set_length(atoi((yyvsp[(3) - (4)].lex_str).str));
            }
            }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1546 "sql_yacc.yy"
    {
              Lex->length=(yyvsp[(3) - (4)].lex_str).str;
              Lex->charset=&my_charset_bin;
              (yyval.num)= DRIZZLE_TYPE_VARCHAR;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
	    {
              statement->current_proto_field->set_type(message::Table::Field::VARCHAR);
              message::Table::Field::StringFieldOptions *string_field_options;

              string_field_options= statement->current_proto_field->mutable_string_options();

              string_field_options->set_length(atoi((yyvsp[(3) - (4)].lex_str).str));
              string_field_options->set_collation_id(my_charset_bin.number);
              string_field_options->set_collation(my_charset_bin.name);
            }
            }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1567 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_DATE;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::DATE);
          }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1577 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_TIMESTAMP;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::TIMESTAMP);
          }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1587 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_DATETIME;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::DATETIME);
          }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1597 "sql_yacc.yy"
    {
              Lex->charset=&my_charset_bin;
              (yyval.num)=DRIZZLE_TYPE_BLOB;
              Lex->length=(char*) 0; /* use default length */

              statement::CreateTable *statement=
                (statement::CreateTable *)Lex->statement;

              if (statement->current_proto_field)
              {
                statement->current_proto_field->set_type(message::Table::Field::BLOB);
                message::Table::Field::StringFieldOptions *string_field_options;

                string_field_options= statement->current_proto_field->mutable_string_options();
                string_field_options->set_collation_id(my_charset_bin.number);
                string_field_options->set_collation(my_charset_bin.name);
              }
            }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1616 "sql_yacc.yy"
    {
              (yyval.num)=DRIZZLE_TYPE_BLOB;
              Lex->length=(char*) 0; /* use default length */

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::BLOB);
            }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1627 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_DECIMAL;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::DECIMAL);
          }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1637 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_DECIMAL;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::DECIMAL);
          }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1647 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_DECIMAL;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::DECIMAL);
          }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1657 "sql_yacc.yy"
    {Lex->interval_list.empty();}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1659 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_ENUM;

            statement::CreateTable *statement=
              (statement::CreateTable *)Lex->statement;

            if (statement->current_proto_field)
              statement->current_proto_field->set_type(message::Table::Field::ENUM);
          }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1669 "sql_yacc.yy"
    {
            (yyval.num)=DRIZZLE_TYPE_LONGLONG;
            Lex->type|= (AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_FLAG);

            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
            if (statement->current_proto_field)
            {
              message::Table::Field::FieldConstraints *constraints;
              constraints= statement->current_proto_field->mutable_constraints();
              constraints->set_is_nullable(false);

              statement->current_proto_field->set_type(message::Table::Field::BIGINT);
            }
          }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1686 "sql_yacc.yy"
    {}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1690 "sql_yacc.yy"
    {}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1691 "sql_yacc.yy"
    {}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1695 "sql_yacc.yy"
    { (yyval.num)=DRIZZLE_TYPE_LONG; }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1696 "sql_yacc.yy"
    { (yyval.num)=DRIZZLE_TYPE_LONGLONG; }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1701 "sql_yacc.yy"
    {
            (yyval.num)= DRIZZLE_TYPE_DOUBLE;
          }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1705 "sql_yacc.yy"
    { (yyval.num)=DRIZZLE_TYPE_DOUBLE; }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1707 "sql_yacc.yy"
    { (yyval.num)=DRIZZLE_TYPE_DOUBLE; }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1712 "sql_yacc.yy"
    { Lex->dec=Lex->length= (char*)0; }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1714 "sql_yacc.yy"
    { Lex->length=(yyvsp[(2) - (3)].lex_str).str; Lex->dec= (char*)0; }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1716 "sql_yacc.yy"
    {}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1721 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->length=(yyvsp[(2) - (5)].lex_str).str;
            lex->dec=(yyvsp[(4) - (5)].lex_str).str;
          }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1729 "sql_yacc.yy"
    { Lex->length=(char*) 0; /* use default length */ }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1730 "sql_yacc.yy"
    { Lex->length= (yyvsp[(2) - (3)].lex_str).str; }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1734 "sql_yacc.yy"
    {}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1735 "sql_yacc.yy"
    {}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1739 "sql_yacc.yy"
    {}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1740 "sql_yacc.yy"
    {}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1744 "sql_yacc.yy"
    {}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1750 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            Lex->type&= ~ NOT_NULL_FLAG;

            if (statement->current_proto_field)
            {
              message::Table::Field::FieldConstraints *constraints;
              constraints= statement->current_proto_field->mutable_constraints();
              constraints->set_is_nullable(true);
            }
          }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1762 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->column_format= (yyvsp[(2) - (2)].column_format_type);
            statement->alter_info.flags.set(ALTER_COLUMN_FORMAT);
          }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1769 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            Lex->type|= NOT_NULL_FLAG;

            if (statement->current_proto_field)
            {
              message::Table::Field::FieldConstraints *constraints;
              constraints= statement->current_proto_field->mutable_constraints();
              constraints->set_is_nullable(false);
            }
          }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1781 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->default_value=(yyvsp[(2) - (2)].item);
            statement->alter_info.flags.set(ALTER_COLUMN_DEFAULT);
          }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1788 "sql_yacc.yy"
    { ((statement::AlterTable *)Lex->statement)->on_update_value= new Item_func_now_local(); }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1790 "sql_yacc.yy"
    {
            Lex->type|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG;

            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            if (statement->current_proto_field)
            {
              message::Table::Field::FieldConstraints *constraints;

              constraints= statement->current_proto_field->mutable_constraints();
              constraints->set_is_nullable(false);
            }
          }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1803 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            lex->type|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_FLAG;
            statement->alter_info.flags.set(ALTER_ADD_INDEX);

            if (statement->current_proto_field)
            {
              message::Table::Field::FieldConstraints *constraints;
              constraints= statement->current_proto_field->mutable_constraints();
              constraints->set_is_nullable(false);
            }
          }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1818 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            lex->type|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            statement->alter_info.flags.set(ALTER_ADD_INDEX);

            if (statement->current_proto_field)
            {
              message::Table::Field::FieldConstraints *constraints;
              constraints= statement->current_proto_field->mutable_constraints();
              constraints->set_is_nullable(false);
            }
          }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1833 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            lex->type|= UNIQUE_FLAG;
            statement->alter_info.flags.set(ALTER_ADD_INDEX);
          }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1841 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            lex->type|= UNIQUE_KEY_FLAG;
            statement->alter_info.flags.set(ALTER_ADD_INDEX);
          }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1849 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            statement->comment= (yyvsp[(2) - (2)].lex_str);

            if (statement->current_proto_field)
              statement->current_proto_field->set_comment((yyvsp[(2) - (2)].lex_str).str);
          }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1857 "sql_yacc.yy"
    {
            if (Lex->charset && !my_charset_same(Lex->charset,(yyvsp[(2) - (2)].charset)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       (yyvsp[(2) - (2)].charset)->name,Lex->charset->csname);
              DRIZZLE_YYABORT;
            }
            else
            {
              Lex->charset=(yyvsp[(2) - (2)].charset);
            }
          }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1873 "sql_yacc.yy"
    { (yyval.item)= new Item_func_now_local(); }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1875 "sql_yacc.yy"
    { (yyval.item)=(yyvsp[(1) - (1)].item); }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1880 "sql_yacc.yy"
    {
            if (!((yyval.charset)=get_charset_by_name((yyvsp[(1) - (1)].lex_str).str)))
            {
              my_error(ER_UNKNOWN_COLLATION, MYF(0), (yyvsp[(1) - (1)].lex_str).str);
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1890 "sql_yacc.yy"
    { (yyval.charset)=(yyvsp[(1) - (1)].charset); }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1891 "sql_yacc.yy"
    { (yyval.charset)=NULL; }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1895 "sql_yacc.yy"
    {}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1896 "sql_yacc.yy"
    {}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1910 "sql_yacc.yy"
    {
            (yyval.table)=(yyvsp[(2) - (5)].table);
          }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1917 "sql_yacc.yy"
    { Lex->ref_list.empty(); }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1923 "sql_yacc.yy"
    { Lex->ref_list.push_back(new Key_part_spec((yyvsp[(3) - (3)].lex_str), 0)); }
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1925 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(new Key_part_spec((yyvsp[(1) - (1)].lex_str), 0));
          }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1934 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1936 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->fk_match_option= Foreign_key::FK_MATCH_FULL; }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1938 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1940 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1945 "sql_yacc.yy"
    {
            ((statement::CreateTable *)Lex->statement)->fk_update_opt= Foreign_key::FK_OPTION_UNDEF;
            ((statement::CreateTable *)Lex->statement)->fk_delete_opt= Foreign_key::FK_OPTION_UNDEF;
          }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1950 "sql_yacc.yy"
    {
            ((statement::CreateTable *)Lex->statement)->fk_update_opt= (yyvsp[(3) - (3)].m_fk_option);
            ((statement::CreateTable *)Lex->statement)->fk_delete_opt= Foreign_key::FK_OPTION_UNDEF;
          }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1955 "sql_yacc.yy"
    {
            ((statement::CreateTable *)Lex->statement)->fk_update_opt= Foreign_key::FK_OPTION_UNDEF;
            ((statement::CreateTable *)Lex->statement)->fk_delete_opt= (yyvsp[(3) - (3)].m_fk_option);
          }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1961 "sql_yacc.yy"
    {
            ((statement::CreateTable *)Lex->statement)->fk_update_opt= (yyvsp[(3) - (6)].m_fk_option);
            ((statement::CreateTable *)Lex->statement)->fk_delete_opt= (yyvsp[(6) - (6)].m_fk_option);
          }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1967 "sql_yacc.yy"
    {
            ((statement::CreateTable *)Lex->statement)->fk_update_opt= (yyvsp[(6) - (6)].m_fk_option);
            ((statement::CreateTable *)Lex->statement)->fk_delete_opt= (yyvsp[(3) - (6)].m_fk_option);
          }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1974 "sql_yacc.yy"
    { (yyval.m_fk_option)= Foreign_key::FK_OPTION_RESTRICT; }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1975 "sql_yacc.yy"
    { (yyval.m_fk_option)= Foreign_key::FK_OPTION_CASCADE; }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1976 "sql_yacc.yy"
    { (yyval.m_fk_option)= Foreign_key::FK_OPTION_SET_NULL; }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1977 "sql_yacc.yy"
    { (yyval.m_fk_option)= Foreign_key::FK_OPTION_NO_ACTION; }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1978 "sql_yacc.yy"
    { (yyval.m_fk_option)= Foreign_key::FK_OPTION_DEFAULT;  }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1982 "sql_yacc.yy"
    { (yyval.key_type)= Key::MULTIPLE; }
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1986 "sql_yacc.yy"
    { (yyval.key_type)= Key::PRIMARY; }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1987 "sql_yacc.yy"
    { (yyval.key_type)= Key::UNIQUE; }
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1991 "sql_yacc.yy"
    {}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1992 "sql_yacc.yy"
    {}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1996 "sql_yacc.yy"
    {}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 2001 "sql_yacc.yy"
    {}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 2002 "sql_yacc.yy"
    {}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 2003 "sql_yacc.yy"
    {}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 2007 "sql_yacc.yy"
    { (yyval.key_type)= Key::MULTIPLE; }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 2008 "sql_yacc.yy"
    { (yyval.key_type)= Key::UNIQUE; }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 2012 "sql_yacc.yy"
    {
            ((statement::CreateTable *)Lex->statement)->key_create_info= default_key_create_info;
          }
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 2029 "sql_yacc.yy"
    {}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 2039 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->key_create_info.algorithm= (yyvsp[(2) - (2)].key_alg); }
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 2040 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->key_create_info.algorithm= (yyvsp[(2) - (2)].key_alg); }
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 2046 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->key_create_info.block_size= (yyvsp[(3) - (3)].ulong_num); }
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 2048 "sql_yacc.yy"
    { ((statement::CreateTable *)Lex->statement)->key_create_info.comment= (yyvsp[(2) - (2)].lex_str); }
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 2052 "sql_yacc.yy"
    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 2053 "sql_yacc.yy"
    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 2057 "sql_yacc.yy"
    { Lex->col_list.push_back((yyvsp[(3) - (4)].key_part)); }
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 2058 "sql_yacc.yy"
    { Lex->col_list.push_back((yyvsp[(1) - (2)].key_part)); }
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 2062 "sql_yacc.yy"
    { (yyval.key_part)=new Key_part_spec((yyvsp[(1) - (1)].lex_str), 0); }
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 2064 "sql_yacc.yy"
    {
            int key_part_len= atoi((yyvsp[(3) - (4)].lex_str).str);
            if (!key_part_len)
            {
              my_error(ER_KEY_PART_0, MYF(0), (yyvsp[(1) - (4)].lex_str).str);
            }
            (yyval.key_part)=new Key_part_spec((yyvsp[(1) - (4)].lex_str), (uint) key_part_len);
          }
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 2075 "sql_yacc.yy"
    { (yyval.lex_str)= null_lex_str; }
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 2076 "sql_yacc.yy"
    { (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str); }
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 2080 "sql_yacc.yy"
    { (yyval.lex_str)= null_lex_str; }
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 2081 "sql_yacc.yy"
    { (yyval.lex_str)= (yyvsp[(2) - (2)].lex_str); }
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 2085 "sql_yacc.yy"
    { Lex->interval_list.push_back((yyvsp[(1) - (1)].string)); }
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 2086 "sql_yacc.yy"
    { Lex->interval_list.push_back((yyvsp[(3) - (3)].string)); }
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 2094 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            lex->name.str= 0;
            lex->name.length= 0;
            lex->sql_command= SQLCOM_ALTER_TABLE;
            statement::AlterTable *statement= new(std::nothrow) statement::AlterTable(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->duplicates= DUP_ERROR;
            if (!lex->select_lex.add_table_to_list(session, (yyvsp[(5) - (5)].table), NULL,
                                                   TL_OPTION_UPDATING))
              DRIZZLE_YYABORT;
            lex->col_list.empty();
            lex->select_lex.init_order();
            lex->select_lex.db=
              ((TableList*) lex->select_lex.table_list.first)->db;
            statement->create_info.row_type= ROW_TYPE_NOT_USED;
            statement->alter_info.build_method= (yyvsp[(2) - (5)].build_method);
          }
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 2116 "sql_yacc.yy"
    {}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 2118 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->statement= new(std::nothrow) statement::AlterSchema(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 2126 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->name= (yyvsp[(3) - (5)].lex_str);
            if (lex->name.str == NULL &&
                lex->copy_db_to(&lex->name.str, &lex->name.length))
              DRIZZLE_YYABORT;
          }
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 2136 "sql_yacc.yy"
    { (yyval.lex_str).str= 0; (yyval.lex_str).length= 0; }
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 2137 "sql_yacc.yy"
    { (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str); }
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 2143 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            statement->alter_info.tablespace_op= DISCARD_TABLESPACE;
          }
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 2148 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            statement->alter_info.tablespace_op= IMPORT_TABLESPACE;
          }
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 2157 "sql_yacc.yy"
    {
            (yyval.build_method)= HA_BUILD_DEFAULT;
          }
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 2161 "sql_yacc.yy"
    {
            (yyval.build_method)= HA_BUILD_ONLINE;
          }
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 2165 "sql_yacc.yy"
    {
            (yyval.build_method)= HA_BUILD_OFFLINE;
          }
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 2177 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->change=0;
            statement->alter_info.flags.set(ALTER_ADD_COLUMN);
          }
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 2186 "sql_yacc.yy"
    { }
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 2188 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.flags.set(ALTER_ADD_INDEX);
          }
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 2194 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.flags.set(ALTER_ADD_COLUMN);
            statement->alter_info.flags.set(ALTER_ADD_INDEX);
          }
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 2201 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            statement->change= (yyvsp[(3) - (3)].lex_str).str;
            statement->alter_info.flags.set(ALTER_CHANGE_COLUMN);
          }
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 2208 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            lex->length=lex->dec=0; lex->type=0;
            statement->default_value= statement->on_update_value= 0;
            statement->comment= null_lex_str;
            lex->charset= NULL;
            statement->alter_info.flags.set(ALTER_CHANGE_COLUMN);
            statement->column_format= COLUMN_FORMAT_TYPE_DEFAULT;

            statement->current_proto_field= NULL;
          }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 2221 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            if (add_field_to_list(lex->session,&(yyvsp[(3) - (5)].lex_str),
                                  (enum enum_field_types) (yyvsp[(5) - (5)].num),
                                  lex->length, lex->dec, lex->type,
                                  statement->column_format,
                                  statement->default_value,
                                  statement->on_update_value,
                                  &statement->comment,
                                  (yyvsp[(3) - (5)].lex_str).str, &lex->interval_list, lex->charset))
              DRIZZLE_YYABORT;
          }
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 2237 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.drop_list.push_back(new AlterDrop(AlterDrop::COLUMN, (yyvsp[(3) - (3)].lex_str).str));
            statement->alter_info.flags.set(ALTER_DROP_COLUMN);
          }
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 2244 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.flags.set(ALTER_DROP_INDEX);
            statement->alter_info.flags.set(ALTER_FOREIGN_KEY);
          }
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 2251 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.drop_list.push_back(new AlterDrop(AlterDrop::KEY,
                                                               "PRIMARY"));
            statement->alter_info.flags.set(ALTER_DROP_INDEX);
          }
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 2259 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.drop_list.push_back(new AlterDrop(AlterDrop::KEY,
                                                                    (yyvsp[(3) - (3)].lex_str).str));
            statement->alter_info.flags.set(ALTER_DROP_INDEX);
          }
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 2267 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.keys_onoff= DISABLE;
            statement->alter_info.flags.set(ALTER_KEYS_ONOFF);
          }
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 2274 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.keys_onoff= ENABLE;
            statement->alter_info.flags.set(ALTER_KEYS_ONOFF);
          }
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 2281 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.alter_list.push_back(new AlterColumn((yyvsp[(3) - (6)].lex_str).str,(yyvsp[(6) - (6)].item)));
            statement->alter_info.flags.set(ALTER_COLUMN_DEFAULT);
          }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 2288 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.alter_list.push_back(new AlterColumn((yyvsp[(3) - (5)].lex_str).str, (Item*) 0));
            statement->alter_info.flags.set(ALTER_COLUMN_DEFAULT);
          }
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 2295 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
            size_t dummy;

            lex->select_lex.db=(yyvsp[(3) - (3)].table)->db.str;
            if (lex->select_lex.db == NULL &&
                lex->copy_db_to(&lex->select_lex.db, &dummy))
            {
              DRIZZLE_YYABORT;
            }

            if (check_table_name((yyvsp[(3) - (3)].table)->table.str,(yyvsp[(3) - (3)].table)->table.length))
            {
              my_error(ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[(3) - (3)].table)->table.str);
              DRIZZLE_YYABORT;
            }

            lex->name= (yyvsp[(3) - (3)].table)->table;
            statement->alter_info.flags.set(ALTER_RENAME);
          }
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 2317 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->create_info.table_charset=
            statement->create_info.default_table_charset= (yyvsp[(3) - (3)].charset);
            statement->create_info.used_fields|= (HA_CREATE_USED_CHARSET |
              HA_CREATE_USED_DEFAULT_CHARSET);
            statement->alter_info.flags.set(ALTER_CONVERT);
          }
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 2327 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.flags.set(ALTER_OPTIONS);
          }
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 2333 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.flags.set(ALTER_FORCE);
          }
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 2339 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            statement->alter_info.flags.set(ALTER_ORDER);
          }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 2347 "sql_yacc.yy"
    {}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 2348 "sql_yacc.yy"
    {}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 2352 "sql_yacc.yy"
    { Lex->ignore= 0;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 2353 "sql_yacc.yy"
    { Lex->ignore= 1;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 2357 "sql_yacc.yy"
    {}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 2359 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            store_position_for_column((yyvsp[(2) - (2)].lex_str).str);
            statement->alter_info.flags.set(ALTER_COLUMN_ORDER);
          }
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 2366 "sql_yacc.yy"
    {
            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;

            store_position_for_column(first_keyword);
            statement->alter_info.flags.set(ALTER_COLUMN_ORDER);
          }
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 2375 "sql_yacc.yy"
    {}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 2376 "sql_yacc.yy"
    {}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 2377 "sql_yacc.yy"
    {}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 2378 "sql_yacc.yy"
    {}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 2383 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            lex->statement= new(std::nothrow) statement::StartTransaction(YYSession, (start_transaction_option_t)(yyvsp[(3) - (3)].num));
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 2393 "sql_yacc.yy"
    { (yyval.num) = START_TRANS_NO_OPTIONS; }
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 2395 "sql_yacc.yy"
    {
            (yyval.num)= START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 2402 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->statement= new(std::nothrow) statement::Analyze(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 2410 "sql_yacc.yy"
    {}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 2415 "sql_yacc.yy"
    {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->statement= new(std::nothrow) statement::Check(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 2424 "sql_yacc.yy"
    {}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 2429 "sql_yacc.yy"
    {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            Lex->statement= new(std::nothrow) statement::RenameTable(YYSession);
            if (Lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 2436 "sql_yacc.yy"
    {}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 2446 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            Select_Lex *sl= lex->current_select;
            if (!sl->add_table_to_list(lex->session, (yyvsp[(1) - (3)].table),NULL,TL_OPTION_UPDATING,
                                       TL_IGNORE) ||
                !sl->add_table_to_list(lex->session, (yyvsp[(3) - (3)].table),NULL,TL_OPTION_UPDATING,
                                       TL_IGNORE))
              DRIZZLE_YYABORT;
          }
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 2464 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SELECT;
            lex->statement= new(std::nothrow) statement::Select(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 2481 "sql_yacc.yy"
    {
            if (setup_select_in_parentheses(Lex))
              DRIZZLE_YYABORT;
          }
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 2491 "sql_yacc.yy"
    {
            if (setup_select_in_parentheses(Lex))
              DRIZZLE_YYABORT;
          }
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 2500 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            Select_Lex * sel= lex->current_select;
            if (lex->current_select->set_braces(0))
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            if (sel->linkage == UNION_TYPE &&
                sel->master_unit()->first_select()->braces)
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 2519 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            Select_Lex *sel= lex->current_select;
            if (sel->linkage != UNION_TYPE)
              mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
          }
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 2527 "sql_yacc.yy"
    {
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 2534 "sql_yacc.yy"
    {}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2544 "sql_yacc.yy"
    {
            Lex->current_select->context.table_list=
              Lex->current_select->context.first_name_resolution_table=
                reinterpret_cast<TableList *>(Lex->current_select->table_list.first);
          }
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2554 "sql_yacc.yy"
    {
            if (Lex->current_select->options & SELECT_DISTINCT &&
                Lex->current_select->options & SELECT_ALL)
            {
              my_error(ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT");
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2570 "sql_yacc.yy"
    { Lex->current_select->options|= SELECT_STRAIGHT_JOIN; }
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2571 "sql_yacc.yy"
    { Lex->current_select->options|= SELECT_DISTINCT; }
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2572 "sql_yacc.yy"
    { Lex->current_select->options|= SELECT_SMALL_RESULT; }
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2573 "sql_yacc.yy"
    { Lex->current_select->options|= SELECT_BIG_RESULT; }
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2575 "sql_yacc.yy"
    {
            if (check_simple_select())
              DRIZZLE_YYABORT;
            Lex->current_select->options|= OPTION_BUFFER_RESULT;
          }
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2581 "sql_yacc.yy"
    {
            if (check_simple_select())
              DRIZZLE_YYABORT;
            Lex->current_select->options|= OPTION_FOUND_ROWS;
          }
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2586 "sql_yacc.yy"
    { Lex->current_select->options|= SELECT_ALL; }
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2592 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->current_select->set_lock_for_tables(TL_WRITE);
          }
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2597 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->current_select->
              set_lock_for_tables(TL_READ_WITH_SHARED_LOCKS);
          }
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2608 "sql_yacc.yy"
    {
            Session *session= YYSession;
            if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                          context,
                                                          NULL, NULL, "*")))
              DRIZZLE_YYABORT;
            (session->lex->current_select->with_wild)++;
          }
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2620 "sql_yacc.yy"
    {
            Session *session= YYSession;

            if (session->add_item_to_list((yyvsp[(2) - (3)].item)))
              DRIZZLE_YYABORT;
          }
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2627 "sql_yacc.yy"
    {
            Session *session= YYSession;
            assert((yyvsp[(1) - (4)].simple_string) < (yyvsp[(3) - (4)].simple_string));

            if (session->add_item_to_list((yyvsp[(2) - (4)].item)))
              DRIZZLE_YYABORT;
            if ((yyvsp[(4) - (4)].lex_str).str)
            {
              (yyvsp[(2) - (4)].item)->is_autogenerated_name= false;
              (yyvsp[(2) - (4)].item)->set_name((yyvsp[(4) - (4)].lex_str).str, (yyvsp[(4) - (4)].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[(2) - (4)].item)->name)
            {
              (yyvsp[(2) - (4)].item)->set_name((yyvsp[(1) - (4)].simple_string), (uint) ((yyvsp[(3) - (4)].simple_string) - (yyvsp[(1) - (4)].simple_string)), session->charset());
            }
          }
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2646 "sql_yacc.yy"
    {
            Session *session= YYSession;
            Lex_input_stream *lip= session->m_lip;
            (yyval.simple_string)= (char*) lip->get_cpp_tok_start();
          }
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2654 "sql_yacc.yy"
    {
            Session *session= YYSession;
            Lex_input_stream *lip= session->m_lip;
            (yyval.simple_string)= (char*) lip->get_cpp_tok_end();
          }
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2662 "sql_yacc.yy"
    { (yyval.lex_str)=null_lex_str;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2663 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(2) - (2)].lex_str); }
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2664 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(2) - (2)].lex_str); }
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2665 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str); }
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2666 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str); }
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2670 "sql_yacc.yy"
    {}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2671 "sql_yacc.yy"
    {}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2677 "sql_yacc.yy"
    {
            /*
              Design notes:
              Do not use a manually maintained stack like session->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[(1) - (3)].item)))
            {
              item1= (Item_cond_or*) (yyvsp[(1) - (3)].item);
              if (is_cond_or((yyvsp[(3) - (3)].item)))
              {
                item3= (Item_cond_or*) (yyvsp[(3) - (3)].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[(3) - (3)].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[(3) - (3)].item));
                (yyval.item) = (yyvsp[(1) - (3)].item);
              }
            }
            else if (is_cond_or((yyvsp[(3) - (3)].item)))
            {
              item3= (Item_cond_or*) (yyvsp[(3) - (3)].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[(1) - (3)].item));
              (yyval.item) = (yyvsp[(3) - (3)].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item) = new (YYSession->mem_root) Item_cond_or((yyvsp[(1) - (3)].item), (yyvsp[(3) - (3)].item));
            }
          }
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2726 "sql_yacc.yy"
    {
            /* XOR is a proprietary extension */
            (yyval.item) = new (YYSession->mem_root) Item_cond_xor((yyvsp[(1) - (3)].item), (yyvsp[(3) - (3)].item));
          }
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2731 "sql_yacc.yy"
    {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[(1) - (3)].item)))
            {
              item1= (Item_cond_and*) (yyvsp[(1) - (3)].item);
              if (is_cond_and((yyvsp[(3) - (3)].item)))
              {
                item3= (Item_cond_and*) (yyvsp[(3) - (3)].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[(3) - (3)].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[(3) - (3)].item));
                (yyval.item) = (yyvsp[(1) - (3)].item);
              }
            }
            else if (is_cond_and((yyvsp[(3) - (3)].item)))
            {
              item3= (Item_cond_and*) (yyvsp[(3) - (3)].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[(1) - (3)].item));
              (yyval.item) = (yyvsp[(3) - (3)].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item) = new (YYSession->mem_root) Item_cond_and((yyvsp[(1) - (3)].item), (yyvsp[(3) - (3)].item));
            }
          }
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2772 "sql_yacc.yy"
    { (yyval.item)= negate_expression(YYSession, (yyvsp[(2) - (2)].item)); }
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2774 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_istrue((yyvsp[(1) - (3)].item)); }
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2776 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_isnottrue((yyvsp[(1) - (4)].item)); }
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2778 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_isfalse((yyvsp[(1) - (3)].item)); }
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2780 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_isnotfalse((yyvsp[(1) - (4)].item)); }
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2782 "sql_yacc.yy"
    { (yyval.item)= new Item_func_isnull((yyvsp[(1) - (3)].item)); }
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2784 "sql_yacc.yy"
    { (yyval.item)= new Item_func_isnotnull((yyvsp[(1) - (4)].item)); }
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2790 "sql_yacc.yy"
    { (yyval.item)= new Item_func_isnull((yyvsp[(1) - (3)].item)); }
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2792 "sql_yacc.yy"
    { (yyval.item)= new Item_func_isnotnull((yyvsp[(1) - (4)].item)); }
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2794 "sql_yacc.yy"
    { (yyval.item)= new Item_func_equal((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2796 "sql_yacc.yy"
    { (yyval.item)= (*(yyvsp[(2) - (3)].boolfunc2creator))(0)->create((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2798 "sql_yacc.yy"
    { (yyval.item)= all_any_subquery_creator((yyvsp[(1) - (6)].item), (yyvsp[(2) - (6)].boolfunc2creator), (yyvsp[(3) - (6)].num), (yyvsp[(5) - (6)].select_lex)); }
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2804 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_in_subselect((yyvsp[(1) - (5)].item), (yyvsp[(4) - (5)].select_lex));
          }
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2808 "sql_yacc.yy"
    {
            Session *session= YYSession;
            Item *item= new (session->mem_root) Item_in_subselect((yyvsp[(1) - (6)].item), (yyvsp[(5) - (6)].select_lex));
            (yyval.item)= negate_expression(session, item);
          }
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2814 "sql_yacc.yy"
    {
            (yyval.item)= handle_sql2003_note184_exception(YYSession, (yyvsp[(1) - (5)].item), true, (yyvsp[(4) - (5)].item));
          }
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2818 "sql_yacc.yy"
    {
            (yyvsp[(6) - (7)].item_list)->push_front((yyvsp[(4) - (7)].item));
            (yyvsp[(6) - (7)].item_list)->push_front((yyvsp[(1) - (7)].item));
            (yyval.item)= new (YYSession->mem_root) Item_func_in(*(yyvsp[(6) - (7)].item_list));
          }
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2824 "sql_yacc.yy"
    {
            (yyval.item)= handle_sql2003_note184_exception(YYSession, (yyvsp[(1) - (6)].item), false, (yyvsp[(5) - (6)].item));
          }
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2828 "sql_yacc.yy"
    {
            (yyvsp[(7) - (8)].item_list)->push_front((yyvsp[(5) - (8)].item));
            (yyvsp[(7) - (8)].item_list)->push_front((yyvsp[(1) - (8)].item));
            Item_func_in *item = new (YYSession->mem_root) Item_func_in(*(yyvsp[(7) - (8)].item_list));
            item->negate();
            (yyval.item)= item;
          }
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2836 "sql_yacc.yy"
    { (yyval.item)= new Item_func_between((yyvsp[(1) - (5)].item),(yyvsp[(3) - (5)].item),(yyvsp[(5) - (5)].item)); }
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2838 "sql_yacc.yy"
    {
            Item_func_between *item= new Item_func_between((yyvsp[(1) - (6)].item),(yyvsp[(4) - (6)].item),(yyvsp[(6) - (6)].item));
            item->negate();
            (yyval.item)= item;
          }
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2844 "sql_yacc.yy"
    { (yyval.item)= new Item_func_like((yyvsp[(1) - (4)].item),(yyvsp[(3) - (4)].item),(yyvsp[(4) - (4)].item),Lex->escape_used); }
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2846 "sql_yacc.yy"
    { (yyval.item)= new Item_func_not(new Item_func_like((yyvsp[(1) - (5)].item),(yyvsp[(4) - (5)].item),(yyvsp[(5) - (5)].item), Lex->escape_used)); }
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2852 "sql_yacc.yy"
    { (yyval.item)= new Item_func_plus((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2854 "sql_yacc.yy"
    { (yyval.item)= new Item_func_minus((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2856 "sql_yacc.yy"
    { (yyval.item)= new Item_date_add_interval((yyvsp[(1) - (5)].item),(yyvsp[(4) - (5)].item),(yyvsp[(5) - (5)].interval),0); }
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2858 "sql_yacc.yy"
    { (yyval.item)= new Item_date_add_interval((yyvsp[(1) - (5)].item),(yyvsp[(4) - (5)].item),(yyvsp[(5) - (5)].interval),1); }
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2860 "sql_yacc.yy"
    { (yyval.item)= new Item_func_mul((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2862 "sql_yacc.yy"
    { (yyval.item)= new Item_func_div((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2864 "sql_yacc.yy"
    { (yyval.item)= new Item_func_mod((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2866 "sql_yacc.yy"
    { (yyval.item)= new Item_func_int_div((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2868 "sql_yacc.yy"
    { (yyval.item)= new Item_func_mod((yyvsp[(1) - (3)].item),(yyvsp[(3) - (3)].item)); }
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2885 "sql_yacc.yy"
    { (yyval.boolfunc2creator) = &comp_eq_creator; }
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2886 "sql_yacc.yy"
    { (yyval.boolfunc2creator) = &comp_ge_creator; }
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2887 "sql_yacc.yy"
    { (yyval.boolfunc2creator) = &comp_gt_creator; }
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2888 "sql_yacc.yy"
    { (yyval.boolfunc2creator) = &comp_le_creator; }
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2889 "sql_yacc.yy"
    { (yyval.boolfunc2creator) = &comp_lt_creator; }
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2890 "sql_yacc.yy"
    { (yyval.boolfunc2creator) = &comp_ne_creator; }
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2894 "sql_yacc.yy"
    { (yyval.num) = 1; }
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2895 "sql_yacc.yy"
    { (yyval.num) = 0; }
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2905 "sql_yacc.yy"
    {
            Session *session= YYSession;
            Item *i1= new (session->mem_root) Item_string((yyvsp[(3) - (3)].lex_str).str,
                                                      (yyvsp[(3) - (3)].lex_str).length,
                                                      session->charset());
            (yyval.item)= new (session->mem_root) Item_func_set_collation((yyvsp[(1) - (3)].item), i1);
          }
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2915 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(2) - (2)].item); }
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2917 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_neg((yyvsp[(2) - (2)].item)); }
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2919 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_singlerow_subselect((yyvsp[(2) - (3)].select_lex));
          }
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2922 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(2) - (3)].item); }
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2924 "sql_yacc.yy"
    {
            (yyvsp[(4) - (5)].item_list)->push_front((yyvsp[(2) - (5)].item));
            (yyval.item)= new (YYSession->mem_root) Item_row(*(yyvsp[(4) - (5)].item_list));
          }
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2929 "sql_yacc.yy"
    {
            (yyvsp[(5) - (6)].item_list)->push_front((yyvsp[(3) - (6)].item));
            (yyval.item)= new (YYSession->mem_root) Item_row(*(yyvsp[(5) - (6)].item_list));
          }
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2934 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_exists_subselect((yyvsp[(3) - (4)].select_lex));
          }
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2937 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(3) - (4)].item); }
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2939 "sql_yacc.yy"
    {
            (yyval.item)= create_func_cast(YYSession, (yyvsp[(2) - (2)].item), ITEM_CAST_CHAR, NULL, NULL,
                                 &my_charset_bin);
          }
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2944 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            (yyval.item)= create_func_cast(YYSession, (yyvsp[(3) - (6)].item), (yyvsp[(5) - (6)].cast_type), lex->length, lex->dec,
                                 lex->charset);
            if (!(yyval.item))
              DRIZZLE_YYABORT;
          }
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2952 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_case(* (yyvsp[(3) - (5)].item_list), (yyvsp[(2) - (5)].item), (yyvsp[(4) - (5)].item) ); }
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2954 "sql_yacc.yy"
    {
            (yyval.item)= create_func_cast(YYSession, (yyvsp[(3) - (6)].item), (yyvsp[(5) - (6)].cast_type), Lex->length, Lex->dec,
                                 Lex->charset);
            if (!(yyval.item))
              DRIZZLE_YYABORT;
          }
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2961 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_default_value(Lex->current_context(),
                                                         (yyvsp[(3) - (4)].item));
          }
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2966 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_insert_value(Lex->current_context(),
                                                        (yyvsp[(3) - (4)].item));
          }
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2972 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(5) - (5)].item),(yyvsp[(2) - (5)].item),(yyvsp[(3) - (5)].interval),0); }
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2983 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_char(*(yyvsp[(3) - (4)].item_list)); }
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2985 "sql_yacc.yy"
    {
            std::string user_str("user");
            if (! ((yyval.item)= reserved_keyword_function(user_str, NULL)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2993 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_typecast((yyvsp[(3) - (4)].item)); }
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2995 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_dayofmonth((yyvsp[(3) - (4)].item)); }
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2997 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_hour((yyvsp[(3) - (4)].item)); }
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2999 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_insert((yyvsp[(3) - (10)].item),(yyvsp[(5) - (10)].item),(yyvsp[(7) - (10)].item),(yyvsp[(9) - (10)].item)); }
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 3001 "sql_yacc.yy"
    {
            Session *session= YYSession;
            List<Item> *list= new (session->mem_root) List<Item>;
            list->push_front((yyvsp[(5) - (6)].item));
            list->push_front((yyvsp[(3) - (6)].item));
            Item_row *item= new (session->mem_root) Item_row(*list);
            (yyval.item)= new (session->mem_root) Item_func_interval(item);
          }
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 3010 "sql_yacc.yy"
    {
            Session *session= YYSession;
            (yyvsp[(7) - (8)].item_list)->push_front((yyvsp[(5) - (8)].item));
            (yyvsp[(7) - (8)].item_list)->push_front((yyvsp[(3) - (8)].item));
            Item_row *item= new (session->mem_root) Item_row(*(yyvsp[(7) - (8)].item_list));
            (yyval.item)= new (session->mem_root) Item_func_interval(item);
          }
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 3018 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_left((yyvsp[(3) - (6)].item),(yyvsp[(5) - (6)].item)); }
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 3020 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_minute((yyvsp[(3) - (4)].item)); }
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 3022 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_month((yyvsp[(3) - (4)].item)); }
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 3024 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_right((yyvsp[(3) - (6)].item),(yyvsp[(5) - (6)].item)); }
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 3026 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_second((yyvsp[(3) - (4)].item)); }
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 3028 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_datetime_typecast((yyvsp[(3) - (4)].item)); }
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 3030 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_trim((yyvsp[(3) - (4)].item)); }
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 3032 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_ltrim((yyvsp[(6) - (7)].item),(yyvsp[(4) - (7)].item)); }
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 3034 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_rtrim((yyvsp[(6) - (7)].item),(yyvsp[(4) - (7)].item)); }
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 3036 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_trim((yyvsp[(6) - (7)].item),(yyvsp[(4) - (7)].item)); }
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 3038 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_ltrim((yyvsp[(5) - (6)].item)); }
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 3040 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_rtrim((yyvsp[(5) - (6)].item)); }
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 3042 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_trim((yyvsp[(5) - (6)].item)); }
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 3044 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_trim((yyvsp[(5) - (6)].item),(yyvsp[(3) - (6)].item)); }
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 3046 "sql_yacc.yy"
    {
            std::string user_str("user");
            if (! ((yyval.item)= reserved_keyword_function(user_str, NULL)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 3054 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_year((yyvsp[(3) - (4)].item)); }
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 3070 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(3) - (6)].item), (yyvsp[(5) - (6)].item),
                                                             INTERVAL_DAY, 0);
          }
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 3075 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(3) - (8)].item), (yyvsp[(6) - (8)].item), (yyvsp[(7) - (8)].interval), 0); }
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 3077 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_func_curdate_local();
          }
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 3081 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(3) - (8)].item),(yyvsp[(6) - (8)].item),(yyvsp[(7) - (8)].interval),0); }
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 3083 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(3) - (8)].item),(yyvsp[(6) - (8)].item),(yyvsp[(7) - (8)].interval),1); }
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 3085 "sql_yacc.yy"
    { (yyval.item)=new (YYSession->mem_root) Item_extract( (yyvsp[(3) - (6)].interval), (yyvsp[(5) - (6)].item)); }
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 3087 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_func_now_local();
          }
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 3091 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_func_now_local((yyvsp[(3) - (4)].item));
          }
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 3095 "sql_yacc.yy"
    { (yyval.item) = new (YYSession->mem_root) Item_func_locate((yyvsp[(5) - (6)].item),(yyvsp[(3) - (6)].item)); }
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 3097 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(3) - (6)].item), (yyvsp[(5) - (6)].item),
                                                             INTERVAL_DAY, 1);
          }
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 3102 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(3) - (8)].item), (yyvsp[(6) - (8)].item), (yyvsp[(7) - (8)].interval), 1); }
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 3104 "sql_yacc.yy"
    {
            std::string reverse_str("substr");
            List<Item> *args= new (YYSession->mem_root) List<Item>;
            args->push_back((yyvsp[(3) - (8)].item));
            args->push_back((yyvsp[(5) - (8)].item));
            args->push_back((yyvsp[(7) - (8)].item));
            if (! ((yyval.item)= reserved_keyword_function(reverse_str, args)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 3116 "sql_yacc.yy"
    {
            std::string reverse_str("substr");
            List<Item> *args= new (YYSession->mem_root) List<Item>;
            args->push_back((yyvsp[(3) - (6)].item));
            args->push_back((yyvsp[(5) - (6)].item));
            if (! ((yyval.item)= reserved_keyword_function(reverse_str, args)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 3127 "sql_yacc.yy"
    {
            std::string reverse_str("substr");
            List<Item> *args= new (YYSession->mem_root) List<Item>;
            args->push_back((yyvsp[(3) - (8)].item));
            args->push_back((yyvsp[(5) - (8)].item));
            args->push_back((yyvsp[(7) - (8)].item));
            if (! ((yyval.item)= reserved_keyword_function(reverse_str, args)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 3139 "sql_yacc.yy"
    {
            std::string reverse_str("substr");
            List<Item> *args= new (YYSession->mem_root) List<Item>;
            args->push_back((yyvsp[(3) - (6)].item));
            args->push_back((yyvsp[(5) - (6)].item));
            if (! ((yyval.item)= reserved_keyword_function(reverse_str, args)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 3150 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_sysdate_local(); }
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 3152 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_sysdate_local((yyvsp[(3) - (4)].item)); }
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 3154 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_date_add_interval((yyvsp[(7) - (8)].item),(yyvsp[(5) - (8)].item),(yyvsp[(3) - (8)].interval_time_st),0); }
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 3156 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_timestamp_diff((yyvsp[(5) - (8)].item),(yyvsp[(7) - (8)].item),(yyvsp[(3) - (8)].interval_time_st)); }
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 3158 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_func_curdate_utc();
          }
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 3162 "sql_yacc.yy"
    {
            (yyval.item)= new (YYSession->mem_root) Item_func_now_utc();
          }
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 3174 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_coalesce(* (yyvsp[(3) - (4)].item_list)); }
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 3176 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_collation((yyvsp[(3) - (4)].item)); }
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 3178 "sql_yacc.yy"
    {
            std::string database_str("database");
            if (! ((yyval.item)= reserved_keyword_function(database_str, NULL)))
            {
              DRIZZLE_YYABORT;
            }
	  }
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 3186 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_if((yyvsp[(3) - (8)].item),(yyvsp[(5) - (8)].item),(yyvsp[(7) - (8)].item)); }
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 3188 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_microsecond((yyvsp[(3) - (4)].item)); }
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 3190 "sql_yacc.yy"
    { (yyval.item) = new (YYSession->mem_root) Item_func_mod( (yyvsp[(3) - (6)].item), (yyvsp[(5) - (6)].item)); }
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 3192 "sql_yacc.yy"
    { (yyval.item) = new (YYSession->mem_root) Item_func_quarter((yyvsp[(3) - (4)].item)); }
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 3194 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_repeat((yyvsp[(3) - (6)].item),(yyvsp[(5) - (6)].item)); }
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 3196 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_replace((yyvsp[(3) - (8)].item),(yyvsp[(5) - (8)].item),(yyvsp[(7) - (8)].item)); }
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 3198 "sql_yacc.yy"
    {
            std::string reverse_str("reverse");
            List<Item> *args= new (YYSession->mem_root) List<Item>;
            args->push_back((yyvsp[(3) - (4)].item));
            if (! ((yyval.item)= reserved_keyword_function(reverse_str, args)))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 3208 "sql_yacc.yy"
    { (yyval.item)= new (YYSession->mem_root) Item_func_round((yyvsp[(3) - (6)].item),(yyvsp[(5) - (6)].item),1); }
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 3221 "sql_yacc.yy"
    {
            const plugin::Function *udf= plugin::Function::get((yyvsp[(1) - (2)].lex_str).str, (yyvsp[(1) - (2)].lex_str).length);

            /* Temporary placing the result of getFunction in $3 */
            (yyval.udf)= udf;
          }
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 3228 "sql_yacc.yy"
    {
            Session *session= YYSession;
            Create_func *builder;
            Item *item= NULL;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= find_native_function_builder((yyvsp[(1) - (5)].lex_str));
            if (builder)
            {
              item= builder->create(session, (yyvsp[(1) - (5)].lex_str), (yyvsp[(4) - (5)].item_list));
            }
            else
            {
              /* Retrieving the result of service::Function::get */
              const plugin::Function *udf= (yyvsp[(3) - (5)].udf);
              if (udf)
              {
                item= Create_udf_func::s_singleton.create(session, udf, (yyvsp[(4) - (5)].item_list));
              } else {
                /* fix for bug 250065, from Andrew Garner <muzazzi@gmail.com> */
                my_error(ER_SP_DOES_NOT_EXIST, MYF(0), "FUNCTION", (yyvsp[(1) - (5)].lex_str).str);
              }
            }

            if (! ((yyval.item)= item))
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 3268 "sql_yacc.yy"
    { (yyval.item_list)= NULL; }
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 3269 "sql_yacc.yy"
    { (yyval.item_list)= (yyvsp[(1) - (1)].item_list); }
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 3274 "sql_yacc.yy"
    {
            (yyval.item_list)= new (YYSession->mem_root) List<Item>;
            (yyval.item_list)->push_back((yyvsp[(1) - (1)].item));
          }
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 3279 "sql_yacc.yy"
    {
            (yyvsp[(1) - (3)].item_list)->push_back((yyvsp[(3) - (3)].item));
            (yyval.item_list)= (yyvsp[(1) - (3)].item_list);
          }
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 3287 "sql_yacc.yy"
    {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[(4) - (4)].lex_str).str)
            {
              (yyvsp[(2) - (4)].item)->is_autogenerated_name= false;
              (yyvsp[(2) - (4)].item)->set_name((yyvsp[(4) - (4)].lex_str).str, (yyvsp[(4) - (4)].lex_str).length, system_charset_info);
            }
            else
              (yyvsp[(2) - (4)].item)->set_name((yyvsp[(1) - (4)].simple_string), (uint) ((yyvsp[(3) - (4)].simple_string) - (yyvsp[(1) - (4)].simple_string)), YYSession->charset());
            (yyval.item)= (yyvsp[(2) - (4)].item);
          }
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 3307 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_avg((yyvsp[(3) - (4)].item)); }
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 3309 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_avg_distinct((yyvsp[(4) - (5)].item)); }
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 3311 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_count(new Item_int((int32_t) 0L,1)); }
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 3313 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_count((yyvsp[(3) - (4)].item)); }
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 3315 "sql_yacc.yy"
    { Lex->current_select->in_sum_expr++; }
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 3317 "sql_yacc.yy"
    { Lex->current_select->in_sum_expr--; }
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 3319 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_count_distinct(* (yyvsp[(5) - (7)].item_list)); }
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 3321 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_min((yyvsp[(3) - (4)].item)); }
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 3328 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_min((yyvsp[(4) - (5)].item)); }
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 3330 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_max((yyvsp[(3) - (4)].item)); }
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 3332 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_max((yyvsp[(4) - (5)].item)); }
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 3334 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_std((yyvsp[(3) - (4)].item), 0); }
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 3336 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_variance((yyvsp[(3) - (4)].item), 0); }
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3338 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_std((yyvsp[(3) - (4)].item), 1); }
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3340 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_variance((yyvsp[(3) - (4)].item), 1); }
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3342 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_sum((yyvsp[(3) - (4)].item)); }
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3344 "sql_yacc.yy"
    { (yyval.item)=new Item_sum_sum_distinct((yyvsp[(4) - (5)].item)); }
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3346 "sql_yacc.yy"
    { Lex->current_select->in_sum_expr++; }
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3350 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->in_sum_expr--;
            (yyval.item)=new Item_func_group_concat(Lex->current_context(), (yyvsp[(3) - (8)].num), (yyvsp[(5) - (8)].item_list),
                                          sel->gorder_list, (yyvsp[(7) - (8)].string));
            (yyvsp[(5) - (8)].item_list)->empty();
          }
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3361 "sql_yacc.yy"
    { }
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3363 "sql_yacc.yy"
    {
            (yyval.item)= (yyvsp[(3) - (3)].item);
          }
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3370 "sql_yacc.yy"
    {
            (yyval.item)= new Item_func_set_user_var((yyvsp[(1) - (3)].lex_str), (yyvsp[(3) - (3)].item));
          }
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3374 "sql_yacc.yy"
    {
            (yyval.item)= new Item_func_get_user_var((yyvsp[(1) - (1)].lex_str));
          }
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3378 "sql_yacc.yy"
    {
            /* disallow "SELECT @@global.global.variable" */
            if ((yyvsp[(3) - (4)].lex_str).str && (yyvsp[(4) - (4)].lex_str).str && check_reserved_words(&(yyvsp[(3) - (4)].lex_str)))
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            if (!((yyval.item)= get_system_var(YYSession, (yyvsp[(2) - (4)].var_type), (yyvsp[(3) - (4)].lex_str), (yyvsp[(4) - (4)].lex_str))))
              DRIZZLE_YYABORT;
          }
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3391 "sql_yacc.yy"
    { (yyval.num) = 0; }
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3392 "sql_yacc.yy"
    { (yyval.num) = 1; }
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3397 "sql_yacc.yy"
    {
              (yyval.string)= new (YYSession->mem_root) String(",", 1, &my_charset_utf8_general_ci);
            }
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3400 "sql_yacc.yy"
    { (yyval.string) = (yyvsp[(2) - (2)].string); }
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3405 "sql_yacc.yy"
    {
            Lex->current_select->gorder_list = NULL;
          }
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3409 "sql_yacc.yy"
    {
            Select_Lex *select= Lex->current_select;
            select->gorder_list=
              (SQL_LIST*) memory::sql_memdup((char*) &select->order_list,
                                     sizeof(st_sql_list));
            select->order_list.empty();
          }
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3420 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if (lex->current_select->inc_in_sum_expr())
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3429 "sql_yacc.yy"
    {
            Lex->current_select->in_sum_expr--;
            (yyval.item)= (yyvsp[(3) - (3)].item);
          }
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3437 "sql_yacc.yy"
    { (yyval.cast_type)=ITEM_CAST_CHAR; Lex->charset= &my_charset_bin; Lex->dec= 0; }
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3439 "sql_yacc.yy"
    { (yyval.cast_type)=ITEM_CAST_CHAR; Lex->dec= 0; }
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3441 "sql_yacc.yy"
    { (yyval.cast_type)=ITEM_CAST_DATE; Lex->charset= NULL; Lex->dec=Lex->length= (char*)0; }
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3443 "sql_yacc.yy"
    { (yyval.cast_type)=ITEM_CAST_DATETIME; Lex->charset= NULL; Lex->dec=Lex->length= (char*)0; }
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3445 "sql_yacc.yy"
    { (yyval.cast_type)=ITEM_CAST_DECIMAL; Lex->charset= NULL; }
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3450 "sql_yacc.yy"
    {
            (yyval.item_list)= new (YYSession->mem_root) List<Item>;
            (yyval.item_list)->push_back((yyvsp[(1) - (1)].item));
          }
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3455 "sql_yacc.yy"
    {
            (yyvsp[(1) - (3)].item_list)->push_back((yyvsp[(3) - (3)].item));
            (yyval.item_list)= (yyvsp[(1) - (3)].item_list);
          }
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3462 "sql_yacc.yy"
    { (yyval.item)= NULL; }
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3463 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(1) - (1)].item); }
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3467 "sql_yacc.yy"
    { (yyval.item)= NULL; }
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3468 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(2) - (2)].item); }
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3473 "sql_yacc.yy"
    {
            (yyval.item_list)= new List<Item>;
            (yyval.item_list)->push_back((yyvsp[(2) - (4)].item));
            (yyval.item_list)->push_back((yyvsp[(4) - (4)].item));
          }
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3479 "sql_yacc.yy"
    {
            (yyvsp[(1) - (5)].item_list)->push_back((yyvsp[(3) - (5)].item));
            (yyvsp[(1) - (5)].item_list)->push_back((yyvsp[(5) - (5)].item));
            (yyval.item_list)= (yyvsp[(1) - (5)].item_list);
          }
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3489 "sql_yacc.yy"
    { (yyval.table_list)=(yyvsp[(1) - (1)].table_list); }
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3491 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(lex->session)))
              DRIZZLE_YYABORT;
          }
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3499 "sql_yacc.yy"
    { DRIZZLE_YYABORT_UNLESS((yyval.table_list)=(yyvsp[(1) - (1)].table_list)); }
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3510 "sql_yacc.yy"
    { (yyval.table_list)=(yyvsp[(1) - (1)].table_list); }
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3511 "sql_yacc.yy"
    { (yyval.table_list)=(yyvsp[(3) - (4)].table_list); }
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3517 "sql_yacc.yy"
    { (yyval.table_list)=(yyvsp[(1) - (1)].table_list); }
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3519 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (3)].table_list) && ((yyval.table_list)=(yyvsp[(3) - (3)].table_list)));
          }
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3539 "sql_yacc.yy"
    { DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (3)].table_list) && ((yyval.table_list)=(yyvsp[(3) - (3)].table_list))); }
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3541 "sql_yacc.yy"
    { DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (3)].table_list) && ((yyval.table_list)=(yyvsp[(3) - (3)].table_list))); (yyvsp[(3) - (3)].table_list)->straight=1; }
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3544 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (4)].table_list) && (yyvsp[(3) - (4)].table_list));
            /* Change the current name resolution context to a local context. */
            if (push_new_name_resolution_context(YYSession, (yyvsp[(1) - (4)].table_list), (yyvsp[(3) - (4)].table_list)))
              DRIZZLE_YYABORT;
            Lex->current_select->parsing_place= IN_ON;
          }
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3552 "sql_yacc.yy"
    {
            add_join_on((yyvsp[(3) - (6)].table_list),(yyvsp[(6) - (6)].item));
            Lex->pop_context();
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3559 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (4)].table_list) && (yyvsp[(3) - (4)].table_list));
            /* Change the current name resolution context to a local context. */
            if (push_new_name_resolution_context(YYSession, (yyvsp[(1) - (4)].table_list), (yyvsp[(3) - (4)].table_list)))
              DRIZZLE_YYABORT;
            Lex->current_select->parsing_place= IN_ON;
          }
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3567 "sql_yacc.yy"
    {
            (yyvsp[(3) - (6)].table_list)->straight=1;
            add_join_on((yyvsp[(3) - (6)].table_list),(yyvsp[(6) - (6)].item));
            Lex->pop_context();
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3575 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (4)].table_list) && (yyvsp[(3) - (4)].table_list));
          }
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3579 "sql_yacc.yy"
    { add_join_natural((yyvsp[(1) - (8)].table_list),(yyvsp[(3) - (8)].table_list),(yyvsp[(7) - (8)].string_list),Lex->current_select); (yyval.table_list)=(yyvsp[(3) - (8)].table_list); }
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3581 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (4)].table_list) && ((yyval.table_list)=(yyvsp[(4) - (4)].table_list)));
            add_join_natural((yyvsp[(1) - (4)].table_list),(yyvsp[(4) - (4)].table_list),NULL,Lex->current_select);
          }
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3589 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (6)].table_list) && (yyvsp[(5) - (6)].table_list));
            /* Change the current name resolution context to a local context. */
            if (push_new_name_resolution_context(YYSession, (yyvsp[(1) - (6)].table_list), (yyvsp[(5) - (6)].table_list)))
              DRIZZLE_YYABORT;
            Lex->current_select->parsing_place= IN_ON;
          }
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3597 "sql_yacc.yy"
    {
            add_join_on((yyvsp[(5) - (8)].table_list),(yyvsp[(8) - (8)].item));
            Lex->pop_context();
            (yyvsp[(5) - (8)].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[(5) - (8)].table_list);
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3605 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (5)].table_list) && (yyvsp[(5) - (5)].table_list));
          }
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3609 "sql_yacc.yy"
    {
            add_join_natural((yyvsp[(1) - (10)].table_list),(yyvsp[(5) - (10)].table_list),(yyvsp[(9) - (10)].string_list),Lex->current_select);
            (yyvsp[(5) - (10)].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[(5) - (10)].table_list);
          }
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3615 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (6)].table_list) && (yyvsp[(6) - (6)].table_list));
            add_join_natural((yyvsp[(1) - (6)].table_list),(yyvsp[(6) - (6)].table_list),NULL,Lex->current_select);
            (yyvsp[(6) - (6)].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[(6) - (6)].table_list);
          }
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3625 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (6)].table_list) && (yyvsp[(5) - (6)].table_list));
            /* Change the current name resolution context to a local context. */
            if (push_new_name_resolution_context(YYSession, (yyvsp[(1) - (6)].table_list), (yyvsp[(5) - (6)].table_list)))
              DRIZZLE_YYABORT;
            Lex->current_select->parsing_place= IN_ON;
          }
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3633 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->convert_right_join()))
              DRIZZLE_YYABORT;
            add_join_on((yyval.table_list), (yyvsp[(8) - (8)].item));
            Lex->pop_context();
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3642 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (5)].table_list) && (yyvsp[(5) - (5)].table_list));
          }
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3646 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->convert_right_join()))
              DRIZZLE_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[(5) - (10)].table_list),(yyvsp[(9) - (10)].string_list),Lex->current_select);
          }
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3653 "sql_yacc.yy"
    {
            DRIZZLE_YYABORT_UNLESS((yyvsp[(1) - (6)].table_list) && (yyvsp[(6) - (6)].table_list));
            add_join_natural((yyvsp[(6) - (6)].table_list),(yyvsp[(1) - (6)].table_list),NULL,Lex->current_select);
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->convert_right_join()))
              DRIZZLE_YYABORT;
          }
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3663 "sql_yacc.yy"
    {}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3664 "sql_yacc.yy"
    {}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3665 "sql_yacc.yy"
    {}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3677 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->table_join_options= 0;
          }
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3682 "sql_yacc.yy"
    {
            if (!((yyval.table_list)= Lex->current_select->add_table_to_list(YYSession, (yyvsp[(2) - (4)].table), (yyvsp[(3) - (4)].lex_str_ptr),
                             Lex->current_select->get_table_join_options(),
                             Lex->lock_option,
                             Lex->current_select->pop_index_hints())))
              DRIZZLE_YYABORT;
            Lex->current_select->add_joined_table((yyval.table_list));
          }
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3691 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            Select_Lex *sel= lex->current_select;
            if ((yyvsp[(1) - (3)].num))
            {
              if (sel->set_braces(1))
              {
                my_parse_error(ER(ER_SYNTAX_ERROR));
                DRIZZLE_YYABORT;
              }
              /* select in braces, can't contain global parameters */
              if (sel->master_unit()->fake_select_lex)
                sel->master_unit()->global_parameters=
                   sel->master_unit()->fake_select_lex;
            }
            if ((yyvsp[(2) - (3)].select_lex)->init_nested_join(lex->session))
              DRIZZLE_YYABORT;
            (yyval.table_list)= 0;
            /* incomplete derived tables return NULL, we must be
               nested in select_derived rule to be here. */
          }
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3731 "sql_yacc.yy"
    {
            /* Use $2 instead of Lex->current_select as derived table will
               alter value of Lex->current_select. */
            if (!((yyvsp[(3) - (5)].table_list) || (yyvsp[(5) - (5)].lex_str_ptr)) && (yyvsp[(2) - (5)].select_lex)->embedding &&
                !(yyvsp[(2) - (5)].select_lex)->embedding->nested_join->join_list.elements)
            {
              /* we have a derived table ($3 == NULL) but no alias,
                 Since we are nested in further parentheses so we
                 can pass NULL to the outer level parentheses
                 Permits parsing of "((((select ...))) as xyz)" */
              (yyval.table_list)= 0;
            }
            else if (!(yyvsp[(3) - (5)].table_list))
            {
              /* Handle case of derived table, alias may be NULL if there
                 are no outer parentheses, add_table_to_list() will throw
                 error in this case */
              LEX *lex=Lex;
              Select_Lex *sel= lex->current_select;
              Select_Lex_Unit *unit= sel->master_unit();
              lex->current_select= sel= unit->outer_select();
              if (!((yyval.table_list)= sel->add_table_to_list(lex->session,
                                               new Table_ident(unit), (yyvsp[(5) - (5)].lex_str_ptr), 0,
                                               TL_READ)))

                DRIZZLE_YYABORT;
              sel->add_joined_table((yyval.table_list));
              lex->pop_context();
            }
            else if (((yyvsp[(3) - (5)].table_list)->select_lex && (yyvsp[(3) - (5)].table_list)->select_lex->master_unit()->is_union()) || (yyvsp[(5) - (5)].lex_str_ptr))
            {
              /* simple nested joins cannot have aliases or unions */
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            else
              (yyval.table_list)= (yyvsp[(3) - (5)].table_list);
          }
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3776 "sql_yacc.yy"
    {
            if (add_select_to_union_list(Lex, (bool)(yyvsp[(3) - (3)].num)))
              DRIZZLE_YYABORT;
          }
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3781 "sql_yacc.yy"
    {
            /*
              Remove from the name resolution context stack the context of the
              last select in the union.
             */
            Lex->pop_context();
          }
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3794 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            Select_Lex * sel= lex->current_select;
            if (lex->current_select->set_braces(0))
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            if (sel->linkage == UNION_TYPE &&
                sel->master_unit()->first_select()->braces)
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3813 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            Select_Lex *sel= lex->current_select;
            if (sel->linkage != UNION_TYPE)
              mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
          }
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3821 "sql_yacc.yy"
    {
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3830 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if ((yyvsp[(1) - (1)].select_lex)->init_nested_join(lex->session))
              DRIZZLE_YYABORT;
          }
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3836 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            /* for normal joins, $3 != NULL and end_nested_join() != NULL,
               for derived tables, both must equal NULL */

            if (!((yyval.table_list)= (yyvsp[(1) - (3)].select_lex)->end_nested_join(lex->session)) && (yyvsp[(3) - (3)].table_list))
              DRIZZLE_YYABORT;
            if (!(yyvsp[(3) - (3)].table_list) && (yyval.table_list))
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3852 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->derived_tables|= DERIVED_SUBQUERY;
            if (!lex->expr_allows_subselect)
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            if (lex->current_select->linkage == GLOBAL_OPTIONS_TYPE ||
                mysql_new_select(lex, 1))
              DRIZZLE_YYABORT;
            mysql_init_select(lex);
            lex->current_select->linkage= DERIVED_TABLE_TYPE;
            lex->current_select->parsing_place= SELECT_LIST;
          }
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3868 "sql_yacc.yy"
    {
            Lex->current_select->parsing_place= NO_MATTER;
          }
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3875 "sql_yacc.yy"
    { (yyval.select_lex)= Lex->current_select; }
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3880 "sql_yacc.yy"
    {
            LEX *lex= Lex;

            Select_Lex *sel= lex->current_select;
            TableList *embedding;
            if (!sel->embedding || sel->end_nested_join(lex->session))
            {
              /* we are not in parentheses */
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            embedding= Lex->current_select->embedding;
            (yyval.num)= embedding &&
                !embedding->nested_join->join_list.elements;
            /* return true if we are deeply nested */
          }
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3899 "sql_yacc.yy"
    {}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3900 "sql_yacc.yy"
    {}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3905 "sql_yacc.yy"
    {
            (yyval.num)= INDEX_HINT_MASK_ALL;
          }
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3908 "sql_yacc.yy"
    { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3909 "sql_yacc.yy"
    { (yyval.num)= INDEX_HINT_MASK_ORDER; }
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3910 "sql_yacc.yy"
    { (yyval.num)= INDEX_HINT_MASK_GROUP; }
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3914 "sql_yacc.yy"
    { (yyval.index_hint)= INDEX_HINT_FORCE; }
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3915 "sql_yacc.yy"
    { (yyval.index_hint)= INDEX_HINT_IGNORE; }
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3920 "sql_yacc.yy"
    {
            Lex->current_select->set_index_hint_type((yyvsp[(1) - (3)].index_hint), (yyvsp[(3) - (3)].num));
          }
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3925 "sql_yacc.yy"
    {
            Lex->current_select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[(3) - (3)].num));
          }
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3938 "sql_yacc.yy"
    { Lex->current_select->alloc_index_hints(YYSession); }
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3942 "sql_yacc.yy"
    {  Lex->current_select->clear_index_hints(); }
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3947 "sql_yacc.yy"
    { Lex->current_select->add_index_hint(YYSession, NULL, 0); }
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3948 "sql_yacc.yy"
    {}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3953 "sql_yacc.yy"
    { Lex->current_select->add_index_hint(YYSession, (yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length); }
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3955 "sql_yacc.yy"
    { Lex->current_select->add_index_hint(YYSession, (char *)"PRIMARY", 7); }
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3965 "sql_yacc.yy"
    {
            if (!((yyval.string_list)= new List<String>))
              DRIZZLE_YYABORT;
            (yyval.string_list)->push_back(new (YYSession->mem_root)
                              String((const char *) (yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length,
                                      system_charset_info));
          }
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3973 "sql_yacc.yy"
    {
            (yyvsp[(1) - (3)].string_list)->push_back(new (YYSession->mem_root)
                              String((const char *) (yyvsp[(3) - (3)].lex_str).str, (yyvsp[(3) - (3)].lex_str).length,
                                      system_charset_info));
            (yyval.string_list)= (yyvsp[(1) - (3)].string_list);
          }
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3982 "sql_yacc.yy"
    {}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3983 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_DAY_HOUR; }
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3984 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3985 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_DAY_MINUTE; }
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3986 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_DAY_SECOND; }
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3987 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3988 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3989 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_HOUR_SECOND; }
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3990 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3991 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3992 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3993 "sql_yacc.yy"
    { (yyval.interval)=INTERVAL_YEAR_MONTH; }
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3997 "sql_yacc.yy"
    {}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3998 "sql_yacc.yy"
    {
                                  (yyval.interval_time_st)=INTERVAL_MICROSECOND;
                                  /*
                                    FRAC_SECOND was mistakenly implemented with
                                    a wrong resolution. According to the ODBC
                                    standard it should be nanoseconds, not
                                    microseconds. Changing it to nanoseconds
                                    in MySQL would mean making TIMESTAMPDIFF
                                    and TIMESTAMPADD to return DECIMAL, since
                                    the return value would be too big for BIGINT
                                    Hence we just deprecate the incorrect
                                    implementation without changing its
                                    resolution.
                                  */
                                }
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 4016 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_DAY; }
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 4017 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_WEEK; }
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 4018 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_HOUR; }
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 4019 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_MINUTE; }
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 4020 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_MONTH; }
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 4021 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_QUARTER; }
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 4022 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_SECOND; }
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 4023 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 4024 "sql_yacc.yy"
    { (yyval.interval_time_st)=INTERVAL_YEAR; }
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 4034 "sql_yacc.yy"
    { (yyval.lex_str_ptr)=0; }
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 4036 "sql_yacc.yy"
    { (yyval.lex_str_ptr)= (drizzled::LEX_STRING*) memory::sql_memdup(&(yyvsp[(2) - (2)].lex_str),sizeof(drizzled::LEX_STRING)); }
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 4045 "sql_yacc.yy"
    { Lex->current_select->where= 0; }
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 4047 "sql_yacc.yy"
    {
            Lex->current_select->parsing_place= IN_WHERE;
          }
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 4051 "sql_yacc.yy"
    {
            Select_Lex *select= Lex->current_select;
            select->where= (yyvsp[(3) - (3)].item);
            select->parsing_place= NO_MATTER;
            if ((yyvsp[(3) - (3)].item))
              (yyvsp[(3) - (3)].item)->top_level_item();
          }
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 4063 "sql_yacc.yy"
    {
            Lex->current_select->parsing_place= IN_HAVING;
          }
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 4067 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->having= (yyvsp[(3) - (3)].item);
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[(3) - (3)].item))
              (yyvsp[(3) - (3)].item)->top_level_item();
          }
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 4078 "sql_yacc.yy"
    {
            Lex->escape_used= true;
            (yyval.item)= (yyvsp[(2) - (2)].item);
          }
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 4083 "sql_yacc.yy"
    {
            Lex->escape_used= false;
            (yyval.item)= new Item_string("\\", 1, &my_charset_utf8_general_ci);
          }
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 4100 "sql_yacc.yy"
    { if (YYSession->add_group_to_list((yyvsp[(3) - (4)].item),(bool) (yyvsp[(4) - (4)].num))) DRIZZLE_YYABORT; }
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 4102 "sql_yacc.yy"
    { if (YYSession->add_group_to_list((yyvsp[(1) - (2)].item),(bool) (yyvsp[(2) - (2)].num))) DRIZZLE_YYABORT; }
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 4106 "sql_yacc.yy"
    {}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 4108 "sql_yacc.yy"
    {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (lex->current_select->linkage == GLOBAL_OPTIONS_TYPE)
            {
              my_error(ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                       "global union parameters");
              DRIZZLE_YYABORT;
            }
            lex->current_select->olap= ROLLUP_TYPE;
          }
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4142 "sql_yacc.yy"
    {
            Session *session= YYSession;
            bool ascending= ((yyvsp[(2) - (2)].num) == 1) ? true : false;
            if (session->add_order_to_list((yyvsp[(1) - (2)].item), ascending))
              DRIZZLE_YYABORT;
          }
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4161 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            Select_Lex *sel= lex->current_select;
            Select_Lex_Unit *unit= sel-> master_unit();
            if (sel->linkage != GLOBAL_OPTIONS_TYPE &&
                sel->olap != UNSPECIFIED_OLAP_TYPE &&
                (sel->linkage != UNION_TYPE || sel->braces))
            {
              my_error(ER_WRONG_USAGE, MYF(0),
                       "CUBE/ROLLUP", "ORDER BY");
              DRIZZLE_YYABORT;
            }
            if (lex->sql_command != SQLCOM_ALTER_TABLE && !unit->fake_select_lex)
            {
              /*
                A query of the of the form (SELECT ...) ORDER BY order_list is
                executed in the same way as the query
                SELECT ... ORDER BY order_list
                unless the SELECT construct contains ORDER BY or LIMIT clauses.
                Otherwise we create a fake Select_Lex if it has not been created
                yet.
              */
              Select_Lex *first_sl= unit->first_select();
              if (!unit->is_union() &&
                  (first_sl->order_list.elements ||
                   first_sl->select_limit) &&           
                  unit->add_fake_select_lex(lex->session))
                DRIZZLE_YYABORT;
            }
          }
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4196 "sql_yacc.yy"
    { if (YYSession->add_order_to_list((yyvsp[(3) - (4)].item),(bool) (yyvsp[(4) - (4)].num))) DRIZZLE_YYABORT; }
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4198 "sql_yacc.yy"
    { if (YYSession->add_order_to_list((yyvsp[(1) - (2)].item),(bool) (yyvsp[(2) - (2)].num))) DRIZZLE_YYABORT; }
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4202 "sql_yacc.yy"
    { (yyval.num) =  1; }
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4203 "sql_yacc.yy"
    { (yyval.num) =1; }
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4204 "sql_yacc.yy"
    { (yyval.num) =0; }
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4209 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            Select_Lex *sel= lex->current_select;
            sel->offset_limit= 0;
            sel->select_limit= 0;
          }
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4215 "sql_yacc.yy"
    {}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4219 "sql_yacc.yy"
    {}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4220 "sql_yacc.yy"
    {}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4224 "sql_yacc.yy"
    {}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4229 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->select_limit= (yyvsp[(1) - (1)].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4236 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->select_limit= (yyvsp[(3) - (3)].item);
            sel->offset_limit= (yyvsp[(1) - (3)].item);
            sel->explicit_limit= 1;
          }
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4243 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->select_limit= (yyvsp[(1) - (3)].item);
            sel->offset_limit= (yyvsp[(3) - (3)].item);
            sel->explicit_limit= 1;
          }
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4252 "sql_yacc.yy"
    { (yyval.item)= new Item_uint((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length); }
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4253 "sql_yacc.yy"
    { (yyval.item)= new Item_uint((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length); }
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4254 "sql_yacc.yy"
    { (yyval.item)= new Item_uint((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length); }
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4259 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4264 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            sel->select_limit= (yyvsp[(2) - (2)].item);
            sel->explicit_limit= 1;
          }
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4272 "sql_yacc.yy"
    { int error; (yyval.ulong_num)= (ulong) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4273 "sql_yacc.yy"
    { (yyval.ulong_num)= (ulong) strtol((yyvsp[(1) - (1)].lex_str).str, (char**) 0, 16); }
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4274 "sql_yacc.yy"
    { int error; (yyval.ulong_num)= (ulong) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4275 "sql_yacc.yy"
    { int error; (yyval.ulong_num)= (ulong) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4276 "sql_yacc.yy"
    { int error; (yyval.ulong_num)= (ulong) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4277 "sql_yacc.yy"
    { int error; (yyval.ulong_num)= (ulong) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4281 "sql_yacc.yy"
    { int error; (yyval.ulonglong_number)= (uint64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4282 "sql_yacc.yy"
    { int error; (yyval.ulonglong_number)= (uint64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4283 "sql_yacc.yy"
    { int error; (yyval.ulonglong_number)= (uint64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4284 "sql_yacc.yy"
    { int error; (yyval.ulonglong_number)= (uint64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4285 "sql_yacc.yy"
    { int error; (yyval.ulonglong_number)= (uint64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, (char**) 0, &error); }
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4289 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (!lex->describe && (!(lex->result= new select_dumpvar())))
              DRIZZLE_YYABORT;
          }
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4295 "sql_yacc.yy"
    {}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4300 "sql_yacc.yy"
    {}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4305 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (lex->result)
              ((select_dumpvar *)lex->result)->var_list.push_back( new var((yyvsp[(2) - (2)].lex_str),0,0,(enum_field_types)0));
            else
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              assert(lex->describe);
          }
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4320 "sql_yacc.yy"
    { }
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4326 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if (!(lex->exchange= new file_exchange((yyvsp[(2) - (2)].lex_str).str, 0)) ||
                !(lex->result= new select_export(lex->exchange)))
              DRIZZLE_YYABORT;
          }
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4334 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              if (!(lex->exchange= new file_exchange((yyvsp[(2) - (2)].lex_str).str,1)))
                DRIZZLE_YYABORT;
              if (!(lex->result= new select_dump(lex->exchange)))
                DRIZZLE_YYABORT;
            }
          }
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4345 "sql_yacc.yy"
    { }
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4354 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DROP_TABLE;
            statement::DropTable *statement= new(std::nothrow) statement::DropTable(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->drop_temporary= (yyvsp[(2) - (5)].num);
            statement->drop_if_exists= (yyvsp[(4) - (5)].num);
          }
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4364 "sql_yacc.yy"
    {}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4365 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_DROP_INDEX;
            statement::DropIndex *statement= new(std::nothrow) statement::DropIndex(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->alter_info.flags.set(ALTER_DROP_INDEX);
            statement->alter_info.build_method= (yyvsp[(2) - (7)].build_method);
            statement->alter_info.drop_list.push_back(new AlterDrop(AlterDrop::KEY, (yyvsp[(4) - (7)].lex_str).str));
            if (!lex->current_select->add_table_to_list(lex->session, (yyvsp[(6) - (7)].table), NULL,
                                                        TL_OPTION_UPDATING))
              DRIZZLE_YYABORT;
          }
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4380 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_DROP_DB;
            statement::DropSchema *statement= new(std::nothrow) statement::DropSchema(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->drop_if_exists=(yyvsp[(3) - (4)].num);
            lex->name= (yyvsp[(4) - (4)].lex_str);
          }
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4397 "sql_yacc.yy"
    {
            if (!Lex->current_select->add_table_to_list(YYSession, (yyvsp[(1) - (1)].table), NULL, TL_OPTION_UPDATING))
              DRIZZLE_YYABORT;
          }
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4404 "sql_yacc.yy"
    { (yyval.num)= 0; }
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4405 "sql_yacc.yy"
    { (yyval.num)= 1; }
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4409 "sql_yacc.yy"
    { (yyval.num)= 0; }
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4410 "sql_yacc.yy"
    { (yyval.num)= 1; }
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4418 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->statement= new(std::nothrow) statement::Insert(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->duplicates= DUP_ERROR;
            mysql_init_select(lex);
            /* for subselects */
            lex->lock_option= TL_READ;
          }
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4430 "sql_yacc.yy"
    {
            Lex->current_select->set_lock_for_tables(TL_WRITE_CONCURRENT_INSERT);
            Lex->current_select= &Lex->select_lex;
          }
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4435 "sql_yacc.yy"
    {}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4440 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REPLACE;
            lex->statement= new(std::nothrow) statement::Replace(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->duplicates= DUP_REPLACE;
            mysql_init_select(lex);
          }
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4450 "sql_yacc.yy"
    {
            Lex->current_select->set_lock_for_tables(TL_WRITE_DEFAULT);
            Lex->current_select= &Lex->select_lex;
          }
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4455 "sql_yacc.yy"
    {}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4459 "sql_yacc.yy"
    {}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4460 "sql_yacc.yy"
    {}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4465 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4473 "sql_yacc.yy"
    {}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4474 "sql_yacc.yy"
    {}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4475 "sql_yacc.yy"
    {}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4477 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (!(lex->insert_list = new List_item) ||
                lex->many_values.push_back(lex->insert_list))
              DRIZZLE_YYABORT;
          }
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4487 "sql_yacc.yy"
    { Lex->field_list.push_back((yyvsp[(3) - (3)].item)); }
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4488 "sql_yacc.yy"
    { Lex->field_list.push_back((yyvsp[(1) - (1)].item)); }
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4492 "sql_yacc.yy"
    {}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4493 "sql_yacc.yy"
    {}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4495 "sql_yacc.yy"
    { Lex->current_select->set_braces(0);}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4496 "sql_yacc.yy"
    {}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4498 "sql_yacc.yy"
    { Lex->current_select->set_braces(1);}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4499 "sql_yacc.yy"
    {}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4514 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (lex->field_list.push_back((yyvsp[(1) - (3)].item)) ||
                lex->insert_list->push_back((yyvsp[(3) - (3)].item)))
              DRIZZLE_YYABORT;
          }
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4523 "sql_yacc.yy"
    {}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4524 "sql_yacc.yy"
    {}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4528 "sql_yacc.yy"
    {}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4529 "sql_yacc.yy"
    {}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4534 "sql_yacc.yy"
    {
              if (!(Lex->insert_list = new List_item))
                DRIZZLE_YYABORT;
          }
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4539 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (lex->many_values.push_back(lex->insert_list))
              DRIZZLE_YYABORT;
          }
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4547 "sql_yacc.yy"
    {}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4553 "sql_yacc.yy"
    {
            if (Lex->insert_list->push_back((yyvsp[(3) - (3)].item)))
              DRIZZLE_YYABORT;
          }
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4558 "sql_yacc.yy"
    {
            if (Lex->insert_list->push_back((yyvsp[(1) - (1)].item)))
              DRIZZLE_YYABORT;
          }
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4565 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(1) - (1)].item);}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4566 "sql_yacc.yy"
    {(yyval.item)= new Item_default_value(Lex->current_context()); }
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4571 "sql_yacc.yy"
    { Lex->duplicates= DUP_UPDATE; }
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4579 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->statement= new(std::nothrow) statement::Update(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->lock_option= TL_UNLOCK; /* Will be set later */
            lex->duplicates= DUP_ERROR;
            if (!lex->select_lex.add_table_to_list(YYSession, (yyvsp[(3) - (3)].table), NULL,0))
              DRIZZLE_YYABORT;
          }
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4592 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            if (lex->select_lex.get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       lex->select_lex.get_table_list()->alias, "UPDATE");
              DRIZZLE_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            Lex->current_select->set_lock_for_tables(TL_WRITE_DEFAULT);
          }
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4608 "sql_yacc.yy"
    {}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 4618 "sql_yacc.yy"
    {
            if (YYSession->add_item_to_list((yyvsp[(1) - (3)].item)) || YYSession->add_value_to_list((yyvsp[(3) - (3)].item)))
              DRIZZLE_YYABORT;
          }
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 4631 "sql_yacc.yy"
    {
          LEX *lex= Lex;
          if (lex->update_list.push_back((yyvsp[(1) - (3)].item)) ||
              lex->value_list.push_back((yyvsp[(3) - (3)].item)))
              DRIZZLE_YYABORT;
          }
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 4643 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            lex->statement= new(std::nothrow) statement::Delete(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            mysql_init_select(lex);
            lex->lock_option= TL_WRITE_DEFAULT;
            lex->ignore= 0;
            lex->select_lex.init_order();
          }
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 4659 "sql_yacc.yy"
    {
            if (!Lex->current_select->add_table_to_list(YYSession, (yyvsp[(2) - (2)].table), NULL, TL_OPTION_UPDATING,
                                           Lex->lock_option))
              DRIZZLE_YYABORT;
          }
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 4665 "sql_yacc.yy"
    {}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 4669 "sql_yacc.yy"
    {}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 4670 "sql_yacc.yy"
    {}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 4674 "sql_yacc.yy"
    { Lex->ignore= 1; }
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 4679 "sql_yacc.yy"
    {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->statement= new(std::nothrow) statement::Truncate(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->select_lex.options= 0;
            lex->select_lex.init_order();
          }
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 4699 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->wild=0;
            lex->lock_option= TL_READ;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
          }
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 4707 "sql_yacc.yy"
    {}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 4712 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             Session *session= YYSession;

             lex->sql_command= SQLCOM_SELECT;
             lex->statement=
               new(std::nothrow) statement::Select(session);
             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             std::string column_name= "Database";
             if (Lex->wild)
             {
               column_name.append(" (");
               column_name.append(Lex->wild->ptr());
               column_name.append(")");
             }

             if (Lex->current_select->where)
             {
               if (prepare_new_schema_table(session, lex, "SCHEMAS"))
                 DRIZZLE_YYABORT;
             }
             else
             {
               if (prepare_new_schema_table(session, lex, "SHOW_SCHEMAS"))
                 DRIZZLE_YYABORT;
             }

             Item_field *my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "SCHEMA_NAME");
             my_field->is_autogenerated_name= false;
             my_field->set_name(column_name.c_str(), column_name.length(), system_charset_info);

             if (session->add_item_to_list(my_field))
               DRIZZLE_YYABORT;
           }
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 4749 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             Session *session= YYSession;

             lex->sql_command= SQLCOM_SELECT;

             statement::Select *select=
               new(std::nothrow) statement::Select(YYSession);

             lex->statement= select;

             if (lex->statement == NULL)
               DRIZZLE_YYABORT;


              std::string column_name= "Tables_in_";

              if ((yyvsp[(2) - (3)].simple_string))
              {
		SchemaIdentifier identifier((yyvsp[(2) - (3)].simple_string));
                column_name.append((yyvsp[(2) - (3)].simple_string));
                lex->select_lex.db= (yyvsp[(2) - (3)].simple_string);
                if (not plugin::StorageEngine::doesSchemaExist(identifier))
                {
                  my_error(ER_BAD_DB_ERROR, MYF(0), (yyvsp[(2) - (3)].simple_string));
                }
                select->setShowPredicate((yyvsp[(2) - (3)].simple_string), "");
              }
              else if (not session->db.empty())
              {
                column_name.append(session->db);
                select->setShowPredicate(session->db, "");
              }
              else
              {
                 my_error(ER_NO_DB_ERROR, MYF(0));
              }


             if (Lex->wild)
             {
               column_name.append(" (");
               column_name.append(Lex->wild->ptr());
               column_name.append(")");
             }

             if (prepare_new_schema_table(YYSession, lex, "SHOW_TABLES"))
               DRIZZLE_YYABORT;

             Item_field *my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "TABLE_NAME");
             my_field->is_autogenerated_name= false;
             my_field->set_name(column_name.c_str(), column_name.length(), system_charset_info);

             if (session->add_item_to_list(my_field))
               DRIZZLE_YYABORT;
           }
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 4806 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             Session *session= YYSession;

             lex->sql_command= SQLCOM_SELECT;

             statement::Select *select=
               new(std::nothrow) statement::Select(YYSession);

             lex->statement= select;

             if (lex->statement == NULL)
               DRIZZLE_YYABORT;


             if (prepare_new_schema_table(YYSession, lex, "SHOW_TEMPORARY_TABLES"))
               DRIZZLE_YYABORT;

             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                           context,
                                                           NULL, NULL, "*")))
               DRIZZLE_YYABORT;
             (session->lex->current_select->with_wild)++;

           }
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 4832 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SELECT;
             statement::Select *select=
               new(std::nothrow) statement::Select(YYSession);

             lex->statement= select;

             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             Session *session= YYSession;

             std::string column_name= "Tables_in_";

             if ((yyvsp[(3) - (4)].simple_string))
             {
               lex->select_lex.db= (yyvsp[(3) - (4)].simple_string);

	       SchemaIdentifier identifier((yyvsp[(3) - (4)].simple_string));
               if (not plugin::StorageEngine::doesSchemaExist(identifier))
               {
                 my_error(ER_BAD_DB_ERROR, MYF(0), (yyvsp[(3) - (4)].simple_string));
               }

               select->setShowPredicate((yyvsp[(3) - (4)].simple_string), "");
             }
             else
             {
               select->setShowPredicate(session->db, "");
             }

             if (prepare_new_schema_table(session, lex, "SHOW_TABLE_STATUS"))
               DRIZZLE_YYABORT;

             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                           context,
                                                           NULL, NULL, "*")))
               DRIZZLE_YYABORT;
             (session->lex->current_select->with_wild)++;
           }
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 4874 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             Session *session= YYSession;
             statement::Select *select;

             lex->sql_command= SQLCOM_SELECT;

             select= new(std::nothrow) statement::Select(session);

             lex->statement= select;

             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             if ((yyvsp[(4) - (5)].simple_string))
              select->setShowPredicate((yyvsp[(4) - (5)].simple_string), (yyvsp[(3) - (5)].table)->table.str);
             else if ((yyvsp[(3) - (5)].table)->db.str)
              select->setShowPredicate((yyvsp[(3) - (5)].table)->db.str, (yyvsp[(3) - (5)].table)->table.str);
             else
              select->setShowPredicate(session->db, (yyvsp[(3) - (5)].table)->table.str);

             {
               drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), (yyvsp[(3) - (5)].table)->table.str);
               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
               {
                   my_error(ER_NO_SUCH_TABLE, MYF(0),
                            select->getShowSchema().c_str(), 
                            (yyvsp[(3) - (5)].table)->table.str);
               }
             }

             if (prepare_new_schema_table(session, lex, "SHOW_COLUMNS"))
               DRIZZLE_YYABORT;

             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                           context,
                                                           NULL, NULL, "*")))
               DRIZZLE_YYABORT;
             (session->lex->current_select->with_wild)++;

          }
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 4916 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             Session *session= YYSession;
             statement::Select *select;

             lex->sql_command= SQLCOM_SELECT;

             select= new(std::nothrow) statement::Select(session);

             lex->statement= select;

             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             if ((yyvsp[(4) - (5)].simple_string))
              select->setShowPredicate((yyvsp[(4) - (5)].simple_string), (yyvsp[(3) - (5)].table)->table.str);
             else if ((yyvsp[(3) - (5)].table)->db.str)
              select->setShowPredicate((yyvsp[(3) - (5)].table)->db.str, (yyvsp[(3) - (5)].table)->table.str);
             else
              select->setShowPredicate(session->db, (yyvsp[(3) - (5)].table)->table.str);

             {
               drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), (yyvsp[(3) - (5)].table)->table.str);
               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
               {
                   my_error(ER_NO_SUCH_TABLE, MYF(0),
                            select->getShowSchema().c_str(), 
                            (yyvsp[(3) - (5)].table)->table.str);
               }
             }

             if (prepare_new_schema_table(session, lex, "SHOW_INDEXES"))
               DRIZZLE_YYABORT;

             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                           context,
                                                           NULL, NULL, "*")))
               DRIZZLE_YYABORT;
             (session->lex->current_select->with_wild)++;
          }
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 4957 "sql_yacc.yy"
    {
            (void) create_select_for_variable("warning_count");
            LEX *lex= Lex;
            lex->statement= new(std::nothrow) statement::Select(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 4965 "sql_yacc.yy"
    {
            (void) create_select_for_variable("error_count");
            LEX *lex= Lex;
            lex->statement= new(std::nothrow) statement::Select(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 4973 "sql_yacc.yy"
    {
            Lex->sql_command = SQLCOM_SHOW_WARNS;
            Lex->statement= new(std::nothrow) statement::ShowWarnings(YYSession);
            if (Lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 4980 "sql_yacc.yy"
    {
            Lex->sql_command = SQLCOM_SHOW_ERRORS;
            Lex->statement= new(std::nothrow) statement::ShowErrors(YYSession);
            if (Lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 4987 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SELECT;
             lex->statement=
               new(std::nothrow) statement::Select(YYSession);
             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             Session *session= YYSession;

             if ((yyvsp[(1) - (3)].var_type) == OPT_GLOBAL)
             {
               if (prepare_new_schema_table(session, lex, "GLOBAL_STATUS"))
                 DRIZZLE_YYABORT;
             }
             else
             {
               if (prepare_new_schema_table(session, lex, "SESSION_STATUS"))
                 DRIZZLE_YYABORT;
             }

             std::string key("Variable_name");
             std::string value("Value");

             Item_field *my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "VARIABLE_NAME");
             my_field->is_autogenerated_name= false;
             my_field->set_name(key.c_str(), key.length(), system_charset_info);

             if (session->add_item_to_list(my_field))
               DRIZZLE_YYABORT;

             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "VARIABLE_VALUE");
             my_field->is_autogenerated_name= false;
             my_field->set_name(value.c_str(), value.length(), system_charset_info);

             if (session->add_item_to_list(my_field))
               DRIZZLE_YYABORT;
           }
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 5026 "sql_yacc.yy"
    {
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SELECT;
             lex->statement=
               new(std::nothrow) statement::Select(YYSession);
             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             Session *session= YYSession;

             if (prepare_new_schema_table(session, lex, "PROCESSLIST"))
               DRIZZLE_YYABORT;

             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                           context,
                                                           NULL, NULL, "*")))
               DRIZZLE_YYABORT;
             (session->lex->current_select->with_wild)++;
           }
          }
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 5048 "sql_yacc.yy"
    {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SELECT;
             lex->statement=
               new(std::nothrow) statement::Select(YYSession);
             if (lex->statement == NULL)
               DRIZZLE_YYABORT;

             Session *session= YYSession;

             if ((yyvsp[(1) - (3)].var_type) == OPT_GLOBAL)
             {
               if (prepare_new_schema_table(session, lex, "GLOBAL_VARIABLES"))
                 DRIZZLE_YYABORT;
             }
             else
             {
               if (prepare_new_schema_table(session, lex, "SESSION_VARIABLES"))
                 DRIZZLE_YYABORT;
             }

             std::string key("Variable_name");
             std::string value("Value");

             Item_field *my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "VARIABLE_NAME");
             my_field->is_autogenerated_name= false;
             my_field->set_name(key.c_str(), key.length(), system_charset_info);

             if (session->add_item_to_list(my_field))
               DRIZZLE_YYABORT;

             my_field= new Item_field(&session->lex->current_select->context, NULL, NULL, "VARIABLE_VALUE");
             my_field->is_autogenerated_name= false;
             my_field->set_name(value.c_str(), value.length(), system_charset_info);

             if (session->add_item_to_list(my_field))
               DRIZZLE_YYABORT;
           }
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 5087 "sql_yacc.yy"
    {
            Lex->sql_command=SQLCOM_SHOW_CREATE_DB;
            statement::ShowCreateSchema *statement= new(std::nothrow) statement::ShowCreateSchema(YYSession);
            Lex->statement= statement;
            if (Lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->is_if_not_exists= (yyvsp[(3) - (4)].num);
            Lex->name= (yyvsp[(4) - (4)].lex_str);
          }
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 5097 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            lex->statement= new(std::nothrow) statement::ShowCreate(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            if (!lex->select_lex.add_table_to_list(YYSession, (yyvsp[(3) - (3)].table), NULL,0))
              DRIZZLE_YYABORT;
          }
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 5108 "sql_yacc.yy"
    { (yyval.simple_string)= 0; }
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 5109 "sql_yacc.yy"
    { (yyval.simple_string)= (yyvsp[(2) - (2)].lex_str).str; }
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 5120 "sql_yacc.yy"
    {
            Lex->wild= new (YYSession->mem_root) String((yyvsp[(2) - (2)].lex_str).str, (yyvsp[(2) - (2)].lex_str).length,
                                                    system_charset_info);
            if (Lex->wild == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 5127 "sql_yacc.yy"
    {
            Lex->current_select->where= (yyvsp[(2) - (2)].item);
            if ((yyvsp[(2) - (2)].item))
              (yyvsp[(2) - (2)].item)->top_level_item();
          }
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 5137 "sql_yacc.yy"
    {
            Session *session= YYSession;
            statement::Select *select;
            LEX *lex= Lex;
            lex->lock_option= TL_READ;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SELECT;
            select= new(std::nothrow) statement::Select(session);
            lex->statement= select;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->select_lex.db= 0;

             if ((yyvsp[(2) - (2)].table)->db.str)
              select->setShowPredicate((yyvsp[(2) - (2)].table)->db.str, (yyvsp[(2) - (2)].table)->table.str);
             else
              select->setShowPredicate(session->db, (yyvsp[(2) - (2)].table)->table.str);

             {
               drizzled::TableIdentifier identifier(select->getShowSchema().c_str(), (yyvsp[(2) - (2)].table)->table.str);
               if (not plugin::StorageEngine::doesTableExist(*session, identifier))
               {
                   my_error(ER_NO_SUCH_TABLE, MYF(0),
                            select->getShowSchema().c_str(), 
                            (yyvsp[(2) - (2)].table)->table.str);
               }
             }

             if (prepare_new_schema_table(session, lex, "SHOW_COLUMNS"))
               DRIZZLE_YYABORT;

             if (session->add_item_to_list( new Item_field(&session->lex->current_select->
                                                           context,
                                                           NULL, NULL, "*")))
               DRIZZLE_YYABORT;
             (session->lex->current_select->with_wild)++;

          }
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 5176 "sql_yacc.yy"
    {}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 5178 "sql_yacc.yy"
    { Lex->describe|= DESCRIBE_NORMAL; }
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 5180 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->select_lex.options|= SELECT_DESCRIBE;
          }
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 5192 "sql_yacc.yy"
    {}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 5193 "sql_yacc.yy"
    { Lex->describe|= DESCRIBE_EXTENDED; }
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 5197 "sql_yacc.yy"
    {}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 5198 "sql_yacc.yy"
    { Lex->wild= (yyvsp[(1) - (1)].string); }
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 5200 "sql_yacc.yy"
    {
            Lex->wild= new (YYSession->mem_root) String((const char*) (yyvsp[(1) - (1)].lex_str).str,
                                                    (yyvsp[(1) - (1)].lex_str).length,
                                                    system_charset_info);
          }
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 5212 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->statement= new(std::nothrow) statement::Flush(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->type= 0;
          }
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 5221 "sql_yacc.yy"
    {}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 5231 "sql_yacc.yy"
    {
            statement::Flush *statement= (statement::Flush*)Lex->statement;
            statement->setFlushTables(true);
          }
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 5235 "sql_yacc.yy"
    {}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5237 "sql_yacc.yy"
    {
            statement::Flush *statement= (statement::Flush*)Lex->statement;
            statement->setFlushTablesWithReadLock(true);
          }
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5242 "sql_yacc.yy"
    {
            statement::Flush *statement= (statement::Flush*)Lex->statement;
            statement->setFlushLog(true);
          }
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5247 "sql_yacc.yy"
    {
            statement::Flush *statement= (statement::Flush*)Lex->statement;
            statement->setFlushStatus(true);
          }
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5254 "sql_yacc.yy"
    {}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5255 "sql_yacc.yy"
    {}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5262 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->value_list.push_front((yyvsp[(3) - (3)].item));
            lex->sql_command= SQLCOM_KILL;
            lex->statement= new(std::nothrow) statement::Kill(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5274 "sql_yacc.yy"
    { Lex->type= 0; }
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5275 "sql_yacc.yy"
    { Lex->type= 0; }
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5276 "sql_yacc.yy"
    { Lex->type= ONLY_KILL_QUERY; }
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5283 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->statement= new(std::nothrow) statement::ChangeSchema(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->select_lex.db= (yyvsp[(2) - (2)].lex_str).str;
          }
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5297 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;

            lex->sql_command= SQLCOM_LOAD;
            statement::Load *statement= new(std::nothrow) statement::Load(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;

            Lex_input_stream *lip= session->m_lip;
            statement->fname_start= lip->get_ptr();
          }
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5311 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->lock_option= (yyvsp[(4) - (6)].lock_type);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (!(lex->exchange= new file_exchange((yyvsp[(6) - (6)].lex_str).str, 0, (yyvsp[(2) - (6)].filetype))))
              DRIZZLE_YYABORT;
          }
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5320 "sql_yacc.yy"
    {
            Session *session= YYSession;
            Lex_input_stream *lip= session->m_lip;
            ((statement::Load *)Lex->statement)->fname_end= lip->get_ptr();
          }
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5326 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (!Lex->current_select->add_table_to_list(YYSession,
                    (yyvsp[(12) - (12)].table), NULL, TL_OPTION_UPDATING,
                    lex->lock_option))
              DRIZZLE_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
          }
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5338 "sql_yacc.yy"
    {}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5342 "sql_yacc.yy"
    { (yyval.filetype)= FILETYPE_CSV; }
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5345 "sql_yacc.yy"
    { (yyval.lock_type)= TL_WRITE_DEFAULT; }
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5347 "sql_yacc.yy"
    {
              (yyval.lock_type)= TL_WRITE_CONCURRENT_INSERT;
          }
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5353 "sql_yacc.yy"
    { Lex->duplicates=DUP_ERROR; }
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5354 "sql_yacc.yy"
    { Lex->duplicates=DUP_REPLACE; }
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5355 "sql_yacc.yy"
    { Lex->ignore= 1; }
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5370 "sql_yacc.yy"
    {
            assert(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[(3) - (3)].string);
          }
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5375 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            assert(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[(4) - (4)].string);
            lex->exchange->opt_enclosed= 1;
          }
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5382 "sql_yacc.yy"
    {
            assert(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[(3) - (3)].string);
          }
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5387 "sql_yacc.yy"
    {
            assert(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[(3) - (3)].string);
          }
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5405 "sql_yacc.yy"
    {
            assert(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[(3) - (3)].string);
          }
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5410 "sql_yacc.yy"
    {
            assert(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[(3) - (3)].string);
          }
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5419 "sql_yacc.yy"
    {
            assert(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[(2) - (3)].lex_str).str);
          }
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5426 "sql_yacc.yy"
    { }
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5427 "sql_yacc.yy"
    { }
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5431 "sql_yacc.yy"
    {}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5432 "sql_yacc.yy"
    {}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5433 "sql_yacc.yy"
    {}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5438 "sql_yacc.yy"
    { Lex->field_list.push_back((yyvsp[(3) - (3)].item)); }
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5440 "sql_yacc.yy"
    { Lex->field_list.push_back((yyvsp[(1) - (1)].item)); }
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5444 "sql_yacc.yy"
    {(yyval.item)= (yyvsp[(1) - (1)].item);}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5446 "sql_yacc.yy"
    { (yyval.item)= new Item_user_var_as_out_param((yyvsp[(2) - (2)].lex_str)); }
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5450 "sql_yacc.yy"
    {}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5451 "sql_yacc.yy"
    {}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5458 "sql_yacc.yy"
    {
          Session *session= YYSession;
          (yyval.item) = new Item_string((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length, session->variables.getCollation());
        }
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5463 "sql_yacc.yy"
    {
            ((Item_string*) (yyvsp[(1) - (2)].item))->append((yyvsp[(2) - (2)].lex_str).str, (yyvsp[(2) - (2)].lex_str).length);
          }
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5470 "sql_yacc.yy"
    {
            (yyval.string)= new (YYSession->mem_root) String((yyvsp[(1) - (1)].lex_str).str,
                                             (yyvsp[(1) - (1)].lex_str).length,
                                             YYSession->variables.getCollation());
          }
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5476 "sql_yacc.yy"
    {
            Item *tmp= new Item_hex_string((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length);
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp ?
              tmp->quick_fix_field(), tmp->val_str((String*) 0) :
              (String*) 0;
          }
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5487 "sql_yacc.yy"
    {
            Item *tmp= new Item_bin_string((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length);
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp ? tmp->quick_fix_field(), tmp->val_str((String*) 0) :
              (String*) 0;
          }
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5499 "sql_yacc.yy"
    { (yyval.item) = (yyvsp[(1) - (1)].item); }
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5500 "sql_yacc.yy"
    { (yyval.item) = (yyvsp[(2) - (2)].item_num); }
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5502 "sql_yacc.yy"
    {
            (yyvsp[(2) - (2)].item_num)->max_length++;
            (yyval.item)= (yyvsp[(2) - (2)].item_num)->neg();
          }
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5509 "sql_yacc.yy"
    { (yyval.item) = (yyvsp[(1) - (1)].item); }
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5510 "sql_yacc.yy"
    { (yyval.item) = (yyvsp[(1) - (1)].item_num); }
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5512 "sql_yacc.yy"
    {
            (yyval.item) = new Item_null();
            YYSession->m_lip->next_state=MY_LEX_OPERATOR_OR_IDENT;
          }
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5516 "sql_yacc.yy"
    { (yyval.item)= new Item_int((char*) "FALSE",0,1); }
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5517 "sql_yacc.yy"
    { (yyval.item)= new Item_int((char*) "TRUE",1,1); }
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5518 "sql_yacc.yy"
    { (yyval.item) = new Item_hex_string((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length);}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5519 "sql_yacc.yy"
    { (yyval.item)= new Item_bin_string((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length); }
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5520 "sql_yacc.yy"
    { (yyval.item) = (yyvsp[(2) - (2)].item); }
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5521 "sql_yacc.yy"
    { (yyval.item) = (yyvsp[(2) - (2)].item); }
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5526 "sql_yacc.yy"
    {
            int error;
            (yyval.item_num) = new Item_int((yyvsp[(1) - (1)].lex_str).str, (int64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, NULL, &error), (yyvsp[(1) - (1)].lex_str).length);
          }
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5531 "sql_yacc.yy"
    {
            int error;
            (yyval.item_num) = new Item_int((yyvsp[(1) - (1)].lex_str).str, (int64_t) internal::my_strtoll10((yyvsp[(1) - (1)].lex_str).str, NULL, &error), (yyvsp[(1) - (1)].lex_str).length);
          }
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5536 "sql_yacc.yy"
    { (yyval.item_num) = new Item_uint((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length); }
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5538 "sql_yacc.yy"
    {
            (yyval.item_num)= new Item_decimal((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length, YYSession->charset());
            if (YYSession->is_error())
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5546 "sql_yacc.yy"
    {
            (yyval.item_num) = new Item_float((yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length);
            if (YYSession->is_error())
            {
              DRIZZLE_YYABORT;
            }
          }
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5560 "sql_yacc.yy"
    { (yyval.item)=(yyvsp[(1) - (1)].item); }
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5561 "sql_yacc.yy"
    { (yyval.item)=(yyvsp[(1) - (1)].item); }
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5566 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            (yyval.item) = new Item_field(Lex->current_context(), NULL, (yyvsp[(1) - (3)].lex_str).str, "*");
            sel->with_wild++;
          }
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5572 "sql_yacc.yy"
    {
            Select_Lex *sel= Lex->current_select;
            (yyval.item) = new Item_field(Lex->current_context(), (yyvsp[(1) - (5)].lex_str).str, (yyvsp[(3) - (5)].lex_str).str,"*");
            sel->with_wild++;
          }
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5580 "sql_yacc.yy"
    { (yyval.item)=(yyvsp[(1) - (1)].item); }
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5585 "sql_yacc.yy"
    {
            {
              Select_Lex *sel=Lex->current_select;
              (yyval.item)= (sel->parsing_place != IN_HAVING ||
                  sel->get_in_sum_expr() > 0) ?
                  (Item*) new Item_field(Lex->current_context(),
                                         (const char *)NULL, NULL, (yyvsp[(1) - (1)].lex_str).str) :
                  (Item*) new Item_ref(Lex->current_context(),
                                       (const char *)NULL, NULL, (yyvsp[(1) - (1)].lex_str).str);
            }
          }
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5596 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(1) - (1)].item); }
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5601 "sql_yacc.yy"
    {
            Select_Lex *sel=Lex->current_select;
            (yyval.item)= (sel->parsing_place != IN_HAVING ||
                sel->get_in_sum_expr() > 0) ?
                (Item*) new Item_field(Lex->current_context(),
                                       (const char *)NULL, NULL, (yyvsp[(1) - (1)].lex_str).str) :
                (Item*) new Item_ref(Lex->current_context(),
                                     (const char *)NULL, NULL, (yyvsp[(1) - (1)].lex_str).str);
          }
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5610 "sql_yacc.yy"
    { (yyval.item)= (yyvsp[(1) - (1)].item); }
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5615 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;

            {
              Select_Lex *sel= lex->current_select;
              if (sel->no_table_names_allowed)
              {
                my_error(ER_TABLENAME_NOT_ALLOWED_HERE,
                         MYF(0), (yyvsp[(1) - (3)].lex_str).str, session->where);
              }
              (yyval.item)= (sel->parsing_place != IN_HAVING ||
                  sel->get_in_sum_expr() > 0) ?
                  (Item*) new Item_field(Lex->current_context(),
                                         (const char *)NULL, (yyvsp[(1) - (3)].lex_str).str, (yyvsp[(3) - (3)].lex_str).str) :
                  (Item*) new Item_ref(Lex->current_context(),
                                       (const char *)NULL, (yyvsp[(1) - (3)].lex_str).str, (yyvsp[(3) - (3)].lex_str).str);
            }
          }
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5635 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            Select_Lex *sel= lex->current_select;
            if (sel->no_table_names_allowed)
            {
              my_error(ER_TABLENAME_NOT_ALLOWED_HERE,
                       MYF(0), (yyvsp[(2) - (4)].lex_str).str, session->where);
            }
            (yyval.item)= (sel->parsing_place != IN_HAVING ||
                sel->get_in_sum_expr() > 0) ?
                (Item*) new Item_field(Lex->current_context(), NULL, (yyvsp[(2) - (4)].lex_str).str, (yyvsp[(4) - (4)].lex_str).str) :
                (Item*) new Item_ref(Lex->current_context(),
                                     (const char *)NULL, (yyvsp[(2) - (4)].lex_str).str, (yyvsp[(4) - (4)].lex_str).str);
          }
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5651 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            Select_Lex *sel= lex->current_select;
            if (sel->no_table_names_allowed)
            {
              my_error(ER_TABLENAME_NOT_ALLOWED_HERE,
                       MYF(0), (yyvsp[(3) - (5)].lex_str).str, session->where);
            }
            (yyval.item)= (sel->parsing_place != IN_HAVING ||
                sel->get_in_sum_expr() > 0) ?
                (Item*) new Item_field(Lex->current_context(), (yyvsp[(1) - (5)].lex_str).str, (yyvsp[(3) - (5)].lex_str).str,
                                       (yyvsp[(5) - (5)].lex_str).str) :
                (Item*) new Item_ref(Lex->current_context(), (yyvsp[(1) - (5)].lex_str).str, (yyvsp[(3) - (5)].lex_str).str,
                                     (yyvsp[(5) - (5)].lex_str).str);
          }
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5670 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str);}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5672 "sql_yacc.yy"
    {
            TableList *table=
              reinterpret_cast<TableList*>(Lex->current_select->table_list.first);
            if (my_strcasecmp(table_alias_charset, (yyvsp[(1) - (5)].lex_str).str, table->db))
            {
              my_error(ER_WRONG_DB_NAME, MYF(0), (yyvsp[(1) - (5)].lex_str).str);
              DRIZZLE_YYABORT;
            }
            if (my_strcasecmp(table_alias_charset, (yyvsp[(3) - (5)].lex_str).str,
                              table->table_name))
            {
              my_error(ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[(3) - (5)].lex_str).str);
              DRIZZLE_YYABORT;
            }
            (yyval.lex_str)=(yyvsp[(5) - (5)].lex_str);
          }
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5689 "sql_yacc.yy"
    {
            TableList *table=
              reinterpret_cast<TableList*>(Lex->current_select->table_list.first);
            if (my_strcasecmp(table_alias_charset, (yyvsp[(1) - (3)].lex_str).str, table->alias))
            {
              my_error(ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[(1) - (3)].lex_str).str);
              DRIZZLE_YYABORT;
            }
            (yyval.lex_str)=(yyvsp[(3) - (3)].lex_str);
          }
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5699 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(2) - (2)].lex_str);}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5703 "sql_yacc.yy"
    { (yyval.table)=new Table_ident((yyvsp[(1) - (1)].lex_str)); }
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5704 "sql_yacc.yy"
    { (yyval.table)=new Table_ident((yyvsp[(1) - (3)].lex_str),(yyvsp[(3) - (3)].lex_str));}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5705 "sql_yacc.yy"
    { (yyval.table)=new Table_ident((yyvsp[(2) - (2)].lex_str));}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5709 "sql_yacc.yy"
    { (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str); }
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5711 "sql_yacc.yy"
    {
            const CHARSET_INFO * const cs= system_charset_info;
            int dummy_error;
            uint32_t wlen= cs->cset->well_formed_len(cs, (yyvsp[(1) - (1)].lex_str).str,
                                                 (yyvsp[(1) - (1)].lex_str).str+(yyvsp[(1) - (1)].lex_str).length,
                                                 (yyvsp[(1) - (1)].lex_str).length, &dummy_error);
            if (wlen < (yyvsp[(1) - (1)].lex_str).length)
            {
              my_error(ER_INVALID_CHARACTER_STRING, MYF(0),
                       cs->csname, (yyvsp[(1) - (1)].lex_str).str + wlen);
              DRIZZLE_YYABORT;
            }
            (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str);
          }
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5729 "sql_yacc.yy"
    {
            (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str);
          }
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5736 "sql_yacc.yy"
    {
            (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str);
          }
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5743 "sql_yacc.yy"
    {
            (yyval.lex_str)= (yyvsp[(1) - (1)].lex_str);
          }
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5749 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str); }
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 5751 "sql_yacc.yy"
    {
            Session *session= YYSession;
            (yyval.lex_str).str= session->strmake((yyvsp[(1) - (1)].symbol).str, (yyvsp[(1) - (1)].symbol).length);
            (yyval.lex_str).length= (yyvsp[(1) - (1)].symbol).length;
          }
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5759 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str);}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5760 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str);}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5761 "sql_yacc.yy"
    { (yyval.lex_str)=(yyvsp[(1) - (1)].lex_str);}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5766 "sql_yacc.yy"
    {}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5767 "sql_yacc.yy"
    {}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 5768 "sql_yacc.yy"
    {}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 5769 "sql_yacc.yy"
    {}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 5770 "sql_yacc.yy"
    {}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 5771 "sql_yacc.yy"
    {}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 5772 "sql_yacc.yy"
    {}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5773 "sql_yacc.yy"
    {}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5774 "sql_yacc.yy"
    {}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5775 "sql_yacc.yy"
    {}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5776 "sql_yacc.yy"
    {}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5777 "sql_yacc.yy"
    {}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5778 "sql_yacc.yy"
    {}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5779 "sql_yacc.yy"
    {}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5780 "sql_yacc.yy"
    {}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5781 "sql_yacc.yy"
    {}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5782 "sql_yacc.yy"
    {}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 5783 "sql_yacc.yy"
    {}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 5784 "sql_yacc.yy"
    {}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 5785 "sql_yacc.yy"
    {}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 5795 "sql_yacc.yy"
    {}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 5796 "sql_yacc.yy"
    {}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 5797 "sql_yacc.yy"
    {}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 5798 "sql_yacc.yy"
    {}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 5799 "sql_yacc.yy"
    {}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 5800 "sql_yacc.yy"
    {}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 5801 "sql_yacc.yy"
    {}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 5802 "sql_yacc.yy"
    {}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 5803 "sql_yacc.yy"
    {}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 5804 "sql_yacc.yy"
    {}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 5805 "sql_yacc.yy"
    {}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 5806 "sql_yacc.yy"
    {}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 5807 "sql_yacc.yy"
    {}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 5808 "sql_yacc.yy"
    {}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 5809 "sql_yacc.yy"
    {}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 5810 "sql_yacc.yy"
    {}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 5811 "sql_yacc.yy"
    {}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 5812 "sql_yacc.yy"
    {}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 5813 "sql_yacc.yy"
    {}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 5814 "sql_yacc.yy"
    {}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 5815 "sql_yacc.yy"
    {}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 5816 "sql_yacc.yy"
    {}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 5817 "sql_yacc.yy"
    {}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 5818 "sql_yacc.yy"
    {}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 5819 "sql_yacc.yy"
    {}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 5820 "sql_yacc.yy"
    {}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 5821 "sql_yacc.yy"
    {}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 5822 "sql_yacc.yy"
    {}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 5823 "sql_yacc.yy"
    {}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 5824 "sql_yacc.yy"
    {}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 5825 "sql_yacc.yy"
    {}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 5826 "sql_yacc.yy"
    {}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 5827 "sql_yacc.yy"
    {}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 5828 "sql_yacc.yy"
    {}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 5829 "sql_yacc.yy"
    {}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 5830 "sql_yacc.yy"
    {}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 5831 "sql_yacc.yy"
    {}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 5832 "sql_yacc.yy"
    {}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 5833 "sql_yacc.yy"
    {}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 5834 "sql_yacc.yy"
    {}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 5835 "sql_yacc.yy"
    {}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 5836 "sql_yacc.yy"
    {}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 5837 "sql_yacc.yy"
    {}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 5838 "sql_yacc.yy"
    {}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 5839 "sql_yacc.yy"
    {}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 5840 "sql_yacc.yy"
    {}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 5841 "sql_yacc.yy"
    {}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 5842 "sql_yacc.yy"
    {}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 5843 "sql_yacc.yy"
    {}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 5844 "sql_yacc.yy"
    {}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 5845 "sql_yacc.yy"
    {}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 5846 "sql_yacc.yy"
    {}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 5847 "sql_yacc.yy"
    {}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 5848 "sql_yacc.yy"
    {}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 5849 "sql_yacc.yy"
    {}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 5850 "sql_yacc.yy"
    {}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 5851 "sql_yacc.yy"
    {}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 5852 "sql_yacc.yy"
    {}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 5853 "sql_yacc.yy"
    {}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 5854 "sql_yacc.yy"
    {}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 5855 "sql_yacc.yy"
    {}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 5856 "sql_yacc.yy"
    {}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 5857 "sql_yacc.yy"
    {}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 5858 "sql_yacc.yy"
    {}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 5859 "sql_yacc.yy"
    {}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 5860 "sql_yacc.yy"
    {}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 5861 "sql_yacc.yy"
    {}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 5862 "sql_yacc.yy"
    {}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 5863 "sql_yacc.yy"
    {}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 5864 "sql_yacc.yy"
    {}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 5865 "sql_yacc.yy"
    {}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 5866 "sql_yacc.yy"
    {}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 5867 "sql_yacc.yy"
    {}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 5868 "sql_yacc.yy"
    {}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 5869 "sql_yacc.yy"
    {}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 5870 "sql_yacc.yy"
    {}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 5871 "sql_yacc.yy"
    {}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 5872 "sql_yacc.yy"
    {}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 5873 "sql_yacc.yy"
    {}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 5874 "sql_yacc.yy"
    {}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 5875 "sql_yacc.yy"
    {}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 5876 "sql_yacc.yy"
    {}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 5877 "sql_yacc.yy"
    {}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 5878 "sql_yacc.yy"
    {}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 5879 "sql_yacc.yy"
    {}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 5880 "sql_yacc.yy"
    {}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 5881 "sql_yacc.yy"
    {}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 5882 "sql_yacc.yy"
    {}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 5883 "sql_yacc.yy"
    {}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 5884 "sql_yacc.yy"
    {}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 5885 "sql_yacc.yy"
    {}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 5886 "sql_yacc.yy"
    {}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 5887 "sql_yacc.yy"
    {}
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 5888 "sql_yacc.yy"
    {}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 5889 "sql_yacc.yy"
    {}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 5890 "sql_yacc.yy"
    {}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 5891 "sql_yacc.yy"
    {}
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 5892 "sql_yacc.yy"
    {}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 5893 "sql_yacc.yy"
    {}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 5894 "sql_yacc.yy"
    {}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 5895 "sql_yacc.yy"
    {}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 5896 "sql_yacc.yy"
    {}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 5897 "sql_yacc.yy"
    {}
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 5898 "sql_yacc.yy"
    {}
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 5899 "sql_yacc.yy"
    {}
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 5900 "sql_yacc.yy"
    {}
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 5901 "sql_yacc.yy"
    {}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 5902 "sql_yacc.yy"
    {}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 5903 "sql_yacc.yy"
    {}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 5904 "sql_yacc.yy"
    {}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 5905 "sql_yacc.yy"
    {}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 5906 "sql_yacc.yy"
    {}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 5907 "sql_yacc.yy"
    {}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 5908 "sql_yacc.yy"
    {}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 5909 "sql_yacc.yy"
    {}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 5910 "sql_yacc.yy"
    {}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 5911 "sql_yacc.yy"
    {}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 5912 "sql_yacc.yy"
    {}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 5913 "sql_yacc.yy"
    {}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 5914 "sql_yacc.yy"
    {}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 5915 "sql_yacc.yy"
    {}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 5916 "sql_yacc.yy"
    {}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 5917 "sql_yacc.yy"
    {}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 5918 "sql_yacc.yy"
    {}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 5919 "sql_yacc.yy"
    {}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 5920 "sql_yacc.yy"
    {}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 5921 "sql_yacc.yy"
    {}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 5922 "sql_yacc.yy"
    {}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 5923 "sql_yacc.yy"
    {}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 5924 "sql_yacc.yy"
    {}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 5925 "sql_yacc.yy"
    {}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 5926 "sql_yacc.yy"
    {}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 5927 "sql_yacc.yy"
    {}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 5928 "sql_yacc.yy"
    {}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 5929 "sql_yacc.yy"
    {}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 5930 "sql_yacc.yy"
    {}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 5931 "sql_yacc.yy"
    {}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 5932 "sql_yacc.yy"
    {}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 5933 "sql_yacc.yy"
    {}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 5934 "sql_yacc.yy"
    {}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 5935 "sql_yacc.yy"
    {}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 5936 "sql_yacc.yy"
    {}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 5943 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SET_OPTION;
            statement::SetOption *statement= new(std::nothrow) statement::SetOption(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            mysql_init_select(lex);
            lex->option_type=OPT_SESSION;
            lex->var_list.empty();
          }
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 5955 "sql_yacc.yy"
    {}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 5959 "sql_yacc.yy"
    {}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 5960 "sql_yacc.yy"
    {}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 5969 "sql_yacc.yy"
    {
          }
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 5972 "sql_yacc.yy"
    {
          }
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 5977 "sql_yacc.yy"
    {}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 5978 "sql_yacc.yy"
    { (yyval.var_type)=OPT_GLOBAL; }
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 5979 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 5980 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 5984 "sql_yacc.yy"
    { (yyval.num)= OPT_DEFAULT; }
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 5985 "sql_yacc.yy"
    { ((statement::SetOption *)Lex->statement)->one_shot_set= true; (yyval.num)= OPT_SESSION; }
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 5989 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 5990 "sql_yacc.yy"
    { (yyval.var_type)=OPT_GLOBAL; }
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 5991 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 5992 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 5996 "sql_yacc.yy"
    { (yyval.var_type)=OPT_DEFAULT; }
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 5997 "sql_yacc.yy"
    { (yyval.var_type)=OPT_GLOBAL; }
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 5998 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 5999 "sql_yacc.yy"
    { (yyval.var_type)=OPT_SESSION; }
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6009 "sql_yacc.yy"
    {
            LEX *lex=Lex;

            if ((yyvsp[(2) - (4)].variable).var)
            { /* System variable */
              if ((yyvsp[(1) - (4)].var_type))
                lex->option_type= (yyvsp[(1) - (4)].var_type);
              lex->var_list.push_back(new set_var(lex->option_type, (yyvsp[(2) - (4)].variable).var,
                                      &(yyvsp[(2) - (4)].variable).base_name, (yyvsp[(4) - (4)].item)));
            }
          }
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6021 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->option_type= (yyvsp[(1) - (5)].var_type);
            lex->var_list.push_back(new set_var(lex->option_type,
                                                find_sys_var(YYSession, "tx_isolation"),
                                                &null_lex_str,
                                                new Item_int((int32_t) (yyvsp[(5) - (5)].tx_isolation))));
          }
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6033 "sql_yacc.yy"
    {
            Lex->var_list.push_back(new set_var_user(new Item_func_set_user_var((yyvsp[(2) - (4)].lex_str),(yyvsp[(4) - (4)].item))));
          }
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 6037 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->var_list.push_back(new set_var((yyvsp[(3) - (6)].var_type), (yyvsp[(4) - (6)].variable).var, &(yyvsp[(4) - (6)].variable).base_name, (yyvsp[(6) - (6)].item)));
          }
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 6045 "sql_yacc.yy"
    {
            Session *session= YYSession;

            /* We have to lookup here since local vars can shadow sysvars */
            {
              /* Not an SP local variable */
              sys_var *tmp=find_sys_var(session, (yyvsp[(1) - (1)].lex_str).str, (yyvsp[(1) - (1)].lex_str).length);
              if (!tmp)
                DRIZZLE_YYABORT;
              (yyval.variable).var= tmp;
              (yyval.variable).base_name= null_lex_str;
            }
          }
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 6061 "sql_yacc.yy"
    { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 6062 "sql_yacc.yy"
    { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6063 "sql_yacc.yy"
    { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6064 "sql_yacc.yy"
    { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 6068 "sql_yacc.yy"
    { (yyval.item)=(yyvsp[(1) - (1)].item); }
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 6069 "sql_yacc.yy"
    { (yyval.item)=0; }
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 6070 "sql_yacc.yy"
    { (yyval.item)=new Item_string("ON",  2, system_charset_info); }
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 6071 "sql_yacc.yy"
    { (yyval.item)=new Item_string("ALL", 3, system_charset_info); }
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 6072 "sql_yacc.yy"
    { (yyval.item)=new Item_string("binary", 6, system_charset_info); }
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 6082 "sql_yacc.yy"
    {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
            lex->statement= new(std::nothrow) statement::UnlockTables(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 6090 "sql_yacc.yy"
    {}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 6095 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->statement= new(std::nothrow) statement::StartTransaction(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
          }
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 6102 "sql_yacc.yy"
    {}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 6106 "sql_yacc.yy"
    {}
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 6107 "sql_yacc.yy"
    {}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 6112 "sql_yacc.yy"
    { (yyval.num)= (YYSession->variables.completion_type == 1); }
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 6113 "sql_yacc.yy"
    { (yyval.num)=0; }
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 6114 "sql_yacc.yy"
    { (yyval.num)=1; }
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 6119 "sql_yacc.yy"
    { (yyval.num)= (YYSession->variables.completion_type == 2); }
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 6120 "sql_yacc.yy"
    { (yyval.num)=1; }
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 6121 "sql_yacc.yy"
    { (yyval.num)=0; }
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 6125 "sql_yacc.yy"
    {}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 6126 "sql_yacc.yy"
    {}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 6131 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            statement::Commit *statement= new(std::nothrow) statement::Commit(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->tx_chain= (yyvsp[(3) - (4)].num);
            statement->tx_release= (yyvsp[(4) - (4)].num);
          }
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 6145 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            statement::Rollback *statement= new(std::nothrow) statement::Rollback(YYSession);
            lex->statement= statement;
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            statement->tx_chain= (yyvsp[(3) - (4)].num);
            statement->tx_release= (yyvsp[(4) - (4)].num);
          }
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 6157 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->statement= new(std::nothrow) statement::RollbackToSavepoint(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->ident= (yyvsp[(5) - (5)].lex_str);
          }
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 6169 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->statement= new(std::nothrow) statement::Savepoint(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->ident= (yyvsp[(2) - (2)].lex_str);
          }
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 6181 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->statement= new(std::nothrow) statement::ReleaseSavepoint(YYSession);
            if (lex->statement == NULL)
              DRIZZLE_YYABORT;
            lex->ident= (yyvsp[(3) - (3)].lex_str);
          }
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 6197 "sql_yacc.yy"
    {}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 6203 "sql_yacc.yy"
    {
            if (add_select_to_union_list(Lex, (bool)(yyvsp[(2) - (2)].num)))
              DRIZZLE_YYABORT;
          }
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 6208 "sql_yacc.yy"
    {
            /*
              Remove from the name resolution context stack the context of the
              last select in the union.
            */
            Lex->pop_context();
          }
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 6218 "sql_yacc.yy"
    { (yyval.num)= 0; }
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 6219 "sql_yacc.yy"
    { (yyval.num)= 1; }
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 6220 "sql_yacc.yy"
    { (yyval.num)= 1; }
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 6224 "sql_yacc.yy"
    {
            Session *session= YYSession;
            LEX *lex= session->lex;
            assert(lex->current_select->linkage != GLOBAL_OPTIONS_TYPE);
            Select_Lex *sel= lex->current_select;
            Select_Lex_Unit *unit= sel->master_unit();
            Select_Lex *fake= unit->fake_select_lex;
            if (fake)
            {
              unit->global_parameters= fake;
              fake->no_table_names_allowed= 1;
              lex->current_select= fake;
            }
            session->where= "global ORDER clause";
          }
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 6240 "sql_yacc.yy"
    {
            Session *session= YYSession;
            session->lex->current_select->no_table_names_allowed= 0;
            session->where= "";
          }
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 6253 "sql_yacc.yy"
    { (yyval.num)=1; }
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 6254 "sql_yacc.yy"
    { (yyval.num)=1; }
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 6255 "sql_yacc.yy"
    { (yyval.num)=0; }
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 6260 "sql_yacc.yy"
    {
            (yyval.select_lex)= Lex->current_select->master_unit()->first_select();
          }
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 6264 "sql_yacc.yy"
    {
            (yyval.select_lex)= Lex->current_select->master_unit()->first_select();
          }
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 6273 "sql_yacc.yy"
    {
            if (add_select_to_union_list(Lex, (bool)(yyvsp[(3) - (3)].num)))
              DRIZZLE_YYABORT;
          }
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 6278 "sql_yacc.yy"
    {
            Lex->pop_context();
            (yyval.select_lex)= (yyvsp[(1) - (5)].select_lex);
          }
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 6287 "sql_yacc.yy"
    {
            (yyval.select_lex)= (yyvsp[(2) - (3)].select_lex);
          }
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 6293 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            if (!lex->expr_allows_subselect)
            {
              my_parse_error(ER(ER_SYNTAX_ERROR));
              DRIZZLE_YYABORT;
            }
            /*
              we are making a "derived table" for the parenthesis
              as we need to have a lex level to fit the union
              after the parenthesis, e.g.
              (SELECT .. ) UNION ...  becomes
              SELECT * FROM ((SELECT ...) UNION ...)
            */
            if (mysql_new_select(Lex, 1))
              DRIZZLE_YYABORT;
          }
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 6313 "sql_yacc.yy"
    {
            LEX *lex=Lex;
            lex->pop_context();
            Select_Lex *child= lex->current_select;
            lex->current_select = lex->current_select->return_after_parsing();
            lex->nest_level--;
            lex->current_select->n_child_sum_items += child->n_sum_items;
            /*
              A subselect can add fields to an outer select. Reserve space for
              them.
            */
            lex->current_select->select_n_where_fields+=
            child->select_n_where_fields;
          }
    break;



/* Line 1455 of yacc.c  */
#line 17520 "drizzled/sql_yacc.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



